create temporary table pgdump_restore_path(p text);
--
-- NOTE:
--
-- File paths need to be edited. Search for $$PATH$$ and
-- replace it with the path to the directory containing
-- the extracted data files.
--
-- Edit the following to match the path where the
-- tar archive has been extracted.
--
insert into pgdump_restore_path values('/tmp');

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET search_path = public, pg_catalog;

ALTER TABLE ONLY public.vm_static DROP CONSTRAINT vm_templates_vm_static;
ALTER TABLE ONLY public.vm_statistics DROP CONSTRAINT vm_static_vm_statistics;
ALTER TABLE ONLY public.vm_dynamic DROP CONSTRAINT vm_static_vm_dynamic;
ALTER TABLE ONLY public.vm_pool_map DROP CONSTRAINT vm_pools_vm;
ALTER TABLE ONLY public.vm_ovf_generations DROP CONSTRAINT vm_ovf_generations_storage_pool_id_fkey;
ALTER TABLE ONLY public.vm_pool_map DROP CONSTRAINT vm_guid_pools;
ALTER TABLE ONLY public.vm_dynamic DROP CONSTRAINT vds_static_vm_dynamic_r;
ALTER TABLE ONLY public.vm_dynamic DROP CONSTRAINT vds_static_vm_dynamic_m;
ALTER TABLE ONLY public.vds_statistics DROP CONSTRAINT vds_static_vds_statistics;
ALTER TABLE ONLY public.vds_dynamic DROP CONSTRAINT vds_static_vds_dynamic;
ALTER TABLE ONLY public.vm_static DROP CONSTRAINT vds_groups_vm_static;
ALTER TABLE ONLY public.vds_static DROP CONSTRAINT vds_groups_vds_static;
ALTER TABLE ONLY public.tags_vm_map DROP CONSTRAINT tags_vm_map_vm;
ALTER TABLE ONLY public.tags_vm_map DROP CONSTRAINT tags_vm_map_tag;
ALTER TABLE ONLY public.tags_vds_map DROP CONSTRAINT tags_vds_map_vds;
ALTER TABLE ONLY public.tags_vds_map DROP CONSTRAINT tags_vds_map_tag;
ALTER TABLE ONLY public.tags_user_group_map DROP CONSTRAINT tags_user_map_user_group;
ALTER TABLE ONLY public.tags_user_map DROP CONSTRAINT tags_user_map_user;
ALTER TABLE ONLY public.tags_user_map DROP CONSTRAINT tags_user_map_tag;
ALTER TABLE ONLY public.tags_user_group_map DROP CONSTRAINT tags_user_group_map_tag;
ALTER TABLE ONLY public.quota DROP CONSTRAINT quota_storage_pool_id_fkey;
ALTER TABLE ONLY public.quota_limitation DROP CONSTRAINT quota_limitation_vds_group_id_fkey;
ALTER TABLE ONLY public.quota_limitation DROP CONSTRAINT quota_limitation_storage_id_fkey;
ALTER TABLE ONLY public.quota_limitation DROP CONSTRAINT quota_limitation_quota_id_fkey;
ALTER TABLE ONLY public.images DROP CONSTRAINT image_templates_images;
ALTER TABLE ONLY public.gluster_volumes DROP CONSTRAINT gluster_volumes_cluster_id_fkey;
ALTER TABLE ONLY public.gluster_volume_transport_types DROP CONSTRAINT gluster_volume_transport_types_volume_id_fkey;
ALTER TABLE ONLY public.gluster_volume_options DROP CONSTRAINT gluster_volume_options_volume_id_fkey;
ALTER TABLE ONLY public.gluster_volume_bricks DROP CONSTRAINT gluster_volume_bricks_volume_id_fkey;
ALTER TABLE ONLY public.gluster_volume_bricks DROP CONSTRAINT gluster_volume_bricks_server_id_fkey;
ALTER TABLE ONLY public.gluster_volume_access_protocols DROP CONSTRAINT gluster_volume_access_protocols_volume_id_fkey;
ALTER TABLE ONLY public.vm_interface DROP CONSTRAINT fk_vm_interface_vm_static_template;
ALTER TABLE ONLY public.vm_interface DROP CONSTRAINT fk_vm_interface_vm_static;
ALTER TABLE ONLY public.vm_interface_statistics DROP CONSTRAINT fk_vm_interface_statistics_vm_static;
ALTER TABLE ONLY public.vm_guest_agent_interfaces DROP CONSTRAINT fk_vm_guest_agent_interfaces;
ALTER TABLE ONLY public.vm_device DROP CONSTRAINT fk_vm_device_vm_static;
ALTER TABLE ONLY public.vm_static DROP CONSTRAINT fk_vds_static_vm_static;
ALTER TABLE ONLY public.vds_spm_id_map DROP CONSTRAINT fk_vds_spm_id_map_vds_id;
ALTER TABLE ONLY public.vds_spm_id_map DROP CONSTRAINT fk_vds_spm_id_map_storage_pool;
ALTER TABLE ONLY public.vds_interface DROP CONSTRAINT fk_vds_interface_vds_interface;
ALTER TABLE ONLY public.vds_interface_statistics DROP CONSTRAINT fk_vds_interface_statistics_vds_static;
ALTER TABLE ONLY public.vm_pools DROP CONSTRAINT fk_vds_groups_vm_pools;
ALTER TABLE ONLY public.vds_groups DROP CONSTRAINT fk_vds_groups_storage_pool_id;
ALTER TABLE ONLY public.user_sessions DROP CONSTRAINT fk_users;
ALTER TABLE ONLY public.tags_vm_pool_map DROP CONSTRAINT fk_tags_vm_pool_map_vm_pool;
ALTER TABLE ONLY public.tags_vm_pool_map DROP CONSTRAINT fk_tags_vm_pool_map_tag;
ALTER TABLE ONLY public.storage_pool_iso_map DROP CONSTRAINT fk_storage_domain_pool_map_storage_pool;
ALTER TABLE ONLY public.storage_pool_iso_map DROP CONSTRAINT fk_storage_domain_pool_map_storage_domain_static;
ALTER TABLE ONLY public.storage_domain_dynamic DROP CONSTRAINT fk_storage_domain_dynamic_storage_domain_static;
ALTER TABLE ONLY public.step DROP CONSTRAINT fk_step_job;
ALTER TABLE ONLY public.snapshots DROP CONSTRAINT fk_snapshot_vm;
ALTER TABLE ONLY public.roles_relations DROP CONSTRAINT fk_roles_relations_role_id;
ALTER TABLE ONLY public.roles_relations DROP CONSTRAINT fk_roles_relations_container_id;
ALTER TABLE ONLY public.roles_groups DROP CONSTRAINT fk_roles_groups_action_id;
ALTER TABLE ONLY public.repo_file_meta_data DROP CONSTRAINT fk_repo_file_meta_data_storage_domain_static;
ALTER TABLE ONLY public.permissions DROP CONSTRAINT fk_permissions_roles;
ALTER TABLE ONLY public.network DROP CONSTRAINT fk_network_storage_pool;
ALTER TABLE ONLY public.network_cluster DROP CONSTRAINT fk_network_cluster_vds_groups;
ALTER TABLE ONLY public.network_cluster DROP CONSTRAINT fk_network_cluster_network;
ALTER TABLE ONLY public.lun_storage_server_connection_map DROP CONSTRAINT fk_lun_storage_server_connection_map_storage_server_connections;
ALTER TABLE ONLY public.lun_storage_server_connection_map DROP CONSTRAINT fk_lun_storage_server_connection_map_luns;
ALTER TABLE ONLY public.job_subject_entity DROP CONSTRAINT fk_job_subject_entity_job;
ALTER TABLE ONLY public.image_storage_domain_map DROP CONSTRAINT fk_image_storage_domain_map_storage_domain_static;
ALTER TABLE ONLY public.image_storage_domain_map DROP CONSTRAINT fk_image_storage_domain_map_images;
ALTER TABLE ONLY public.event_subscriber DROP CONSTRAINT fk_event_subscriber_users;
ALTER TABLE ONLY public.event_subscriber DROP CONSTRAINT fk_event_subscriber_event_notification_methods;
ALTER TABLE ONLY public.event_subscriber DROP CONSTRAINT fk_event_subscriber_event_map;
ALTER TABLE ONLY public.event_notification_hist DROP CONSTRAINT fk_event_notification_users;
ALTER TABLE ONLY public.event_notification_hist DROP CONSTRAINT fk_event_notification_hist_audit_log;
ALTER TABLE ONLY public.disk_image_dynamic DROP CONSTRAINT fk_disk_image_dynamic_images;
ALTER TABLE ONLY public.async_tasks_entities DROP CONSTRAINT fk_async_task_entity;
ALTER TABLE ONLY public.disk_lun_map DROP CONSTRAINT disk_lun_to_lun_fk;
ALTER TABLE ONLY public.disk_lun_map DROP CONSTRAINT disk_lun_to_disk_fk;
DROP INDEX public.ix_vdc_options;
DROP INDEX public.idx_vm_static_vm_name;
DROP INDEX public.idx_vm_ovf_generations_vm_guid;
DROP INDEX public.idx_vm_ovf_generations_storage_pool_id;
DROP INDEX public.idx_vm_interface_vm_vmt_guid;
DROP INDEX public.idx_vm_guest_agent_interfaces_vm_id;
DROP INDEX public.idx_vm_dynamic_run_on_vds;
DROP INDEX public.idx_vds_interface_vds_id;
DROP INDEX public.idx_storage_pool_id;
DROP INDEX public.idx_step_parent_step_id;
DROP INDEX public.idx_step_job_id;
DROP INDEX public.idx_roles_groups_action_group_id;
DROP INDEX public.idx_repo_file_file_type;
DROP INDEX public.idx_quota_limitation_vds_group_id;
DROP INDEX public.idx_quota_limitation_storage_id;
DROP INDEX public.idx_quota_limitation_quota_id;
DROP INDEX public.idx_permissions_role_id;
DROP INDEX public.idx_permissions_object_id;
DROP INDEX public.idx_permissions_ad_element_id;
DROP INDEX public.idx_job_subject_entity_entity_id;
DROP INDEX public.idx_gluster_volumes_cluster_id;
DROP INDEX public.idx_gluster_volume_transport_types_volume_id;
DROP INDEX public.idx_gluster_volume_options_volume_id;
DROP INDEX public.idx_gluster_volume_bricks_volume_id;
DROP INDEX public.idx_gluster_volume_access_protocols_volume_id;
DROP INDEX public.idx_combined_ad_role_object;
DROP INDEX public.idx_business_entity_snapshot_command_id;
DROP INDEX public.idx_audit_log_vm_template_name;
DROP INDEX public.idx_audit_log_vm_name;
DROP INDEX public.idx_audit_log_vds_name;
DROP INDEX public.idx_audit_log_user_name;
DROP INDEX public.idx_audit_log_storage_pool_name;
DROP INDEX public.idx_audit_log_storage_domain_name;
DROP INDEX public.idx_audit_log_log_time;
DROP INDEX public.idx_audit_log_job_id;
DROP INDEX public.idx_audit_correlation_id;
DROP INDEX public.audit_log_origin_custom_event_id_idx;
ALTER TABLE ONLY public.vm_ovf_generations DROP CONSTRAINT vm_ovf_generations_pkey;
ALTER TABLE ONLY public.vds_static DROP CONSTRAINT vds_static_vds_name_unique;
ALTER TABLE ONLY public.vds_static DROP CONSTRAINT vds_static_host_name_unique;
ALTER TABLE ONLY public.business_entity_snapshot DROP CONSTRAINT uq_command_id_entity_id;
ALTER TABLE ONLY public.schema_version DROP CONSTRAINT schema_version_primary_key;
ALTER TABLE ONLY public.quota DROP CONSTRAINT quota_quota_name_unique;
ALTER TABLE ONLY public.vm_statistics DROP CONSTRAINT pk_vm_statistics;
ALTER TABLE ONLY public.vm_static DROP CONSTRAINT pk_vm_static;
ALTER TABLE ONLY public.vm_pools DROP CONSTRAINT pk_vm_pools;
ALTER TABLE ONLY public.vm_pool_map DROP CONSTRAINT pk_vm_pool_map;
ALTER TABLE ONLY public.vm_interface_statistics DROP CONSTRAINT pk_vm_interface_statistics;
ALTER TABLE ONLY public.vm_interface DROP CONSTRAINT pk_vm_interface;
ALTER TABLE ONLY public.vm_dynamic DROP CONSTRAINT pk_vm_dynamic;
ALTER TABLE ONLY public.vm_device DROP CONSTRAINT pk_vm_device;
ALTER TABLE ONLY public.vds_statistics DROP CONSTRAINT pk_vds_statistics;
ALTER TABLE ONLY public.vds_static DROP CONSTRAINT pk_vds_static;
ALTER TABLE ONLY public.vds_spm_id_map DROP CONSTRAINT pk_vds_spm_id_map;
ALTER TABLE ONLY public.vds_interface_statistics DROP CONSTRAINT pk_vds_interface_statistics;
ALTER TABLE ONLY public.vds_interface DROP CONSTRAINT pk_vds_interface;
ALTER TABLE ONLY public.vds_groups DROP CONSTRAINT pk_vds_groups;
ALTER TABLE ONLY public.vds_dynamic DROP CONSTRAINT pk_vds_dynamic;
ALTER TABLE ONLY public.vdc_options DROP CONSTRAINT pk_vdc_options;
ALTER TABLE ONLY public.vdc_db_log DROP CONSTRAINT pk_vdc_db_log;
ALTER TABLE ONLY public.users DROP CONSTRAINT pk_users;
ALTER TABLE ONLY public.user_sessions DROP CONSTRAINT pk_user_sessions;
ALTER TABLE ONLY public.tags_vm_pool_map DROP CONSTRAINT pk_tags_vm_pool_map;
ALTER TABLE ONLY public.tags_vm_map DROP CONSTRAINT pk_tags_vm_map;
ALTER TABLE ONLY public.tags_vds_map DROP CONSTRAINT pk_tags_vds_map;
ALTER TABLE ONLY public.tags_user_map DROP CONSTRAINT pk_tags_user_map;
ALTER TABLE ONLY public.tags_user_group_map DROP CONSTRAINT pk_tags_user_group_map;
ALTER TABLE ONLY public.tags DROP CONSTRAINT pk_tags_id;
ALTER TABLE ONLY public.storage_server_connections DROP CONSTRAINT pk_storage_server;
ALTER TABLE ONLY public.storage_pool DROP CONSTRAINT pk_storage_pool;
ALTER TABLE ONLY public.storage_pool_iso_map DROP CONSTRAINT pk_storage_domain_pool_map;
ALTER TABLE ONLY public.storage_domain_dynamic DROP CONSTRAINT pk_storage_domain_dynamic;
ALTER TABLE ONLY public.storage_domain_static DROP CONSTRAINT pk_storage;
ALTER TABLE ONLY public.step DROP CONSTRAINT pk_steps;
ALTER TABLE ONLY public.snapshots DROP CONSTRAINT pk_snapshots;
ALTER TABLE ONLY public.roles_relations DROP CONSTRAINT pk_roles_relations;
ALTER TABLE ONLY public.roles DROP CONSTRAINT pk_roles_id;
ALTER TABLE ONLY public.roles_groups DROP CONSTRAINT pk_roles_groups;
ALTER TABLE ONLY public.repo_file_meta_data DROP CONSTRAINT pk_repo_file_meta_data;
ALTER TABLE ONLY public.quota_limitation DROP CONSTRAINT pk_quota_limitation;
ALTER TABLE ONLY public.quota DROP CONSTRAINT pk_quota;
ALTER TABLE ONLY public.permissions DROP CONSTRAINT pk_permissions_id;
ALTER TABLE ONLY public.object_column_white_list_sql DROP CONSTRAINT pk_object_column_white_list_sql;
ALTER TABLE ONLY public.object_column_white_list DROP CONSTRAINT pk_object_column_white_list;
ALTER TABLE ONLY public.network_cluster DROP CONSTRAINT pk_network_cluster;
ALTER TABLE ONLY public.network DROP CONSTRAINT pk_network;
ALTER TABLE ONLY public.luns DROP CONSTRAINT pk_luns;
ALTER TABLE ONLY public.lun_storage_server_connection_map DROP CONSTRAINT pk_lun_storage_server_connection_map;
ALTER TABLE ONLY public.job_subject_entity DROP CONSTRAINT pk_jobs_subject_entity;
ALTER TABLE ONLY public.job DROP CONSTRAINT pk_jobs;
ALTER TABLE ONLY public.images DROP CONSTRAINT pk_images;
ALTER TABLE ONLY public.image_storage_domain_map DROP CONSTRAINT pk_image_storage_domain_map;
ALTER TABLE ONLY public.business_entity_snapshot DROP CONSTRAINT pk_id;
ALTER TABLE ONLY public.gluster_volumes DROP CONSTRAINT pk_gluster_volumes;
ALTER TABLE ONLY public.gluster_volume_transport_types DROP CONSTRAINT pk_gluster_volume_transport_types;
ALTER TABLE ONLY public.gluster_volume_options DROP CONSTRAINT pk_gluster_volume_options;
ALTER TABLE ONLY public.gluster_volume_bricks DROP CONSTRAINT pk_gluster_volume_bricks;
ALTER TABLE ONLY public.gluster_volume_access_protocols DROP CONSTRAINT pk_gluster_volume_access_protocols;
ALTER TABLE ONLY public.event_subscriber DROP CONSTRAINT pk_event_subscriber;
ALTER TABLE ONLY public.event_notification_methods DROP CONSTRAINT pk_event_notification_methods;
ALTER TABLE ONLY public.event_map DROP CONSTRAINT pk_event_map;
ALTER TABLE ONLY public.base_disks DROP CONSTRAINT pk_disks;
ALTER TABLE ONLY public.disk_image_dynamic DROP CONSTRAINT pk_disk_image_dynamic;
ALTER TABLE ONLY public.custom_actions DROP CONSTRAINT pk_custom_actions;
ALTER TABLE ONLY public.bookmarks DROP CONSTRAINT pk_bookmarks;
ALTER TABLE ONLY public.audit_log DROP CONSTRAINT pk_audit_log;
ALTER TABLE ONLY public.async_tasks DROP CONSTRAINT pk_async_tasks;
ALTER TABLE ONLY public.ad_groups DROP CONSTRAINT pk_ad_group_id;
ALTER TABLE ONLY public.action_version_map DROP CONSTRAINT pk_action_version_map;
ALTER TABLE ONLY public.materialized_views DROP CONSTRAINT materialized_views_pkey;
ALTER TABLE ONLY public.gluster_volume_options DROP CONSTRAINT idx_gluster_volume_options_volume_id_option_key;
ALTER TABLE ONLY public.gluster_volume_bricks DROP CONSTRAINT idx_gluster_volume_bricks_volume_server_brickdir;
ALTER TABLE ONLY public.gluster_volumes DROP CONSTRAINT gluster_volumes_name_unique;
ALTER TABLE ONLY public.disk_lun_map DROP CONSTRAINT disk_lun_map_pk;
DROP VIEW public.vms_with_tags;
DROP TABLE public.vm_ovf_generations;
DROP VIEW public.vm_images_storage_domains_view;
DROP VIEW public.vds_with_tags;
DROP VIEW public.vds_groups_storage_domain;
DROP VIEW public.vdc_users_with_tags;
DROP VIEW public.vdc_users;
DROP TABLE public.vdc_db_log;
DROP SEQUENCE public.vdc_db_log_seq;
DROP SEQUENCE public.uuid_sequence;
DROP VIEW public.users_and_groups_to_vm_pool_map_view;
DROP VIEW public.user_vm_pool_permissions_view;
DROP VIEW public.user_vm_pool_permissions_view_base;
DROP VIEW public.user_vds_permissions_view;
DROP VIEW public.user_vds_permissions_view_base;
DROP VIEW public.user_vds_groups_permissions_view;
DROP VIEW public.user_vds_groups_permissions_view_base;
DROP VIEW public.user_storage_pool_permissions_view;
DROP VIEW public.user_storage_pool_permissions_view_base;
DROP VIEW public.user_storage_domain_permissions_view;
DROP VIEW public.user_storage_domain_permissions_view_base;
DROP VIEW public.vm_templates_storage_domain;
DROP VIEW public.user_permissions_permissions_view;
DROP VIEW public.user_object_permissions_view;
DROP VIEW public.user_network_permissions_view;
DROP VIEW public.user_network_permissions_view_base;
DROP VIEW public.vm_interface_ext_view;
DROP VIEW public.user_disk_permissions_view;
DROP VIEW public.user_disk_permissions_view_base;
DROP VIEW public.user_vm_template_permissions_view;
DROP VIEW public.user_vm_template_permissions_view_base;
DROP VIEW public.user_vm_permissions_view;
DROP VIEW public.user_vm_permissions_view_base;
DROP VIEW public.user_flat_groups;
DROP VIEW public.storage_pool_with_storage_domain;
DROP VIEW public.storage_domains_with_hosts_view;
DROP VIEW public.storage_domains_for_search;
DROP VIEW public.server_vms;
DROP TABLE public.schema_version;
DROP SEQUENCE public.schema_version_seq;
DROP VIEW public.quota_limitations_view;
DROP TABLE public.object_column_white_list_sql;
DROP TABLE public.object_column_white_list;
DROP VIEW public.network_view;
DROP VIEW public.network_vds_view;
DROP VIEW public.network_cluster_view;
DROP TABLE public.materialized_views;
DROP VIEW public.internal_permissions_view;
DROP VIEW public.dwh_vm_interface_history_view;
DROP VIEW public.dwh_vm_interface_configuration_history_view;
DROP VIEW public.dwh_vm_history_view;
DROP VIEW public.dwh_vm_disks_history_view;
DROP VIEW public.dwh_vm_disk_configuration_history_view;
DROP VIEW public.dwh_vm_device_history_view;
DROP VIEW public.dwh_vm_configuration_history_view;
DROP VIEW public.dwh_tags_details_history_view;
DROP VIEW public.dwh_storage_domain_history_view;
DROP VIEW public.dwh_storage_domain_configuration_history_view;
DROP VIEW public.dwh_remove_tags_relations_history_view;
DROP VIEW public.dwh_host_interface_history_view;
DROP VIEW public.dwh_host_interface_configuration_history_view;
DROP VIEW public.dwh_host_history_view;
DROP VIEW public.dwh_host_configuration_history_view;
DROP VIEW public.dwh_host_configuration_full_check_view;
DROP VIEW public.dwh_disk_vm_map_history_view;
DROP VIEW public.dwh_datacenter_storage_map_history_view;
DROP VIEW public.dwh_datacenter_history_view;
DROP VIEW public.dwh_datacenter_configuration_history_view;
DROP VIEW public.dwh_cluster_configuration_history_view;
DROP VIEW public.dwh_add_tags_relations_history_view;
DROP TABLE public.dwh_history_timekeeping;
DROP VIEW public.desktop_vms;
DROP TABLE public.async_tasks_entities;
DROP FUNCTION public.uuid_generate_v1();
DROP FUNCTION public.updatevmtemplatestatus(v_vmt_guid uuid, v_status integer);
DROP FUNCTION public.updatevmtemplate(v_child_count integer, v_creation_date timestamp with time zone, v_description character varying, v_mem_size_mb integer, v_name character varying, v_num_of_sockets integer, v_cpu_per_socket integer, v_os integer, v_vmt_guid uuid, v_vds_group_id uuid, v_domain character varying, v_num_of_monitors integer, v_allow_console_reconnect boolean, v_status integer, v_usb_policy integer, v_time_zone character varying, v_fail_back boolean, v_is_auto_suspend boolean, v_vm_type integer, v_nice_level integer, v_default_boot_sequence integer, v_default_display_type integer, v_priority integer, v_auto_startup boolean, v_is_stateless boolean, v_is_smartcard_enabled boolean, v_is_delete_protected boolean, v_is_disabled boolean, v_iso_path character varying, v_origin integer, v_initrd_url character varying, v_kernel_url character varying, v_kernel_params character varying, v_quota_id uuid, v_migration_support integer, v_dedicated_vm_for_vds uuid, v_min_allocated_mem integer);
DROP FUNCTION public.updatevmtagsdefaultdisplaytype(v_tag_id uuid, v_vm_id uuid, v_defaultdisplaytype integer);
DROP FUNCTION public.updatevmstatistics(v_cpu_sys numeric, v_cpu_user numeric, v_elapsed_time numeric, v_usage_cpu_percent integer, v_usage_mem_percent integer, v_usage_network_percent integer, v_disks_usage text, v_vm_guid uuid);
DROP FUNCTION public.updatevmstatic(v_description character varying, v_mem_size_mb integer, v_os integer, v_vds_group_id uuid, v_vm_guid uuid, v_vm_name character varying, v_vmt_guid uuid, v_domain character varying, v_creation_date timestamp with time zone, v_num_of_monitors integer, v_allow_console_reconnect boolean, v_is_initialized boolean, v_is_auto_suspend boolean, v_num_of_sockets integer, v_cpu_per_socket integer, v_usb_policy integer, v_time_zone character varying, v_auto_startup boolean, v_is_stateless boolean, v_is_smartcard_enabled boolean, v_is_delete_protected boolean, v_dedicated_vm_for_vds uuid, v_fail_back boolean, v_vm_type integer, v_nice_level integer, v_default_boot_sequence integer, v_default_display_type integer, v_priority integer, v_iso_path character varying, v_origin integer, v_initrd_url character varying, v_kernel_url character varying, v_kernel_params character varying, v_migration_support integer, v_predefined_properties character varying, v_userdefined_properties character varying, v_min_allocated_mem integer, v_quota_id uuid, v_cpu_pinning character varying, v_host_cpu_flags boolean);
DROP FUNCTION public.updatevmdynamicstatus(v_vm_guid uuid, v_status integer);
DROP FUNCTION public.updatevmdynamic(v_app_list character varying, v_guest_cur_user_name character varying, v_console_cur_user_name character varying, v_guest_last_login_time timestamp with time zone, v_guest_last_logout_time timestamp with time zone, v_console_user_id uuid, v_guest_os character varying, v_migrating_to_vds uuid, v_run_on_vds uuid, v_status integer, v_vm_guid uuid, v_vm_host character varying, v_vm_ip character varying, v_last_start_time timestamp with time zone, v_vm_pid integer, v_display integer, v_acpi_enable boolean, v_session integer, v_display_ip character varying, v_display_type integer, v_kvm_enable boolean, v_boot_sequence integer, v_display_secure_port integer, v_utc_diff integer, v_last_vds_run_on uuid, v_client_ip character varying, v_guest_requested_memory integer, v_hibernation_vol_handle character varying, v_exit_status integer, v_pause_status integer, v_exit_message character varying, v_hash character varying, v_guest_agent_nics_hash integer);
DROP FUNCTION public.updatevmdeviceruntimeinfo(v_device_id uuid, v_vm_id uuid, v_address character varying, v_alias character varying);
DROP FUNCTION public.updatevmdeviceforhotplugdisk(v_device_id uuid, v_vm_id uuid, v_boot_order integer, v_is_plugged boolean);
DROP FUNCTION public.updatevmdevice(v_device_id uuid, v_vm_id uuid, v_device character varying, v_type character varying, v_address character varying, v_boot_order integer, v_spec_params text, v_is_managed boolean, v_is_plugged boolean, v_is_readonly boolean, v_alias character varying);
DROP FUNCTION public.updatevm_pools(v_vm_pool_description character varying, v_vm_pool_id uuid, v_vm_pool_name character varying, v_vm_pool_type integer, v_parameters character varying, v_prestarted_vms integer, v_vds_group_id uuid);
DROP FUNCTION public.updatevm_pool_map(v_vm_guid uuid, v_vm_pool_id uuid);
DROP FUNCTION public.updatevm_interface_statistics(v_id uuid, v_rx_drop numeric, v_rx_rate numeric, v_tx_drop numeric, v_tx_rate numeric, v_iface_status integer, v_vm_id uuid);
DROP FUNCTION public.updatevm_interface(v_id uuid, v_mac_addr character varying, v_name character varying, v_network_name character varying, v_speed integer, v_vm_guid uuid, v_vmt_guid uuid, v_type integer, v_port_mirroring boolean, v_linked boolean);
DROP FUNCTION public.updatevdsstatistics(v_cpu_idle numeric, v_cpu_load numeric, v_cpu_sys numeric, v_cpu_user numeric, v_usage_cpu_percent integer, v_usage_mem_percent integer, v_usage_network_percent integer, v_vds_id uuid, v_mem_available bigint, v_mem_shared bigint, v_swap_free bigint, v_swap_total bigint, v_ksm_cpu_percent integer, v_ksm_pages bigint, v_ksm_state boolean);
DROP FUNCTION public.updatevdsstatic(v_host_name character varying, v_ip character varying, v_vds_unique_id character varying, v_port integer, v_vds_group_id uuid, v_vds_id uuid, v_vds_name character varying, v_server_ssl_enabled boolean, v_vds_type integer, v_vds_strength integer, v_pm_type character varying, v_pm_user character varying, v_pm_password character varying, v_pm_port integer, v_pm_options character varying, v_pm_enabled boolean, v_pm_proxy_preferences character varying, v_pm_secondary_ip character varying, v_pm_secondary_type character varying, v_pm_secondary_user character varying, v_pm_secondary_password text, v_pm_secondary_port integer, v_pm_secondary_options character varying, v_pm_secondary_concurrent boolean, v_otp_validity bigint, v_vds_spm_priority integer, v_sshkeyfingerprint character varying, v_console_address character varying);
DROP FUNCTION public.updatevdsgroup(v_description character varying, v_name character varying, v_vds_group_id uuid, v_cpu_name character varying, v_selection_algorithm integer, v_high_utilization integer, v_low_utilization integer, v_cpu_over_commit_duration_minutes integer, v_storage_pool_id uuid, v_max_vds_memory_over_commit integer, v_count_threads_as_cores boolean, v_compatibility_version character varying, v_transparent_hugepages boolean, v_migrate_on_error integer, v_virt_service boolean, v_gluster_service boolean);
DROP FUNCTION public.updatevdsdynamicstatus(v_vds_guid uuid, v_status integer);
DROP FUNCTION public.updatevdsdynamic(v_cpu_cores integer, v_cpu_threads integer, v_cpu_model character varying, v_cpu_speed_mh numeric, v_if_total_speed character varying, v_kvm_enabled boolean, v_mem_commited integer, v_physical_mem_mb integer, v_status integer, v_vds_id uuid, v_vm_active integer, v_vm_count integer, v_vms_cores_count integer, v_vm_migrating integer, v_reserved_mem integer, v_guest_overhead integer, v_rpm_version character varying, v_software_version character varying, v_version_name character varying, v_build_name character varying, v_previous_status integer, v_cpu_flags character varying, v_cpu_over_commit_time_stamp timestamp with time zone, v_pending_vcpus_count integer, v_pending_vmem_size integer, v_cpu_sockets integer, v_net_config_dirty boolean, v_supported_cluster_levels character varying, v_supported_engines character varying, v_host_os character varying, v_kvm_version character varying, v_libvirt_version character varying, v_spice_version character varying, v_kernel_version character varying, v_iscsi_initiator_name character varying, v_transparent_hugepages_state integer, v_anonymous_hugepages integer, v_hooks character varying, v_non_operational_reason integer, v_hw_manufacturer character varying, v_hw_product_name character varying, v_hw_version character varying, v_hw_serial_number character varying, v_hw_uuid character varying, v_hw_family character varying);
DROP FUNCTION public.updatevds_interface_statistics(v_id uuid, v_rx_drop numeric, v_rx_rate numeric, v_tx_drop numeric, v_tx_rate numeric, v_iface_status integer, v_vds_id uuid);
DROP FUNCTION public.updatevds_interface(v_addr character varying, v_bond_name character varying, v_bond_type integer, v_gateway character varying, v_id uuid, v_is_bond boolean, v_bond_opts character varying, v_mac_addr character varying, v_name character varying, v_network_name character varying, v_speed integer, v_subnet character varying, v_boot_protocol integer, v_type integer, v_vds_id uuid, v_vlan_id integer, v_mtu integer, v_bridged boolean);
DROP FUNCTION public.updatevdcoption(v_option_name character varying, v_option_value character varying, v_option_id integer, v_version character varying);
DROP FUNCTION public.updateuser(v_department character varying, v_desktop_device character varying, v_domain character varying, v_email character varying, v_groups character varying, v_name character varying, v_note character varying, v_role character varying, v_status integer, v_surname character varying, v_user_icon_path character varying, v_user_id uuid, v_session_count integer, v_username character varying, v_last_admin_check_status boolean, v_group_ids character varying);
DROP FUNCTION public.updatetags_vm_pool_map(v_tag_id integer, v_vm_pool_id integer);
DROP FUNCTION public.updatetags(v_description character varying, v_tag_id uuid, v_tag_name character varying, v_parent_id uuid, v_readonly boolean, v_type integer);
DROP FUNCTION public.updatestripecount(v_volume_id uuid, v_stripe_count integer);
DROP FUNCTION public.updatestorage_server_connections(v_connection character varying, v_id character varying, v_iqn character varying, v_password text, v_storage_type integer, v_port character varying, v_portal character varying, v_user_name character varying, v_mount_options character varying, v_vfs_type character varying, v_nfs_version character varying, v_nfs_timeo smallint, v_nfs_retrans smallint);
DROP FUNCTION public.updatestorage_pool_status(v_id uuid, v_status integer);
DROP FUNCTION public.updatestorage_pool_partial(v_description character varying, v_id uuid, v_name character varying, v_storage_pool_type integer, v_storage_pool_format_type character varying, v_compatibility_version character varying, v_quota_enforcement_type integer);
DROP FUNCTION public.updatestorage_pool_iso_map_status(v_storage_id uuid, v_storage_pool_id uuid, v_status integer);
DROP FUNCTION public.updatestorage_pool_iso_map(v_storage_id uuid, v_storage_pool_id uuid, v_status integer, v_owner integer);
DROP FUNCTION public.updatestorage_pool(v_description character varying, v_id uuid, v_name character varying, v_storage_pool_type integer, v_status integer, v_storage_pool_format_type character varying, v_master_domain_version integer, v_spm_vds_id uuid, v_compatibility_version character varying, v_quota_enforcement_type integer);
DROP FUNCTION public.updatestorage_domain_static(v_id uuid, v_storage character varying, v_storage_name character varying, v_storage_type integer, v_storage_domain_type integer, v_storage_domain_format_type integer, v_last_time_used_as_master bigint);
DROP FUNCTION public.updatestorage_domain_dynamic(v_available_disk_size integer, v_id uuid, v_used_disk_size integer);
DROP FUNCTION public.updatestepstatusandendtime(v_step_id uuid, v_status character varying, v_end_time timestamp with time zone);
DROP FUNCTION public.updatestepexternalidandtype(v_step_id uuid, v_external_id uuid, v_external_system_type character varying);
DROP FUNCTION public.updatestep(v_step_id uuid, v_parent_step_id uuid, v_job_id uuid, v_step_type character varying, v_description text, v_step_number integer, v_status character varying, v_start_time timestamp with time zone, v_end_time timestamp with time zone, v_correlation_id character varying, v_external_id uuid, v_external_system_type character varying);
DROP FUNCTION public.updatestartedexecutionentitiestounknown(v_end_time timestamp with time zone);
DROP FUNCTION public.updatesnapshotstatus(v_snapshot_id uuid, v_status character varying);
DROP FUNCTION public.updatesnapshotid(v_snapshot_id uuid, v_new_snapshot_id uuid);
DROP FUNCTION public.updatesnapshot(v_snapshot_id uuid, v_vm_id uuid, v_snapshot_type character varying, v_status character varying, v_description character varying, v_creation_date timestamp with time zone, v_app_list text, v_vm_configuration text);
DROP FUNCTION public.updateroles_relations(v_role_container_id uuid, v_role_id uuid);
DROP FUNCTION public.updaterole(v_description character varying, v_id uuid, v_name character varying, v_is_readonly boolean, v_role_type integer, v_allows_viewing_children boolean);
DROP FUNCTION public.updatereplicacount(v_volume_id uuid, v_replica_count integer);
DROP FUNCTION public.updatequotametadata(v_id uuid, v_storage_pool_id uuid, v_quota_name character varying, v_description character varying, v_threshold_vds_group_percentage integer, v_threshold_storage_percentage integer, v_grace_vds_group_percentage integer, v_grace_storage_percentage integer);
DROP FUNCTION public.updatequotaforimageandsnapshots(v_image_group_id uuid, v_quota_id uuid);
DROP FUNCTION public.updateovfgenerations(v_vms_ids character varying, v_vms_db_generations character varying);
DROP FUNCTION public.updatenetwork_cluster_status(v_cluster_id uuid, v_network_id uuid, v_status integer);
DROP FUNCTION public.updatenetwork_cluster(v_cluster_id uuid, v_network_id uuid, v_status integer, v_is_display boolean, v_required boolean);
DROP FUNCTION public.updatenetwork(v_addr character varying, v_description character varying, v_id uuid, v_name character varying, v_subnet character varying, v_gateway character varying, v_type integer, v_vlan_id integer, v_stp boolean, v_storage_pool_id uuid, v_mtu integer, v_vm_network boolean);
DROP FUNCTION public.updatematerializedviewrefreshrate(v_matview name, v_refresh_rate integer);
DROP FUNCTION public.updatematerializedviewminrefreshrate(v_matview name, v_min_refresh_rate integer);
DROP FUNCTION public.updatelunsvolumegroupid(v_lun_id character varying, v_volume_group_id character varying);
DROP FUNCTION public.updatelun_storage_server_connection_map(v_lun_id character varying, v_storage_server_connection character varying);
DROP FUNCTION public.updatelastadmincheckstatus(v_userids character varying);
DROP FUNCTION public.updatejobstepscompleted(v_job_id uuid, v_status character varying, v_end_time timestamp with time zone);
DROP FUNCTION public.updatejoblastupdatetime(v_job_id uuid, v_last_update_time timestamp with time zone);
DROP FUNCTION public.updatejob(v_job_id uuid, v_action_type character varying, v_description text, v_status character varying, v_owner_id uuid, v_visible boolean, v_start_time timestamp with time zone, v_end_time timestamp with time zone, v_last_update_time timestamp with time zone, v_correlation_id character varying);
DROP FUNCTION public.updateisinitialized(v_vm_guid uuid, v_is_initialized boolean);
DROP FUNCTION public.updateimagevmsnapshotid(v_image_id uuid, v_vm_snapshot_id uuid);
DROP FUNCTION public.updateimagestatus(v_image_id uuid, v_status integer);
DROP FUNCTION public.updateimage(v_creation_date timestamp with time zone, v_image_guid uuid, v_it_guid uuid, v_size bigint, v_parentid uuid, v_imagestatus integer, v_lastmodified timestamp with time zone, v_vm_snapshot_id uuid, v_volume_type integer, v_volume_format integer, v_image_group_id uuid, v_active boolean, v_quota_id uuid);
DROP FUNCTION public.updateglustervolumestatusbyname(v_cluster_id uuid, v_vol_name character varying, v_status character varying);
DROP FUNCTION public.updateglustervolumestatus(v_volume_id uuid, v_status character varying);
DROP FUNCTION public.updateglustervolumeoption(v_id uuid, v_option_val character varying);
DROP FUNCTION public.updateglustervolumebrickstatus(v_id uuid, v_status character varying);
DROP FUNCTION public.updateglustervolumebrickorder(v_id uuid, v_brick_order integer);
DROP FUNCTION public.updateglustervolumebrick(v_id uuid, v_new_id uuid, v_new_server_id uuid, v_new_brick_dir character varying, v_new_status character varying);
DROP FUNCTION public.updateglustervolume(v_id uuid, v_cluster_id uuid, v_vol_name character varying, v_vol_type character varying, v_status character varying, v_replica_count integer, v_stripe_count integer);
DROP FUNCTION public.updateevent_subscriber(v_event_up_name character varying, v_old_method_id integer, v_new_method_id integer, v_subscriber_id uuid);
DROP FUNCTION public.updatedisk_image_dynamic(v_image_id uuid, v_read_rate integer, v_write_rate integer, v_actual_size bigint, v_read_latency_seconds numeric, v_write_latency_seconds numeric, v_flush_latency_seconds numeric);
DROP FUNCTION public.updatecustom_actions(v_action_id integer, v_action_name character varying, v_path character varying, v_tab integer, v_description character varying);
DROP FUNCTION public.updateconsoleuserwithoptimisticlocking(v_vm_guid uuid, v_console_user_id uuid, v_guest_cur_user_name character varying, v_console_cur_user_name character varying, OUT v_updated boolean);
DROP FUNCTION public.updatebookmark(v_bookmark_id uuid, v_bookmark_name character varying, v_bookmark_value character varying);
DROP FUNCTION public.updatebasedisk(v_disk_id uuid, v_disk_interface character varying, v_wipe_after_delete boolean, v_propagate_errors character varying, v_disk_alias character varying, v_disk_description character varying, v_shareable boolean, v_boot boolean);
DROP FUNCTION public.updateasync_tasks(v_action_type integer, v_result integer, v_status integer, v_task_id uuid, v_action_parameters text, v_action_params_class character varying, v_task_parameters text, v_task_params_class character varying, v_step_id uuid, v_command_id uuid);
DROP FUNCTION public.updatead_groups(v_id uuid, v_name character varying, v_status integer, v_domain character varying, v_distinguishedname character varying);
DROP FUNCTION public.to_interval(sec integer);
DROP FUNCTION public.set_network_exclusively_as_display(v_cluster_id uuid, v_network_id uuid);
DROP FUNCTION public.removeallvmtagsbyvmid(v_vm_id uuid);
DROP FUNCTION public.refreshmaterializedview(v_matview name);
DROP FUNCTION public.refreshallmaterializedviews(v_force boolean);
DROP FUNCTION public.isquotainuse(v_quota_id uuid);
DROP FUNCTION public.ismemballoonenabled(v_vm_id uuid);
DROP FUNCTION public.ismaterializedviewrefreshed(v_matview name);
DROP FUNCTION public.isloggingenabled(errorcode text);
DROP FUNCTION public.inst_update_default_storage_pool_type(v_storage_pool_type integer);
DROP FUNCTION public.inst_add_iso_storage_domain(v_storage_domain_id uuid, v_name character varying, v_connection_id uuid, v_connection character varying, v_available integer, v_used integer);
DROP FUNCTION public.insertvmtemplate(v_child_count integer, v_creation_date timestamp with time zone, v_description character varying, v_mem_size_mb integer, v_name character varying, v_num_of_sockets integer, v_cpu_per_socket integer, v_os integer, v_vmt_guid uuid, v_vds_group_id uuid, v_domain character varying, v_num_of_monitors integer, v_allow_console_reconnect boolean, v_status integer, v_usb_policy integer, v_time_zone character varying, v_fail_back boolean, v_is_auto_suspend boolean, v_vm_type integer, v_nice_level integer, v_default_boot_sequence integer, v_default_display_type integer, v_priority integer, v_auto_startup boolean, v_is_stateless boolean, v_is_smartcard_enabled boolean, v_is_delete_protected boolean, v_is_disabled boolean, v_iso_path character varying, v_origin integer, v_initrd_url character varying, v_kernel_url character varying, v_kernel_params character varying, v_quota_id uuid, v_migration_support integer, v_dedicated_vm_for_vds uuid, v_min_allocated_mem integer);
DROP FUNCTION public.insertvmstatistics(v_cpu_sys numeric, v_cpu_user numeric, v_elapsed_time numeric, v_usage_cpu_percent integer, v_usage_mem_percent integer, v_usage_network_percent integer, v_disks_usage text, v_vm_guid uuid);
DROP FUNCTION public.insertvmstatic(v_description character varying, v_mem_size_mb integer, v_os integer, v_vds_group_id uuid, v_vm_guid uuid, v_vm_name character varying, v_vmt_guid uuid, v_domain character varying, v_creation_date timestamp with time zone, v_num_of_monitors integer, v_allow_console_reconnect boolean, v_is_initialized boolean, v_is_auto_suspend boolean, v_num_of_sockets integer, v_cpu_per_socket integer, v_usb_policy integer, v_time_zone character varying, v_auto_startup boolean, v_is_stateless boolean, v_is_smartcard_enabled boolean, v_is_delete_protected boolean, v_dedicated_vm_for_vds uuid, v_fail_back boolean, v_vm_type integer, v_nice_level integer, v_default_boot_sequence integer, v_default_display_type integer, v_priority integer, v_iso_path character varying, v_origin integer, v_initrd_url character varying, v_kernel_url character varying, v_kernel_params character varying, v_migration_support integer, v_predefined_properties character varying, v_userdefined_properties character varying, v_min_allocated_mem integer, v_quota_id uuid, v_cpu_pinning character varying, v_host_cpu_flags boolean);
DROP FUNCTION public.insertvmguestagentinterface(v_vm_id uuid, v_interface_name character varying, v_mac_address character varying, v_ipv4_addresses text, v_ipv6_addresses text);
DROP FUNCTION public.insertvmdynamic(v_app_list character varying, v_guest_cur_user_name character varying, v_console_cur_user_name character varying, v_guest_last_login_time timestamp with time zone, v_guest_last_logout_time timestamp with time zone, v_console_user_id uuid, v_guest_os character varying, v_migrating_to_vds uuid, v_run_on_vds uuid, v_status integer, v_vm_guid uuid, v_vm_host character varying, v_vm_ip character varying, v_last_start_time timestamp with time zone, v_vm_pid integer, v_display integer, v_acpi_enable boolean, v_session integer, v_display_ip character varying, v_display_type integer, v_kvm_enable boolean, v_boot_sequence integer, v_display_secure_port integer, v_utc_diff integer, v_last_vds_run_on uuid, v_client_ip character varying, v_guest_requested_memory integer, v_hibernation_vol_handle character varying, v_exit_status integer, v_pause_status integer, v_exit_message character varying, v_guest_agent_nics_hash integer);
DROP FUNCTION public.insertvmdevice(v_device_id uuid, v_vm_id uuid, v_device character varying, v_type character varying, v_address character varying, v_boot_order integer, v_spec_params text, v_is_managed boolean, v_is_plugged boolean, v_is_readonly boolean, v_alias character varying);
DROP FUNCTION public.insertvm_pools(v_vm_pool_description character varying, v_vm_pool_id uuid, v_vm_pool_name character varying, v_vm_pool_type integer, v_parameters character varying, v_prestarted_vms integer, v_vds_group_id uuid);
DROP FUNCTION public.insertvm_pool_map(v_vm_guid uuid, v_vm_pool_id uuid);
DROP FUNCTION public.insertvm_interface_statistics(v_id uuid, v_rx_drop numeric, v_rx_rate numeric, v_tx_drop numeric, v_tx_rate numeric, v_iface_status integer, v_vm_id uuid);
DROP FUNCTION public.insertvm_interface(v_id uuid, v_mac_addr character varying, v_name character varying, v_network_name character varying, v_speed integer, v_vm_guid uuid, v_vmt_guid uuid, v_type integer, v_port_mirroring boolean, v_linked boolean);
DROP FUNCTION public.insertvm(v_description character varying, v_mem_size_mb integer, v_os integer, v_vds_group_id uuid, v_vm_guid uuid, v_vm_name character varying, v_vmt_guid uuid, v_num_of_monitors integer, v_allow_console_reconnect boolean, v_is_initialized boolean, v_is_auto_suspend boolean, v_num_of_sockets integer, v_cpu_per_socket integer, v_usb_policy integer, v_time_zone character varying, v_auto_startup boolean, v_is_stateless boolean, v_is_smartcard_enabled boolean, v_is_delete_protected boolean, v_dedicated_vm_for_vds uuid, v_fail_back boolean, v_vm_type integer, v_nice_level integer, v_default_boot_sequence integer, v_default_display_type integer, v_priority integer, v_iso_path character varying, v_origin integer, v_initrd_url character varying, v_kernel_url character varying, v_kernel_params character varying, v_migration_support integer, v_predefined_properties character varying, v_userdefined_properties character varying, v_min_allocated_mem integer, v_cpu_pinning character varying, v_host_cpu_flags boolean);
DROP FUNCTION public.insertvdsstatistics(v_cpu_idle numeric, v_cpu_load numeric, v_cpu_sys numeric, v_cpu_user numeric, v_usage_cpu_percent integer, v_usage_mem_percent integer, v_usage_network_percent integer, v_vds_id uuid, v_mem_available bigint, v_mem_shared bigint, v_swap_free bigint, v_swap_total bigint, v_ksm_cpu_percent integer, v_ksm_pages bigint, v_ksm_state boolean);
DROP FUNCTION public.insertvdsstatic(v_vds_id uuid, v_host_name character varying, v_ip character varying, v_vds_unique_id character varying, v_port integer, v_vds_group_id uuid, v_vds_name character varying, v_server_ssl_enabled boolean, v_vds_type integer, v_vds_strength integer, v_pm_type character varying, v_pm_user character varying, v_pm_password character varying, v_pm_port integer, v_pm_options character varying, v_pm_enabled boolean, v_pm_proxy_preferences character varying, v_pm_secondary_ip character varying, v_pm_secondary_type character varying, v_pm_secondary_user character varying, v_pm_secondary_password text, v_pm_secondary_port integer, v_pm_secondary_options character varying, v_pm_secondary_concurrent boolean, v_vds_spm_priority integer, v_sshkeyfingerprint character varying, v_console_address character varying);
DROP FUNCTION public.insertvdsgroups(v_vds_group_id uuid, v_description character varying, v_name character varying, v_cpu_name character varying, v_selection_algorithm integer, v_high_utilization integer, v_low_utilization integer, v_cpu_over_commit_duration_minutes integer, v_storage_pool_id uuid, v_max_vds_memory_over_commit integer, v_count_threads_as_cores boolean, v_compatibility_version character varying, v_transparent_hugepages boolean, v_migrate_on_error integer, v_virt_service boolean, v_gluster_service boolean);
DROP FUNCTION public.insertvdsdynamic(v_cpu_cores integer, v_cpu_threads integer, v_cpu_model character varying, v_cpu_speed_mh numeric, v_if_total_speed character varying, v_kvm_enabled boolean, v_mem_commited integer, v_physical_mem_mb integer, v_status integer, v_vds_id uuid, v_vm_active integer, v_vm_count integer, v_vms_cores_count integer, v_vm_migrating integer, v_reserved_mem integer, v_guest_overhead integer, v_rpm_version character varying, v_software_version character varying, v_version_name character varying, v_build_name character varying, v_previous_status integer, v_cpu_flags character varying, v_cpu_over_commit_time_stamp timestamp with time zone, v_pending_vcpus_count integer, v_pending_vmem_size integer, v_cpu_sockets integer, v_net_config_dirty boolean, v_supported_cluster_levels character varying, v_supported_engines character varying, v_host_os character varying, v_kvm_version character varying, v_libvirt_version character varying, v_spice_version character varying, v_kernel_version character varying, v_iscsi_initiator_name character varying, v_transparent_hugepages_state integer, v_anonymous_hugepages integer, v_hooks character varying, v_hw_manufacturer character varying, v_hw_product_name character varying, v_hw_version character varying, v_hw_serial_number character varying, v_hw_uuid character varying, v_hw_family character varying);
DROP FUNCTION public.insertvds_spm_id_map(v_storage_pool_id uuid, v_vds_id uuid, v_vds_spm_id integer);
DROP FUNCTION public.insertvds_interface_statistics(v_id uuid, v_rx_drop numeric, v_rx_rate numeric, v_tx_drop numeric, v_tx_rate numeric, v_iface_status integer, v_vds_id uuid);
DROP FUNCTION public.insertvds_interface(v_addr character varying, v_bond_name character varying, v_bond_type integer, v_gateway character varying, v_id uuid, v_is_bond boolean, v_bond_opts character varying, v_mac_addr character varying, v_name character varying, v_network_name character varying, v_speed integer, v_subnet character varying, v_boot_protocol integer, v_type integer, v_vds_id uuid, v_vlan_id integer, v_mtu integer, v_bridged boolean);
DROP FUNCTION public.insertvds(v_vds_id uuid, v_host_name character varying, v_ip character varying, v_vds_unique_id character varying, v_port integer, v_vds_group_id uuid, v_vds_name character varying, v_server_ssl_enabled boolean, v_vds_type integer, v_vds_strength integer, v_pm_type character varying, v_pm_user character varying, v_pm_password character varying, v_pm_port integer, v_pm_options character varying, v_pm_enabled boolean, v_pm_proxy_preferences character varying, v_pm_secondary_ip character varying, v_pm_secondary_type character varying, v_pm_secondary_user character varying, v_pm_secondary_password text, v_pm_secondary_port integer, v_pm_secondary_options character varying, v_pm_secondary_concurrent boolean, v_vds_spm_priority integer, v_console_address character varying);
DROP FUNCTION public.insertvdcoption(v_option_name character varying, v_option_value character varying, v_version character varying, INOUT v_option_id integer);
DROP FUNCTION public.insertuser_sessions(v_browser character, v_client_type character, v_login_time timestamp with time zone, v_os character, v_session_id character, v_user_id uuid);
DROP FUNCTION public.insertuser(v_department character varying, v_desktop_device character varying, v_domain character varying, v_email character varying, v_groups character varying, v_name character varying, v_note character varying, v_role character varying, v_status integer, v_surname character varying, v_user_icon_path character varying, v_user_id uuid, v_session_count integer, v_username character varying, v_group_ids character varying);
DROP FUNCTION public.inserttags_vm_pool_map(v_tag_id uuid, v_vm_pool_id uuid);
DROP FUNCTION public.inserttags_vm_map(v_tag_id uuid, v_vm_id uuid, v_defaultdisplaytype integer);
DROP FUNCTION public.inserttags_vds_map(v_tag_id uuid, v_vds_id uuid);
DROP FUNCTION public.inserttags_user_map(v_tag_id uuid, v_user_id uuid);
DROP FUNCTION public.inserttags_user_group_map(v_group_id uuid, v_tag_id uuid);
DROP FUNCTION public.inserttags(v_description character varying, v_tag_id uuid, v_tag_name character varying, v_parent_id uuid, v_readonly boolean, v_type integer);
DROP FUNCTION public.insertstorage_server_connections(v_connection character varying, v_id character varying, v_iqn character varying, v_port character varying, v_portal character varying, v_password text, v_storage_type integer, v_user_name character varying, v_mount_options character varying, v_vfs_type character varying, v_nfs_version character varying, v_nfs_timeo smallint, v_nfs_retrans smallint);
DROP FUNCTION public.insertstorage_pool_iso_map(v_storage_id uuid, v_storage_pool_id uuid, v_status integer, v_owner integer);
DROP FUNCTION public.insertstorage_pool(v_description character varying, v_id uuid, v_name character varying, v_storage_pool_type integer, v_status integer, v_master_domain_version integer, v_spm_vds_id uuid, v_compatibility_version character varying, v_quota_enforcement_type integer);
DROP FUNCTION public.insertstorage_domain_static(v_id uuid, v_storage character varying, v_storage_name character varying, v_storage_type integer, v_storage_domain_type integer, v_storage_domain_format_type character varying, v_last_time_used_as_master bigint);
DROP FUNCTION public.insertstorage_domain_dynamic(v_available_disk_size integer, v_id uuid, v_used_disk_size integer);
DROP FUNCTION public.insertstep(v_step_id uuid, v_parent_step_id uuid, v_job_id uuid, v_step_type character varying, v_description text, v_step_number integer, v_status character varying, v_start_time timestamp with time zone, v_end_time timestamp with time zone, v_correlation_id character varying, v_external_id uuid, v_external_system_type character varying);
DROP FUNCTION public.insertsnapshot(v_snapshot_id uuid, v_vm_id uuid, v_snapshot_type character varying, v_status character varying, v_description character varying, v_creation_date timestamp with time zone, v_app_list text, v_vm_configuration text);
DROP FUNCTION public.insertroles_relations(v_role_container_id uuid, v_role_id uuid);
DROP FUNCTION public.insertrole(v_description character varying, v_id uuid, v_name character varying, v_is_readonly boolean, v_role_type integer, v_allows_viewing_children boolean);
DROP FUNCTION public.insertrepo_domain_file_meta_data(v_repo_domain_id uuid, v_repo_file_name character varying, v_size bigint, v_date_created timestamp with time zone, v_last_refreshed bigint, v_file_type integer);
DROP FUNCTION public.insertquotalimitation(v_id uuid, v_quota_id uuid, v_storage_id uuid, v_vds_group_id uuid, v_virtual_cpu integer, v_mem_size_mb bigint, v_storage_size_gb bigint);
DROP FUNCTION public.insertquota(v_id uuid, v_storage_pool_id uuid, v_quota_name character varying, v_description character varying, v_threshold_vds_group_percentage integer, v_threshold_storage_percentage integer, v_grace_vds_group_percentage integer, v_grace_storage_percentage integer);
DROP FUNCTION public.insertpermission(v_ad_element_id uuid, v_id uuid, v_role_id uuid, v_object_id uuid, v_object_type_id integer);
DROP FUNCTION public.insertorupdateasynctasks(v_action_type integer, v_result integer, v_status integer, v_task_id uuid, v_action_parameters text, v_action_params_class character varying, v_task_parameters text, v_task_params_class character varying, v_step_id uuid, v_command_id uuid, v_entity_type character varying, v_started_at timestamp without time zone, v_storage_pool_id uuid, v_async_task_type integer, v_entity_ids text);
DROP FUNCTION public.insertnetwork_cluster(v_cluster_id uuid, v_network_id uuid, v_status integer, v_is_display boolean, v_required boolean);
DROP FUNCTION public.insertnetwork(v_addr character varying, v_description character varying, v_id uuid, v_name character varying, v_subnet character varying, v_gateway character varying, v_type integer, v_vlan_id integer, v_stp boolean, v_storage_pool_id uuid, v_mtu integer, v_vm_network boolean);
DROP FUNCTION public.insertluns(v_lun_id character varying, v_physical_volume_id character varying, v_volume_group_id character varying, v_serial character varying, v_lun_mapping integer, v_vendor_id character varying, v_product_id character varying, v_device_size integer);
DROP FUNCTION public.insertlun_storage_server_connection_map(v_lun_id character varying, v_storage_server_connection character varying);
DROP FUNCTION public.insertjobsubjectentity(v_job_id uuid, v_entity_id uuid, v_entity_type character varying);
DROP FUNCTION public.insertjob(v_job_id uuid, v_action_type character varying, v_description text, v_status character varying, v_owner_id uuid, v_visible boolean, v_start_time timestamp with time zone, v_end_time timestamp with time zone, v_last_update_time timestamp with time zone, v_correlation_id character varying);
DROP FUNCTION public.insertimage_storage_domain_map(v_image_id uuid, v_storage_domain_id uuid);
DROP FUNCTION public.insertimage(v_creation_date timestamp with time zone, v_image_guid uuid, v_it_guid uuid, v_size bigint, v_parentid uuid, v_imagestatus integer, v_lastmodified timestamp with time zone, v_vm_snapshot_id uuid, v_volume_type integer, v_volume_format integer, v_image_group_id uuid, v_active boolean, v_quota_id uuid);
DROP FUNCTION public.insertglustervolumetransporttype(v_volume_id uuid, v_transport_type character varying);
DROP FUNCTION public.insertglustervolumeoption(v_id uuid, v_volume_id uuid, v_option_key character varying, v_option_val character varying);
DROP FUNCTION public.insertglustervolumebrick(v_id uuid, v_volume_id uuid, v_server_id uuid, v_brick_dir character varying, v_brick_order integer, v_status character varying);
DROP FUNCTION public.insertglustervolumeaccessprotocol(v_volume_id uuid, v_access_protocol character varying);
DROP FUNCTION public.insertglustervolume(v_id uuid, v_cluster_id uuid, v_vol_name character varying, v_vol_type character varying, v_status character varying, v_replica_count integer, v_stripe_count integer);
DROP FUNCTION public.insertexternalauditlog(INOUT v_audit_log_id integer, v_log_time timestamp with time zone, v_log_type integer, v_log_type_name character varying, v_severity integer, v_message text, v_user_id uuid, v_user_name character varying, v_vds_id uuid, v_vds_name character varying, v_vm_id uuid, v_vm_name character varying, v_vm_template_id uuid, v_vm_template_name character varying, v_storage_pool_id uuid, v_storage_pool_name character varying, v_storage_domain_id uuid, v_storage_domain_name character varying, v_vds_group_id uuid, v_vds_group_name character varying, v_quota_id uuid, v_quota_name character varying, v_correlation_id character varying, v_job_id uuid, v_gluster_volume_id uuid, v_gluster_volume_name character varying, v_origin character varying, v_custom_event_id integer, v_event_flood_in_sec integer, v_custom_data text);
DROP FUNCTION public.insertevent_subscriber(v_event_up_name character varying, v_method_id integer, v_method_address character varying, v_subscriber_id uuid, v_tag_name character varying);
DROP FUNCTION public.insertevent_notification_hist(v_audit_log_id bigint, v_event_name character varying, v_method_type character, v_reason character, v_sent_at timestamp with time zone, v_status boolean, v_subscriber_id character varying);
DROP FUNCTION public.insertdisklunmap(v_disk_id uuid, v_lun_id character varying);
DROP FUNCTION public.insertdisk_image_dynamic(v_image_id uuid, v_read_rate integer, v_write_rate integer, v_actual_size bigint, v_read_latency_seconds numeric, v_write_latency_seconds numeric, v_flush_latency_seconds numeric);
DROP FUNCTION public.insertcustom_actions(INOUT v_action_id integer, v_action_name character varying, v_path character varying, v_tab integer, v_description character varying);
DROP FUNCTION public.insertbookmark(v_bookmark_id uuid, v_bookmark_name character varying, v_bookmark_value character varying);
DROP FUNCTION public.insertbasedisk(v_disk_id uuid, v_disk_interface character varying, v_wipe_after_delete boolean, v_propagate_errors character varying, v_disk_alias character varying, v_disk_description character varying, v_shareable boolean, v_boot boolean);
DROP FUNCTION public.insertauditlog(INOUT v_audit_log_id integer, v_log_time timestamp with time zone, v_log_type integer, v_log_type_name character varying, v_severity integer, v_message text, v_user_id uuid, v_user_name character varying, v_vds_id uuid, v_vds_name character varying, v_vm_id uuid, v_vm_name character varying, v_vm_template_id uuid, v_vm_template_name character varying, v_storage_pool_id uuid, v_storage_pool_name character varying, v_storage_domain_id uuid, v_storage_domain_name character varying, v_vds_group_id uuid, v_vds_group_name character varying, v_quota_id uuid, v_quota_name character varying, v_correlation_id character varying, v_job_id uuid, v_gluster_volume_id uuid, v_gluster_volume_name character varying);
DROP FUNCTION public.insertasync_tasks(v_action_type integer, v_result integer, v_status integer, v_task_id uuid, v_action_parameters text, v_action_params_class character varying, v_task_parameters text, v_task_params_class character varying, v_step_id uuid, v_command_id uuid, v_entity_type character varying, v_started_at timestamp without time zone, v_storage_pool_id uuid, v_async_task_type integer, v_entity_ids text);
DROP FUNCTION public.insertad_groups(v_id uuid, v_name character varying, v_status integer, v_domain character varying, v_distinguishedname character varying);
DROP FUNCTION public.insertaction_version_map(v_action_type integer, v_cluster_minimal_version character varying, v_storage_pool_minimal_version character varying);
DROP FUNCTION public.insert_roles_groups(v_action_group_id integer, v_role_id uuid);
DROP FUNCTION public.insert_entity_snapshot(v_id uuid, v_command_id uuid, v_command_type character varying, v_entity_id character varying, v_entity_type character varying, v_entity_snapshot text, v_snapshot_class character varying, v_snapshot_type integer, v_insertion_order integer);
DROP FUNCTION public.incrementdbgenerationforallinstoragepool(v_storage_pool_id uuid);
DROP FUNCTION public.incrementdbgeneration(v_vm_guid uuid);
DROP FUNCTION public.getvmunmanageddevicesbyvmid(v_vm_id uuid);
DROP FUNCTION public.getvmtemplatesidsforovfupdate(v_storage_pool_id uuid);
DROP FUNCTION public.getvmtemplatesbystoragedomainid(v_storage_domain_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvmtemplatesbynetworkid(v_network_id uuid);
DROP FUNCTION public.getvmtemplatesbyimageid(v_image_guid uuid);
DROP VIEW public.vm_templates_with_plug_info;
DROP FUNCTION public.getvmtemplatesbyids(v_vm_templates_ids character varying);
DROP FUNCTION public.getvmtemplateinterfacesbynetworkid(v_network_id uuid);
DROP FUNCTION public.getvmtemplatebyvmtname(v_vmt_name character varying, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvmtemplatebyvmtguid(v_vmt_guid uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvmtemplatebyvdsgroupid(v_vds_group_id uuid);
DROP FUNCTION public.getvmtagsbytagid(v_tag_ids character varying);
DROP FUNCTION public.getvmstatisticsbyvmguid(v_vm_guid uuid);
DROP FUNCTION public.getvmstaticwithfailbackbyvdsid(v_vds_id uuid);
DROP FUNCTION public.getvmstaticbyvmguid(v_vm_guid uuid);
DROP FUNCTION public.getvmstaticbyvdsgroup(v_vds_group_id uuid);
DROP FUNCTION public.getvmstaticbyname(v_vm_name character varying);
DROP FUNCTION public.getvmstaticbygroupidandnetwork(v_groupid uuid, v_networkname character varying);
DROP FUNCTION public.getvmsrunningonvds(v_vds_id uuid);
DROP FUNCTION public.getvmsmigratingtovds(v_vds_id uuid);
DROP FUNCTION public.getvmsidsforovfupdate(v_storage_pool_id uuid);
DROP FUNCTION public.getvmsdynamicrunningonvds(v_vds_id uuid);
DROP FUNCTION public.getvmsdedicatedtopowerclientbyvdsid(v_dedicated_vm_for_vds uuid);
DROP FUNCTION public.getvmsbyvmtguid(v_vmt_guid uuid);
DROP FUNCTION public.getvmsbyvmpoolid(v_vm_pool_id uuid);
DROP FUNCTION public.getvmsbyuseridwithgroupsanduserroles(v_user_id uuid);
DROP FUNCTION public.getvmsbyuserid(v_user_id uuid);
DROP FUNCTION public.getvmsbystoragedomainid(v_storage_domain_id uuid);
DROP FUNCTION public.getvmsbynetworkid(v_network_id uuid);
DROP FUNCTION public.getvmsbyids(v_vms_ids character varying);
DROP FUNCTION public.getvmsbydiskid(v_disk_guid uuid);
DROP VIEW public.vms_with_plug_info;
DROP FUNCTION public.getvmsbyadgroupnames(v_ad_group_names character varying);
DROP FUNCTION public.getvmmapsinvmpoolbyvmpoolidandstatus(v_vm_pool_id uuid, v_status integer);
DROP FUNCTION public.getvminterfacesbynetworkid(v_network_id uuid);
DROP FUNCTION public.getvmimagebyimageguid(v_image_guid uuid);
DROP FUNCTION public.getvmguestagentinterfacesbyvmid(v_vm_id uuid, v_user_id uuid, v_filtered boolean);
DROP TABLE public.vm_guest_agent_interfaces;
DROP FUNCTION public.getvmdynamicbyvmguid(v_vm_guid uuid);
DROP FUNCTION public.getvmdevicebyvmidtypeanddevice(v_vm_id uuid, v_type character varying, v_device character varying, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvmdevicebyvmidandtype(v_vm_id uuid, v_type character varying);
DROP FUNCTION public.getvmdevicebyvmid(v_vm_id uuid);
DROP FUNCTION public.getvmdevicebydeviceid(v_device_id uuid, v_vm_id uuid);
DROP FUNCTION public.getvmdatafrompoolbypoolid(v_pool_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvmbyvmnamefordatacenter(v_data_center_id uuid, v_vm_name character varying, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvmbyvmguid(v_vm_guid uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvmbyhibernationimageid(v_image_id character varying);
DROP FUNCTION public.getvm_poolsbyvm_pool_name(v_vm_pool_name character varying);
DROP FUNCTION public.getvm_poolsbyvm_pool_id(v_vm_pool_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP VIEW public.vm_pools_full_view;
DROP FUNCTION public.getvm_poolsbyadgroup_names(v_ad_group_names character varying);
DROP FUNCTION public.getvm_pool_mapbyvm_pool_id(v_vm_pool_id uuid);
DROP FUNCTION public.getvm_pool_mapbyvm_guid(v_vm_guid uuid);
DROP FUNCTION public.getvm_interfacebyvm_id(v_vm_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvm_interfacebyvm_guidandbyvmt_guid(v_vm_guid uuid, v_vmt_guid uuid);
DROP FUNCTION public.getvm_interfacebytemplate_id(v_template_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvm_interfacebyid(v_id uuid);
DROP FUNCTION public.getvm_interface_statisticsbyid(v_id uuid);
DROP FUNCTION public.getvdswithoutnetwork(v_network_id uuid);
DROP FUNCTION public.getvdswithoutmigratingvmsbyvdsgroupid(v_vds_group_id uuid);
DROP FUNCTION public.getvdstagsbytagids(v_tag_ids character varying);
DROP FUNCTION public.getvdsstatisticsbyvdsid(v_vds_id uuid);
DROP FUNCTION public.getvdsstaticbyvdsname(v_vds_name character varying);
DROP FUNCTION public.getvdsstaticbyvdsid(v_vds_id uuid);
DROP FUNCTION public.getvdsstaticbyvdsgroupid(v_vds_group_id uuid);
DROP FUNCTION public.getvdsstaticbyip(v_ip character varying);
DROP FUNCTION public.getvdsstaticbyhostname(v_host_name character varying);
DROP FUNCTION public.getvdsmanagedinterfacebyvdsid(v_vds_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvdsinterfacesbynetworkid(v_network_id uuid);
DROP FUNCTION public.getvdsinterfacebyid(v_vds_interface_id uuid);
DROP FUNCTION public.getvdsgroupwithrunningvms(v_vds_group_id uuid);
DROP FUNCTION public.getvdsgroupsbystoragepoolid(v_storage_pool_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvdsgroupforuserbyvdsgroupname(v_vds_group_name character varying, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvdsgroupbyvdsgroupname(v_vds_group_name character varying);
DROP FUNCTION public.getvdsgroupbyvdsgroupid(v_vds_group_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvdsforvdsgroupwithstatus(v_vds_group_id uuid, v_status integer);
DROP FUNCTION public.getvdsdynamicbyvdsid(v_vds_id uuid);
DROP FUNCTION public.getvdsbyvdsid(v_vds_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvdsbyvdsgroupid(v_vds_group_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvdsbyuniqueid(v_vds_unique_id character varying);
DROP FUNCTION public.getvdsbytype(v_vds_type integer);
DROP FUNCTION public.getvdsbystoragepoolidwithstatus(v_storage_pool_id uuid, v_status integer);
DROP FUNCTION public.getvdsbystoragepoolid(v_storage_pool_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getvdsbynetworkid(v_network_id uuid);
DROP FUNCTION public.getvdsbyname(v_vds_name character varying);
DROP FUNCTION public.getvdsbyip(v_ip character varying);
DROP FUNCTION public.getvdsbyhostname(v_host_name character varying);
DROP FUNCTION public.getvds_spm_id_mapbyvds_id(v_vds_id uuid);
DROP FUNCTION public.getvds_spm_id_mapbystorage_pool_idandbyvds_spm_id(v_storage_pool_id uuid, v_vds_spm_id integer);
DROP FUNCTION public.getvds_spm_id_mapbystorage_pool_id(v_storage_pool_id uuid);
DROP FUNCTION public.getvdcoptionbyname(v_option_name character varying, v_version character varying);
DROP FUNCTION public.getvdcoptionbyid(v_option_id integer);
DROP FUNCTION public.getusertagsbytagids(v_tag_ids character varying);
DROP FUNCTION public.getusersbyvmguid(v_vm_guid uuid);
DROP FUNCTION public.getuserpermissionsbyentityid(v_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getusergrouptagsbytagids(v_tag_ids character varying);
DROP FUNCTION public.getuserbyusername(v_username character varying);
DROP FUNCTION public.getuserbyuserid(v_user_id uuid);
DROP FUNCTION public.getuserandgroupsbyid(v_id uuid);
DROP FUNCTION public.getuser_sessionsbysession_idandbyuser_id(v_session_id character, v_user_id uuid);
DROP FUNCTION public.getupandprioritizedvds(v_storage_pool_id uuid);
DROP FUNCTION public.gettransporttypesbyglustervolumeguid(v_volume_id uuid);
DROP TABLE public.gluster_volume_transport_types;
DROP FUNCTION public.gettimeleasedusersvmsbygroupidandpoolid(v_groupid uuid, v_vm_pool_id uuid);
DROP FUNCTION public.gettagvmbytagidandbyvmid(v_tag_id uuid, v_vm_id uuid);
DROP FUNCTION public.gettagvdsbytagidandbyvdsid(v_tag_id uuid, v_vds_id uuid);
DROP FUNCTION public.gettagusergroupbygroupidandbytagid(v_group_id uuid, v_tag_id uuid);
DROP FUNCTION public.gettaguserbytagidandbyuserid(v_tag_id uuid, v_user_id uuid);
DROP FUNCTION public.gettagsbyvmpoolid(v_vm_pool_ids character varying);
DROP VIEW public.tags_vm_pool_map_view;
DROP FUNCTION public.gettagsbyvmid(v_vm_ids character varying);
DROP FUNCTION public.gettagsbyvdsid(v_vds_ids character varying);
DROP FUNCTION public.gettagsbyuserid(v_user_ids character varying);
DROP FUNCTION public.gettagsbyusergroupid(v_group_ids character varying);
DROP FUNCTION public.gettagsbytag_name(v_tag_name character varying);
DROP FUNCTION public.gettagsbytag_id(v_tag_id uuid);
DROP FUNCTION public.gettagsbyparent_id(v_parent_id uuid);
DROP FUNCTION public.gettags_vm_pool_mapbytag_idandbyvm_pool_id(v_tag_id uuid, v_vm_pool_id uuid);
DROP FUNCTION public.gettags_vm_mapbytagname(v_tag_name character varying);
DROP VIEW public.tags_vm_map_view;
DROP FUNCTION public.gettags_vds_mapbytagname(v_tag_name character varying);
DROP VIEW public.tags_vds_map_view;
DROP FUNCTION public.gettags_user_mapbytagname(v_tag_name character varying);
DROP VIEW public.tags_user_map_view;
DROP FUNCTION public.gettags_user_group_mapbytagname(v_tag_name character varying);
DROP VIEW public.tags_user_group_map_view;
DROP FUNCTION public.getsystem_statistics(v_entity character varying, v_status character varying);
DROP FUNCTION public.getstoragepoolsbyclusterservice(v_supports_virt_service boolean, v_supports_gluster_service boolean);
DROP FUNCTION public.getstoragedomainidsbystoragepoolidandstatus(v_storage_pool_id uuid, v_status integer);
DROP FUNCTION public.getstorage_server_connectionsbyvolumegroupid(v_volume_group_id character varying);
DROP FUNCTION public.getstorage_server_connectionsbystoragetype(v_storage_type integer);
DROP FUNCTION public.getstorage_server_connectionsbylunid(v_lunid character varying);
DROP FUNCTION public.getstorage_server_connectionsbykey(v_iqn character varying, v_connection character varying, v_port character varying, v_portal character varying, v_username character varying, v_password character varying);
DROP FUNCTION public.getstorage_server_connectionsbyiqnandconnection(v_iqn character varying, v_connection character varying);
DROP FUNCTION public.getstorage_server_connectionsbyiqn(v_iqn character varying);
DROP FUNCTION public.getstorage_server_connectionsbyid(v_id character varying);
DROP FUNCTION public.getstorage_server_connectionsbyconnection(v_connection character varying);
DROP FUNCTION public.getstorage_poolsbyvdsid(v_vdsid uuid);
DROP FUNCTION public.getstorage_poolsbyvdsgroupid(v_clusterid uuid);
DROP FUNCTION public.getstorage_poolsbytype(v_storage_pool_type integer);
DROP FUNCTION public.getstorage_poolsbystoragedomainid(v_storage_domain_id uuid);
DROP FUNCTION public.getstorage_poolbyname(v_name character varying);
DROP FUNCTION public.getstorage_poolbyid(v_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getstorage_pool_iso_mapsbystorage_id(v_storage_id uuid);
DROP FUNCTION public.getstorage_pool_iso_mapsbybystorage_pool_id(v_storage_id uuid, v_storage_pool_id uuid);
DROP FUNCTION public.getstorage_pool_iso_mapbystorage_idandbystorage_pool_id(v_storage_id uuid, v_storage_pool_id uuid);
DROP FUNCTION public.getstorage_domains_list_by_storagedomainid(v_storage_domain_id uuid);
DROP FUNCTION public.getstorage_domains_list_by_imageid(v_image_id uuid);
DROP FUNCTION public.getstorage_domains_by_storagepoolid(v_storage_pool_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getstorage_domains_by_storage_pool_id_with_permitted_action(v_user_id uuid, v_action_group_id integer, v_storage_pool_id uuid);
DROP FUNCTION public.getstorage_domains_by_storage_pool_id_and_connection(v_storage_pool_id uuid, v_connection character varying);
DROP FUNCTION public.getstorage_domains_by_id_and_by_storage_pool_id(v_id uuid, v_storage_pool_id uuid);
DROP FUNCTION public.getstorage_domains_by_id(v_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP VIEW public.storage_domains_without_storage_pools;
DROP FUNCTION public.getstorage_domains_by_connection(v_connection character varying);
DROP FUNCTION public.getstorage_domain_staticbystorage_type_and_storage_pool_id(v_storage_type integer, v_storage_pool_id uuid);
DROP FUNCTION public.getstorage_domain_staticbystorage_pool_type(v_storage_pool_type integer);
DROP FUNCTION public.getstorage_domain_staticbystorage_pool_id(v_storage_pool_id uuid);
DROP FUNCTION public.getstorage_domain_staticbyname(v_name character varying);
DROP FUNCTION public.getstorage_domain_staticbyid(v_id uuid);
DROP FUNCTION public.getstorage_domain_dynamicbyid(v_id uuid);
DROP FUNCTION public.getstorage_domain_by_type_and_storagepoolid(v_storage_domain_type integer, v_storage_pool_id uuid);
DROP FUNCTION public.getstorage_domain_by_id_with_permitted_action(v_user_id uuid, v_action_group_id integer, v_storage_id uuid);
DROP FUNCTION public.getstepsbyparentstepid(v_parent_step_id uuid);
DROP FUNCTION public.getstepsbyjobid(v_job_id uuid);
DROP FUNCTION public.getstepbystepid(v_step_id uuid);
DROP FUNCTION public.getsnapshotsbyvmsnapshotid(v_vm_snapshot_id uuid);
DROP FUNCTION public.getsnapshotsbystoragedomainid(v_storage_domain_id uuid);
DROP FUNCTION public.getsnapshotsbyimagegroupid(v_image_group_id uuid);
DROP FUNCTION public.getsnapshotidsbyvmidandtypeandstatus(v_vm_id uuid, v_snapshot_type character varying, v_status character varying);
DROP FUNCTION public.getsnapshotidsbyvmidandtype(v_vm_id uuid, v_snapshot_type character varying);
DROP FUNCTION public.getsnapshotbyvmidandtype(v_vm_id uuid, v_snapshot_type character varying);
DROP FUNCTION public.getsnapshotbysnapshotid(v_snapshot_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getsnapshotbyparentguid(v_parent_guid uuid);
DROP FUNCTION public.getsnapshotbyguid(v_image_guid uuid);
DROP FUNCTION public.getrolsbyid(v_id uuid);
DROP FUNCTION public.getrolesbyadelementid(v_ad_element_id uuid);
DROP FUNCTION public.getroles_relationsbyrole_container_idandbyrole_id(v_role_container_id uuid, v_role_id uuid);
DROP FUNCTION public.getrolebyname(v_name character varying);
DROP FUNCTION public.getroleactiongroupsbyroleid(v_id uuid);
DROP FUNCTION public.getrole_children(v_role_id uuid);
DROP FUNCTION public.getrepo_files_in_all_storage_pools(v_storage_domain_type integer, v_storage_pool_status integer, v_vds_status integer, v_storage_domain_status integer);
DROP FUNCTION public.getrepo_files_by_storage_domain_and_storage_pool(v_storage_pool_id uuid, v_storage_domain_id uuid, v_file_type integer);
DROP VIEW public.storage_domain_file_repos;
DROP FUNCTION public.getrepo_files_by_storage_domain(v_storage_domain_id uuid, v_file_type integer);
DROP TABLE public.repo_file_meta_data;
DROP FUNCTION public.getquotavdsgroupbyvdsgroupguid(v_vds_group_id uuid, v_id uuid, v_allow_empty boolean);
DROP FUNCTION public.getquotavdsgroupbyquotaguid(v_id uuid);
DROP VIEW public.quota_vds_group_view;
DROP FUNCTION public.getquotastoragebystorageguid(v_storage_id uuid, v_id uuid, v_allow_empty boolean);
DROP FUNCTION public.getquotastoragebyquotaguid(v_id uuid);
DROP VIEW public.quota_storage_view;
DROP FUNCTION public.getquotacount();
DROP FUNCTION public.getquotabystoragepoolguid(v_storage_pool_id uuid);
DROP FUNCTION public.getquotabyquotaname(v_quota_name character varying);
DROP FUNCTION public.getquotabyquotaguid(v_id uuid);
DROP VIEW public.quota_global_view;
DROP TABLE public.quota_limitation;
DROP FUNCTION public.getquotabyadelementid(v_ad_element_id uuid, v_storage_pool_id uuid, v_recursive boolean);
DROP FUNCTION public.getpluggedvminterfacesbymac(v_mac_address character varying);
DROP FUNCTION public.getpermissionstreebyentityid(v_id uuid, v_object_type_id integer, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getpermissionsbyroleidandobjectid(v_role_id uuid, v_object_id uuid);
DROP FUNCTION public.getpermissionsbyroleidandadelementidandobjectid(v_role_id uuid, v_ad_element_id uuid, v_object_id uuid);
DROP FUNCTION public.getpermissionsbyroleidandadelementid(v_role_id uuid, v_ad_element_id uuid);
DROP FUNCTION public.getpermissionsbyroleid(v_role_id uuid);
DROP FUNCTION public.getpermissionsbyid(v_id uuid);
DROP FUNCTION public.getpermissionsbyentityid(v_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getpermissionsbyadelementid(v_ad_element_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getpermissionbyroleid(v_role_id uuid);
DROP FUNCTION public.getovfgeneration(v_vm_id uuid);
DROP FUNCTION public.getorderedvmguidsforrunmultipleactions(v_vm_guids character varying);
DROP FUNCTION public.getoptionsbyglustervolumeguid(v_volume_id uuid);
DROP FUNCTION public.getnvmtagsbyvmidanddefaulttag(v_vm_id uuid);
DROP FUNCTION public.getnvmtagsbyvmid(v_vm_id uuid);
DROP FUNCTION public.getnoncountablequtoavmstatuses();
DROP FUNCTION public.getnfsstorage_server_connectionsbystoragepoolid(v_storage_pool_id uuid);
DROP FUNCTION public.getnetworkbynameanddatacenter(v_name character varying, v_storage_pool_id uuid);
DROP FUNCTION public.getnetworkbynameandcluster(v_name character varying, v_cluster_id uuid);
DROP FUNCTION public.getnetworkbyname(v_networkname character varying);
DROP FUNCTION public.getnetworkbyid(v_id uuid);
DROP FUNCTION public.getnetwork_clusterbycluster_idandbynetwork_id(v_cluster_id uuid, v_network_id uuid);
DROP FUNCTION public.getnamesofvmstaticdedicatedtovds(v_vds_id uuid);
DROP FUNCTION public.getmacsbydatacenterid(v_data_center_id uuid);
DROP FUNCTION public.getlunsbyvolumegroupid(v_volume_group_id character varying);
DROP FUNCTION public.getlunsbystorage_server_connection(v_storage_server_connection character varying);
DROP FUNCTION public.getlunbylunid(v_lun_id character varying);
DROP FUNCTION public.getlun_storage_server_connection_mapbylunbystorage_server_conn(v_lun_id character varying, v_storage_server_connection character varying);
DROP FUNCTION public.getjobsubjectentitybyjobid(v_job_id uuid);
DROP TABLE public.job_subject_entity;
DROP FUNCTION public.getjobsbyoffsetandpagesize(v_position integer, v_page_size integer);
DROP FUNCTION public.getjobsbycorrelationid(v_correlation_id character varying);
DROP FUNCTION public.getjobbyjobid(v_job_id uuid);
DROP FUNCTION public.getinterface_viewbyvds_id(v_vds_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getinterface_viewbyaddr(v_cluster_id uuid, v_addr character varying);
DROP VIEW public.vds_interface_view;
DROP TABLE public.vds_interface_statistics;
DROP TABLE public.vds_interface;
DROP FUNCTION public.getimageswhichhavenodisk(v_vm_id uuid);
DROP FUNCTION public.getimagesbyquotaid(v_quota_id uuid);
DROP FUNCTION public.getimagebyimageid(v_image_guid uuid);
DROP FUNCTION public.getimagebyimageguid(v_image_guid uuid);
DROP VIEW public.vm_images_view;
DROP FUNCTION public.getimage_storage_domain_mapbystorage_domain_id(v_storage_domain_id uuid);
DROP FUNCTION public.getimage_storage_domain_mapbyimage_id(v_image_id uuid);
DROP FUNCTION public.getidsforovfdeletion(v_storage_pool_id uuid);
DROP FUNCTION public.getglustervolumesbystatustypesandoption(v_cluster_id uuid, v_status character varying, v_vol_types text, v_option_key character varying, v_option_val character varying);
DROP FUNCTION public.getglustervolumesbystatusandtypes(v_cluster_id uuid, v_status character varying, v_vol_types text);
DROP FUNCTION public.getglustervolumesbyoption(v_cluster_id uuid, v_status character varying, v_option_key character varying, v_option_val character varying);
DROP FUNCTION public.getglustervolumesbyclusterguid(v_cluster_id uuid);
DROP FUNCTION public.getglustervolumebyname(v_cluster_id uuid, v_vol_name character varying);
DROP FUNCTION public.getglustervolumebyid(v_volume_id uuid);
DROP TABLE public.gluster_volumes;
DROP FUNCTION public.getglustervolumebricksbyserverguid(v_server_id uuid);
DROP FUNCTION public.getglusteroptionbyid(v_id uuid);
DROP TABLE public.gluster_volume_options;
DROP FUNCTION public.getglusterbrickbyid(v_id uuid);
DROP FUNCTION public.getglobalids(v_name character varying);
DROP FUNCTION public.getforroleandadelementandobject_wgroupcheck(v_role_id uuid, v_ad_element_id uuid, v_object_id uuid);
DROP FUNCTION public.getfailingvdss();
DROP FUNCTION public.getfailingstorage_domains();
DROP FUNCTION public.geteventnotificationmethodbytype(v_method_type character);
DROP FUNCTION public.geteventnotificationmethodbyid(v_method_id integer);
DROP FUNCTION public.geteventmapbyname(v_event_name character varying);
DROP FUNCTION public.getevent_subscriberbysubscriber_id(v_subscriber_id uuid);
DROP FUNCTION public.getelementidsbyidandgroups(v_id uuid, v_group_ids text);
DROP FUNCTION public.getdisksvmguid(v_vm_guid uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getdisklunmapbylunid(v_lun_id character varying);
DROP FUNCTION public.getdisklunmapbydisklunmapid(v_disk_id uuid, v_lun_id character varying);
DROP FUNCTION public.getdiskbydiskid(v_disk_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getdisk_image_dynamicbyimage_id(v_image_id uuid);
DROP FUNCTION public.getdirectpermissionsbyadelementid(v_ad_element_id uuid);
DROP FUNCTION public.getdbgeneration(v_vm_guid uuid);
DROP FUNCTION public.getcustom_actionsbytab_id(v_tab integer);
DROP FUNCTION public.getcustom_actionsbynameandtab(v_action_name character varying, v_tab integer);
DROP FUNCTION public.getcustom_actionsbyaction_id(v_action_id integer);
DROP FUNCTION public.getconsumedpermissionsforquotaid(v_quota_id uuid);
DROP FUNCTION public.getbricksbyglustervolumeguid(v_volume_id uuid);
DROP TABLE public.gluster_volume_bricks;
DROP FUNCTION public.getbookmarkbybookmark_name(v_bookmark_name character varying);
DROP FUNCTION public.getbookmarkbybookmark_id(v_bookmark_id uuid);
DROP FUNCTION public.getbasediskbybasediskid(v_disk_id uuid);
DROP FUNCTION public.getauditloglaterthendate(v_date timestamp with time zone);
DROP FUNCTION public.getauditlogbyvmtemplatename(v_vm_template_name character varying, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getauditlogbyvmname(v_vm_name character varying, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getauditlogbyoriginandcustomeventid(v_origin character varying, v_custom_event_id integer);
DROP FUNCTION public.getauditlogbyauditlogid(v_audit_log_id integer);
DROP FUNCTION public.getasynctasksbystoragepoolid(v_storage_pool_id uuid);
DROP FUNCTION public.getasynctasksbyentityid(v_entity_id uuid);
DROP FUNCTION public.getasync_tasksbytask_id(v_task_id uuid);
DROP FUNCTION public.getancestralimagebyimageguid(v_image_guid uuid);
DROP FUNCTION public.getallvmtemplatesrelatedtoquotaid(v_quota_id uuid);
DROP FUNCTION public.getallvmsrelatedtoquotaid(v_quota_id uuid);
DROP FUNCTION public.getallvm_poolsbyuser_id_with_groups_and_userroles(v_user_id uuid);
DROP FUNCTION public.getallvm_poolsbyuser_id(v_user_id uuid);
DROP VIEW public.vm_pools_view;
DROP FUNCTION public.getallthinquotasbyvdsgroupid(v_vds_group_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getallthinquotasbystorageid(v_storage_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getallthinquota();
DROP VIEW public.quota_view;
DROP FUNCTION public.getallsteps();
DROP TABLE public.step;
DROP FUNCTION public.getallrolesbyuseridandgroupids(v_user_id uuid, v_group_ids text);
DROP FUNCTION public.getallrolesbyadelementid(v_ad_element_id uuid);
DROP FUNCTION public.getallnetworkbystoragepoolid(v_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getallnetworkbyclusterid(v_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getalljobs();
DROP TABLE public.job;
DROP FUNCTION public.getalljobidsbyentityid(v_entity_id uuid);
DROP FUNCTION public.getallfromvmtemplates(v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getallfromvmstatistics();
DROP FUNCTION public.getallfromvmstaticbystoragepoolid(v_sp_id uuid);
DROP FUNCTION public.getallfromvmstatic();
DROP FUNCTION public.getallfromvms(v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getallfromvmdynamic();
DROP FUNCTION public.getallfromvmdevice();
DROP VIEW public.vm_device_view;
DROP FUNCTION public.getallfromvm_pools();
DROP FUNCTION public.getallfromvm_pool_map();
DROP FUNCTION public.getallfromvm_interface();
DROP VIEW public.vm_interface_view;
DROP TABLE public.vm_interface_statistics;
DROP TABLE public.vm_interface;
DROP FUNCTION public.getallfromvdsstatistics();
DROP FUNCTION public.getallfromvdsstatic();
DROP FUNCTION public.getallfromvdsgroups(v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getallfromvdsdynamic();
DROP FUNCTION public.getallfromvds_spm_id_map();
DROP FUNCTION public.getallfromvds(v_user_id uuid, v_is_filtered boolean);
DROP VIEW public.vds;
DROP TABLE public.vds_statistics;
DROP TABLE public.vds_spm_id_map;
DROP TABLE public.vds_dynamic;
DROP FUNCTION public.getallfromvdcoption();
DROP TABLE public.vdc_options;
DROP SEQUENCE public.vdc_options_seq;
DROP FUNCTION public.getallfromusers();
DROP TABLE public.users;
DROP FUNCTION public.getallfromuser_sessions();
DROP TABLE public.user_sessions;
DROP FUNCTION public.getallfromtags_vm_pool_map();
DROP TABLE public.tags_vm_pool_map;
DROP FUNCTION public.getallfromtags_vm_map();
DROP TABLE public.tags_vm_map;
DROP FUNCTION public.getallfromtags_vds_map();
DROP TABLE public.tags_vds_map;
DROP FUNCTION public.getallfromtags_user_map();
DROP TABLE public.tags_user_map;
DROP FUNCTION public.getallfromtags_user_group_map();
DROP TABLE public.tags_user_group_map;
DROP FUNCTION public.getallfromtags();
DROP TABLE public.tags;
DROP FUNCTION public.getallfromstoragedomainsbyconnectionid(v_connection_id character varying);
DROP FUNCTION public.getallfromstorage_server_connections();
DROP FUNCTION public.getallfromstorage_pool_iso_map();
DROP FUNCTION public.getallfromstorage_pool(v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getallfromstorage_domains(v_user_id uuid, v_is_filtered boolean);
DROP VIEW public.storage_domains;
DROP FUNCTION public.getallfromstorage_domain_static();
DROP FUNCTION public.getallfromstorage_domain_dynamic();
DROP TABLE public.storage_domain_dynamic;
DROP FUNCTION public.getallfromsnapshotsbyvmid(v_vm_id uuid, v_user_id uuid, v_is_filtered boolean, v_fill_configuration boolean);
DROP FUNCTION public.getallfromsnapshots();
DROP FUNCTION public.getallfromroles_relations();
DROP TABLE public.roles_relations;
DROP FUNCTION public.getallfromrole();
DROP FUNCTION public.getallfromnetwork_clusterbynetworkid(v_network_id uuid);
DROP FUNCTION public.getallfromnetwork_clusterbyclusterid(v_cluster_id uuid);
DROP FUNCTION public.getallfromnetwork_cluster();
DROP TABLE public.network_cluster;
DROP FUNCTION public.getallfromnetwork(v_user_id uuid, v_is_filtered boolean);
DROP TABLE public.network;
DROP FUNCTION public.getallfromluns();
DROP VIEW public.luns_view;
DROP FUNCTION public.getallfromlun_storage_server_connection_map();
DROP TABLE public.lun_storage_server_connection_map;
DROP FUNCTION public.getallfromimages();
DROP FUNCTION public.getallfromevent_subscriber_notification_methods();
DROP VIEW public.event_subscriber_notification_methods_view;
DROP FUNCTION public.getallfromevent_subscriber();
DROP FUNCTION public.getallfromevent_notification_methods();
DROP TABLE public.event_notification_methods;
DROP FUNCTION public.getallfromevent_notification_hist();
DROP TABLE public.event_notification_hist;
DROP FUNCTION public.getallfromevent_map();
DROP FUNCTION public.getallfromevent_audit_log_subscriber_only();
DROP FUNCTION public.getallfromevent_audit_log_subscriber();
DROP VIEW public.event_audit_log_subscriber_view;
DROP TABLE public.event_subscriber;
DROP TABLE public.event_map;
DROP FUNCTION public.getallfromdisks(v_user_id uuid, v_is_filtered boolean);
DROP FUNCTION public.getallfromdisklunmaps();
DROP FUNCTION public.getallfromdisk_image_dynamic();
DROP FUNCTION public.getallfromcustom_actions();
DROP TABLE public.custom_actions;
DROP SEQUENCE public.custom_actions_seq;
DROP FUNCTION public.getallfrombookmarks();
DROP TABLE public.bookmarks;
DROP FUNCTION public.getallfrombasedisks();
DROP FUNCTION public.getallfromauditlog(v_user_id uuid, v_is_filtered boolean);
DROP TABLE public.audit_log;
DROP SEQUENCE public.audit_log_seq;
DROP FUNCTION public.getallfromasync_tasks();
DROP TABLE public.async_tasks;
DROP FUNCTION public.getallfromad_groups();
DROP FUNCTION public.getallfromaction_version_map();
DROP FUNCTION public.getallconnectablestorageseverconnection(v_storage_pool_id uuid);
DROP TABLE public.storage_server_connections;
DROP FUNCTION public.getallbystatus(v_status integer);
DROP FUNCTION public.getallattachabledisksbypoolid(v_storage_pool_id uuid, v_vm_id uuid, v_user_id uuid, v_is_filtered boolean);
DROP VIEW public.all_disks;
DROP VIEW public.storage_for_image_view;
DROP TABLE public.luns;
DROP VIEW public.images_storage_domain_view;
DROP VIEW public.vms_for_disk_view;
DROP TABLE public.vm_device;
DROP VIEW public.storage_domain_static_view;
DROP TABLE public.storage_pool_iso_map;
DROP TABLE public.storage_domain_static;
DROP TABLE public.snapshots;
DROP TABLE public.images;
DROP TABLE public.image_storage_domain_map;
DROP TABLE public.disk_lun_map;
DROP TABLE public.disk_image_dynamic;
DROP TABLE public.base_disks;
DROP FUNCTION public.getad_groupsbyname(v_name character varying);
DROP FUNCTION public.getad_groupsbyid(v_id uuid);
DROP TABLE public.ad_groups;
DROP FUNCTION public.getactivevmsbystoragedomainid(v_storage_domain_id uuid);
DROP VIEW public.vms;
DROP TABLE public.vm_statistics;
DROP VIEW public.vm_pool_map_view;
DROP TABLE public.vm_pools;
DROP TABLE public.vm_pool_map;
DROP TABLE public.vm_dynamic;
DROP TABLE public.vds_static;
DROP FUNCTION public.getaction_version_mapbyaction_type(v_action_type integer);
DROP TABLE public.action_version_map;
DROP FUNCTION public.getaccessprotocolsbyglustervolumeguid(v_volume_id uuid);
DROP TABLE public.gluster_volume_access_protocols;
DROP FUNCTION public.get_user_permissions_for_domain(v_name character varying, v_domain character varying);
DROP VIEW public.permissions_view;
DROP TABLE public.roles;
DROP TABLE public.permissions;
DROP FUNCTION public.get_seconds_to_wait_before_pm_operation(v_vds_name character varying, v_event character varying, v_wait_for_sec integer);
DROP FUNCTION public.get_roles_groups_by_action_group_id_and_by_role_id(v_action_group_id integer, v_role_id uuid);
DROP FUNCTION public.get_role_groups_by_role_id(v_role_id uuid);
DROP TABLE public.roles_groups;
DROP FUNCTION public.get_entity_snapshot_by_id(v_id uuid);
DROP FUNCTION public.get_entity_snapshot_by_command_id(v_command_id uuid);
DROP TABLE public.business_entity_snapshot;
DROP FUNCTION public.get_entity_permissions_for_user_and_groups(v_user_id uuid, v_group_ids text, v_action_group_id integer, v_object_id uuid, v_object_type_id integer, v_ignore_everyone boolean, OUT v_permission_id uuid);
DROP FUNCTION public.get_entity_permissions(v_user_id uuid, v_action_group_id integer, v_object_id uuid, v_object_type_id integer, OUT v_permission_id uuid);
DROP FUNCTION public.get_all_commands();
DROP FUNCTION public.generate_drop_all_views_syntax();
DROP FUNCTION public.generate_drop_all_functions_syntax();
DROP FUNCTION public.force_delete_storage_domain(v_storage_domain_id uuid);
DROP FUNCTION public.fnsplitteruuid(ids text);
DROP FUNCTION public.fnsplitter(ids text);
DROP FUNCTION public.fn_user_permissions(v_userid uuid);
DROP FUNCTION public.fn_perms_get_vds_groups_with_permitted_action(v_user_id uuid, v_action_group_id integer);
DROP VIEW public.vds_groups_view;
DROP FUNCTION public.fn_perms_get_templates_with_permitted_action(v_user_id uuid, v_action_group_id integer);
DROP VIEW public.vm_templates_view;
DROP TABLE public.vm_static;
DROP TABLE public.vds_groups;
DROP TABLE public.quota;
DROP FUNCTION public.fn_perms_get_storage_pools_with_permitted_action_on_vds_groups(v_user_id uuid, v_action_group_id integer, v_supports_virt_service boolean, v_supports_gluster_service boolean);
DROP TABLE public.storage_pool;
DROP FUNCTION public.fn_get_storage_domain_shared_status_by_domain_id(v_storage_domain_id uuid, v_storage_status integer, v_storage_domain_type integer);
DROP FUNCTION public.fn_get_entity_parents(v_entity_id uuid, v_object_type integer);
DROP FUNCTION public.fn_get_entity_name(v_entity_id uuid, v_object_type integer);
DROP FUNCTION public.fn_get_disk_commited_value_by_storage(v_storage_domain_id uuid);
DROP FUNCTION public.fn_get_comparable_ip_list(text);
DROP FUNCTION public.fn_get_column_size(v_table character varying, v_column character varying);
DROP FUNCTION public.fn_get_ad_element_name(v_ad_element_id uuid);
DROP FUNCTION public.fn_db_update_default_config_value(v_option_name character varying, v_default_option_value character varying, v_option_value character varying, v_version character varying, v_ignore_default_value_case boolean);
DROP FUNCTION public.fn_db_update_config_value(v_option_name character varying, v_option_value character varying, v_version character varying);
DROP FUNCTION public.fn_db_unlock_snapshot(v_id uuid);
DROP FUNCTION public.fn_db_unlock_entity(v_object_type character varying, v_name character varying, v_recursive boolean);
DROP FUNCTION public.fn_db_unlock_disk(v_id uuid);
DROP FUNCTION public.fn_db_split_config_value(v_option_name character varying, v_old_option_value character varying, v_new_option_value character varying, v_update_from_version character varying);
DROP FUNCTION public.fn_db_rename_column(v_table character varying, v_column character varying, v_new_name character varying);
DROP FUNCTION public.fn_db_mask_object(v_object regclass);
DROP FUNCTION public.fn_db_grant_action_group_to_all_roles_filter(v_action_group_id integer, uuid[]);
DROP FUNCTION public.fn_db_get_async_tasks();
DROP FUNCTION public.fn_db_drop_constraint(v_table character varying, v_constraint character varying);
DROP FUNCTION public.fn_db_drop_column(v_table character varying, v_column character varying);
DROP FUNCTION public.fn_db_delete_version_map(v_cluster_version character varying, v_sp_version character varying);
DROP FUNCTION public.fn_db_delete_config_value(v_option_name character varying, v_version text);
DROP FUNCTION public.fn_db_delete_config_for_version(v_version text);
DROP FUNCTION public.fn_db_create_constraint(v_table character varying, v_constraint character varying, v_constraint_sql text);
DROP FUNCTION public.fn_db_change_column_type(v_table character varying, v_column character varying, v_type character varying, v_new_type character varying);
DROP FUNCTION public.fn_db_add_config_value(v_option_name character varying, v_option_value character varying, v_version character varying);
DROP FUNCTION public.fn_db_add_column_to_object_white_list(v_object_name character varying, v_column_name character varying);
DROP FUNCTION public.fn_db_add_column(v_table character varying, v_column character varying, v_column_def text);
DROP FUNCTION public.fn_db_add_action_group_to_role(v_role_id uuid, v_action_group_id integer);
DROP FUNCTION public.dropmaterializedview(v_matview name);
DROP FUNCTION public.dropallmaterializedviews();
DROP FUNCTION public.dropallcustommaterializedviews();
DROP FUNCTION public.deletevmtemplates(v_vmt_guid uuid);
DROP FUNCTION public.deletevmstatistics(v_vm_guid uuid);
DROP FUNCTION public.deletevmstatic(v_vm_guid uuid);
DROP FUNCTION public.deletevmguestagentinterfacesbyvmid(v_vm_id uuid);
DROP FUNCTION public.deletevmdynamic(v_vm_guid uuid);
DROP FUNCTION public.deletevmdevice(v_device_id uuid, v_vm_id uuid);
DROP FUNCTION public.deletevm_pools(v_vm_pool_id uuid);
DROP FUNCTION public.deletevm_pool_map(v_vm_guid uuid);
DROP FUNCTION public.deletevm_interface_statistics(v_id uuid);
DROP FUNCTION public.deletevm_interface(v_id uuid);
DROP FUNCTION public.deletevm(v_vm_guid uuid);
DROP FUNCTION public.deletevdsstatistics(v_vds_id uuid);
DROP FUNCTION public.deletevdsstatic(v_vds_id uuid);
DROP FUNCTION public.deletevdsgroup(v_vds_group_id uuid);
DROP FUNCTION public.deletevdsdynamic(v_vds_id uuid);
DROP FUNCTION public.deletevds_spm_id_map(v_vds_id uuid);
DROP FUNCTION public.deletevds_interface_statistics(v_id uuid);
DROP FUNCTION public.deletevds_interface(v_id uuid);
DROP FUNCTION public.deletevds(v_vds_id uuid);
DROP FUNCTION public.deletevdcoption(v_option_id integer);
DROP FUNCTION public.deleteuser_sessionsbyuser_id(v_user_id uuid);
DROP FUNCTION public.deleteuser_sessions(v_session_id character, v_user_id uuid);
DROP FUNCTION public.deleteuser(v_user_id uuid);
DROP FUNCTION public.deletetags_vm_pool_map(v_tag_id uuid, v_vm_pool_id uuid);
DROP FUNCTION public.deletetags_vm_map(v_tag_id uuid, v_vm_id uuid);
DROP FUNCTION public.deletetags_vds_map(v_tag_id uuid, v_vds_id uuid);
DROP FUNCTION public.deletetags_user_map(v_tag_id uuid, v_user_id uuid);
DROP FUNCTION public.deletetags_user_group_map(v_group_id uuid, v_tag_id uuid);
DROP FUNCTION public.deletetags(v_tag_id uuid);
DROP FUNCTION public.deletestorage_server_connections(v_id character varying);
DROP FUNCTION public.deletestorage_pool_iso_map(v_storage_id uuid, v_storage_pool_id uuid);
DROP FUNCTION public.deletestorage_pool(v_id uuid);
DROP FUNCTION public.deletestorage_domain_static(v_id uuid);
DROP FUNCTION public.deletestorage_domain_dynamic(v_id uuid);
DROP FUNCTION public.deletestep(v_step_id uuid);
DROP FUNCTION public.deletesnapshot(v_snapshot_id uuid);
DROP FUNCTION public.deleteroles_relations(v_role_container_id uuid, v_role_id uuid);
DROP FUNCTION public.deleterole(v_id uuid);
DROP FUNCTION public.deleterepo_domain_file_list(v_repo_domain_id uuid, v_file_type integer);
DROP FUNCTION public.deletequotalimitationbyquotaguid(v_id uuid);
DROP FUNCTION public.deletequotabyquotaguid(v_id uuid);
DROP FUNCTION public.deletepermissionsbyentityid(v_id uuid);
DROP FUNCTION public.deletepermission(v_id uuid);
DROP FUNCTION public.deleteovfgenerations(v_vms_ids character varying);
DROP FUNCTION public.deletenetwork_cluster(v_cluster_id uuid, v_network_id uuid);
DROP FUNCTION public.deletenetwork(v_id uuid);
DROP FUNCTION public.deletelun_storage_server_connection_map(v_lun_id character varying, v_storage_server_connection character varying);
DROP FUNCTION public.deletelun(v_lun_id character varying);
DROP FUNCTION public.deletejobolderthandatewithstatus(v_end_time timestamp with time zone, v_status text);
DROP FUNCTION public.deletejob(v_job_id uuid);
DROP FUNCTION public.deleteimage_storage_domain_map_by_image_id(v_image_id uuid);
DROP FUNCTION public.deleteimage_storage_domain_map(v_image_id uuid, v_storage_domain_id uuid);
DROP FUNCTION public.deleteimage(v_image_guid uuid);
DROP FUNCTION public.deleteglustervolumetransporttype(v_volume_id uuid, v_transport_type character varying);
DROP FUNCTION public.deleteglustervolumesbyguids(v_volume_ids character varying);
DROP FUNCTION public.deleteglustervolumesbyclusterid(v_cluster_id uuid);
DROP FUNCTION public.deleteglustervolumeoptions(v_ids character varying);
DROP FUNCTION public.deleteglustervolumeoption(v_id uuid);
DROP FUNCTION public.deleteglustervolumebyname(v_cluster_id uuid, v_vol_name character varying);
DROP FUNCTION public.deleteglustervolumebyguid(v_volume_id uuid);
DROP FUNCTION public.deleteglustervolumebricks(v_ids character varying);
DROP FUNCTION public.deleteglustervolumebrick(v_id uuid);
DROP FUNCTION public.deleteglustervolumeaccessprotocol(v_volume_id uuid, v_access_protocol character varying);
DROP FUNCTION public.deleteevent_subscriber(v_event_up_name character varying, v_method_id integer, v_subscriber_id uuid, v_tag_name character varying);
DROP FUNCTION public.deleteevent_notification_hist(v_sent_at timestamp without time zone);
DROP FUNCTION public.deletedisklunmap(v_disk_id uuid, v_lun_id character varying);
DROP FUNCTION public.deletedisk_image_dynamic(v_image_id uuid);
DROP FUNCTION public.deletecustom_actions(v_action_id integer);
DROP FUNCTION public.deletecompletedjobsolderthandate(v_succeeded_end_time timestamp with time zone, v_failed_end_time timestamp with time zone);
DROP FUNCTION public.deletebypoolvds_spm_id_map(v_vds_id uuid, v_storage_pool_id uuid);
DROP FUNCTION public.deletebookmark(v_bookmark_id uuid);
DROP FUNCTION public.deletebasedisk(v_disk_id uuid);
DROP FUNCTION public.deleteauditlogolderthendate(v_date timestamp with time zone);
DROP FUNCTION public.deleteauditlogalertsbyvdsid(v_vds_id uuid, v_delete_config_alerts boolean);
DROP FUNCTION public.deleteauditlog(v_audit_log_id integer);
DROP FUNCTION public.deleteauditalertlogbyvdsidandtype(v_vds_id uuid, v_log_type integer);
DROP FUNCTION public.deleteasync_tasks(v_task_id uuid);
DROP FUNCTION public.deletealluser_sessions();
DROP FUNCTION public.deletead_groups(v_id uuid);
DROP FUNCTION public.deleteaction_version_map(v_action_type integer);
DROP FUNCTION public.delete_roles_groups(v_action_group_id integer, v_role_id uuid);
DROP FUNCTION public.delete_entity_snapshot_by_command_id(v_command_id uuid);
DROP FUNCTION public.creatematerializedviewas(v_view_name name, v_refresh_rate_in_sec integer);
DROP FUNCTION public.creatematerializedviewas(v_view_name name, v_refresh_rate_in_sec integer, v_min_refesh_rate_in_sec integer);
DROP FUNCTION public.creatematerializedviewas(v_view_name name, v_refresh_rate_in_sec integer, v_custom boolean, v_min_refesh_rate_in_sec integer);
DROP FUNCTION public.creatematerializedview(v_matview name, v_view_name name, v_refresh_rate_in_sec integer);
DROP FUNCTION public.creatematerializedview(v_matview name, v_view_name name, v_refresh_rate_in_sec integer, v_min_refresh_rate_in_sec integer);
DROP FUNCTION public.creatematerializedview(v_matview name, v_view_name name, v_refresh_rate_in_sec integer, v_custom boolean, v_min_refresh_rate_in_sec integer);
DROP FUNCTION public.createcustommaterializedviewas(v_view_name name, v_refresh_rate_in_sec integer);
DROP FUNCTION public.createcustommaterializedviewas(v_view_name name, v_refresh_rate_in_sec integer, v_min_refesh_rate_in_sec integer);
DROP FUNCTION public.createcustommaterializedview(v_matview name, v_view_name name, v_refresh_rate_in_sec integer);
DROP FUNCTION public.createcustommaterializedview(v_matview name, v_view_name name, v_refresh_rate_in_sec integer, v_min_refresh_rate_in_sec integer);
DROP FUNCTION public.createallmaterializedviewsiindexes();
DROP FUNCTION public.clearvmdeviceaddress(v_device_id uuid);
DROP FUNCTION public.checkifsnapshotexistsbyvmidandtype(v_vm_id uuid, v_snapshot_type character varying);
DROP FUNCTION public.checkifsnapshotexistsbyvmidandstatus(v_vm_id uuid, v_status character varying);
DROP FUNCTION public.checkifsnapshotexistsbyvmidandsnapshotid(v_vm_id uuid, v_snapshot_id uuid);
DROP FUNCTION public.checkifjobhastasks(v_job_id uuid);
DROP FUNCTION public.checkdbconnection();
DROP FUNCTION public.calculatevdsgroupusage(v_quota_id uuid, v_vds_group_id uuid);
DROP FUNCTION public.calculatestorageusage(v_quota_id uuid, v_storage_id uuid);
DROP FUNCTION public.calculateallvdsgroupusage();
DROP FUNCTION public.calculateallstorageusage();
DROP FUNCTION public.attach_user_to_su_role(v_permission_id uuid, v_user_id character varying, v_name character varying, v_domain character varying);
DROP FUNCTION public.attach_user_to_su_role(v_permission_id uuid);
DROP FUNCTION public.activatematerializedview(v_matview name, v_active boolean);
DROP FUNCTION public.activateallmaterializedviews(v_active boolean);
DROP TYPE public.vds_group_usage_rs;
DROP TYPE public.user_permissions;
DROP TYPE public.networkviewclustertype;
DROP TYPE public.iduuidtype;
DROP TYPE public.idtexttype;
DROP TYPE public.getsystem_statistics_rs;
DROP TYPE public.getstoragedomainidsbystoragepoolidandstatus_rs;
DROP TYPE public.getrepo_files_in_all_storage_pools_rs;
DROP TYPE public.getorderedvmguidsforrunmultipleactions_rs;
DROP TYPE public.getnamesofvmstaticdedicatedtovds_rs;
DROP TYPE public.getallfromvm_pools_rs;
DROP TYPE public.getallfromsnapshotsbyvmid_rs;
DROP TYPE public.get_all_commands_rs;
DROP TYPE public.fk_info_rs;
DROP TYPE public.booleanresulttype;
DROP TYPE public.async_tasks_info_rs;
DROP TYPE public.all_vds_group_usage_rs;
DROP TYPE public.all_storage_usage_rs;
DROP PROCEDURAL LANGUAGE plpgsql;
DROP SCHEMA public;
--
-- Name: public; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA public;


ALTER SCHEMA public OWNER TO postgres;

--
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: postgres
--

COMMENT ON SCHEMA public IS 'standard public schema';


--
-- Name: plpgsql; Type: PROCEDURAL LANGUAGE; Schema: -; Owner: engineer
--

CREATE PROCEDURAL LANGUAGE plpgsql;


ALTER PROCEDURAL LANGUAGE plpgsql OWNER TO engineer;

SET search_path = public, pg_catalog;

--
-- Name: all_storage_usage_rs; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE all_storage_usage_rs AS (
	quota_storage_id uuid,
	quota_id uuid,
	storage_id uuid,
	storage_name character varying(250),
	storage_size_gb bigint,
	storage_size_gb_usage double precision
);


ALTER TYPE public.all_storage_usage_rs OWNER TO engineer;

--
-- Name: all_vds_group_usage_rs; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE all_vds_group_usage_rs AS (
	quota_vds_group_id uuid,
	quota_id uuid,
	vds_group_id uuid,
	vds_group_name character varying(40),
	virtual_cpu integer,
	virtual_cpu_usage integer,
	mem_size_mb bigint,
	mem_size_mb_usage bigint
);


ALTER TYPE public.all_vds_group_usage_rs OWNER TO engineer;

--
-- Name: async_tasks_info_rs; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE async_tasks_info_rs AS (
	dc_id uuid,
	dc_name character varying,
	spm_host_id uuid,
	spm_host_name character varying,
	task_count integer
);


ALTER TYPE public.async_tasks_info_rs OWNER TO engineer;

--
-- Name: booleanresulttype; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE booleanresulttype AS (
	result boolean
);


ALTER TYPE public.booleanresulttype OWNER TO engineer;

--
-- Name: fk_info_rs; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE fk_info_rs AS (
	table_name character varying,
	table_col character varying,
	fk_table_name character varying,
	fk_col character varying,
	fk_violation character varying,
	fk_status integer
);


ALTER TYPE public.fk_info_rs OWNER TO engineer;

--
-- Name: get_all_commands_rs; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE get_all_commands_rs AS (
	command_id uuid,
	command_type character varying(256)
);


ALTER TYPE public.get_all_commands_rs OWNER TO engineer;

--
-- Name: getallfromsnapshotsbyvmid_rs; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE getallfromsnapshotsbyvmid_rs AS (
	snapshot_id uuid,
	vm_id uuid,
	snapshot_type character varying(32),
	status character varying(32),
	description character varying(4000),
	creation_date timestamp with time zone,
	app_list text,
	vm_configuration text,
	vm_configuration_available boolean
);


ALTER TYPE public.getallfromsnapshotsbyvmid_rs OWNER TO engineer;

--
-- Name: getallfromvm_pools_rs; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE getallfromvm_pools_rs AS (
	vm_pool_id uuid,
	assigned_vm_count integer,
	vm_running_count integer,
	vm_pool_description character varying(4000),
	vm_pool_name character varying(255),
	vm_pool_type integer,
	parameters character varying(200),
	prestarted_vms integer,
	vds_group_id uuid,
	vds_group_name character varying(40)
);


ALTER TYPE public.getallfromvm_pools_rs OWNER TO engineer;

--
-- Name: getnamesofvmstaticdedicatedtovds_rs; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE getnamesofvmstaticdedicatedtovds_rs AS (
	vm_name character varying
);


ALTER TYPE public.getnamesofvmstaticdedicatedtovds_rs OWNER TO engineer;

--
-- Name: getorderedvmguidsforrunmultipleactions_rs; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE getorderedvmguidsforrunmultipleactions_rs AS (
	vm_guid uuid
);


ALTER TYPE public.getorderedvmguidsforrunmultipleactions_rs OWNER TO engineer;

--
-- Name: getrepo_files_in_all_storage_pools_rs; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE getrepo_files_in_all_storage_pools_rs AS (
	storage_domain_id uuid,
	last_refreshed bigint,
	file_type integer
);


ALTER TYPE public.getrepo_files_in_all_storage_pools_rs OWNER TO engineer;

--
-- Name: getstoragedomainidsbystoragepoolidandstatus_rs; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE getstoragedomainidsbystoragepoolidandstatus_rs AS (
	storage_id uuid
);


ALTER TYPE public.getstoragedomainidsbystoragepoolidandstatus_rs OWNER TO engineer;

--
-- Name: getsystem_statistics_rs; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE getsystem_statistics_rs AS (
	val integer
);


ALTER TYPE public.getsystem_statistics_rs OWNER TO engineer;

--
-- Name: idtexttype; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE idtexttype AS (
	id text
);


ALTER TYPE public.idtexttype OWNER TO engineer;

--
-- Name: iduuidtype; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE iduuidtype AS (
	id uuid
);


ALTER TYPE public.iduuidtype OWNER TO engineer;

--
-- Name: networkviewclustertype; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE networkviewclustertype AS (
	id uuid,
	name character varying(50),
	description character varying(4000),
	type integer,
	addr character varying(50),
	subnet character varying(20),
	gateway character varying(20),
	vlan_id integer,
	stp boolean,
	storage_pool_id uuid,
	mtu integer,
	vm_network boolean,
	network_id uuid,
	cluster_id uuid,
	status integer,
	is_display boolean,
	required boolean
);


ALTER TYPE public.networkviewclustertype OWNER TO engineer;

--
-- Name: user_permissions; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE user_permissions AS (
	permission_id uuid,
	role_id uuid,
	user_id uuid
);


ALTER TYPE public.user_permissions OWNER TO engineer;

--
-- Name: vds_group_usage_rs; Type: TYPE; Schema: public; Owner: engineer
--

CREATE TYPE vds_group_usage_rs AS (
	virtual_cpu_usage integer,
	mem_size_mb_usage bigint
);


ALTER TYPE public.vds_group_usage_rs OWNER TO engineer;

--
-- Name: activateallmaterializedviews(boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION activateallmaterializedviews(v_active boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
     v_entry materialized_views%ROWTYPE;
 BEGIN
    update materialized_views set active = v_active;
    RETURN;
 END; $$;


ALTER FUNCTION public.activateallmaterializedviews(v_active boolean) OWNER TO engineer;

--
-- Name: activatematerializedview(name, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION activatematerializedview(v_matview name, v_active boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
     v_entry materialized_views%ROWTYPE;
 BEGIN
     SELECT * INTO v_entry FROM materialized_views WHERE mv_name = v_matview;
     IF NOT FOUND THEN
         RAISE EXCEPTION 'Materialized view % does not exist.', v_matview;
    END IF;

    update materialized_views set active = v_active
    where  mv_name = v_matview;
    RETURN;
 END; $$;


ALTER FUNCTION public.activatematerializedview(v_matview name, v_active boolean) OWNER TO engineer;

--
-- Name: attach_user_to_su_role(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION attach_user_to_su_role(v_permission_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_user_entry VARCHAR(255);
   v_user_id  UUID;
   v_name  VARCHAR(255);
   v_domain  VARCHAR(255);
   v_user_name  VARCHAR(255);

   v_document  VARCHAR(64);
   v_index  INTEGER;
BEGIN

   select   option_value INTO v_user_entry from vdc_options where option_name = 'AdUserId';
   select   option_value INTO v_name from vdc_options where option_name = 'AdUserName';
   select   option_value INTO v_domain from vdc_options where option_name = 'DomainName';

   v_index := POSITION(':' IN v_user_entry);
   if ( v_index <> 0 ) then
      v_user_entry := substring( v_user_entry from v_index + 1 );
      v_user_id := CAST( v_user_entry AS uuid );
   end if;

   v_index := POSITION(':' IN v_name);
   if ( v_index <> 0 ) then
      v_name := substring( v_name from v_index + 1 );
   end if;

-- find if name already includes domain (@)
   v_index := POSITION('@' IN v_name);

   if (v_index = 0) then
      v_user_name := coalesce(v_name,'') || '@' || coalesce(v_domain,'');
   else
      v_user_name := v_name;
   end if;


insert into users(user_id,name,domain,username,groups,status) select v_user_id, v_name, v_domain, v_user_name,'',1 where not exists (select user_id,name,domain,username,groups,status from users where user_id = v_user_id and name = v_name and domain = v_domain and username = v_user_name and groups = '' and status = 1);

insert into permissions(id,role_id,ad_element_id,object_id,object_type_id) select v_permission_id, '00000000-0000-0000-0000-000000000001', v_user_id, getGlobalIds('system'), 1 where not exists(select role_id,ad_element_id,object_id,object_type_id from permissions where role_id = '00000000-0000-0000-0000-000000000001' and ad_element_id = v_user_id and object_id= getGlobalIds('system') and object_type_id = 1);
END; $$;


ALTER FUNCTION public.attach_user_to_su_role(v_permission_id uuid) OWNER TO engineer;

--
-- Name: attach_user_to_su_role(uuid, character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION attach_user_to_su_role(v_permission_id uuid, v_user_id character varying, v_name character varying, v_domain character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_user_name VARCHAR(255);
   v_document  VARCHAR(64);
   v_index  INTEGER;
   input_uuid uuid;
BEGIN
   input_uuid = CAST( v_user_id AS uuid );
-- find if name already includes domain (@)
   v_index := POSITION('@' IN v_name);

   if (v_index = 0) then
      v_user_name := coalesce(v_name,'') || '@' || coalesce(v_domain,'');
   else
      v_user_name := v_name;
   end if;


insert into users(user_id,name,domain,username,groups,status) select input_uuid, v_name, v_domain, v_user_name,'',1 where not exists (select user_id,name,domain,username,groups,status from users where user_id = input_uuid);

insert into permissions(id,role_id,ad_element_id,object_id,object_type_id) select v_permission_id, '00000000-0000-0000-0000-000000000001', input_uuid, getGlobalIds('system'), 1 where not exists(select role_id,ad_element_id,object_id,object_type_id from permissions where role_id = '00000000-0000-0000-0000-000000000001' and ad_element_id = input_uuid and object_id= getGlobalIds('system') and object_type_id = 1);
END; $$;


ALTER FUNCTION public.attach_user_to_su_role(v_permission_id uuid, v_user_id character varying, v_name character varying, v_domain character varying) OWNER TO engineer;

--
-- Name: calculateallstorageusage(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION calculateallstorageusage() RETURNS SETOF all_storage_usage_rs
    LANGUAGE plpgsql
    AS $$
BEGIN
    -- Summarize size of all disks that are active.
    RETURN QUERY SELECT
        quota_limitation.id AS quota_storage_id,
        quota_limitation.quota_id as quota_id,
        quota_limitation.storage_id as storage_id,
        storage_domain_static.storage_name,
        quota_limitation.storage_size_gb,
        cast(COALESCE(sum(size * cast(active as integer) + disk_image_dynamic.actual_size * cast((not active) as integer)) / 1073741824 ,0) as double precision)  as storage_usage -- 1073741824 is 1024^3 (for GB)
    FROM quota_limitation
        LEFT JOIN images ON quota_limitation.quota_id = images.quota_id
        LEFT JOIN image_storage_domain_map ON images.image_guid = image_storage_domain_map.image_id
        LEFT JOIN disk_image_dynamic ON images.image_guid = disk_image_dynamic.image_id
        LEFT JOIN storage_domain_static ON image_storage_domain_map.storage_domain_id = storage_domain_static.id
    WHERE quota_limitation.storage_size_gb IS NOT NULL
    GROUP BY quota_limitation.quota_id, storage_id,quota_limitation.id,storage_domain_static.storage_name,quota_limitation.storage_size_gb;
END; $$;


ALTER FUNCTION public.calculateallstorageusage() OWNER TO engineer;

--
-- Name: calculateallvdsgroupusage(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION calculateallvdsgroupusage() RETURNS SETOF all_vds_group_usage_rs
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT
        quota_limitation.id AS quota_vds_group_id,
        quota_limitation.quota_id as quota_id,
        quota_limitation.vds_group_id as vds_group_id,
        vds_groups.name AS vds_group_name,
        quota_limitation.virtual_cpu,
        cast(COALESCE(sum(num_of_sockets * cpu_per_socket * cast(vm_dynamic.status not in (SELECT getNonCountableQutoaVmStatuses()) as INTEGER)), 0) as INTEGER) as virtual_cpu_usage,
        quota_limitation.mem_size_mb,
        COALESCE(sum(vm_static.mem_size_mb), 0) as mem_size_mb_usage
    FROM quota_limitation
        LEFT JOIN vm_static ON vm_static.quota_id = quota_limitation.quota_id
        LEFT JOIN vm_dynamic ON vm_dynamic.vm_guid = vm_static.vm_guid
        LEFT JOIN vds_groups ON vds_groups.vds_group_id = vm_static.vds_group_id
    WHERE quota_limitation.virtual_cpu IS NOT NULL
        AND quota_limitation.mem_size_mb IS NOT NULL
    GROUP BY quota_limitation.quota_id, quota_limitation.vds_group_id, vds_group_name, quota_limitation.virtual_cpu, quota_limitation.mem_size_mb,
        vm_static.quota_id, vds_groups.vds_group_id, vm_static.vds_group_id, quota_limitation.id;
END; $$;


ALTER FUNCTION public.calculateallvdsgroupusage() OWNER TO engineer;

--
-- Name: calculatestorageusage(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION calculatestorageusage(v_quota_id uuid, v_storage_id uuid) RETURNS double precision
    LANGUAGE plpgsql
    AS $$
DECLARE
	v_virtual_size double precision;
	v_actual_size double precision;
BEGIN
	-- Summarize size of all disks that are active.
    SELECT COALESCE(sum(size) / (1024 * 1024 * 1024),0) INTO v_virtual_size
	FROM disk_image_dynamic, images_storage_domain_view
	WHERE image_guid = disk_image_dynamic.image_id
    AND image_guid in (SELECT image_guid FROM  images WHERE  active = TRUE)
	AND quota_id = v_quota_id
    AND (v_storage_id = images_storage_domain_view.storage_id or v_storage_id IS NULL);

	-- Summarize the actual size of all the rest disks that are read only disks such as snapshots, not active, template disks.
	SELECT COALESCE(sum(disk_image_dynamic.actual_size) / (1024 * 1024 * 1024),0) INTO v_actual_size
	FROM disk_image_dynamic, images_storage_domain_view
	WHERE image_guid = disk_image_dynamic.image_id
    AND image_guid not in (SELECT image_guid
                           FROM   images i JOIN vm_device vd ON i.image_group_id = vd.device_id
                           WHERE  active = TRUE)
	AND quota_id = v_quota_id
	AND (v_storage_id = images_storage_domain_view.storage_id or v_storage_id IS NULL);
	RETURN v_actual_size + v_virtual_size;
END; $$;


ALTER FUNCTION public.calculatestorageusage(v_quota_id uuid, v_storage_id uuid) OWNER TO engineer;

--
-- Name: calculatevdsgroupusage(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION calculatevdsgroupusage(v_quota_id uuid, v_vds_group_id uuid) RETURNS SETOF vds_group_usage_rs
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT cast(COALESCE(sum(num_of_sockets * cpu_per_socket), 0) as INTEGER) as virtual_cpu_usage,
    COALESCE(sum(mem_size_mb), 0) as mem_size_mb_usage
    FROM vm_static,vm_dynamic
    WHERE quota_id = v_quota_id
      AND vm_dynamic.vm_guid = vm_static.vm_guid
      AND vm_dynamic.status not in (SELECT getNonCountableQutoaVmStatuses())
      AND (v_vds_group_id = vm_static.vds_group_id or v_vds_group_id IS NULL);
END; $$;


ALTER FUNCTION public.calculatevdsgroupusage(v_quota_id uuid, v_vds_group_id uuid) OWNER TO engineer;

--
-- Name: checkdbconnection(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION checkdbconnection() RETURNS SETOF integer
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT 1;
END; $$;


ALTER FUNCTION public.checkdbconnection() OWNER TO engineer;

--
-- Name: checkifjobhastasks(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION checkifjobhastasks(v_job_id uuid) RETURNS SETOF booleanresulttype
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT EXISTS(
        SELECT *
        FROM   step
        WHERE  job_id = v_job_id
        AND    external_id is not null
        AND    external_system_type = 'VDSM');
END; $$;


ALTER FUNCTION public.checkifjobhastasks(v_job_id uuid) OWNER TO engineer;

--
-- Name: checkifsnapshotexistsbyvmidandsnapshotid(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION checkifsnapshotexistsbyvmidandsnapshotid(v_vm_id uuid, v_snapshot_id uuid) RETURNS SETOF booleanresulttype
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT EXISTS(
        SELECT *
        FROM   snapshots
        WHERE  vm_id = v_vm_id
        AND    snapshot_id = v_snapshot_id);
END; $$;


ALTER FUNCTION public.checkifsnapshotexistsbyvmidandsnapshotid(v_vm_id uuid, v_snapshot_id uuid) OWNER TO engineer;

--
-- Name: checkifsnapshotexistsbyvmidandstatus(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION checkifsnapshotexistsbyvmidandstatus(v_vm_id uuid, v_status character varying) RETURNS SETOF booleanresulttype
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT EXISTS(
        SELECT *
        FROM   snapshots
        WHERE  vm_id = v_vm_id
        AND    status = v_status);
END; $$;


ALTER FUNCTION public.checkifsnapshotexistsbyvmidandstatus(v_vm_id uuid, v_status character varying) OWNER TO engineer;

--
-- Name: checkifsnapshotexistsbyvmidandtype(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION checkifsnapshotexistsbyvmidandtype(v_vm_id uuid, v_snapshot_type character varying) RETURNS SETOF booleanresulttype
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT EXISTS(
        SELECT *
        FROM   snapshots
        WHERE  vm_id = v_vm_id
        AND    snapshot_type = v_snapshot_type);
END; $$;


ALTER FUNCTION public.checkifsnapshotexistsbyvmidandtype(v_vm_id uuid, v_snapshot_type character varying) OWNER TO engineer;

--
-- Name: clearvmdeviceaddress(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION clearvmdeviceaddress(v_device_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
begin
    update vm_device set address = '' where device_id = v_device_id;
end;
$$;


ALTER FUNCTION public.clearvmdeviceaddress(v_device_id uuid) OWNER TO engineer;

--
-- Name: createallmaterializedviewsiindexes(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION createallmaterializedviewsiindexes() RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
    v_cur CURSOR FOR SELECT * FROM materialized_views;
    v_record materialized_views%ROWTYPE;
    v_create_index_sp NAME;
BEGIN
       OPEN v_cur;
       -- loop on all entries in materialized_views and create indexes(if defined)
       LOOP
           FETCH v_cur INTO v_record;
           EXIT WHEN NOT FOUND;
           v_create_index_sp := 'MtCreate' || v_record.mv_name || 'Indexes';
           -- Check if SP that creates the indexes exists
           IF NOT EXISTS (select 1 from information_schema.routines where routine_name ilike v_create_index_sp) THEN
               v_create_index_sp := NULL;
           END IF;
           IF (v_create_index_sp IS NOT NULL) THEN
               EXECUTE 'select ' || v_create_index_sp || '()';
           END IF;
       END LOOP;
       CLOSE v_cur;
END; $$;


ALTER FUNCTION public.createallmaterializedviewsiindexes() OWNER TO engineer;

--
-- Name: createcustommaterializedview(name, name, integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION createcustommaterializedview(v_matview name, v_view_name name, v_refresh_rate_in_sec integer, v_min_refresh_rate_in_sec integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
 BEGIN
     PERFORM CreateMaterializedView(v_matview, v_view_name, v_refresh_rate_in_sec, true,  v_min_refresh_rate_in_sec);
     RETURN;
 END; $$;


ALTER FUNCTION public.createcustommaterializedview(v_matview name, v_view_name name, v_refresh_rate_in_sec integer, v_min_refresh_rate_in_sec integer) OWNER TO engineer;

--
-- Name: createcustommaterializedview(name, name, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION createcustommaterializedview(v_matview name, v_view_name name, v_refresh_rate_in_sec integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
     PERFORM  CreateMaterializedView(v_matview, v_view_name, v_refresh_rate_in_sec, true, 0);
END; $$;


ALTER FUNCTION public.createcustommaterializedview(v_matview name, v_view_name name, v_refresh_rate_in_sec integer) OWNER TO engineer;

--
-- Name: createcustommaterializedviewas(name, integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION createcustommaterializedviewas(v_view_name name, v_refresh_rate_in_sec integer, v_min_refesh_rate_in_sec integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
 BEGIN
     PERFORM CreateMaterializedViewAs(v_view_name, v_refresh_rate_in_sec, true, v_min_refesh_rate_in_sec);
     RETURN;
 END; $$;


ALTER FUNCTION public.createcustommaterializedviewas(v_view_name name, v_refresh_rate_in_sec integer, v_min_refesh_rate_in_sec integer) OWNER TO engineer;

--
-- Name: createcustommaterializedviewas(name, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION createcustommaterializedviewas(v_view_name name, v_refresh_rate_in_sec integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    PERFORM  CreateMaterializedViewAs(v_view_name, v_refresh_rate_in_sec, true, 0);
END; $$;


ALTER FUNCTION public.createcustommaterializedviewas(v_view_name name, v_refresh_rate_in_sec integer) OWNER TO engineer;

--
-- Name: creatematerializedview(name, name, integer, boolean, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION creatematerializedview(v_matview name, v_view_name name, v_refresh_rate_in_sec integer, v_custom boolean, v_min_refresh_rate_in_sec integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
     v_entry materialized_views%ROWTYPE;
 BEGIN
     SELECT * INTO v_entry FROM materialized_views WHERE mv_name = v_matview;

     IF FOUND THEN
         RAISE EXCEPTION 'Materialized view % already exists.',
           v_matview;
     END IF;

     EXECUTE 'REVOKE ALL ON ' || v_view_name || ' FROM PUBLIC';

     EXECUTE 'GRANT SELECT ON ' || v_view_name || ' TO PUBLIC';

     EXECUTE 'CREATE TABLE ' || v_matview || ' AS SELECT * FROM ' || v_view_name;

     EXECUTE 'REVOKE ALL ON ' || v_matview || ' FROM PUBLIC';

     EXECUTE 'GRANT SELECT ON ' || v_matview || ' TO PUBLIC';

     INSERT INTO materialized_views (mv_name, v_name, refresh_rate_in_sec, last_refresh, custom, min_refresh_rate_in_sec)
       VALUES (v_matview, v_view_name, v_refresh_rate_in_sec, CURRENT_TIMESTAMP, v_custom, v_min_refresh_rate_in_sec);

     RETURN;
 END; $$;


ALTER FUNCTION public.creatematerializedview(v_matview name, v_view_name name, v_refresh_rate_in_sec integer, v_custom boolean, v_min_refresh_rate_in_sec integer) OWNER TO engineer;

--
-- Name: creatematerializedview(name, name, integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION creatematerializedview(v_matview name, v_view_name name, v_refresh_rate_in_sec integer, v_min_refresh_rate_in_sec integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
 BEGIN
     PERFORM CreateMaterializedView(v_matview, v_view_name, v_refresh_rate_in_sec, false,  v_min_refresh_rate_in_sec);
     RETURN;
 END; $$;


ALTER FUNCTION public.creatematerializedview(v_matview name, v_view_name name, v_refresh_rate_in_sec integer, v_min_refresh_rate_in_sec integer) OWNER TO engineer;

--
-- Name: creatematerializedview(name, name, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION creatematerializedview(v_matview name, v_view_name name, v_refresh_rate_in_sec integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
     PERFORM  CreateMaterializedView(v_matview, v_view_name, v_refresh_rate_in_sec, false, 0);
END; $$;


ALTER FUNCTION public.creatematerializedview(v_matview name, v_view_name name, v_refresh_rate_in_sec integer) OWNER TO engineer;

--
-- Name: creatematerializedviewas(name, integer, boolean, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION creatematerializedviewas(v_view_name name, v_refresh_rate_in_sec integer, v_custom boolean, v_min_refesh_rate_in_sec integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
     v_entry materialized_views%ROWTYPE;
     v_renamed_view NAME;
 BEGIN
     IF FOUND THEN
         RAISE EXCEPTION 'Materialized view % already exists.',
           v_view_name;
     END IF;

     v_renamed_view := v_view_name || '_mt_base';
     EXECUTE  'ALTER VIEW ' ||  v_view_name || ' RENAME TO ' || v_renamed_view;
     perform CreateMaterializedView(v_view_name, v_renamed_view, v_refresh_rate_in_sec, v_custom, v_min_refesh_rate_in_sec);

     RETURN;
 END; $$;


ALTER FUNCTION public.creatematerializedviewas(v_view_name name, v_refresh_rate_in_sec integer, v_custom boolean, v_min_refesh_rate_in_sec integer) OWNER TO engineer;

--
-- Name: creatematerializedviewas(name, integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION creatematerializedviewas(v_view_name name, v_refresh_rate_in_sec integer, v_min_refesh_rate_in_sec integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
 BEGIN
     PERFORM CreateMaterializedViewAs(v_view_name, v_refresh_rate_in_sec, false, v_min_refesh_rate_in_sec);
     RETURN;
 END; $$;


ALTER FUNCTION public.creatematerializedviewas(v_view_name name, v_refresh_rate_in_sec integer, v_min_refesh_rate_in_sec integer) OWNER TO engineer;

--
-- Name: creatematerializedviewas(name, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION creatematerializedviewas(v_view_name name, v_refresh_rate_in_sec integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    PERFORM  CreateMaterializedViewAs(v_view_name, v_refresh_rate_in_sec, false, 0);
END; $$;


ALTER FUNCTION public.creatematerializedviewas(v_view_name name, v_refresh_rate_in_sec integer) OWNER TO engineer;

--
-- Name: delete_entity_snapshot_by_command_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION delete_entity_snapshot_by_command_id(v_command_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
	BEGIN
		delete from business_entity_snapshot where command_id = v_command_id;
	END;
	RETURN;
END; $$;


ALTER FUNCTION public.delete_entity_snapshot_by_command_id(v_command_id uuid) OWNER TO engineer;

--
-- Name: delete_roles_groups(integer, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION delete_roles_groups(v_action_group_id integer, v_role_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   DELETE FROM roles_groups
   WHERE action_group_id = v_action_group_id AND role_id = v_role_id;

END; $$;


ALTER FUNCTION public.delete_roles_groups(v_action_group_id integer, v_role_id uuid) OWNER TO engineer;

--
-- Name: deleteaction_version_map(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteaction_version_map(v_action_type integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   DELETE FROM action_version_map
   WHERE action_type = v_action_type;

END; $$;


ALTER FUNCTION public.deleteaction_version_map(v_action_type integer) OWNER TO engineer;

--
-- Name: deletead_groups(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletead_groups(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      DELETE FROM tags_user_group_map
      WHERE group_id = v_id;
      DELETE FROM ad_groups
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.deletead_groups(v_id uuid) OWNER TO engineer;

--
-- Name: deletealluser_sessions(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletealluser_sessions() RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      TRUNCATE TABLE user_sessions;
      UPDATE users
      SET session_count = 0
      WHERE
      session_count > 0;
END; $$;


ALTER FUNCTION public.deletealluser_sessions() OWNER TO engineer;

--
-- Name: deleteasync_tasks(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteasync_tasks(v_task_id uuid) RETURNS integer
    LANGUAGE plpgsql
    AS $$
DECLARE
deleted_rows int;
BEGIN
   DELETE FROM async_tasks
   WHERE task_id = v_task_id;
   GET DIAGNOSTICS deleted_rows = ROW_COUNT;
   RETURN deleted_rows;

END; $$;


ALTER FUNCTION public.deleteasync_tasks(v_task_id uuid) OWNER TO engineer;

--
-- Name: deleteauditalertlogbyvdsidandtype(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteauditalertlogbyvdsidandtype(v_vds_id uuid, v_log_type integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE audit_log set deleted = true
      where vds_id = v_vds_id and log_type = v_log_type;
END; $$;


ALTER FUNCTION public.deleteauditalertlogbyvdsidandtype(v_vds_id uuid, v_log_type integer) OWNER TO engineer;

--
-- Name: deleteauditlog(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteauditlog(v_audit_log_id integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE audit_log SET deleted = true
      WHERE audit_log_id = v_audit_log_id;
END; $$;


ALTER FUNCTION public.deleteauditlog(v_audit_log_id integer) OWNER TO engineer;

--
-- Name: deleteauditlogalertsbyvdsid(uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteauditlogalertsbyvdsid(v_vds_id uuid, v_delete_config_alerts boolean DEFAULT true) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_min_alret_severity  INTEGER;
   v_no_config_alret_type  INTEGER;
   v_no_max_alret_type  INTEGER;
BEGIN
      v_min_alret_severity := 10;
      v_no_config_alret_type := 9000;
      v_no_max_alret_type := 9005;
      if (v_delete_config_alerts = true) then
         UPDATE audit_log set deleted = true
         where vds_id = v_vds_id and severity >= v_min_alret_severity and
         log_type  between v_no_config_alret_type and v_no_max_alret_type;
      else
         UPDATE audit_log set deleted = true
         where vds_id = v_vds_id and severity >= v_min_alret_severity and
         log_type  between v_no_config_alret_type + 1 and v_no_max_alret_type;
      end if;
END; $$;


ALTER FUNCTION public.deleteauditlogalertsbyvdsid(v_vds_id uuid, v_delete_config_alerts boolean) OWNER TO engineer;

--
-- Name: deleteauditlogolderthendate(timestamp with time zone); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteauditlogolderthendate(v_date timestamp with time zone) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_id  INTEGER;
   SWV_RowCount INTEGER;
BEGIN
        -- get first the id from which to remove in order to use index
      select   audit_log_id INTO v_id FROM audit_log WHERE LOG_TIME < v_date   order by audit_log_id desc LIMIT 1;
        -- check if there are candidates to remove
      GET DIAGNOSTICS SWV_RowCount = ROW_COUNT;
      if (SWV_RowCount > 0) then
         DELETE FROM audit_log
         WHERE audit_log_id <= v_id and
         audit_log_id not in(select audit_log_id from event_notification_hist);
      end if;
END; $$;


ALTER FUNCTION public.deleteauditlogolderthendate(v_date timestamp with time zone) OWNER TO engineer;

--
-- Name: deletebasedisk(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletebasedisk(v_disk_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
    v_val  UUID;
BEGIN
    DELETE
    FROM   base_disks
    WHERE  disk_id = v_disk_id;

    -- Delete the disk's permissions
   DELETE FROM permissions WHERE object_id = v_disk_id;
END; $$;


ALTER FUNCTION public.deletebasedisk(v_disk_id uuid) OWNER TO engineer;

--
-- Name: deletebookmark(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletebookmark(v_bookmark_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      DELETE FROM bookmarks
      WHERE bookmark_Id = v_bookmark_id;
END; $$;


ALTER FUNCTION public.deletebookmark(v_bookmark_id uuid) OWNER TO engineer;

--
-- Name: deletebypoolvds_spm_id_map(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletebypoolvds_spm_id_map(v_vds_id uuid, v_storage_pool_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   DELETE FROM vds_spm_id_map
   WHERE vds_id = v_vds_id AND storage_pool_id = v_storage_pool_id;

END; $$;


ALTER FUNCTION public.deletebypoolvds_spm_id_map(v_vds_id uuid, v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: deletecompletedjobsolderthandate(timestamp with time zone, timestamp with time zone); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletecompletedjobsolderthandate(v_succeeded_end_time timestamp with time zone, v_failed_end_time timestamp with time zone) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE FROM job
    WHERE (end_time < v_succeeded_end_time
    AND    status = 'FINISHED')
    OR    (end_time < v_failed_end_time
    AND    status IN ('FAILED', 'ABORTED', 'UNKNOWN'));
END; $$;


ALTER FUNCTION public.deletecompletedjobsolderthandate(v_succeeded_end_time timestamp with time zone, v_failed_end_time timestamp with time zone) OWNER TO engineer;

--
-- Name: deletecustom_actions(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletecustom_actions(v_action_id integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      DELETE FROM custom_actions
      WHERE action_id = v_action_id;
END; $$;


ALTER FUNCTION public.deletecustom_actions(v_action_id integer) OWNER TO engineer;

--
-- Name: deletedisk_image_dynamic(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletedisk_image_dynamic(v_image_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   DELETE FROM disk_image_dynamic
   WHERE image_id = v_image_id;

END; $$;


ALTER FUNCTION public.deletedisk_image_dynamic(v_image_id uuid) OWNER TO engineer;

--
-- Name: deletedisklunmap(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletedisklunmap(v_disk_id uuid, v_lun_id character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE
    FROM   disk_lun_map
    WHERE  disk_id = v_disk_id
    AND    lun_id = v_lun_id;
END; $$;


ALTER FUNCTION public.deletedisklunmap(v_disk_id uuid, v_lun_id character varying) OWNER TO engineer;

--
-- Name: deleteevent_notification_hist(timestamp without time zone); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteevent_notification_hist(v_sent_at timestamp without time zone) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      DELETE FROM event_notification_hist WHERE sent_at < v_sent_at;
END; $$;


ALTER FUNCTION public.deleteevent_notification_hist(v_sent_at timestamp without time zone) OWNER TO engineer;

--
-- Name: deleteevent_subscriber(character varying, integer, uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteevent_subscriber(v_event_up_name character varying, v_method_id integer, v_subscriber_id uuid, v_tag_name character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      if (v_tag_name IS NULL) then
         delete from event_subscriber
         where event_up_name = v_event_up_name
         and method_id = v_method_id
         and subscriber_id = v_subscriber_id;
      else
         delete from event_subscriber
         where event_up_name = v_event_up_name
         and method_id = v_method_id
         and subscriber_id = v_subscriber_id
         and tag_name = v_tag_name;
      end if;
END; $$;


ALTER FUNCTION public.deleteevent_subscriber(v_event_up_name character varying, v_method_id integer, v_subscriber_id uuid, v_tag_name character varying) OWNER TO engineer;

--
-- Name: deleteglustervolumeaccessprotocol(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteglustervolumeaccessprotocol(v_volume_id uuid, v_access_protocol character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE FROM gluster_volume_access_protocols
    WHERE volume_id = v_volume_id
    AND   access_protocol = v_access_protocol;
END; $$;


ALTER FUNCTION public.deleteglustervolumeaccessprotocol(v_volume_id uuid, v_access_protocol character varying) OWNER TO engineer;

--
-- Name: deleteglustervolumebrick(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteglustervolumebrick(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE FROM gluster_volume_bricks
    WHERE id = v_id;
END; $$;


ALTER FUNCTION public.deleteglustervolumebrick(v_id uuid) OWNER TO engineer;

--
-- Name: deleteglustervolumebricks(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteglustervolumebricks(v_ids character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE FROM gluster_volume_bricks
    WHERE id in (select * from fnSplitterUuid(v_ids));
END; $$;


ALTER FUNCTION public.deleteglustervolumebricks(v_ids character varying) OWNER TO engineer;

--
-- Name: deleteglustervolumebyguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteglustervolumebyguid(v_volume_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE FROM gluster_volumes
    WHERE id = v_volume_id;
END; $$;


ALTER FUNCTION public.deleteglustervolumebyguid(v_volume_id uuid) OWNER TO engineer;

--
-- Name: deleteglustervolumebyname(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteglustervolumebyname(v_cluster_id uuid, v_vol_name character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE FROM gluster_volumes
    WHERE cluster_id = v_cluster_id
    AND   vol_name = v_vol_name;
END; $$;


ALTER FUNCTION public.deleteglustervolumebyname(v_cluster_id uuid, v_vol_name character varying) OWNER TO engineer;

--
-- Name: deleteglustervolumeoption(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteglustervolumeoption(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE FROM gluster_volume_options
    WHERE id = v_id;
END; $$;


ALTER FUNCTION public.deleteglustervolumeoption(v_id uuid) OWNER TO engineer;

--
-- Name: deleteglustervolumeoptions(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteglustervolumeoptions(v_ids character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE FROM gluster_volume_options
    WHERE id in (select * from fnSplitterUuid(v_ids));
END; $$;


ALTER FUNCTION public.deleteglustervolumeoptions(v_ids character varying) OWNER TO engineer;

--
-- Name: deleteglustervolumesbyclusterid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteglustervolumesbyclusterid(v_cluster_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
DELETE FROM gluster_volumes
WHERE cluster_id = v_cluster_id;
END; $$;


ALTER FUNCTION public.deleteglustervolumesbyclusterid(v_cluster_id uuid) OWNER TO engineer;

--
-- Name: deleteglustervolumesbyguids(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteglustervolumesbyguids(v_volume_ids character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE FROM gluster_volumes
    WHERE id in (select * from fnSplitterUuid(v_volume_ids));
END; $$;


ALTER FUNCTION public.deleteglustervolumesbyguids(v_volume_ids character varying) OWNER TO engineer;

--
-- Name: deleteglustervolumetransporttype(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteglustervolumetransporttype(v_volume_id uuid, v_transport_type character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE FROM gluster_volume_transport_types
    WHERE volume_id = v_volume_id
    AND   transport_type = v_transport_type;
END; $$;


ALTER FUNCTION public.deleteglustervolumetransporttype(v_volume_id uuid, v_transport_type character varying) OWNER TO engineer;

--
-- Name: deleteimage(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteimage(v_image_guid uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
    v_val  UUID;
BEGIN
    DELETE
    FROM   images
    WHERE  image_guid = v_image_guid;
END; $$;


ALTER FUNCTION public.deleteimage(v_image_guid uuid) OWNER TO engineer;

--
-- Name: deleteimage_storage_domain_map(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteimage_storage_domain_map(v_image_id uuid, v_storage_domain_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   DELETE FROM image_storage_domain_map
   WHERE image_id = v_image_id AND storage_domain_id = v_storage_domain_id;

END; $$;


ALTER FUNCTION public.deleteimage_storage_domain_map(v_image_id uuid, v_storage_domain_id uuid) OWNER TO engineer;

--
-- Name: deleteimage_storage_domain_map_by_image_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteimage_storage_domain_map_by_image_id(v_image_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   DELETE FROM image_storage_domain_map
   WHERE image_id = v_image_id;

END; $$;


ALTER FUNCTION public.deleteimage_storage_domain_map_by_image_id(v_image_id uuid) OWNER TO engineer;

--
-- Name: deletejob(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletejob(v_job_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE FROM job
    WHERE job_id = v_job_id;
END; $$;


ALTER FUNCTION public.deletejob(v_job_id uuid) OWNER TO engineer;

--
-- Name: deletejobolderthandatewithstatus(timestamp with time zone, text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletejobolderthandatewithstatus(v_end_time timestamp with time zone, v_status text) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE FROM job
    WHERE end_time < v_end_time
    AND status = any (string_to_array(v_status,',')::VARCHAR[] );
END; $$;


ALTER FUNCTION public.deletejobolderthandatewithstatus(v_end_time timestamp with time zone, v_status text) OWNER TO engineer;

--
-- Name: deletelun(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletelun(v_lun_id character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  VARCHAR(50);
BEGIN

	-- Get (and keep) a shared lock with "right to upgrade to exclusive"
	-- in order to force locking parent before children
   select   LUN_id INTO v_val FROM LUNs  WHERE LUN_id = v_LUN_id     FOR UPDATE;

   DELETE FROM LUNs
   WHERE LUN_id = v_LUN_id;

END; $$;


ALTER FUNCTION public.deletelun(v_lun_id character varying) OWNER TO engineer;

--
-- Name: deletelun_storage_server_connection_map(character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletelun_storage_server_connection_map(v_lun_id character varying, v_storage_server_connection character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   DELETE FROM LUN_storage_server_connection_map
   WHERE LUN_id = v_LUN_id AND storage_server_connection = v_storage_server_connection;

END; $$;


ALTER FUNCTION public.deletelun_storage_server_connection_map(v_lun_id character varying, v_storage_server_connection character varying) OWNER TO engineer;

--
-- Name: deletenetwork(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletenetwork(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  UUID;
BEGIN

	-- Get (and keep) a shared lock with "right to upgrade to exclusive"
	-- in order to force locking parent before children
   select   id INTO v_val FROM network  WHERE id = v_id     FOR UPDATE;

   DELETE FROM network
   WHERE id = v_id;

   -- Delete the network's permissions
   DELETE FROM permissions WHERE object_id = v_id;

END; $$;


ALTER FUNCTION public.deletenetwork(v_id uuid) OWNER TO engineer;

--
-- Name: deletenetwork_cluster(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletenetwork_cluster(v_cluster_id uuid, v_network_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   DELETE FROM network_cluster
   WHERE cluster_id = v_cluster_id AND network_id = v_network_id;

END; $$;


ALTER FUNCTION public.deletenetwork_cluster(v_cluster_id uuid, v_network_id uuid) OWNER TO engineer;

--
-- Name: deleteovfgenerations(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteovfgenerations(v_vms_ids character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE FROM vm_ovf_generations WHERE vm_guid IN (SELECT * FROM fnSplitterUuid(v_vms_ids))
    -- needed here to ensure that vm with the same id hasn't been added by import vm/template command
    AND vm_guid NOT IN (SELECT vm_guid FROM vm_static);
END; $$;


ALTER FUNCTION public.deleteovfgenerations(v_vms_ids character varying) OWNER TO engineer;

--
-- Name: deletepermission(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletepermission(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  UUID;
BEGIN

	-- Get (and keep) a shared lock with "right to upgrade to exclusive"
	-- in order to force locking parent before children
   select   id INTO v_val FROM permissions  WHERE id = v_id     FOR UPDATE;

   DELETE FROM permissions
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.deletepermission(v_id uuid) OWNER TO engineer;

--
-- Name: deletepermissionsbyentityid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletepermissionsbyentityid(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
   DELETE FROM permissions
   WHERE object_id = v_id;
END; $$;


ALTER FUNCTION public.deletepermissionsbyentityid(v_id uuid) OWNER TO engineer;

--
-- Name: deletequotabyquotaguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletequotabyquotaguid(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
   DELETE FROM quota
   WHERE id = v_id;
END; $$;


ALTER FUNCTION public.deletequotabyquotaguid(v_id uuid) OWNER TO engineer;

--
-- Name: deletequotalimitationbyquotaguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletequotalimitationbyquotaguid(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
   DELETE FROM quota_limitation
   WHERE quota_id = v_id;
END; $$;


ALTER FUNCTION public.deletequotalimitationbyquotaguid(v_id uuid) OWNER TO engineer;

--
-- Name: deleterepo_domain_file_list(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleterepo_domain_file_list(v_repo_domain_id uuid, v_file_type integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   DELETE FROM repo_file_meta_data
   WHERE repo_domain_id = v_repo_domain_id
     AND file_type = v_file_type;

   RETURN;
END; $$;


ALTER FUNCTION public.deleterepo_domain_file_list(v_repo_domain_id uuid, v_file_type integer) OWNER TO engineer;

--
-- Name: deleterole(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleterole(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  UUID;
BEGIN

	-- Get (and keep) a shared lock with "right to upgrade to exclusive"
    -- in order to force locking parent before children
   select   id INTO v_val FROM roles  WHERE id = v_id     FOR UPDATE;

   DELETE FROM roles
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.deleterole(v_id uuid) OWNER TO engineer;

--
-- Name: deleteroles_relations(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteroles_relations(v_role_container_id uuid, v_role_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   DELETE FROM roles_relations
   WHERE role_container_id = v_role_container_id AND role_id = v_role_id;

END; $$;


ALTER FUNCTION public.deleteroles_relations(v_role_container_id uuid, v_role_id uuid) OWNER TO engineer;

--
-- Name: deletesnapshot(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletesnapshot(v_snapshot_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE
    FROM   snapshots
    WHERE  snapshot_id = v_snapshot_id;
END; $$;


ALTER FUNCTION public.deletesnapshot(v_snapshot_id uuid) OWNER TO engineer;

--
-- Name: deletestep(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletestep(v_step_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE FROM step
    WHERE step_id = v_step_id;
END; $$;


ALTER FUNCTION public.deletestep(v_step_id uuid) OWNER TO engineer;

--
-- Name: deletestorage_domain_dynamic(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletestorage_domain_dynamic(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   DELETE FROM storage_domain_dynamic
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.deletestorage_domain_dynamic(v_id uuid) OWNER TO engineer;

--
-- Name: deletestorage_domain_static(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletestorage_domain_static(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  UUID;
BEGIN

	-- Get (and keep) a shared lock with "right to upgrade to exclusive"
	-- in order to force locking parent before children
   select   id INTO v_val FROM storage_domain_static  WHERE id = v_id     FOR UPDATE;

   DELETE FROM storage_domain_static
   WHERE id = v_id;

	-- delete Storage permissions --
   DELETE FROM permissions where object_id = v_id;

END; $$;


ALTER FUNCTION public.deletestorage_domain_static(v_id uuid) OWNER TO engineer;

--
-- Name: deletestorage_pool(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletestorage_pool(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  UUID;
BEGIN

         -- Get (and keep) a shared lock with "right to upgrade to exclusive"
    select vm_guid INTO v_val FROM vm_static where vm_guid in (select vm_guid from vms where storage_pool_id = v_id) FOR UPDATE;
    DELETE
    FROM   snapshots
    WHERE  vm_id IN (
        SELECT vm_guid
        FROM   vms
        WHERE  storage_pool_id = v_id);
    delete FROM vm_static where vm_guid in (select vm_guid from vms where storage_pool_id = v_id);

	-- Get (and keep) a shared lock with "right to upgrade to exclusive"
	-- in order to force locking parent before children
   select   id INTO v_val FROM storage_pool  WHERE id = v_id     FOR UPDATE;

   DELETE FROM storage_pool
   WHERE id = v_id;

	-- delete StoragePool permissions --
   DELETE FROM permissions where object_id = v_id;

END; $$;


ALTER FUNCTION public.deletestorage_pool(v_id uuid) OWNER TO engineer;

--
-- Name: deletestorage_pool_iso_map(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletestorage_pool_iso_map(v_storage_id uuid, v_storage_pool_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   DELETE FROM storage_pool_iso_map
   WHERE storage_id = v_storage_id AND storage_pool_id = v_storage_pool_id;

END; $$;


ALTER FUNCTION public.deletestorage_pool_iso_map(v_storage_id uuid, v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: deletestorage_server_connections(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletestorage_server_connections(v_id character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  VARCHAR(50);
BEGIN

	-- Get (and keep) a shared lock with "right to upgrade to exclusive"
	-- in order to force locking parent before children
   select   id INTO v_val FROM storage_server_connections  WHERE id = v_id     FOR UPDATE;

   DELETE FROM storage_server_connections
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.deletestorage_server_connections(v_id character varying) OWNER TO engineer;

--
-- Name: deletetags(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletetags(v_tag_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  UUID;
BEGIN
			-- Get (and keep) a shared lock with "right to upgrade to exclusive"
			-- in order to force locking parent before children
      select   tag_id INTO v_val FROM tags  WHERE tag_id = v_tag_id     FOR UPDATE;
      DELETE FROM tags_user_group_map
      WHERE tag_id = v_tag_id;
      DELETE FROM tags_user_map
      WHERE tag_id = v_tag_id;
      DELETE FROM tags_vm_map
      WHERE tag_id = v_tag_id;
      DELETE FROM tags_vds_map
      WHERE tag_id = v_tag_id;
      DELETE FROM tags_vm_pool_map
      WHERE tag_id = v_tag_id;
      DELETE FROM tags
      WHERE tag_id = v_tag_id;
END; $$;


ALTER FUNCTION public.deletetags(v_tag_id uuid) OWNER TO engineer;

--
-- Name: deletetags_user_group_map(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletetags_user_group_map(v_group_id uuid, v_tag_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      DELETE FROM tags_user_group_map
      WHERE group_id = v_group_id AND tag_id = v_tag_id;
END; $$;


ALTER FUNCTION public.deletetags_user_group_map(v_group_id uuid, v_tag_id uuid) OWNER TO engineer;

--
-- Name: deletetags_user_map(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletetags_user_map(v_tag_id uuid, v_user_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      DELETE FROM tags_user_map
      WHERE tag_id = v_tag_id AND user_id = v_user_id;
END; $$;


ALTER FUNCTION public.deletetags_user_map(v_tag_id uuid, v_user_id uuid) OWNER TO engineer;

--
-- Name: deletetags_vds_map(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletetags_vds_map(v_tag_id uuid, v_vds_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      DELETE FROM tags_vds_map
      WHERE tag_id = v_tag_id AND vds_id = v_vds_id;
END; $$;


ALTER FUNCTION public.deletetags_vds_map(v_tag_id uuid, v_vds_id uuid) OWNER TO engineer;

--
-- Name: deletetags_vm_map(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletetags_vm_map(v_tag_id uuid, v_vm_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      DELETE FROM tags_vm_map
      WHERE tag_id = v_tag_id AND vm_id = v_vm_id;
END; $$;


ALTER FUNCTION public.deletetags_vm_map(v_tag_id uuid, v_vm_id uuid) OWNER TO engineer;

--
-- Name: deletetags_vm_pool_map(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletetags_vm_pool_map(v_tag_id uuid, v_vm_pool_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   DELETE FROM tags_vm_pool_map
   WHERE tag_id = v_tag_id AND vm_pool_id = v_vm_pool_id;

END; $$;


ALTER FUNCTION public.deletetags_vm_pool_map(v_tag_id uuid, v_vm_pool_id uuid) OWNER TO engineer;

--
-- Name: deleteuser(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteuser(v_user_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  UUID;
BEGIN
			-- Get (and keep) a shared lock with "right to upgrade to exclusive"
			-- in order to force locking parent before children
      select   user_id INTO v_val FROM users  WHERE user_id = v_user_id     FOR UPDATE;
      DELETE FROM tags_user_map
      WHERE user_id = v_user_id;
      DELETE FROM users
      WHERE user_id = v_user_id;
END; $$;


ALTER FUNCTION public.deleteuser(v_user_id uuid) OWNER TO engineer;

--
-- Name: deleteuser_sessions(character, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteuser_sessions(v_session_id character, v_user_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_counter  INTEGER;
   SWV_RowCount INTEGER;
BEGIN
      DELETE FROM user_sessions
      WHERE session_id = v_session_id AND user_id = v_user_id;
      GET DIAGNOSTICS SWV_RowCount = ROW_COUNT;
      if (SWV_RowCount > 0) then
         select   session_count INTO v_counter from users WHERE
         user_id = v_user_id;
         if (v_counter > 0) then
            UPDATE users
            SET session_count = session_count -1
            WHERE
            user_id = v_user_id;
         end if;
      end if;
END; $$;


ALTER FUNCTION public.deleteuser_sessions(v_session_id character, v_user_id uuid) OWNER TO engineer;

--
-- Name: deleteuser_sessionsbyuser_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deleteuser_sessionsbyuser_id(v_user_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      DELETE FROM user_sessions
      WHERE user_id = v_user_id;
      UPDATE users
      SET session_count = 0
      WHERE
      user_id = v_user_id;
END; $$;


ALTER FUNCTION public.deleteuser_sessionsbyuser_id(v_user_id uuid) OWNER TO engineer;

--
-- Name: deletevdcoption(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevdcoption(v_option_id integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      DELETE FROM vdc_options
      WHERE option_id = v_option_id;
END; $$;


ALTER FUNCTION public.deletevdcoption(v_option_id integer) OWNER TO engineer;

--
-- Name: deletevds(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevds(v_vds_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
   BEGIN
      UPDATE vm_static
      SET dedicated_vm_for_vds = null
      WHERE dedicated_vm_for_vds = v_vds_id;
      DELETE FROM tags_vds_map
      WHERE vds_id = v_vds_id;
   -- Delete all Vds Alerts from the database
      PERFORM DeleteAuditLogAlertsByVdsID(v_vds_id);
      DELETE FROM vds_statistics WHERE vds_id = v_vds_id;
      DELETE FROM vds_dynamic WHERE vds_id = v_vds_id;
      DELETE FROM vds_static WHERE vds_id = v_vds_id;
      DELETE FROM permissions where object_id = v_vds_id;
   END;
   RETURN;
END; $$;


ALTER FUNCTION public.deletevds(v_vds_id uuid) OWNER TO engineer;

--
-- Name: deletevds_interface(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevds_interface(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   DELETE FROM vds_interface
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.deletevds_interface(v_id uuid) OWNER TO engineer;

--
-- Name: deletevds_interface_statistics(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevds_interface_statistics(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  UUID;
BEGIN

	-- Get (and keep) a shared lock with "right to upgrade to exclusive"
	-- in order to force locking parent before children
   select   id INTO v_val FROM vds_interface_statistics  WHERE id = v_id     FOR UPDATE;

   DELETE FROM vds_interface_statistics
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.deletevds_interface_statistics(v_id uuid) OWNER TO engineer;

--
-- Name: deletevds_spm_id_map(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevds_spm_id_map(v_vds_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   DELETE FROM vds_spm_id_map
   WHERE vds_id = v_vds_id;

END; $$;


ALTER FUNCTION public.deletevds_spm_id_map(v_vds_id uuid) OWNER TO engineer;

--
-- Name: deletevdsdynamic(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevdsdynamic(v_vds_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
   BEGIN
      DELETE FROM vds_dynamic
      WHERE vds_id = v_vds_id;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.deletevdsdynamic(v_vds_id uuid) OWNER TO engineer;

--
-- Name: deletevdsgroup(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevdsgroup(v_vds_group_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  UUID;
BEGIN
		-- Get (and keep) a shared lock with "right to upgrade to exclusive"
		-- in order to force locking parent before children
      select   vds_group_id INTO v_val FROM vds_groups  WHERE vds_group_id = v_vds_group_id     FOR UPDATE;
      DELETE FROM vds_groups
      WHERE vds_group_id = v_vds_group_id;
		-- delete VDS group permissions --
      DELETE FROM permissions where object_id = v_vds_group_id;
END; $$;


ALTER FUNCTION public.deletevdsgroup(v_vds_group_id uuid) OWNER TO engineer;

--
-- Name: deletevdsstatic(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevdsstatic(v_vds_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
   BEGIN
      UPDATE vm_static
      SET dedicated_vm_for_vds = null,
          migration_support = 0
      WHERE dedicated_vm_for_vds = v_vds_id;
      DELETE FROM tags_vds_map
      WHERE vds_id = v_vds_id;
   -- Delete all Vds Alerts from the database
      PERFORM DeleteAuditLogAlertsByVdsID(v_vds_id);
      DELETE FROM vds_static
      WHERE vds_id = v_vds_id;
	-- delete VDS permissions --
      DELETE FROM permissions where object_id = v_vds_id;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.deletevdsstatic(v_vds_id uuid) OWNER TO engineer;

--
-- Name: deletevdsstatistics(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevdsstatistics(v_vds_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
   BEGIN
      DELETE FROM vds_statistics
      WHERE vds_id = v_vds_id;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.deletevdsstatistics(v_vds_id uuid) OWNER TO engineer;

--
-- Name: deletevm(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevm(v_vm_guid uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_vmt_guid  UUID;
BEGIN
      select   vm_static.vmt_guid INTO v_vmt_guid FROM vm_static WHERE vm_guid = v_vm_guid;
      UPDATE vm_static
      SET child_count =(SELECT COUNT(*) FROM vm_static WHERE vmt_guid = v_vmt_guid) -1
      WHERE vm_guid = v_vmt_guid;
      DELETE FROM tags_vm_map
      WHERE vm_id = v_vm_guid;
      DELETE
      FROM   snapshots
      WHERE  vm_id = v_vm_guid;
      DELETE FROM vm_statistics WHERE vm_guid = v_vm_guid;
      DELETE FROM vm_dynamic WHERE vm_guid = v_vm_guid;
      DELETE FROM vm_static WHERE vm_guid = v_vm_guid;
      DELETE FROM permissions where object_id = v_vm_guid;
END; $$;


ALTER FUNCTION public.deletevm(v_vm_guid uuid) OWNER TO engineer;

--
-- Name: deletevm_interface(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevm_interface(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  UUID;
BEGIN

	-- Get (and keep) a shared lock with "right to upgrade to exclusive"
	-- in order to force locking parent before children
   select   id INTO v_val FROM vm_interface  WHERE id = v_id     FOR UPDATE;

   DELETE FROM vm_interface
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.deletevm_interface(v_id uuid) OWNER TO engineer;

--
-- Name: deletevm_interface_statistics(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevm_interface_statistics(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  UUID;
BEGIN

	-- Get (and keep) a shared lock with "right to upgrade to exclusive"
	-- in order to force locking parent before children
   select   id INTO v_val FROM vm_interface_statistics  WHERE id = v_id     FOR UPDATE;

   DELETE FROM vm_interface_statistics
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.deletevm_interface_statistics(v_id uuid) OWNER TO engineer;

--
-- Name: deletevm_pool_map(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevm_pool_map(v_vm_guid uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  VARCHAR(50);
BEGIN
		-- Get (and keep) a shared lock with "right to upgrade to exclusive"
		-- in order to force locking parent before children
      select   vm_guid INTO v_val FROM vm_pool_map  WHERE vm_guid = v_vm_guid     FOR UPDATE;
      DELETE FROM vm_pool_map
      WHERE vm_guid = v_vm_guid;
END; $$;


ALTER FUNCTION public.deletevm_pool_map(v_vm_guid uuid) OWNER TO engineer;

--
-- Name: deletevm_pools(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevm_pools(v_vm_pool_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  UUID;
BEGIN
		-- Get (and keep) a shared lock with "right to upgrade to exclusive"
		-- in order to force locking parent before children
      select   vm_pool_id INTO v_val FROM vm_pools  WHERE vm_pool_id = v_vm_pool_id     FOR UPDATE;
      DELETE FROM vm_pools
      WHERE vm_pool_id = v_vm_pool_id;

		-- delete VmPool permissions --
      DELETE FROM permissions where object_id = v_vm_pool_id;
END; $$;


ALTER FUNCTION public.deletevm_pools(v_vm_pool_id uuid) OWNER TO engineer;

--
-- Name: deletevmdevice(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevmdevice(v_device_id uuid, v_vm_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    DELETE
    FROM   vm_device
    WHERE  device_id = v_device_id
    AND (v_vm_id IS NULL or vm_id = v_vm_id);
END; $$;


ALTER FUNCTION public.deletevmdevice(v_device_id uuid, v_vm_id uuid) OWNER TO engineer;

--
-- Name: deletevmdynamic(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevmdynamic(v_vm_guid uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      DELETE FROM vm_dynamic
      WHERE vm_guid = v_vm_guid;
END; $$;


ALTER FUNCTION public.deletevmdynamic(v_vm_guid uuid) OWNER TO engineer;

--
-- Name: deletevmguestagentinterfacesbyvmid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevmguestagentinterfacesbyvmid(v_vm_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
   DELETE FROM vm_guest_agent_interfaces
   WHERE vm_id = v_vm_id;
END; $$;


ALTER FUNCTION public.deletevmguestagentinterfacesbyvmid(v_vm_id uuid) OWNER TO engineer;

--
-- Name: deletevmstatic(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevmstatic(v_vm_guid uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  UUID;
BEGIN
			-- Get (and keep) a shared lock with "right to upgrade to exclusive"
            -- in order to force locking parent before children
      select   vm_guid INTO v_val FROM vm_static  WHERE vm_guid = v_vm_guid     FOR UPDATE;
      DELETE FROM vm_static
      WHERE vm_guid = v_vm_guid
      AND   entity_type = 'VM';

			-- delete VM permissions --
      DELETE FROM permissions where object_id = v_vm_guid;
END; $$;


ALTER FUNCTION public.deletevmstatic(v_vm_guid uuid) OWNER TO engineer;

--
-- Name: deletevmstatistics(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevmstatistics(v_vm_guid uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      DELETE FROM vm_statistics
      WHERE vm_guid = v_vm_guid;
END; $$;


ALTER FUNCTION public.deletevmstatistics(v_vm_guid uuid) OWNER TO engineer;

--
-- Name: deletevmtemplates(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION deletevmtemplates(v_vmt_guid uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_val  UUID;
BEGIN
        -- Get (and keep) a shared lock with "right to upgrade to exclusive"
		-- in order to force locking parent before children
      select   vm_guid INTO v_val FROM vm_static  WHERE vm_guid = v_vmt_guid AND entity_type = 'TEMPLATE' FOR UPDATE;
      DELETE FROM vm_static
      WHERE vm_guid = v_vmt_guid
      AND   entity_type = 'TEMPLATE';
		-- delete Template permissions --
      DELETE FROM permissions where object_id = v_vmt_guid;
END; $$;


ALTER FUNCTION public.deletevmtemplates(v_vmt_guid uuid) OWNER TO engineer;

--
-- Name: dropallcustommaterializedviews(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION dropallcustommaterializedviews() RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
    v_cur CURSOR FOR SELECT * FROM materialized_views where custom;
    v_record materialized_views%ROWTYPE;
BEGIN
       OPEN v_cur;
       -- loop on all entries in materialized_views
       LOOP
           FETCH v_cur INTO v_record;
           EXIT WHEN NOT FOUND;
           perform DropMaterializedView(v_record.mv_name);
       END LOOP;
       CLOSE v_cur;
END; $$;


ALTER FUNCTION public.dropallcustommaterializedviews() OWNER TO engineer;

--
-- Name: dropallmaterializedviews(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION dropallmaterializedviews() RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
    v_cur CURSOR FOR SELECT * FROM materialized_views;
    v_record materialized_views%ROWTYPE;
BEGIN
       OPEN v_cur;
       -- loop on all entries in materialized_views
       LOOP
           FETCH v_cur INTO v_record;
           EXIT WHEN NOT FOUND;
           perform DropMaterializedView(v_record.mv_name);
       END LOOP;
       CLOSE v_cur;
END; $$;


ALTER FUNCTION public.dropallmaterializedviews() OWNER TO engineer;

--
-- Name: dropmaterializedview(name); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION dropmaterializedview(v_matview name) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
     v_entry materialized_views%ROWTYPE;
 BEGIN

     SELECT * INTO v_entry FROM materialized_views WHERE mv_name = v_matview;

     IF NOT FOUND THEN
         RAISE EXCEPTION 'Materialized view % does not exist.', v_matview;
     END IF;

     EXECUTE 'DROP TABLE ' || v_matview || ' CASCADE';
     DELETE FROM materialized_views WHERE mv_name=v_matview;

     RETURN;
 END; $$;


ALTER FUNCTION public.dropmaterializedview(v_matview name) OWNER TO engineer;

--
-- Name: fn_db_add_action_group_to_role(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_add_action_group_to_role(v_role_id uuid, v_action_group_id integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
       INSERT INTO roles_groups(role_id,action_group_id)
       SELECT v_role_id, v_action_group_id
       WHERE NOT EXISTS (SELECT 1
                         FROM roles_groups
                         WHERE role_id = v_role_id
                         AND action_group_id = v_action_group_id);
RETURN;
END; $$;


ALTER FUNCTION public.fn_db_add_action_group_to_role(v_role_id uuid, v_action_group_id integer) OWNER TO engineer;

--
-- Name: fn_db_add_column(character varying, character varying, text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_add_column(v_table character varying, v_column character varying, v_column_def text) RETURNS void
    LANGUAGE plpgsql
    AS $$
declare
v_sql text;

begin
	if (not exists (select 1 from information_schema.columns where table_name ilike v_table and column_name ilike v_column)) then
	    begin
		v_sql := 'ALTER TABLE ' || v_table || ' ADD COLUMN ' || v_column || ' ' || v_column_def;
		EXECUTE v_sql;
            end;
	end if;
END; $$;


ALTER FUNCTION public.fn_db_add_column(v_table character varying, v_column character varying, v_column_def text) OWNER TO engineer;

--
-- Name: fn_db_add_column_to_object_white_list(character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_add_column_to_object_white_list(v_object_name character varying, v_column_name character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
begin
    if (not exists (select 1 from object_column_white_list
                    where object_name = v_object_name and column_name = v_column_name)) then
        begin
            -- verify that there is such object in db
            if exists (select 1 from information_schema.columns
                       where table_name = v_object_name and column_name = v_column_name) then
                insert into object_column_white_list (object_name, column_name) values (v_object_name, v_column_name);
            end if;
        end;
    end if;
END; $$;


ALTER FUNCTION public.fn_db_add_column_to_object_white_list(v_object_name character varying, v_column_name character varying) OWNER TO engineer;

--
-- Name: fn_db_add_config_value(character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_add_config_value(v_option_name character varying, v_option_value character varying, v_version character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
begin
    if (not exists (select 1 from vdc_options where option_name ilike v_option_name and version = v_version)) then
        begin
            insert into vdc_options (option_name, option_value, version) values (v_option_name, v_option_value, v_version);
        end;
    end if;
END; $$;


ALTER FUNCTION public.fn_db_add_config_value(v_option_name character varying, v_option_value character varying, v_version character varying) OWNER TO engineer;

--
-- Name: fn_db_change_column_type(character varying, character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_change_column_type(v_table character varying, v_column character varying, v_type character varying, v_new_type character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
declare
v_sql text;

begin
	if (exists (select 1 from information_schema.columns where table_name ilike v_table and column_name ilike v_column and (udt_name ilike v_type or data_type ilike v_type))) then
	    begin
		v_sql := 'ALTER TABLE ' || v_table || ' ALTER COLUMN ' || v_column || ' TYPE ' || v_new_type;
		EXECUTE v_sql;
            end;
	end if;
END; $$;


ALTER FUNCTION public.fn_db_change_column_type(v_table character varying, v_column character varying, v_type character varying, v_new_type character varying) OWNER TO engineer;

--
-- Name: fn_db_create_constraint(character varying, character varying, text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_create_constraint(v_table character varying, v_constraint character varying, v_constraint_sql text) RETURNS void
    LANGUAGE plpgsql
    AS $$
begin
    if  NOT EXISTS (SELECT 1 from pg_constraint where conname ilike v_constraint) then
        execute 'ALTER TABLE ' || v_table ||  ' ADD CONSTRAINT ' || v_constraint || ' ' || v_constraint_sql;
    end if;
END; $$;


ALTER FUNCTION public.fn_db_create_constraint(v_table character varying, v_constraint character varying, v_constraint_sql text) OWNER TO engineer;

--
-- Name: fn_db_delete_config_for_version(text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_delete_config_for_version(v_version text) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
     delete from vdc_options where version in (select ID from fnSplitter(v_version));
END; $$;


ALTER FUNCTION public.fn_db_delete_config_for_version(v_version text) OWNER TO engineer;

--
-- Name: fn_db_delete_config_value(character varying, text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_delete_config_value(v_option_name character varying, v_version text) RETURNS void
    LANGUAGE plpgsql
    AS $$
begin
    if (exists (select 1 from vdc_options where option_name ilike v_option_name and version in (select ID from fnSplitter(v_version)))) then
        begin
            delete from vdc_options where option_name ilike v_option_name and version in (select ID from fnSplitter(v_version));
        end;
    end if;
END; $$;


ALTER FUNCTION public.fn_db_delete_config_value(v_option_name character varying, v_version text) OWNER TO engineer;

--
-- Name: fn_db_delete_version_map(character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_delete_version_map(v_cluster_version character varying, v_sp_version character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
   DELETE
   FROM action_version_map
   WHERE cluster_minimal_version = v_cluster_version
     AND storage_pool_minimal_version = v_sp_version;
END; $$;


ALTER FUNCTION public.fn_db_delete_version_map(v_cluster_version character varying, v_sp_version character varying) OWNER TO engineer;

--
-- Name: fn_db_drop_column(character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_drop_column(v_table character varying, v_column character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
declare
v_sql text;
begin
        if (exists (select 1 from information_schema.columns where table_name ilike v_table and column_name ilike v_column)) then
            begin
                v_sql := 'ALTER TABLE ' || v_table || ' DROP COLUMN ' || v_column;
                EXECUTE v_sql;
            end;
        end if;
end;$$;


ALTER FUNCTION public.fn_db_drop_column(v_table character varying, v_column character varying) OWNER TO engineer;

--
-- Name: fn_db_drop_constraint(character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_drop_constraint(v_table character varying, v_constraint character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
begin
    if  EXISTS (SELECT 1 from pg_constraint where conname ilike v_constraint) then
        execute 'ALTER TABLE ' || v_table ||  ' DROP CONSTRAINT ' || v_constraint || ' CASCADE';
    end if;
END; $$;


ALTER FUNCTION public.fn_db_drop_constraint(v_table character varying, v_constraint character varying) OWNER TO engineer;

--
-- Name: fn_db_get_async_tasks(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_get_async_tasks() RETURNS SETOF async_tasks_info_rs
    LANGUAGE plpgsql
    AS $$
DECLARE
    v_record async_tasks_info_rs;

    -- selects storage_pool_id uuid found in async_tasks
    v_tasks_cursor cursor for select distinct storage_pool_id from async_tasks;
begin

    OPEN v_tasks_cursor;
    FETCH v_tasks_cursor into v_record.dc_id;
    WHILE FOUND LOOP
        -- get dc_name and SPM Host id
        v_record.dc_name := name from storage_pool where id = v_record.dc_id;
        v_record.spm_host_id :=
            spm_vds_id from storage_pool where id = v_record.dc_id;
        -- get Host name if we have non NULL SPM Host
        if (v_record.spm_host_id IS NOT NULL) then
            v_record.spm_host_name :=
                vds_name from vds_static where vds_id = v_record.spm_host_id;
        else
            v_record.spm_host_name:='';
        end if;
        -- get tasks count for this DC
        v_record.task_count := count(*) from async_tasks
            where position (cast(v_record.dc_id as varchar) in action_parameters) > 0;
        -- return the record
        RETURN NEXT v_record;
        FETCH v_tasks_cursor into v_record.dc_id;
    END LOOP;
    CLOSE v_tasks_cursor;
    -- return full set of generated records
    RETURN;
END; $$;


ALTER FUNCTION public.fn_db_get_async_tasks() OWNER TO engineer;

--
-- Name: fn_db_grant_action_group_to_all_roles_filter(integer, uuid[]); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_grant_action_group_to_all_roles_filter(v_action_group_id integer, uuid[]) RETURNS void
    LANGUAGE plpgsql
    AS $_$
declare
v_role_id_to_filter alias for $2;
begin
    insert into roles_groups (role_id, action_group_id)
    select distinct role_id, v_action_group_id
    from roles_groups rg
    where not ARRAY [role_id] <@ v_role_id_to_filter and not exists (select 1 from roles_groups where role_id = rg.role_id and action_group_id = v_action_group_id);
END; $_$;


ALTER FUNCTION public.fn_db_grant_action_group_to_all_roles_filter(v_action_group_id integer, uuid[]) OWNER TO engineer;

--
-- Name: fn_db_mask_object(regclass); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_mask_object(v_object regclass) RETURNS SETOF record
    LANGUAGE plpgsql
    AS $$
DECLARE
    v_sql TEXT;
    v_table record;
    v_table_name TEXT;
    temprec record;
BEGIN
    -- get full table/view name from v_object (i.e <namespace>.<name>)
    select c.relname, n.nspname INTO v_table
        FROM pg_class c join pg_namespace n on c.relnamespace = n.oid WHERE c.oid = v_object;
    -- try to get filtered query syntax from previous execution
    if exists (select 1 from object_column_white_list_sql where object_name = v_table.relname) then
	select sql into v_sql from object_column_white_list_sql where object_name = v_table.relname;
    else
        v_table_name := quote_ident( v_table.nspname ) || '.' || quote_ident( v_table.relname );
        -- compose sql statement while skipping values for columns not defined in object_column_white_list for this table.
        for temprec in select a.attname, t.typname
                       FROM pg_attribute a join pg_type t on a.atttypid = t.oid
                       WHERE a.attrelid = v_object AND a.attnum > 0 AND NOT a.attisdropped ORDER BY a.attnum
        loop
            v_sql := coalesce( v_sql || ', ', 'SELECT ' );
            if exists(select 1 from object_column_white_list
               where object_name = v_table.relname and column_name = temprec.attname) then
               v_sql := v_sql || quote_ident( temprec.attname );
            ELSE
               v_sql := v_sql || 'NULL::' || quote_ident( temprec.typname ) || ' as ' || quote_ident( temprec.attname );
            END IF;
        END LOOP;
        v_sql := v_sql || ' FROM ' || v_table_name;
        v_sql := 'SELECT x::' || v_table_name || ' as rec FROM (' || v_sql || ') as x';
        -- save generated query for further use
        insert into object_column_white_list_sql(object_name,sql) values (v_table.relname, v_sql);
    end if;
    RETURN QUERY EXECUTE v_sql;
END; $$;


ALTER FUNCTION public.fn_db_mask_object(v_object regclass) OWNER TO engineer;

--
-- Name: fn_db_rename_column(character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_rename_column(v_table character varying, v_column character varying, v_new_name character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
declare
v_sql text;

begin
	if (exists (select 1 from information_schema.columns where table_name ilike v_table and column_name ilike v_column)) then
	    begin
		v_sql := 'ALTER TABLE ' || v_table || ' RENAME COLUMN ' || v_column || ' TO ' || v_new_name;
		EXECUTE v_sql;
            end;
	end if;
END; $$;


ALTER FUNCTION public.fn_db_rename_column(v_table character varying, v_column character varying, v_new_name character varying) OWNER TO engineer;

--
-- Name: fn_db_split_config_value(character varying, character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_split_config_value(v_option_name character varying, v_old_option_value character varying, v_new_option_value character varying, v_update_from_version character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
declare
v_old_value varchar(4000);
v_cur cursor for select distinct version from vdc_options where version <> 'general' order by version;
v_version varchar(40);
v_index integer;
v_count integer;
v_total_count integer;
v_version_count integer;
begin
    v_total_count := count(version) from vdc_options where option_name = v_option_name;
    v_old_value := option_value from vdc_options where option_name = v_option_name and version = 'general';
    v_version_count := count(distinct version) from vdc_options where version <> 'general';
    if (v_total_count <= v_version_count) then
        begin
            if (v_old_value IS NULL) then
                v_old_value := v_old_option_value;
            end if;
            v_count := count(distinct version) from vdc_options where version <> 'general';
            v_index := 1;
        open v_cur;
        loop
            fetch v_cur into v_version;
            exit when not found;
            -- We shouldn't update if already exists
            if (not exists (select 1 from vdc_options where option_name = v_option_name and version = v_version)) then
                -- Might not work well for versions such as 3.10, but we currently don't have any
                if (v_version >= v_update_from_version) then
                    insert into vdc_options (option_name, option_value, version) values (v_option_name, v_new_option_value, v_version);
                else
                    insert into vdc_options (option_name, option_value, version) values (v_option_name, v_old_value, v_version);
                end if;
            end if;
            v_index := v_index +1;
        end loop;
        close v_cur;
        delete from vdc_options where option_name = v_option_name and version = 'general';
        end;
    end if;
END; $$;


ALTER FUNCTION public.fn_db_split_config_value(v_option_name character varying, v_old_option_value character varying, v_new_option_value character varying, v_update_from_version character varying) OWNER TO engineer;

--
-- Name: fn_db_unlock_disk(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_unlock_disk(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
declare
    OK integer;
    LOCKED integer;
begin
    OK:=1;
    LOCKED:=2;
    update images set imagestatus = OK where imagestatus = LOCKED and
    image_group_id in (select device_id from vm_device where device_id = v_id and is_plugged);
END; $$;


ALTER FUNCTION public.fn_db_unlock_disk(v_id uuid) OWNER TO engineer;

--
-- Name: fn_db_unlock_entity(character varying, character varying, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_unlock_entity(v_object_type character varying, v_name character varying, v_recursive boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
declare
    DOWN integer;
    OK integer;
    LOCKED integer;
    TEMPLATE_OK integer;
    TEMPLATE_LOCKED integer;
    IMAGE_LOCKED integer;
    SNAPSHOT_OK varchar;
    SNAPSHOT_LOCKED varchar;
    v_id UUID;
begin
    DOWN:=0;
    OK:=1;
    LOCKED:=2;
    TEMPLATE_OK:=0;
    TEMPLATE_LOCKED:=1;
    IMAGE_LOCKED:=15;
    SNAPSHOT_OK:='OK';
    SNAPSHOT_LOCKED:='LOCKED';
    v_id := vm_guid from vm_static where vm_name = v_name and entity_type ilike v_object_type;
    -- set VM status to DOWN
    if (v_object_type = 'vm') then
        update vm_dynamic set status = DOWN where status = IMAGE_LOCKED and vm_guid  = v_id;
    -- set Template status to OK
    else
        if (v_object_type = 'template') then
            update vm_static set template_status = TEMPLATE_OK where template_status = TEMPLATE_LOCKED and vm_guid  = v_id;
        end if;
    end if;
    --unlock images and snapshots  if recursive flag is set
    if (v_recursive) then
        update images set imagestatus = OK where imagestatus = LOCKED and
        image_group_id in (select device_id from vm_device where vm_id = v_id and is_plugged);

        update snapshots set status = SNAPSHOT_OK where status ilike SNAPSHOT_LOCKED and vm_id = v_id;
    end if;
END; $$;


ALTER FUNCTION public.fn_db_unlock_entity(v_object_type character varying, v_name character varying, v_recursive boolean) OWNER TO engineer;

--
-- Name: fn_db_unlock_snapshot(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_unlock_snapshot(v_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
declare
    OK varchar;
    LOCKED varchar;
begin
    OK:='OK';
    LOCKED:='LOCKED';
    update snapshots set status = OK where status = LOCKED and snapshot_id = v_id;
END; $$;


ALTER FUNCTION public.fn_db_unlock_snapshot(v_id uuid) OWNER TO engineer;

--
-- Name: fn_db_update_config_value(character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_update_config_value(v_option_name character varying, v_option_value character varying, v_version character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
begin
    if (exists (select 1 from vdc_options where option_name ilike v_option_name and version = v_version)) then
        begin
            update  vdc_options set option_value = v_option_value
            where option_name ilike v_option_name and version = v_version;
        end;
    end if;
END; $$;


ALTER FUNCTION public.fn_db_update_config_value(v_option_name character varying, v_option_value character varying, v_version character varying) OWNER TO engineer;

--
-- Name: fn_db_update_default_config_value(character varying, character varying, character varying, character varying, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_db_update_default_config_value(v_option_name character varying, v_default_option_value character varying, v_option_value character varying, v_version character varying, v_ignore_default_value_case boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
begin
    if (exists (select 1 from vdc_options where option_name ilike v_option_name and version = v_version)) then
        begin
            if (v_ignore_default_value_case)
            then
               update  vdc_options set option_value = v_option_value
               where option_name ilike v_option_name and option_value ilike v_default_option_value and version = v_version;
            else
               update  vdc_options set option_value = v_option_value
               where option_name ilike v_option_name and option_value = v_default_option_value and version = v_version;
            end if;
        end;
    end if;
END; $$;


ALTER FUNCTION public.fn_db_update_default_config_value(v_option_name character varying, v_default_option_value character varying, v_option_value character varying, v_version character varying, v_ignore_default_value_case boolean) OWNER TO engineer;

--
-- Name: fn_get_ad_element_name(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_get_ad_element_name(v_ad_element_id uuid) RETURNS text
    LANGUAGE plpgsql
    AS $$
DECLARE
    result text;

BEGIN
   if (v_ad_element_id = getGlobalIds('everyone')) then
      result := 'Everyone';
   else
      select(COALESCE(name,'') || ' ' || COALESCE(surname,'') || ' (' || COALESCE(username,'') || ')') INTO result from users where user_id = v_ad_element_id;
      if (result is null) then
         select   name INTO result from ad_groups where ID = v_ad_element_id;
      end if;
   end if;
   return result;
END; $$;


ALTER FUNCTION public.fn_get_ad_element_name(v_ad_element_id uuid) OWNER TO engineer;

--
-- Name: fn_get_column_size(character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_get_column_size(v_table character varying, v_column character varying) RETURNS integer
    LANGUAGE plpgsql
    AS $$
   declare
   retvalue  integer;
BEGIN
   retvalue := character_maximum_length from information_schema.columns
    where
    table_name ilike v_table and column_name ilike v_column and
    table_schema = 'public' and udt_name in ('char','varchar');
   return retvalue;
END; $$;


ALTER FUNCTION public.fn_get_column_size(v_table character varying, v_column character varying) OWNER TO engineer;

--
-- Name: fn_get_comparable_ip_list(text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_get_comparable_ip_list(text) RETURNS inet[]
    LANGUAGE plpgsql
    AS $_$
BEGIN
CASE
    WHEN ($1 IS NULL) OR ($1 ~ E'^\s*$') THEN
        RETURN NULL;
    ELSE
        RETURN regexp_split_to_array(trim(both from $1), E'\s+')::inet[];
END CASE;
END; $_$;


ALTER FUNCTION public.fn_get_comparable_ip_list(text) OWNER TO engineer;

--
-- Name: fn_get_disk_commited_value_by_storage(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_get_disk_commited_value_by_storage(v_storage_domain_id uuid) RETURNS integer
    LANGUAGE plpgsql
    AS $$
DECLARE
    result integer;
    mult bigint;

BEGIN
	mult := ( SELECT
	    		COALESCE(SUM(images_storage_domain_view.size - disk_image_dynamic.actual_size),0)
				FROM images_storage_domain_view JOIN
	    			disk_image_dynamic ON ( images_storage_domain_view.image_guid = disk_image_dynamic.image_id )
				WHERE
   					images_storage_domain_view.storage_id = v_storage_domain_id );
        -- convert to GB from bytes
	mult := CAST((mult * 0.000000000931322574615478515625) AS bigint);
    result := CAST(mult as integer);

	RETURN result;
END;$$;


ALTER FUNCTION public.fn_get_disk_commited_value_by_storage(v_storage_domain_id uuid) OWNER TO engineer;

--
-- Name: fn_get_entity_name(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_get_entity_name(v_entity_id uuid, v_object_type integer) RETURNS text
    LANGUAGE plpgsql
    AS $$
/*    Gets object name by its id and type

    Object Types (compatible with VdcObjectType, XXX entries are unused currently)
        Unknown XXX,
        System XXX,
        VM = 2,
        VDS = 3,
        VmTemplate = 4,
        VmPool = 5,
        AdElements XXX,
        Tags XXX,
        Bookmarks XXX,
        VdsGroups = 9,
        MultiLevelAdministration XXX,
        Storage = 11,
        EventNotification XXX,
        ImportExport XXX,
        StoragePool = 14,
        User = 15,
        Role = 16,
        Quota = 17,
        GlusterVolume = 18,
        Disk = 19,
        Network = 20
*/
DECLARE
    v_entity_type int4 := v_object_type;
    result text;

BEGIN

    CASE
    WHEN v_entity_type = 1 THEN
        result := 'System';
    WHEN v_entity_type = 2 OR v_entity_type = 4 THEN
        result := ( SELECT vm_name FROM vm_static WHERE vm_guid = v_entity_id );
    WHEN v_entity_type = 3 THEN
        result := ( SELECT vds_name FROM vds_static WHERE vds_id = v_entity_id );
    WHEN v_entity_type = 5 THEN
        result := ( SELECT vm_pool_name FROM vm_pools WHERE vm_pool_id = v_entity_id );
    WHEN v_entity_type = 7 THEN
        result := ( SELECT tag_name FROM tags WHERE tag_id = v_entity_id );
    WHEN v_entity_type = 8 THEN
        result := ( SELECT bookmark_name FROM bookmarks WHERE bookmark_id = v_entity_id );
    WHEN v_entity_type = 9 THEN
        result := ( SELECT name FROM vds_groups WHERE vds_group_id = v_entity_id );
    WHEN v_entity_type = 11 THEN
        result := ( SELECT storage_name FROM storage_domain_static WHERE id = v_entity_id );
    WHEN v_entity_type = 14 THEN
        result := ( SELECT name FROM storage_pool WHERE id = v_entity_id );
    WHEN v_entity_type = 15 THEN
        result := ( SELECT username FROM users WHERE user_id = v_entity_id );
    WHEN v_entity_type = 16 THEN
        result := ( SELECT name FROM roles WHERE id = v_entity_id );
    WHEN v_entity_type = 17 THEN
        result := ( SELECT quota_name FROM quota WHERE id = v_entity_id );
   WHEN v_entity_type = 18 THEN
        result := ( SELECT vol_name FROM gluster_volumes WHERE id = v_entity_id );
    WHEN v_entity_type = 19 THEN
        result := ( SELECT disk_alias FROM base_disks WHERE disk_id = v_entity_id );
    WHEN v_entity_type = 20 THEN
        result := ( SELECT name FROM network WHERE id = v_entity_id );
    ELSE
        result := 'Unknown type ' ||  v_entity_type;
    END CASE;

--      -- This should be written to an error var or include object_id that is missing
--    IF result IS NULL THEN
--        result := v_entity_id || '' NOT FOUND'';
--    END IF;
    RETURN result;
END;$$;


ALTER FUNCTION public.fn_get_entity_name(v_entity_id uuid, v_object_type integer) OWNER TO engineer;

--
-- Name: fn_get_entity_parents(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_get_entity_parents(v_entity_id uuid, v_object_type integer) RETURNS SETOF iduuidtype
    LANGUAGE plpgsql
    AS $$
/*	Gets a list of all parent GUID to the system root (including)

	Object Types (compatible with VdcObjectType, XXX entries are unused currently)
		Unknown XXX,
		System XXX,
        Bottom = 0,
		VM = 2,
		VDS = 3,
		VmTemplate = 4,
		VmPool = 5,
		AdElements XXX,
		Tags XXX,
		Bookmarks XXX,
		VdsGroups = 9,
		MultiLevelAdministration XXX,
		Storage = 11,
		EventNotification XXX,
		ImportExport XXX,
		StoragePool = 14,
		User = 15,
		Role = 16,
		Quota = 17,
		GlusterVolume = 18,
        Disk = 19,
        Network = 20
*/
DECLARE
	v_entity_type int4 := v_object_type;
	system_root_id uuid;
	cluster_id uuid;
	ds_id uuid;
	v_image_id uuid;
	v_storage_id uuid;
    v_vm_id uuid;
    v_storage_pool_id uuid;

BEGIN

	system_root_id := ( SELECT getGlobalIds('system') ); -- hardcoded also in MLA Handler
	CASE
	WHEN v_entity_type = 0 THEN -- Bottom
		RETURN QUERY
			SELECT object_id
			FROM permissions;
	WHEN v_entity_type = 2 THEN -- VM
        -- get cluster id
		cluster_id := ( SELECT vds_group_id FROM vm_static WHERE vm_guid = v_entity_id );
		-- get data center id
		ds_id := ( SELECT storage_pool_id FROM vds_groups WHERE vds_group_id = cluster_id );

		RETURN QUERY
			SELECT system_root_id AS id
			UNION
			SELECT ds_id AS id
			UNION
			SELECT cluster_id AS id
			UNION
			SELECT v_entity_id AS id;
	WHEN v_entity_type = 3 THEN -- VDS
        -- get cluster id
		cluster_id := ( SELECT vds_group_id FROM vds_static WHERE vds_id = v_entity_id );
		-- get data center id
		ds_id := ( SELECT storage_pool_id FROM vds_groups WHERE vds_group_id = cluster_id );

		RETURN QUERY
			SELECT system_root_id AS id
			UNION
			SELECT ds_id AS id
			UNION
			SELECT cluster_id AS id
			UNION
			SELECT v_entity_id AS id;
	WHEN v_entity_type = 4 THEN -- Template
		-- get image id first
		v_image_id := ( SELECT image_guid FROM images i JOIN vm_device vd ON i.image_group_id = vd.device_id WHERE vm_id = v_entity_id limit 1);
		-- get the storage id from images
		v_storage_id := ( SELECT storage_domain_id FROM image_storage_domain_map WHERE image_id = v_image_id limit 1);
		-- finally get data center id
		ds_id := ( SELECT storage_pool_id FROM storage_pool_iso_map WHERE storage_id = v_storage_id );

		RETURN QUERY
			SELECT system_root_id AS id
			UNION
			SELECT ds_id AS id
			UNION
			SELECT v_entity_id AS id;
	WHEN v_entity_type = 5 THEN -- VM Pool
        -- get cluster id
		cluster_id := ( SELECT vds_group_id FROM vm_pools WHERE vm_pool_id = v_entity_id );
		-- get data center id
		ds_id := ( SELECT storage_pool_id FROM vds_groups WHERE vds_group_id = cluster_id );

		RETURN QUERY
			SELECT system_root_id AS id
			UNION
			SELECT ds_id AS id
			UNION
			SELECT cluster_id AS id
			UNION
			SELECT v_entity_id AS id;
	WHEN v_entity_type = 9 THEN -- Cluster
		-- get data center id
		ds_id := ( SELECT storage_pool_id FROM vds_groups WHERE vds_group_id = v_entity_id );

		RETURN QUERY
			SELECT system_root_id AS id
			UNION
			SELECT ds_id AS id
			UNION
			SELECT v_entity_id AS id;
	WHEN v_entity_type = 11 THEN -- Storage Domain

		RETURN QUERY
			SELECT system_root_id AS id
			UNION ALL
			SELECT storage_pool_id as id FROM storage_pool_iso_map WHERE storage_id = v_entity_id
			UNION
			SELECT v_entity_id AS id;
	WHEN v_entity_type = 17 THEN -- Quota
		-- get data center id
		ds_id := ( SELECT storage_pool_id FROM quota WHERE id = v_entity_id );

		RETURN QUERY
			SELECT system_root_id AS id
			UNION
			SELECT ds_id AS id
			UNION
			SELECT v_entity_id AS id;
	WHEN v_entity_type = 18 THEN -- GlusterVolume
        -- get cluster id
		cluster_id := ( SELECT v.cluster_id FROM gluster_volumes v WHERE id = v_entity_id );
		-- get data center id
		ds_id := ( SELECT storage_pool_id FROM vds_groups WHERE vds_group_id = cluster_id );

		RETURN QUERY
			SELECT system_root_id AS id
			UNION
			SELECT ds_id AS id
			UNION
			SELECT cluster_id AS id
			UNION
			SELECT v_entity_id AS id;

	WHEN v_entity_type = 19 THEN -- Disk

        -- get data center, storage domain and vm
        SELECT INTO ds_id, v_storage_id, v_vm_id
                    storage_pool_id, storage_id, vm_id
        FROM images_storage_domain_view
        LEFT OUTER JOIN vm_device ON vm_device.device_id = images_storage_domain_view.disk_id
        WHERE image_group_id = v_entity_id;

        -- get cluster
        cluster_id := ( SELECT vds_group_id FROM vm_static WHERE vm_guid = v_vm_id );

        RETURN QUERY
            SELECT system_root_id AS id
            UNION
            SELECT ds_id AS id
            UNION
            SELECT v_storage_id AS id
            UNION
            SELECT v_vm_id AS id
            UNION
            SELECT cluster_id AS id
            UNION
            SELECT v_entity_id AS id;

	WHEN v_entity_type = 20 THEN -- Network

        SELECT INTO v_storage_pool_id
                    network.storage_pool_id
        FROM network
        WHERE network.id = v_entity_id;

        RETURN QUERY
            SELECT system_root_id AS id
            UNION
            SELECT v_storage_pool_id AS id
            UNION
            SELECT v_entity_id AS id;
	ELSE
		IF v_entity_type IN ( 1,14,15,16 ) THEN -- Data Center, users and roles are under system
			RETURN QUERY
				SELECT system_root_id AS id
				UNION
				SELECT v_entity_id AS id;
		END IF;
	END CASE;
END;$$;


ALTER FUNCTION public.fn_get_entity_parents(v_entity_id uuid, v_object_type integer) OWNER TO engineer;

--
-- Name: fn_get_storage_domain_shared_status_by_domain_id(uuid, integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_get_storage_domain_shared_status_by_domain_id(v_storage_domain_id uuid, v_storage_status integer, v_storage_domain_type integer) RETURNS integer
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_result  INTEGER;
   v_rowsCount  INTEGER;
   v_status  INTEGER;
BEGIN
    if (v_storage_domain_type != 2) then
      if (v_storage_status is null) then
         v_result := 0;
      else
         -- if 1 row and status active (3) then domain is active (1)
         if v_storage_status = 3 then
            v_result := 1;
		 -- if 1 row and status not active then domain is inactive (2)
         else
            v_result := 2;
         end if;
      end if;
    else
      BEGIN
         CREATE GLOBAL TEMPORARY TABLE tt_TEMP22
         (
            status INTEGER,
            count INTEGER
         ) WITH OIDS;
         exception when others then
         truncate table tt_TEMP22;
      END;
      delete from tt_TEMP22;
      Insert INTO tt_TEMP22
      select status, count(storage_id) from storage_pool_iso_map
      where storage_id = v_storage_domain_id
      group by status;

      select count(*) INTO v_rowsCount from tt_TEMP22;

      -- if return 0 rows then the domain is unattached
      if (v_rowsCount = 0) then
         v_result := 0;
      else
         if (v_rowsCount = 1) then
	        -- if 1 row and status active (3) then domain is active (1)
            if v_storage_status = 3 then
               v_result := 1;
		    -- if 1 row and status not active then domain is inactive (2)
            else
               v_result := 2;
            end if;
	      -- else (if return more then 1 row)
          else
            select   count(*) INTO v_rowsCount from tt_TEMP22 where status = 3;
            if (v_rowsCount > 0) then
               v_result := 3;
			   -- non of the statuses is active
            else
               v_result := 2;
          end if;
         end if;
      end if;
    end if;
   return v_result;
END; $$;


ALTER FUNCTION public.fn_get_storage_domain_shared_status_by_domain_id(v_storage_domain_id uuid, v_storage_status integer, v_storage_domain_type integer) OWNER TO engineer;

SET default_tablespace = '';

SET default_with_oids = true;

--
-- Name: storage_pool; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE storage_pool (
    id uuid NOT NULL,
    name character varying(40) NOT NULL,
    description character varying(4000) NOT NULL,
    storage_pool_type integer NOT NULL,
    storage_pool_format_type character varying(50),
    status integer NOT NULL,
    master_domain_version integer NOT NULL,
    spm_vds_id uuid,
    compatibility_version character varying(40) DEFAULT '2.2'::character varying NOT NULL,
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone,
    _update_date timestamp with time zone,
    quota_enforcement_type integer
);


ALTER TABLE public.storage_pool OWNER TO engineer;

--
-- Name: fn_perms_get_storage_pools_with_permitted_action_on_vds_groups(uuid, integer, boolean, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_perms_get_storage_pools_with_permitted_action_on_vds_groups(v_user_id uuid, v_action_group_id integer, v_supports_virt_service boolean, v_supports_gluster_service boolean) RETURNS SETOF storage_pool
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT sp.*
      FROM storage_pool sp
      WHERE sp.id in
        (SELECT vg.storage_pool_id
         FROM vds_groups vg
         WHERE (SELECT get_entity_permissions(v_user_id, v_action_group_id, vg.vds_group_id, 9)) IS NOT NULL
         AND ((v_supports_virt_service = TRUE AND vg.virt_service = TRUE) OR (v_supports_gluster_service = TRUE AND vg.gluster_service = TRUE))
        );
END; $$;


ALTER FUNCTION public.fn_perms_get_storage_pools_with_permitted_action_on_vds_groups(v_user_id uuid, v_action_group_id integer, v_supports_virt_service boolean, v_supports_gluster_service boolean) OWNER TO engineer;

--
-- Name: quota; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE quota (
    id uuid NOT NULL,
    storage_pool_id uuid NOT NULL,
    quota_name character varying(65) NOT NULL,
    description character varying(250),
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone,
    _update_date timestamp with time zone,
    threshold_vds_group_percentage integer DEFAULT 80,
    threshold_storage_percentage integer DEFAULT 80,
    grace_vds_group_percentage integer DEFAULT 20,
    grace_storage_percentage integer DEFAULT 20
);


ALTER TABLE public.quota OWNER TO engineer;

--
-- Name: vds_groups; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vds_groups (
    vds_group_id uuid NOT NULL,
    name character varying(40) NOT NULL,
    description character varying(4000),
    cpu_name character varying(255),
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone,
    _update_date timestamp with time zone,
    selection_algorithm integer DEFAULT 0 NOT NULL,
    high_utilization integer DEFAULT 75 NOT NULL,
    low_utilization integer DEFAULT 0 NOT NULL,
    cpu_over_commit_duration_minutes integer DEFAULT 2 NOT NULL,
    storage_pool_id uuid,
    max_vds_memory_over_commit integer DEFAULT 100 NOT NULL,
    compatibility_version character varying(40) DEFAULT '2.2'::character varying NOT NULL,
    transparent_hugepages boolean DEFAULT false NOT NULL,
    migrate_on_error integer DEFAULT 1 NOT NULL,
    virt_service boolean DEFAULT true NOT NULL,
    gluster_service boolean DEFAULT false NOT NULL,
    count_threads_as_cores boolean DEFAULT false NOT NULL
);


ALTER TABLE public.vds_groups OWNER TO engineer;

--
-- Name: vm_static; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vm_static (
    vm_guid uuid NOT NULL,
    vm_name character varying(255) NOT NULL,
    mem_size_mb integer NOT NULL,
    vmt_guid uuid NOT NULL,
    os integer DEFAULT 0 NOT NULL,
    description character varying(4000),
    vds_group_id uuid NOT NULL,
    domain character varying(40),
    creation_date timestamp with time zone,
    num_of_monitors integer NOT NULL,
    is_initialized boolean,
    is_auto_suspend boolean DEFAULT false,
    num_of_sockets integer DEFAULT 1 NOT NULL,
    cpu_per_socket integer DEFAULT 1 NOT NULL,
    usb_policy integer,
    time_zone character varying(40),
    is_stateless boolean,
    fail_back boolean DEFAULT false NOT NULL,
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone,
    _update_date timestamp with time zone,
    dedicated_vm_for_vds uuid,
    auto_startup boolean,
    vm_type integer DEFAULT 0 NOT NULL,
    nice_level integer DEFAULT 0 NOT NULL,
    default_boot_sequence integer DEFAULT 0 NOT NULL,
    default_display_type integer DEFAULT 0 NOT NULL,
    priority integer DEFAULT 0 NOT NULL,
    iso_path character varying(4000) DEFAULT ''::character varying,
    origin integer DEFAULT 0,
    initrd_url character varying(4000),
    kernel_url character varying(4000),
    kernel_params character varying(4000),
    migration_support integer DEFAULT 0 NOT NULL,
    userdefined_properties character varying(4000),
    predefined_properties character varying(4000),
    min_allocated_mem integer DEFAULT 0 NOT NULL,
    entity_type character varying(32) NOT NULL,
    child_count integer DEFAULT 0,
    template_status integer,
    quota_id uuid,
    allow_console_reconnect boolean DEFAULT false NOT NULL,
    cpu_pinning character varying(4000) DEFAULT NULL::character varying,
    is_smartcard_enabled boolean DEFAULT false,
    host_cpu_flags boolean DEFAULT false,
    db_generation bigint DEFAULT 1,
    is_delete_protected boolean DEFAULT false,
    is_disabled boolean DEFAULT false
);


ALTER TABLE public.vm_static OWNER TO engineer;

--
-- Name: vm_templates_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vm_templates_view AS
    SELECT vm_templates.vm_guid AS vmt_guid, vm_templates.vm_name AS name, vm_templates.mem_size_mb, vm_templates.os, vm_templates.creation_date, vm_templates.child_count, vm_templates.num_of_sockets, vm_templates.cpu_per_socket, (vm_templates.num_of_sockets * vm_templates.cpu_per_socket) AS num_of_cpus, vm_templates.description, vm_templates.vds_group_id, vm_templates.domain, vm_templates.num_of_monitors, vm_templates.allow_console_reconnect, vm_templates.template_status AS status, vm_templates.usb_policy, vm_templates.time_zone, vm_templates.is_auto_suspend, vm_templates.fail_back, vds_groups.name AS vds_group_name, vm_templates.vm_type, vm_templates.nice_level, storage_pool.id AS storage_pool_id, storage_pool.name AS storage_pool_name, storage_pool.quota_enforcement_type, vm_templates.default_boot_sequence, vm_templates.default_display_type, vm_templates.priority, vm_templates.auto_startup, vm_templates.is_stateless, vm_templates.is_smartcard_enabled, vm_templates.is_delete_protected, vm_templates.iso_path, vm_templates.origin, vm_templates.initrd_url, vm_templates.kernel_url, vm_templates.kernel_params, vm_templates.quota_id, quota.quota_name, vm_templates.db_generation, vm_templates.migration_support, vm_templates.dedicated_vm_for_vds, vm_templates.is_disabled, vm_templates.min_allocated_mem FROM (((vm_static vm_templates JOIN vds_groups ON ((vm_templates.vds_group_id = vds_groups.vds_group_id))) LEFT JOIN storage_pool ON ((storage_pool.id = vds_groups.storage_pool_id))) LEFT JOIN quota ON ((vm_templates.quota_id = quota.id))) WHERE ((vm_templates.entity_type)::text = 'TEMPLATE'::text);


ALTER TABLE public.vm_templates_view OWNER TO engineer;

--
-- Name: fn_perms_get_templates_with_permitted_action(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_perms_get_templates_with_permitted_action(v_user_id uuid, v_action_group_id integer) RETURNS SETOF vm_templates_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_templates_view.*
      FROM vm_templates_view, user_vm_template_permissions_view
      WHERE vm_templates_view.vmt_guid = user_vm_template_permissions_view.entity_id AND
            user_vm_template_permissions_view.user_id = v_user_id AND
            (SELECT get_entity_permissions(v_user_id, v_action_group_id, vm_templates_view.vmt_guid, 4) IS NOT NULL);
END; $$;


ALTER FUNCTION public.fn_perms_get_templates_with_permitted_action(v_user_id uuid, v_action_group_id integer) OWNER TO engineer;

--
-- Name: vds_groups_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vds_groups_view AS
    SELECT vds_groups.vds_group_id, vds_groups.name, vds_groups.description, vds_groups.cpu_name, vds_groups._create_date, vds_groups._update_date, vds_groups.selection_algorithm, vds_groups.high_utilization, vds_groups.low_utilization, vds_groups.cpu_over_commit_duration_minutes, vds_groups.storage_pool_id, vds_groups.max_vds_memory_over_commit, vds_groups.compatibility_version, vds_groups.transparent_hugepages, vds_groups.migrate_on_error, vds_groups.virt_service, vds_groups.gluster_service, vds_groups.count_threads_as_cores, storage_pool.name AS storage_pool_name FROM (vds_groups LEFT JOIN storage_pool ON ((vds_groups.storage_pool_id = storage_pool.id)));


ALTER TABLE public.vds_groups_view OWNER TO engineer;

--
-- Name: fn_perms_get_vds_groups_with_permitted_action(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_perms_get_vds_groups_with_permitted_action(v_user_id uuid, v_action_group_id integer) RETURNS SETOF vds_groups_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vds_groups_view.*
      FROM vds_groups_view
      WHERE (SELECT 1 from get_entity_permissions(v_user_id, v_action_group_id, vds_groups_view.vds_group_id, 9)) IS NOT NULL;
END; $$;


ALTER FUNCTION public.fn_perms_get_vds_groups_with_permitted_action(v_user_id uuid, v_action_group_id integer) OWNER TO engineer;

--
-- Name: fn_user_permissions(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fn_user_permissions(v_userid uuid) RETURNS SETOF user_permissions
    LANGUAGE plpgsql
    AS $$
DECLARE

BEGIN
	RETURN QUERY
	    SELECT
		    permissions.id AS permission_id,
		    permissions.role_id,
		    permissions.ad_element_id AS user_id
	    FROM permissions
		INNER JOIN users ON permissions.ad_element_id = users.user_id
	    WHERE users.user_id = v_userId

	    UNION

	    SELECT
		    permissions.id AS permission_id,
		    permissions.role_id,
		    temp.user_id AS user_id
	    FROM permissions INNER JOIN
	    (
		    -- get all groups of admin users
		    SELECT ad_groups.id group_id, users.user_id
		    FROM ad_groups, users
		    WHERE ad_groups.id IN
		    (SELECT * FROM fnsplitteruuid(users.group_ids))
			AND users.user_id = v_userId ) temp
		ON permissions.ad_element_id = temp.group_id;

END; $$;


ALTER FUNCTION public.fn_user_permissions(v_userid uuid) OWNER TO engineer;

--
-- Name: fnsplitter(text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fnsplitter(ids text) RETURNS SETOF idtexttype
    LANGUAGE plpgsql
    AS $$
BEGIN
	RETURN QUERY
		SELECT regexp_split_to_table(ids, ',') AS id;
END; $$;


ALTER FUNCTION public.fnsplitter(ids text) OWNER TO engineer;

--
-- Name: fnsplitteruuid(text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION fnsplitteruuid(ids text) RETURNS SETOF uuid
    LANGUAGE plpgsql
    AS $$
BEGIN
 IF ids != '' THEN
	RETURN QUERY
		SELECT CAST(regexp_split_to_table(ids, ',') AS UUID);
 END IF;
END; $$;


ALTER FUNCTION public.fnsplitteruuid(ids text) OWNER TO engineer;

--
-- Name: force_delete_storage_domain(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION force_delete_storage_domain(v_storage_domain_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   BEGIN
      -- Images residing on only the specified storage domain
      CREATE GLOBAL TEMPORARY TABLE tt_TEMPSTORAGEDOMAINMAPTABLE AS select image_id
         from image_storage_domain_map where storage_domain_id = v_storage_domain_id
         except select image_id from image_storage_domain_map where storage_domain_id != v_storage_domain_id;
      exception when others then
         truncate table tt_TEMPSTORAGEDOMAINMAPTABLE;
         insert into tt_TEMPSTORAGEDOMAINMAPTABLE select image_id
         from image_storage_domain_map where storage_domain_id = v_storage_domain_id
         except select image_id from image_storage_domain_map where storage_domain_id != v_storage_domain_id;
   END;

   BEGIN
      -- Templates with any images residing on only the specified storage domain
      CREATE GLOBAL TEMPORARY TABLE TEMPLATES_IDS_TEMPORARY_TABLE AS select vm_device.vm_id as vm_guid
         from images_storage_domain_view
         JOIN vm_device ON vm_device.device_id = images_storage_domain_view.disk_id
         JOIN tt_TEMPSTORAGEDOMAINMAPTABLE ON tt_TEMPSTORAGEDOMAINMAPTABLE.image_id = images_storage_domain_view.image_guid
         where entity_type = 'TEMPLATE' and storage_id = v_storage_domain_id;
      exception when others then
         truncate table TEMPLATES_IDS_TEMPORARY_TABLE;
         insert into TEMPLATES_IDS_TEMPORARY_TABLE select vm_device.vm_id as vm_guid
         from images_storage_domain_view
         JOIN vm_device ON vm_device.device_id = images_storage_domain_view.disk_id
         JOIN tt_TEMPSTORAGEDOMAINMAPTABLE ON tt_TEMPSTORAGEDOMAINMAPTABLE.image_id = images_storage_domain_view.image_guid
         where entity_type = 'TEMPLATE' and storage_id = v_storage_domain_id;
   END;

   delete FROM image_storage_domain_map where storage_domain_id = v_storage_domain_id;

   delete FROM permissions where object_id in (select vm_id as vm_guid from vm_images_view
                                                              JOIN vm_device ON vm_device.device_id = vm_images_view.disk_id
                                                              where v_storage_domain_id in (SELECT * FROM fnsplitteruuid(storage_id)) and vm_images_view.entity_type <> 'TEMPLATE');
   delete FROM snapshots WHERE vm_id in (select vm_id as vm_guid from vm_images_view
                                         JOIN vm_device ON vm_device.device_id = vm_images_view.disk_id
                                         where v_storage_domain_id in (SELECT * FROM fnsplitteruuid(storage_id)));
   delete FROM images where image_guid in (select image_id from tt_TEMPSTORAGEDOMAINMAPTABLE);
   delete FROM vm_interface where vmt_guid in(select vm_guid from TEMPLATES_IDS_TEMPORARY_TABLE);
   delete FROM permissions where object_id in (select vm_guid from TEMPLATES_IDS_TEMPORARY_TABLE);
   delete FROM permissions where object_id = v_storage_domain_id;
   delete FROM vm_static where vm_guid in(select vm_id as vm_guid from vm_images_view
                                          JOIN vm_device ON vm_device.device_id = vm_images_view.disk_id
                                          where v_storage_domain_id in (SELECT * FROM fnsplitteruuid(storage_id)) and vm_images_view.entity_type <> 'TEMPLATE');

   -- Delete pools and snapshots of pools based on templates from the storage domain to be removed
   delete FROM snapshots where vm_id in (select vm_guid FROM vm_static where vmt_guid in (select vm_guid from TEMPLATES_IDS_TEMPORARY_TABLE));
   delete FROM vm_static where vmt_guid in (select vm_guid from TEMPLATES_IDS_TEMPORARY_TABLE);

   delete FROM vm_static where vm_guid in(select vm_guid from TEMPLATES_IDS_TEMPORARY_TABLE);
   delete FROM storage_domain_dynamic where id  = v_storage_domain_id;
   delete FROM storage_domain_static where id  = v_storage_domain_id;

END; $$;


ALTER FUNCTION public.force_delete_storage_domain(v_storage_domain_id uuid) OWNER TO engineer;

--
-- Name: generate_drop_all_functions_syntax(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION generate_drop_all_functions_syntax() RETURNS SETOF text
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY select 'drop function if exists ' || ns.nspname || '.' || proname || '(' || oidvectortypes(proargtypes) || ') cascade;' from pg_proc inner join pg_namespace ns on (pg_proc.pronamespace=ns.oid) where ns.nspname = 'public' and proname not ilike 'uuid%' order by proname;
END; $$;


ALTER FUNCTION public.generate_drop_all_functions_syntax() OWNER TO engineer;

--
-- Name: generate_drop_all_views_syntax(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION generate_drop_all_views_syntax() RETURNS SETOF text
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY select 'DROP VIEW if exists ' || table_name || ' CASCADE;' from information_schema.views where table_schema = 'public' order by table_name;
END; $$;


ALTER FUNCTION public.generate_drop_all_views_syntax() OWNER TO engineer;

--
-- Name: get_all_commands(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION get_all_commands() RETURNS SETOF get_all_commands_rs
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT distinct business_entity_snapshot.command_id, business_entity_snapshot.command_type
      FROM business_entity_snapshot;

END; $$;


ALTER FUNCTION public.get_all_commands() OWNER TO engineer;

--
-- Name: get_entity_permissions(uuid, integer, uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION get_entity_permissions(v_user_id uuid, v_action_group_id integer, v_object_id uuid, v_object_type_id integer, OUT v_permission_id uuid) RETURNS uuid
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_everyone_object_id  UUID;
BEGIN
   v_everyone_object_id := getGlobalIds('everyone'); -- hardcoded also in MLA Handler
   select   id INTO v_permission_id from permissions where
		-- get all roles of action
   role_id in(select role_id from roles_groups where action_group_id = v_action_group_id)
		-- get allparents of object
   and (object_id in(select id from  fn_get_entity_parents(v_object_id,v_object_type_id)))
		-- get user and his groups
   and (ad_element_id = v_everyone_object_id or
   ad_element_id = v_user_id or ad_element_id in(select * from getUserAndGroupsById(v_user_id)))   LIMIT 1;
END; $$;


ALTER FUNCTION public.get_entity_permissions(v_user_id uuid, v_action_group_id integer, v_object_id uuid, v_object_type_id integer, OUT v_permission_id uuid) OWNER TO engineer;

--
-- Name: get_entity_permissions_for_user_and_groups(uuid, text, integer, uuid, integer, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION get_entity_permissions_for_user_and_groups(v_user_id uuid, v_group_ids text, v_action_group_id integer, v_object_id uuid, v_object_type_id integer, v_ignore_everyone boolean, OUT v_permission_id uuid) RETURNS uuid
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_everyone_object_id  UUID;
BEGIN
   v_everyone_object_id := getGlobalIds('everyone'); -- hardcoded also in MLA Handler
   select   id INTO v_permission_id from permissions where
		-- get all roles of action
   role_id in(select role_id from roles_groups where action_group_id = v_action_group_id)
		-- get allparents of object
   and (object_id in(select id from  fn_get_entity_parents(v_object_id,v_object_type_id)))
		-- get user and his groups
   and ((NOT v_ignore_everyone and ad_element_id = v_everyone_object_id) or
   ad_element_id = v_user_id or ad_element_id in(select * from fnsplitteruuid(v_group_ids)))   LIMIT 1;
END; $$;


ALTER FUNCTION public.get_entity_permissions_for_user_and_groups(v_user_id uuid, v_group_ids text, v_action_group_id integer, v_object_id uuid, v_object_type_id integer, v_ignore_everyone boolean, OUT v_permission_id uuid) OWNER TO engineer;

--
-- Name: business_entity_snapshot; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE business_entity_snapshot (
    id uuid NOT NULL,
    command_id uuid NOT NULL,
    command_type character varying(256) NOT NULL,
    entity_id character varying(128),
    entity_type character varying(128),
    entity_snapshot text,
    snapshot_class character varying(128),
    snapshot_type integer,
    insertion_order integer,
    started_at timestamp with time zone DEFAULT now()
);


ALTER TABLE public.business_entity_snapshot OWNER TO engineer;

--
-- Name: get_entity_snapshot_by_command_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION get_entity_snapshot_by_command_id(v_command_id uuid) RETURNS SETOF business_entity_snapshot
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT business_entity_snapshot.*
      FROM business_entity_snapshot
      WHERE command_id = v_command_id order by insertion_order desc;
END; $$;


ALTER FUNCTION public.get_entity_snapshot_by_command_id(v_command_id uuid) OWNER TO engineer;

--
-- Name: get_entity_snapshot_by_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION get_entity_snapshot_by_id(v_id uuid) RETURNS SETOF business_entity_snapshot
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT business_entity_snapshot.*
      FROM business_entity_snapshot
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.get_entity_snapshot_by_id(v_id uuid) OWNER TO engineer;

--
-- Name: roles_groups; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE roles_groups (
    role_id uuid NOT NULL,
    action_group_id integer NOT NULL
);


ALTER TABLE public.roles_groups OWNER TO engineer;

--
-- Name: get_role_groups_by_role_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION get_role_groups_by_role_id(v_role_id uuid) RETURNS SETOF roles_groups
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM roles_groups
   where
   role_id = v_role_id;

END; $$;


ALTER FUNCTION public.get_role_groups_by_role_id(v_role_id uuid) OWNER TO engineer;

--
-- Name: get_roles_groups_by_action_group_id_and_by_role_id(integer, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION get_roles_groups_by_action_group_id_and_by_role_id(v_action_group_id integer, v_role_id uuid) RETURNS SETOF roles_groups
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM roles_groups
   where
   action_group_id = v_action_group_id AND
   role_id = v_role_id;

END; $$;


ALTER FUNCTION public.get_roles_groups_by_action_group_id_and_by_role_id(v_action_group_id integer, v_role_id uuid) OWNER TO engineer;

--
-- Name: get_seconds_to_wait_before_pm_operation(character varying, character varying, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION get_seconds_to_wait_before_pm_operation(v_vds_name character varying, v_event character varying, v_wait_for_sec integer) RETURNS integer
    LANGUAGE plpgsql
    AS $$
declare v_last_event_dt timestamp with time zone;
declare v_now_dt timestamp with time zone;
BEGIN
      if exists(select 1 from audit_log where vds_name = v_vds_name and log_type_name = v_event) then
       begin
          v_last_event_dt := log_time
          from audit_log
          where vds_name = v_vds_name and log_type_name = v_event
          order by audit_log_id desc limit 1;
          v_now_dt :=  CURRENT_TIMESTAMP;
          RETURN cast((extract(epoch from v_last_event_dt) + v_wait_for_sec) - extract(epoch from v_now_dt) as int);
       end;
     else
          RETURN 0;
     end if;
END; $$;


ALTER FUNCTION public.get_seconds_to_wait_before_pm_operation(v_vds_name character varying, v_event character varying, v_wait_for_sec integer) OWNER TO engineer;

--
-- Name: permissions; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE permissions (
    id uuid NOT NULL,
    role_id uuid NOT NULL,
    ad_element_id uuid NOT NULL,
    object_id uuid NOT NULL,
    object_type_id integer NOT NULL
);


ALTER TABLE public.permissions OWNER TO engineer;

--
-- Name: roles; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE roles (
    id uuid NOT NULL,
    name character varying(126) NOT NULL,
    description character varying(4000),
    is_readonly boolean NOT NULL,
    role_type integer NOT NULL,
    allows_viewing_children boolean DEFAULT false NOT NULL
);


ALTER TABLE public.roles OWNER TO engineer;

--
-- Name: permissions_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW permissions_view AS
    SELECT permissions.id, permissions.role_id, permissions.ad_element_id, permissions.object_id, permissions.object_type_id, roles.name AS role_name, roles.role_type, roles.allows_viewing_children, fn_get_entity_name(permissions.object_id, permissions.object_type_id) AS object_name, fn_get_ad_element_name(permissions.ad_element_id) AS owner_name FROM (permissions JOIN roles ON ((permissions.role_id = roles.id)));


ALTER TABLE public.permissions_view OWNER TO engineer;

--
-- Name: get_user_permissions_for_domain(character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION get_user_permissions_for_domain(v_name character varying, v_domain character varying) RETURNS SETOF permissions_view
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_user_name VARCHAR(255);
   v_index  INTEGER;
BEGIN
-- find if name already includes domain (@)
   v_index := POSITION('@' IN v_name);

   if (v_index > 0) then
      v_user_name := substr(v_name, 0, v_index);
   else
      v_user_name := v_name;
   end if;
   RETURN QUERY SELECT *
   FROM permissions_view
   WHERE permissions_view.ad_element_id in (
                SELECT users.user_id
                FROM users
                WHERE users.domain = v_domain
                  AND (users.name = v_user_name OR
                       users.name = v_user_name || '@' || upper(v_domain)
                      ));

END; $$;


ALTER FUNCTION public.get_user_permissions_for_domain(v_name character varying, v_domain character varying) OWNER TO engineer;

--
-- Name: gluster_volume_access_protocols; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE gluster_volume_access_protocols (
    volume_id uuid NOT NULL,
    access_protocol character varying(32) NOT NULL
);


ALTER TABLE public.gluster_volume_access_protocols OWNER TO engineer;

--
-- Name: getaccessprotocolsbyglustervolumeguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getaccessprotocolsbyglustervolumeguid(v_volume_id uuid) RETURNS SETOF gluster_volume_access_protocols
    LANGUAGE plpgsql
    AS $$
BEGIN
       RETURN QUERY SELECT *
       FROM  gluster_volume_access_protocols
       WHERE volume_id = v_volume_id;
END; $$;


ALTER FUNCTION public.getaccessprotocolsbyglustervolumeguid(v_volume_id uuid) OWNER TO engineer;

--
-- Name: action_version_map; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE action_version_map (
    action_type integer NOT NULL,
    cluster_minimal_version character varying(40) NOT NULL,
    storage_pool_minimal_version character varying(40) NOT NULL
);


ALTER TABLE public.action_version_map OWNER TO engineer;

--
-- Name: getaction_version_mapbyaction_type(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getaction_version_mapbyaction_type(v_action_type integer) RETURNS SETOF action_version_map
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM action_version_map
   WHERE action_type = v_action_type;

END; $$;


ALTER FUNCTION public.getaction_version_mapbyaction_type(v_action_type integer) OWNER TO engineer;

--
-- Name: vds_static; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vds_static (
    vds_id uuid NOT NULL,
    vds_name character varying(255) NOT NULL,
    ip character varying(255),
    vds_unique_id character varying(128),
    host_name character varying(255) NOT NULL,
    port integer NOT NULL,
    vds_group_id uuid NOT NULL,
    server_ssl_enabled boolean,
    vds_type integer DEFAULT 0 NOT NULL,
    vds_strength integer DEFAULT 100 NOT NULL,
    pm_type character varying(20),
    pm_user character varying(50),
    pm_password text,
    pm_port integer,
    pm_options character varying(4000) DEFAULT ''::character varying NOT NULL,
    pm_enabled boolean DEFAULT false NOT NULL,
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone,
    _update_date timestamp with time zone,
    otp_validity bigint,
    vds_spm_priority smallint DEFAULT 5,
    recoverable boolean DEFAULT true NOT NULL,
    sshkeyfingerprint character varying(128),
    pm_proxy_preferences character varying(255) DEFAULT ''::character varying,
    pm_secondary_ip character varying(255),
    pm_secondary_type character varying(20),
    pm_secondary_user character varying(50),
    pm_secondary_password text,
    pm_secondary_port integer,
    pm_secondary_options character varying(4000),
    pm_secondary_concurrent boolean DEFAULT false,
    console_address character varying(255) DEFAULT NULL::character varying,
    CONSTRAINT vds_static_vds_spm_priority_check CHECK (((vds_spm_priority >= (-1)) AND (vds_spm_priority <= 10)))
);


ALTER TABLE public.vds_static OWNER TO engineer;

--
-- Name: vm_dynamic; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vm_dynamic (
    vm_guid uuid NOT NULL,
    status integer NOT NULL,
    vm_ip text,
    vm_host character varying(255),
    vm_pid integer,
    last_start_time timestamp with time zone,
    guest_cur_user_name character varying(255),
    guest_last_login_time timestamp with time zone,
    guest_last_logout_time timestamp with time zone,
    guest_os character varying(255),
    run_on_vds uuid,
    migrating_to_vds uuid,
    app_list text,
    display integer,
    acpi_enable boolean,
    session integer,
    display_ip character varying(255),
    display_type integer,
    kvm_enable boolean,
    display_secure_port integer,
    utc_diff integer,
    last_vds_run_on uuid,
    client_ip character varying(255),
    guest_requested_memory integer,
    hibernation_vol_handle character varying(255),
    boot_sequence integer,
    exit_status integer DEFAULT 0 NOT NULL,
    pause_status integer DEFAULT 0 NOT NULL,
    exit_message character varying(4000),
    hash character varying(30),
    console_user_id uuid,
    guest_agent_nics_hash integer,
    console_cur_user_name character varying(255)
);


ALTER TABLE public.vm_dynamic OWNER TO engineer;

--
-- Name: vm_pool_map; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vm_pool_map (
    vm_pool_id uuid,
    vm_guid uuid NOT NULL
);


ALTER TABLE public.vm_pool_map OWNER TO engineer;

--
-- Name: vm_pools; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vm_pools (
    vm_pool_id uuid NOT NULL,
    vm_pool_name character varying(255) NOT NULL,
    vm_pool_description character varying(4000) NOT NULL,
    vm_pool_type integer,
    parameters character varying(200),
    vds_group_id uuid,
    prestarted_vms smallint DEFAULT 0
);


ALTER TABLE public.vm_pools OWNER TO engineer;

--
-- Name: vm_pool_map_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vm_pool_map_view AS
    SELECT vm_pool_map.vm_guid, vm_pool_map.vm_pool_id, vm_pools.vm_pool_name FROM (vm_pool_map JOIN vm_pools ON ((vm_pool_map.vm_pool_id = vm_pools.vm_pool_id)));


ALTER TABLE public.vm_pool_map_view OWNER TO engineer;

--
-- Name: vm_statistics; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vm_statistics (
    vm_guid uuid NOT NULL,
    cpu_user numeric(18,0) DEFAULT 0,
    cpu_sys numeric(18,0) DEFAULT 0,
    elapsed_time numeric(18,0) DEFAULT 0,
    usage_network_percent integer DEFAULT 0,
    usage_mem_percent integer DEFAULT 0,
    usage_cpu_percent integer DEFAULT 0,
    disks_usage text,
    _update_date timestamp with time zone
);


ALTER TABLE public.vm_statistics OWNER TO engineer;

--
-- Name: vms; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vms AS
    SELECT vm_static.vm_name, vm_static.mem_size_mb AS vm_mem_size_mb, vm_static.nice_level, vm_static.vmt_guid, vm_static.os AS vm_os, vm_static.description AS vm_description, vm_static.vds_group_id, vm_static.domain AS vm_domain, vm_static.creation_date AS vm_creation_date, vm_static.auto_startup, vm_static.is_stateless, vm_static.is_smartcard_enabled, vm_static.is_delete_protected, vm_static.dedicated_vm_for_vds, vm_static.fail_back, vm_static.default_boot_sequence, vm_static.vm_type, vds_groups.name AS vds_group_name, vds_groups.selection_algorithm, vds_groups.transparent_hugepages, storage_pool.id AS storage_pool_id, storage_pool.name AS storage_pool_name, vds_groups.description AS vds_group_description, vm_templates.vm_name AS vmt_name, vm_templates.mem_size_mb AS vmt_mem_size_mb, vm_templates.os AS vmt_os, vm_templates.creation_date AS vmt_creation_date, vm_templates.child_count AS vmt_child_count, vm_templates.num_of_sockets AS vmt_num_of_sockets, vm_templates.cpu_per_socket AS vmt_cpu_per_socket, (vm_templates.num_of_sockets * vm_templates.cpu_per_socket) AS vmt_num_of_cpus, vm_templates.description AS vmt_description, vm_dynamic.status, vm_dynamic.vm_ip, vm_dynamic.vm_host, vm_dynamic.vm_pid, vm_dynamic.last_start_time, vm_dynamic.guest_cur_user_name, vm_dynamic.console_cur_user_name, vm_dynamic.guest_last_login_time, vm_dynamic.guest_last_logout_time, vm_dynamic.guest_os, vm_dynamic.console_user_id, vm_dynamic.guest_agent_nics_hash, vm_dynamic.run_on_vds, vm_dynamic.migrating_to_vds, vm_dynamic.app_list, vm_dynamic.display, vm_dynamic.hibernation_vol_handle, vm_pool_map_view.vm_pool_name, vm_pool_map_view.vm_pool_id, vm_static.vm_guid, vm_static.num_of_monitors, vm_static.allow_console_reconnect, vm_static.is_initialized, vm_static.is_auto_suspend, vm_static.num_of_sockets, vm_static.cpu_per_socket, vm_static.usb_policy, vm_dynamic.acpi_enable, vm_dynamic.session, (vm_static.num_of_sockets * vm_static.cpu_per_socket) AS num_of_cpus, vm_static.quota_id, quota.quota_name, storage_pool.quota_enforcement_type, vm_dynamic.display_ip, vm_dynamic.display_type, vm_dynamic.kvm_enable, vm_dynamic.boot_sequence, vm_dynamic.display_secure_port, vm_dynamic.utc_diff, vm_dynamic.last_vds_run_on, vm_dynamic.client_ip, vm_dynamic.guest_requested_memory, vm_static.time_zone, vm_statistics.cpu_user, vm_statistics.cpu_sys, vm_statistics.elapsed_time, vm_statistics.usage_network_percent, vm_statistics.usage_mem_percent, vm_statistics.usage_cpu_percent, vds_static.vds_name AS run_on_vds_name, vds_groups.cpu_name AS vds_group_cpu_name, vm_static.default_display_type, vm_static.priority, vm_static.iso_path, vm_static.origin, vds_groups.compatibility_version AS vds_group_compatibility_version, vm_static.initrd_url, vm_static.kernel_url, vm_static.kernel_params, vm_dynamic.pause_status, vm_dynamic.exit_message, vm_dynamic.exit_status, vm_static.migration_support, vm_static.predefined_properties, vm_static.userdefined_properties, vm_static.min_allocated_mem, vm_dynamic.hash, vm_static.cpu_pinning, vm_static.db_generation, vm_static.host_cpu_flags FROM ((((((((vm_static JOIN vm_dynamic ON ((vm_static.vm_guid = vm_dynamic.vm_guid))) JOIN vm_static vm_templates ON ((vm_static.vmt_guid = vm_templates.vm_guid))) JOIN vm_statistics ON ((vm_static.vm_guid = vm_statistics.vm_guid))) JOIN vds_groups ON ((vm_static.vds_group_id = vds_groups.vds_group_id))) LEFT JOIN storage_pool ON (((vm_static.vds_group_id = vds_groups.vds_group_id) AND (vds_groups.storage_pool_id = storage_pool.id)))) LEFT JOIN quota ON ((vm_static.quota_id = quota.id))) LEFT JOIN vds_static ON ((vm_dynamic.run_on_vds = vds_static.vds_id))) LEFT JOIN vm_pool_map_view ON ((vm_static.vm_guid = vm_pool_map_view.vm_guid))) WHERE ((vm_static.entity_type)::text = 'VM'::text);


ALTER TABLE public.vms OWNER TO engineer;

--
-- Name: getactivevmsbystoragedomainid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getactivevmsbystoragedomainid(v_storage_domain_id uuid) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT vms.*
      FROM vms
      INNER JOIN vm_device vd ON vd.vm_id = vms.vm_guid
      INNER JOIN images i ON i.image_group_id = vd.device_id AND i.active = TRUE
      inner join image_storage_domain_map on i.image_guid = image_storage_domain_map.image_id
      WHERE status <> 0 and image_storage_domain_map.storage_domain_id = v_storage_domain_id;
END; $$;


ALTER FUNCTION public.getactivevmsbystoragedomainid(v_storage_domain_id uuid) OWNER TO engineer;

--
-- Name: ad_groups; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE ad_groups (
    id uuid NOT NULL,
    name character varying(256) NOT NULL,
    status integer NOT NULL,
    domain character varying(100),
    distinguishedname character varying(4000) DEFAULT NULL::character varying
);


ALTER TABLE public.ad_groups OWNER TO engineer;

--
-- Name: getad_groupsbyid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getad_groupsbyid(v_id uuid) RETURNS SETOF ad_groups
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM ad_groups
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.getad_groupsbyid(v_id uuid) OWNER TO engineer;

--
-- Name: getad_groupsbyname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getad_groupsbyname(v_name character varying) RETURNS SETOF ad_groups
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM ad_groups
      WHERE name = v_name;
END; $$;


ALTER FUNCTION public.getad_groupsbyname(v_name character varying) OWNER TO engineer;

--
-- Name: base_disks; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE base_disks (
    disk_id uuid NOT NULL,
    disk_interface character varying(32) NOT NULL,
    wipe_after_delete boolean DEFAULT false NOT NULL,
    propagate_errors character varying(32) DEFAULT 'Off'::character varying NOT NULL,
    disk_alias character varying(255),
    disk_description character varying(500),
    shareable boolean DEFAULT false,
    boot boolean DEFAULT false NOT NULL
);


ALTER TABLE public.base_disks OWNER TO engineer;

--
-- Name: disk_image_dynamic; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE disk_image_dynamic (
    image_id uuid NOT NULL,
    read_rate integer,
    write_rate integer,
    actual_size bigint NOT NULL,
    read_latency_seconds numeric(18,9),
    write_latency_seconds numeric(18,9),
    flush_latency_seconds numeric(18,9),
    _update_date timestamp with time zone
);


ALTER TABLE public.disk_image_dynamic OWNER TO engineer;

SET default_with_oids = false;

--
-- Name: disk_lun_map; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE disk_lun_map (
    disk_id uuid NOT NULL,
    lun_id character varying NOT NULL
);


ALTER TABLE public.disk_lun_map OWNER TO engineer;

SET default_with_oids = true;

--
-- Name: image_storage_domain_map; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE image_storage_domain_map (
    image_id uuid NOT NULL,
    storage_domain_id uuid NOT NULL
);


ALTER TABLE public.image_storage_domain_map OWNER TO engineer;

--
-- Name: images; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE images (
    image_guid uuid NOT NULL,
    creation_date timestamp with time zone NOT NULL,
    size bigint NOT NULL,
    it_guid uuid NOT NULL,
    parentid uuid,
    imagestatus integer DEFAULT 0,
    lastmodified timestamp with time zone,
    vm_snapshot_id uuid,
    volume_type integer DEFAULT 2 NOT NULL,
    volume_format integer DEFAULT 4 NOT NULL,
    image_group_id uuid,
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone,
    _update_date timestamp with time zone,
    quota_id uuid,
    active boolean DEFAULT false NOT NULL
);


ALTER TABLE public.images OWNER TO engineer;

--
-- Name: snapshots; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE snapshots (
    snapshot_id uuid NOT NULL,
    vm_id uuid NOT NULL,
    snapshot_type character varying(32) NOT NULL,
    status character varying(32) NOT NULL,
    description character varying(4000),
    creation_date timestamp with time zone NOT NULL,
    app_list text,
    vm_configuration text,
    _create_date timestamp with time zone DEFAULT now(),
    _update_date timestamp with time zone
);


ALTER TABLE public.snapshots OWNER TO engineer;

--
-- Name: storage_domain_static; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE storage_domain_static (
    id uuid NOT NULL,
    storage character varying(250) NOT NULL,
    storage_name character varying(250) NOT NULL,
    storage_domain_type integer NOT NULL,
    storage_type integer NOT NULL,
    storage_domain_format_type character varying(50) DEFAULT 0 NOT NULL,
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone,
    _update_date timestamp with time zone,
    recoverable boolean DEFAULT true NOT NULL,
    last_time_used_as_master bigint
);


ALTER TABLE public.storage_domain_static OWNER TO engineer;

--
-- Name: storage_pool_iso_map; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE storage_pool_iso_map (
    storage_id uuid NOT NULL,
    storage_pool_id uuid NOT NULL,
    status integer,
    owner integer
);


ALTER TABLE public.storage_pool_iso_map OWNER TO engineer;

--
-- Name: storage_domain_static_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW storage_domain_static_view AS
    SELECT storage_domain_static.id, storage_domain_static.storage, storage_domain_static.storage_name, storage_pool_iso_map.storage_pool_id, storage_pool_iso_map.status, storage_domain_static.storage_domain_type, storage_domain_static.storage_type, storage_domain_static.storage_domain_format_type, storage_domain_static.last_time_used_as_master, storage_pool.name AS storage_pool_name FROM ((storage_domain_static LEFT JOIN storage_pool_iso_map ON ((storage_pool_iso_map.storage_id = storage_domain_static.id))) LEFT JOIN storage_pool ON ((storage_pool.id = storage_pool_iso_map.storage_pool_id)));


ALTER TABLE public.storage_domain_static_view OWNER TO engineer;

--
-- Name: vm_device; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vm_device (
    device_id uuid NOT NULL,
    vm_id uuid NOT NULL,
    type character varying(30) NOT NULL,
    device character varying(30) NOT NULL,
    address character varying(255) NOT NULL,
    boot_order integer DEFAULT 0,
    spec_params text,
    is_managed boolean DEFAULT false NOT NULL,
    is_plugged boolean,
    is_readonly boolean DEFAULT false NOT NULL,
    _create_date timestamp with time zone DEFAULT now(),
    _update_date timestamp with time zone,
    alias character varying(255) DEFAULT ''::character varying
);


ALTER TABLE public.vm_device OWNER TO engineer;

--
-- Name: vms_for_disk_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vms_for_disk_view AS
    SELECT array_agg(vm_static.vm_name) AS array_vm_names, vm_device.device_id, vm_static.entity_type FROM (vm_static JOIN vm_device ON ((vm_static.vm_guid = vm_device.vm_id))) WHERE ((vm_device.device)::text = 'disk'::text) GROUP BY vm_device.device_id, vm_static.entity_type;


ALTER TABLE public.vms_for_disk_view OWNER TO engineer;

--
-- Name: images_storage_domain_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW images_storage_domain_view AS
    SELECT images.image_guid, storage_domain_static_view.storage_name, storage_domain_static_view.storage AS storage_path, storage_domain_static_view.storage_pool_id, images.creation_date, images.size, images.it_guid, snapshots.description, images.parentid, images.lastmodified, snapshots.app_list, image_storage_domain_map.storage_domain_id AS storage_id, images.vm_snapshot_id, images.volume_type, images.volume_format, images.imagestatus, images.image_group_id, images.active, vms_for_disk_view.entity_type, array_to_string(vms_for_disk_view.array_vm_names, ','::text) AS vm_names, COALESCE(array_upper(vms_for_disk_view.array_vm_names, 1), 0) AS number_of_vms, base_disks.disk_id, base_disks.disk_alias, base_disks.disk_description, base_disks.shareable, base_disks.disk_interface, base_disks.wipe_after_delete, base_disks.propagate_errors, base_disks.boot, images.quota_id, quota.quota_name, storage_pool.quota_enforcement_type, disk_image_dynamic.actual_size, disk_image_dynamic.read_rate, disk_image_dynamic.write_rate, disk_image_dynamic.read_latency_seconds, disk_image_dynamic.write_latency_seconds, disk_image_dynamic.flush_latency_seconds FROM ((((((((images LEFT JOIN disk_image_dynamic ON ((images.image_guid = disk_image_dynamic.image_id))) LEFT JOIN base_disks ON ((images.image_group_id = base_disks.disk_id))) LEFT JOIN vms_for_disk_view ON ((vms_for_disk_view.device_id = images.image_group_id))) LEFT JOIN image_storage_domain_map ON ((image_storage_domain_map.image_id = images.image_guid))) LEFT JOIN storage_domain_static_view ON ((image_storage_domain_map.storage_domain_id = storage_domain_static_view.id))) LEFT JOIN snapshots ON ((images.vm_snapshot_id = snapshots.snapshot_id))) LEFT JOIN quota ON ((images.quota_id = quota.id))) LEFT JOIN storage_pool ON ((storage_pool.id = storage_domain_static_view.storage_pool_id))) WHERE (images.image_guid <> '00000000-0000-0000-0000-000000000000'::uuid);


ALTER TABLE public.images_storage_domain_view OWNER TO engineer;

--
-- Name: luns; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE luns (
    physical_volume_id character varying(50),
    lun_id character varying(255) NOT NULL,
    volume_group_id character varying(50) NOT NULL,
    serial character varying(4000),
    lun_mapping integer,
    vendor_id character varying(50),
    product_id character varying(50),
    device_size integer DEFAULT 0
);


ALTER TABLE public.luns OWNER TO engineer;

--
-- Name: storage_for_image_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW storage_for_image_view AS
    SELECT images.image_guid AS image_id, array_to_string(array_agg(storage_domain_static.storage), ','::text) AS storage_path, array_to_string(array_agg(storage_domain_static.id), ','::text) AS storage_id, array_to_string(array_agg(storage_domain_static.storage_name), ','::text) AS storage_name FROM ((images LEFT JOIN image_storage_domain_map ON ((image_storage_domain_map.image_id = images.image_guid))) LEFT JOIN storage_domain_static ON ((image_storage_domain_map.storage_domain_id = storage_domain_static.id))) GROUP BY images.image_guid;


ALTER TABLE public.storage_for_image_view OWNER TO engineer;

--
-- Name: all_disks; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW all_disks AS
    SELECT storage_impl.disk_storage_type, storage_impl.storage_id, storage_impl.storage_path, storage_impl.storage_name, storage_impl.storage_pool_id, storage_impl.image_guid, storage_impl.creation_date, storage_impl.actual_size, storage_impl.read_rate, storage_impl.write_rate, storage_impl.read_latency_seconds, storage_impl.write_latency_seconds, storage_impl.flush_latency_seconds, storage_impl.size, storage_impl.it_guid, storage_impl.imagestatus, storage_impl.lastmodified, storage_impl.volume_type, storage_impl.volume_format, storage_impl.image_group_id, storage_impl.description, storage_impl.parentid, storage_impl.app_list, storage_impl.vm_snapshot_id, storage_impl.active, storage_impl.entity_type, storage_impl.number_of_vms, storage_impl.vm_names, storage_impl.quota_id, storage_impl.quota_name, storage_impl.quota_enforcement_type, storage_impl.lun_id, storage_impl.physical_volume_id, storage_impl.volume_group_id, storage_impl.serial, storage_impl.lun_mapping, storage_impl.vendor_id, storage_impl.product_id, storage_impl.device_size, bd.disk_id, bd.disk_interface, bd.wipe_after_delete, bd.propagate_errors, bd.disk_alias, bd.disk_description, bd.shareable, bd.boot FROM ((SELECT 0 AS disk_storage_type, storage_for_image_view.storage_id, storage_for_image_view.storage_path, storage_for_image_view.storage_name, images_storage_domain_view.storage_pool_id, images_storage_domain_view.image_guid, images_storage_domain_view.creation_date, images_storage_domain_view.actual_size, images_storage_domain_view.read_rate, images_storage_domain_view.write_rate, images_storage_domain_view.read_latency_seconds, images_storage_domain_view.write_latency_seconds, images_storage_domain_view.flush_latency_seconds, images_storage_domain_view.size, images_storage_domain_view.it_guid, images_storage_domain_view.imagestatus, images_storage_domain_view.lastmodified, images_storage_domain_view.volume_type, images_storage_domain_view.volume_format, images_storage_domain_view.image_group_id, images_storage_domain_view.description, images_storage_domain_view.parentid, images_storage_domain_view.app_list, images_storage_domain_view.vm_snapshot_id, images_storage_domain_view.active, images_storage_domain_view.entity_type, images_storage_domain_view.number_of_vms, images_storage_domain_view.vm_names, images_storage_domain_view.quota_id, images_storage_domain_view.quota_name, images_storage_domain_view.quota_enforcement_type, NULL::unknown AS lun_id, NULL::unknown AS physical_volume_id, NULL::unknown AS volume_group_id, NULL::unknown AS serial, NULL::unknown AS lun_mapping, NULL::unknown AS vendor_id, NULL::unknown AS product_id, NULL::unknown AS device_size FROM (images_storage_domain_view JOIN storage_for_image_view ON ((images_storage_domain_view.image_guid = storage_for_image_view.image_id))) WHERE (images_storage_domain_view.active = true) UNION SELECT 1 AS disk_storage_type, NULL::unknown AS storage_id, NULL::unknown AS storage_path, NULL::unknown AS storage_name, NULL::unknown AS storage_pool_id, NULL::unknown AS image_guid, NULL::unknown AS creation_date, NULL::unknown AS actual_size, NULL::unknown AS read_rate, NULL::unknown AS write_rate, NULL::unknown AS read_latency_seconds, NULL::unknown AS write_latency_seconds, NULL::unknown AS flush_latency_seconds, NULL::unknown AS size, NULL::unknown AS it_guid, NULL::unknown AS imagestatus, NULL::unknown AS lastmodified, NULL::unknown AS volume_type, NULL::unknown AS volume_format, dlm.disk_id AS image_group_id, NULL::unknown AS description, NULL::unknown AS parentid, NULL::unknown AS app_list, NULL::unknown AS vm_snapshot_id, NULL::unknown AS active, vms_for_disk_view.entity_type, COALESCE(array_upper(vms_for_disk_view.array_vm_names, 1), 0) AS number_of_vms, array_to_string(vms_for_disk_view.array_vm_names, ','::text) AS vm_names, NULL::unknown AS quota_id, NULL::unknown AS quota_name, NULL::unknown AS quota_enforcement_type, l.lun_id, l.physical_volume_id, l.volume_group_id, l.serial, l.lun_mapping, l.vendor_id, l.product_id, l.device_size FROM ((disk_lun_map dlm JOIN luns l ON (((l.lun_id)::text = (dlm.lun_id)::text))) LEFT JOIN vms_for_disk_view ON ((vms_for_disk_view.device_id = dlm.disk_id)))) storage_impl JOIN base_disks bd ON ((bd.disk_id = storage_impl.image_group_id)));


ALTER TABLE public.all_disks OWNER TO engineer;

--
-- Name: getallattachabledisksbypoolid(uuid, uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallattachabledisksbypoolid(v_storage_pool_id uuid, v_vm_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF all_disks
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT distinct all_disks.*
    FROM all_disks
    WHERE (v_storage_pool_id IS NULL OR all_disks.storage_pool_id = v_storage_pool_id)
    AND (all_disks.number_of_vms = 0 OR all_disks.shareable)
        -- ImageStatus.ILLEGAL=4 / imagestatus IS NULL -> LunDiski / ImageStatus.Locked=2
        AND (all_disks.imagestatus IS NULL OR (all_disks.imagestatus != 4 AND all_disks.imagestatus != 2))
        AND (v_vm_id IS NULL OR v_vm_id NOT IN (SELECT vm_id FROM vm_device WHERE vm_device.device_id = all_disks.image_group_id))
    AND   (NOT v_is_filtered OR EXISTS (SELECT 1
                                        FROM   user_disk_permissions_view
                                        WHERE  user_id = v_user_id AND entity_id = disk_id));
END; $$;


ALTER FUNCTION public.getallattachabledisksbypoolid(v_storage_pool_id uuid, v_vm_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getallbystatus(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallbystatus(v_status integer) RETURNS SETOF storage_pool
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_pool
   WHERE status = v_status;
END; $$;


ALTER FUNCTION public.getallbystatus(v_status integer) OWNER TO engineer;

--
-- Name: storage_server_connections; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE storage_server_connections (
    id character varying(50) NOT NULL,
    connection character varying(250) NOT NULL,
    user_name character varying(50),
    password text,
    iqn character varying(128),
    port character varying(50),
    portal character varying(50),
    storage_type integer NOT NULL,
    mount_options character varying(500),
    vfs_type character varying(128),
    nfs_version character varying(4),
    nfs_timeo smallint,
    nfs_retrans smallint
);


ALTER TABLE public.storage_server_connections OWNER TO engineer;

--
-- Name: getallconnectablestorageseverconnection(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallconnectablestorageseverconnection(v_storage_pool_id uuid) RETURNS SETOF storage_server_connections
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT distinct storage_server_connections.*
   FROM
   LUN_storage_server_connection_map LUN_storage_server_connection_map
   INNER JOIN  LUNs ON LUN_storage_server_connection_map.LUN_id = LUNs.LUN_id
   INNER JOIN  storage_domains ON LUNs.volume_group_id = storage_domains.storage
   INNER JOIN  storage_server_connections ON LUN_storage_server_connection_map.storage_server_connection = storage_server_connections.id
   WHERE     (storage_domains.storage_pool_id = v_storage_pool_id  and storage_domains.status in(0,3,4))
   UNION
   SELECT distinct storage_server_connections.*
   FROM         storage_server_connections
   INNER JOIN  storage_domains ON storage_server_connections.id = storage_domains.storage
   WHERE     (storage_domains.storage_pool_id = v_storage_pool_id and storage_domains.status in(0,3,4));
END; $$;


ALTER FUNCTION public.getallconnectablestorageseverconnection(v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getallfromaction_version_map(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromaction_version_map() RETURNS SETOF action_version_map
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM action_version_map;

END; $$;


ALTER FUNCTION public.getallfromaction_version_map() OWNER TO engineer;

--
-- Name: getallfromad_groups(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromad_groups() RETURNS SETOF ad_groups
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM ad_groups;
END; $$;


ALTER FUNCTION public.getallfromad_groups() OWNER TO engineer;

--
-- Name: async_tasks; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE async_tasks (
    task_id uuid NOT NULL,
    action_type integer NOT NULL,
    status integer NOT NULL,
    result integer NOT NULL,
    action_parameters text,
    action_params_class character varying(256),
    step_id uuid,
    command_id uuid NOT NULL,
    started_at timestamp with time zone,
    storage_pool_id uuid,
    task_type integer DEFAULT 0 NOT NULL,
    task_parameters text,
    task_params_class character varying(256)
);


ALTER TABLE public.async_tasks OWNER TO engineer;

--
-- Name: getallfromasync_tasks(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromasync_tasks() RETURNS SETOF async_tasks
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM async_tasks;

END; $$;


ALTER FUNCTION public.getallfromasync_tasks() OWNER TO engineer;

--
-- Name: audit_log_seq; Type: SEQUENCE; Schema: public; Owner: engineer
--

CREATE SEQUENCE audit_log_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.audit_log_seq OWNER TO engineer;

--
-- Name: audit_log_seq; Type: SEQUENCE SET; Schema: public; Owner: engineer
--

SELECT pg_catalog.setval('audit_log_seq', 60283, true);


--
-- Name: audit_log; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE audit_log (
    audit_log_id bigint DEFAULT nextval('audit_log_seq'::regclass) NOT NULL,
    user_id uuid,
    user_name character varying(255),
    vm_id uuid,
    vm_name character varying(255),
    vm_template_id uuid,
    vm_template_name character varying(40),
    vds_id uuid,
    vds_name character varying(255),
    log_time timestamp with time zone NOT NULL,
    log_type_name character varying(100) DEFAULT ''::character varying,
    log_type integer NOT NULL,
    severity integer NOT NULL,
    message text NOT NULL,
    processed boolean DEFAULT false NOT NULL,
    storage_pool_id uuid,
    storage_pool_name character varying(40),
    storage_domain_id uuid,
    storage_domain_name character varying(250),
    vds_group_id uuid,
    vds_group_name character varying(255),
    correlation_id character varying(50),
    job_id uuid,
    quota_id uuid,
    quota_name character varying(60),
    gluster_volume_id uuid,
    gluster_volume_name character varying(1000),
    origin character varying(255) DEFAULT 'oVirt'::character varying,
    custom_event_id integer DEFAULT (-1),
    event_flood_in_sec integer DEFAULT 30,
    custom_data text DEFAULT ''::text,
    deleted boolean DEFAULT false
);


ALTER TABLE public.audit_log OWNER TO engineer;

--
-- Name: getallfromauditlog(uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromauditlog(v_user_id uuid, v_is_filtered boolean) RETURNS SETOF audit_log
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM audit_log a
      WHERE NOT deleted AND
     (NOT v_is_filtered OR EXISTS (SELECT 1
                                   FROM   user_vm_permissions_view pv, user_object_permissions_view dpv
                                   WHERE  pv.user_id = v_user_id AND pv.entity_id = a.vm_id AND pv.entity_id = dpv.entity_id)
                        OR EXISTS (SELECT 1
                                   FROM user_vm_template_permissions_view pv, user_object_permissions_view dpv
                                   WHERE pv.user_id = v_user_id AND pv.entity_id = a.vm_template_id AND pv.entity_id = dpv.entity_id)
                        OR EXISTS (SELECT 1
                                   FROM user_vds_permissions_view pv, user_object_permissions_view dpv
                                   WHERE pv.user_id = v_user_id AND pv.entity_id = a.vds_id AND pv.entity_id = dpv.entity_id)
                        OR EXISTS (SELECT 1
                                   FROM user_storage_pool_permissions_view pv, user_object_permissions_view dpv
                                   WHERE pv.user_id = v_user_id AND pv.entity_id = a.storage_pool_id AND pv.entity_id = dpv.entity_id)
                        OR EXISTS (SELECT 1
                                   FROM user_storage_domain_permissions_view pv, user_object_permissions_view dpv
                                   WHERE pv.user_id = v_user_id AND pv.entity_id = a.storage_domain_id AND pv.entity_id = dpv.entity_id)
                        OR EXISTS (SELECT 1
                                   FROM user_vds_groups_permissions_view pv, user_object_permissions_view dpv
                                   WHERE pv.user_id = v_user_id AND pv.entity_id = a.vds_group_id AND pv.entity_id = dpv.entity_id)
     );
END; $$;


ALTER FUNCTION public.getallfromauditlog(v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getallfrombasedisks(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfrombasedisks() RETURNS SETOF base_disks
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   base_disks;
END; $$;


ALTER FUNCTION public.getallfrombasedisks() OWNER TO engineer;

--
-- Name: bookmarks; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE bookmarks (
    bookmark_id uuid NOT NULL,
    bookmark_name character varying(40),
    bookmark_value character varying(300) NOT NULL
);


ALTER TABLE public.bookmarks OWNER TO engineer;

--
-- Name: getallfrombookmarks(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfrombookmarks() RETURNS SETOF bookmarks
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM bookmarks;
END; $$;


ALTER FUNCTION public.getallfrombookmarks() OWNER TO engineer;

--
-- Name: custom_actions_seq; Type: SEQUENCE; Schema: public; Owner: engineer
--

CREATE SEQUENCE custom_actions_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.custom_actions_seq OWNER TO engineer;

--
-- Name: custom_actions_seq; Type: SEQUENCE SET; Schema: public; Owner: engineer
--

SELECT pg_catalog.setval('custom_actions_seq', 1, false);


--
-- Name: custom_actions; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE custom_actions (
    action_id integer DEFAULT nextval('custom_actions_seq'::regclass) NOT NULL,
    action_name character varying(50) NOT NULL,
    path character varying(300) NOT NULL,
    tab integer NOT NULL,
    description character varying(4000)
);


ALTER TABLE public.custom_actions OWNER TO engineer;

--
-- Name: getallfromcustom_actions(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromcustom_actions() RETURNS SETOF custom_actions
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM custom_actions;
END; $$;


ALTER FUNCTION public.getallfromcustom_actions() OWNER TO engineer;

--
-- Name: getallfromdisk_image_dynamic(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromdisk_image_dynamic() RETURNS SETOF disk_image_dynamic
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM disk_image_dynamic;

END; $$;


ALTER FUNCTION public.getallfromdisk_image_dynamic() OWNER TO engineer;

--
-- Name: getallfromdisklunmaps(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromdisklunmaps() RETURNS SETOF disk_lun_map
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   disk_lun_map;
END; $$;


ALTER FUNCTION public.getallfromdisklunmaps() OWNER TO engineer;

--
-- Name: getallfromdisks(uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromdisks(v_user_id uuid, v_is_filtered boolean) RETURNS SETOF all_disks
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   all_disks
    WHERE (NOT v_is_filtered OR EXISTS (SELECT 1
                                        FROM user_disk_permissions_view
                                        WHERE user_id = v_user_id AND entity_id = disk_id));
END; $$;


ALTER FUNCTION public.getallfromdisks(v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: event_map; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE event_map (
    event_up_name character varying(100) NOT NULL,
    event_down_name character varying(100) NOT NULL
);


ALTER TABLE public.event_map OWNER TO engineer;

--
-- Name: event_subscriber; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE event_subscriber (
    subscriber_id uuid NOT NULL,
    event_up_name character varying(100) NOT NULL,
    method_id integer NOT NULL,
    method_address character varying(255),
    tag_name character varying(50) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE public.event_subscriber OWNER TO engineer;

--
-- Name: event_audit_log_subscriber_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW event_audit_log_subscriber_view AS
    SELECT 1 AS event_type, event_subscriber_1.subscriber_id, event_subscriber_1.event_up_name, event_subscriber_1.method_id, event_subscriber_1.method_address, event_subscriber_1.tag_name, audit_log_1.audit_log_id, audit_log_1.user_id, audit_log_1.user_name, audit_log_1.vm_id, audit_log_1.vm_name, audit_log_1.vm_template_id, audit_log_1.vm_template_name, audit_log_1.vds_id, audit_log_1.vds_name, audit_log_1.storage_pool_id, audit_log_1.storage_pool_name, audit_log_1.storage_domain_id, audit_log_1.storage_domain_name, audit_log_1.log_time, audit_log_1.severity, audit_log_1.message FROM (audit_log audit_log_1 JOIN event_subscriber event_subscriber_1 ON (((audit_log_1.log_type_name)::text = (event_subscriber_1.event_up_name)::text))) WHERE (audit_log_1.processed = false) UNION SELECT DISTINCT 0 AS event_type, event_subscriber.subscriber_id, audit_log.log_type_name AS event_up_name, event_subscriber.method_id, event_subscriber.method_address, event_subscriber.tag_name, audit_log.audit_log_id, audit_log.user_id, audit_log.user_name, audit_log.vm_id, audit_log.vm_name, audit_log.vm_template_id, audit_log.vm_template_name, audit_log.vds_id, audit_log.vds_name, audit_log.storage_pool_id, audit_log.storage_pool_name, audit_log.storage_domain_id, audit_log.storage_domain_name, audit_log.log_time, audit_log.severity, audit_log.message FROM ((audit_log audit_log JOIN event_map ON (((audit_log.log_type_name)::text = (event_map.event_down_name)::text))) JOIN event_subscriber event_subscriber ON (((event_subscriber.event_up_name)::text = (event_map.event_up_name)::text))) WHERE (audit_log.processed = false);


ALTER TABLE public.event_audit_log_subscriber_view OWNER TO engineer;

--
-- Name: getallfromevent_audit_log_subscriber(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromevent_audit_log_subscriber() RETURNS SETOF event_audit_log_subscriber_view
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_last  BIGINT;
BEGIN
      -- begin tran


			-- get last event
			select   audit_log_id INTO v_last from audit_log    order by audit_log_id desc LIMIT 1;
			-- mark processed events
      update audit_log set processed = TRUE where audit_log_id <= v_last;
			-- get from view all events with id <= @last
      RETURN QUERY SELECT *
      from event_audit_log_subscriber_view  event_audit_log_subscriber_view
      where audit_log_id <= v_last;
END; $$;


ALTER FUNCTION public.getallfromevent_audit_log_subscriber() OWNER TO engineer;

--
-- Name: getallfromevent_audit_log_subscriber_only(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromevent_audit_log_subscriber_only() RETURNS SETOF event_audit_log_subscriber_view
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_last  BIGINT;
BEGIN
        -- get last event
        select   audit_log_id INTO v_last from audit_log order by audit_log_id desc LIMIT 1;
        -- get from view all events with id <= @last
        RETURN QUERY select *
                   from event_audit_log_subscriber_view  where audit_log_id <= v_last;
END; $$;


ALTER FUNCTION public.getallfromevent_audit_log_subscriber_only() OWNER TO engineer;

--
-- Name: getallfromevent_map(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromevent_map() RETURNS SETOF event_map
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM event_map;

END; $$;


ALTER FUNCTION public.getallfromevent_map() OWNER TO engineer;

--
-- Name: event_notification_hist; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE event_notification_hist (
    subscriber_id uuid NOT NULL,
    event_name character varying(100) NOT NULL,
    audit_log_id bigint NOT NULL,
    method_type character(10) NOT NULL,
    sent_at timestamp with time zone NOT NULL,
    status boolean NOT NULL,
    reason character(255)
);


ALTER TABLE public.event_notification_hist OWNER TO engineer;

--
-- Name: getallfromevent_notification_hist(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromevent_notification_hist() RETURNS SETOF event_notification_hist
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM event_notification_hist;

END; $$;


ALTER FUNCTION public.getallfromevent_notification_hist() OWNER TO engineer;

--
-- Name: event_notification_methods; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE event_notification_methods (
    method_id integer NOT NULL,
    method_type character(10) NOT NULL
);


ALTER TABLE public.event_notification_methods OWNER TO engineer;

--
-- Name: getallfromevent_notification_methods(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromevent_notification_methods() RETURNS SETOF event_notification_methods
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM event_notification_methods;

END; $$;


ALTER FUNCTION public.getallfromevent_notification_methods() OWNER TO engineer;

--
-- Name: getallfromevent_subscriber(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromevent_subscriber() RETURNS SETOF event_subscriber
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM event_subscriber;

END; $$;


ALTER FUNCTION public.getallfromevent_subscriber() OWNER TO engineer;

--
-- Name: event_subscriber_notification_methods_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW event_subscriber_notification_methods_view AS
    SELECT event_subscriber.subscriber_id, event_subscriber.event_up_name, event_notification_methods.method_type FROM (event_notification_methods JOIN event_subscriber ON ((event_notification_methods.method_id = event_subscriber.method_id)));


ALTER TABLE public.event_subscriber_notification_methods_view OWNER TO engineer;

--
-- Name: getallfromevent_subscriber_notification_methods(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromevent_subscriber_notification_methods() RETURNS SETOF event_subscriber_notification_methods_view
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT *
from event_subscriber_notification_methods_view;
END; $$;


ALTER FUNCTION public.getallfromevent_subscriber_notification_methods() OWNER TO engineer;

--
-- Name: getallfromimages(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromimages() RETURNS SETOF images
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   images;
END; $$;


ALTER FUNCTION public.getallfromimages() OWNER TO engineer;

--
-- Name: lun_storage_server_connection_map; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE lun_storage_server_connection_map (
    lun_id character varying(255) NOT NULL,
    storage_server_connection character varying(50) NOT NULL
);


ALTER TABLE public.lun_storage_server_connection_map OWNER TO engineer;

--
-- Name: getallfromlun_storage_server_connection_map(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromlun_storage_server_connection_map() RETURNS SETOF lun_storage_server_connection_map
    LANGUAGE plpgsql
    AS $$
BEGIN

   RETURN QUERY SELECT *
   FROM LUN_storage_server_connection_map lUN_storage_server_connection_map;

END; $$;


ALTER FUNCTION public.getallfromlun_storage_server_connection_map() OWNER TO engineer;

--
-- Name: luns_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW luns_view AS
    SELECT luns.physical_volume_id, luns.lun_id, luns.volume_group_id, luns.serial, luns.lun_mapping, luns.vendor_id, luns.product_id, luns.device_size, storage_domain_static.id AS storage_id, storage_domain_static.storage_name, disk_lun_map.disk_id, all_disks.disk_alias FROM (((luns LEFT JOIN storage_domain_static ON (((luns.volume_group_id)::text = (storage_domain_static.storage)::text))) LEFT JOIN disk_lun_map ON (((luns.lun_id)::text = (disk_lun_map.lun_id)::text))) LEFT JOIN all_disks ON ((disk_lun_map.disk_id = all_disks.disk_id)));


ALTER TABLE public.luns_view OWNER TO engineer;

--
-- Name: getallfromluns(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromluns() RETURNS SETOF luns_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM luns_view;

END; $$;


ALTER FUNCTION public.getallfromluns() OWNER TO engineer;

--
-- Name: network; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE network (
    id uuid NOT NULL,
    name character varying(50) NOT NULL,
    description character varying(4000),
    type integer,
    addr character varying(50),
    subnet character varying(20),
    gateway character varying(20),
    vlan_id integer,
    stp boolean DEFAULT false NOT NULL,
    storage_pool_id uuid,
    mtu integer,
    vm_network boolean DEFAULT true NOT NULL
);


ALTER TABLE public.network OWNER TO engineer;

--
-- Name: getallfromnetwork(uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromnetwork(v_user_id uuid, v_is_filtered boolean) RETURNS SETOF network
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM network
   WHERE NOT v_is_filtered OR EXISTS (SELECT 1
                                      FROM   user_network_permissions_view
                                      WHERE  user_id = v_user_id AND entity_id = network.id);

END; $$;


ALTER FUNCTION public.getallfromnetwork(v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: network_cluster; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE network_cluster (
    network_id uuid NOT NULL,
    cluster_id uuid NOT NULL,
    status integer DEFAULT 0 NOT NULL,
    is_display boolean DEFAULT false NOT NULL,
    required boolean DEFAULT true NOT NULL
);


ALTER TABLE public.network_cluster OWNER TO engineer;

--
-- Name: getallfromnetwork_cluster(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromnetwork_cluster() RETURNS SETOF network_cluster
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM network_cluster;

END; $$;


ALTER FUNCTION public.getallfromnetwork_cluster() OWNER TO engineer;

--
-- Name: getallfromnetwork_clusterbyclusterid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromnetwork_clusterbyclusterid(v_cluster_id uuid) RETURNS SETOF network_cluster
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM network_cluster
   WHERE cluster_id = v_cluster_id;

END; $$;


ALTER FUNCTION public.getallfromnetwork_clusterbyclusterid(v_cluster_id uuid) OWNER TO engineer;

--
-- Name: getallfromnetwork_clusterbynetworkid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromnetwork_clusterbynetworkid(v_network_id uuid) RETURNS SETOF network_cluster
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM network_cluster
   WHERE network_id = v_network_id;

END; $$;


ALTER FUNCTION public.getallfromnetwork_clusterbynetworkid(v_network_id uuid) OWNER TO engineer;

--
-- Name: getallfromrole(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromrole() RETURNS SETOF roles
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM roles;

END; $$;


ALTER FUNCTION public.getallfromrole() OWNER TO engineer;

--
-- Name: roles_relations; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE roles_relations (
    role_id uuid NOT NULL,
    role_container_id uuid NOT NULL
);


ALTER TABLE public.roles_relations OWNER TO engineer;

--
-- Name: getallfromroles_relations(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromroles_relations() RETURNS SETOF roles_relations
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM roles_relations;

END; $$;


ALTER FUNCTION public.getallfromroles_relations() OWNER TO engineer;

--
-- Name: getallfromsnapshots(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromsnapshots() RETURNS SETOF snapshots
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   snapshots;
END; $$;


ALTER FUNCTION public.getallfromsnapshots() OWNER TO engineer;

--
-- Name: getallfromsnapshotsbyvmid(uuid, uuid, boolean, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromsnapshotsbyvmid(v_vm_id uuid, v_user_id uuid, v_is_filtered boolean, v_fill_configuration boolean) RETURNS SETOF getallfromsnapshotsbyvmid_rs
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT snapshot_id,
           vm_id,
           snapshot_type,
           status,
           description,
           creation_date,
           app_list,
           CASE WHEN v_fill_configuration = TRUE THEN vm_configuration ELSE NULL END,
           vm_configuration IS NOT NULL AND LENGTH(vm_configuration) > 0
    FROM   snapshots
    WHERE  vm_id = v_vm_id
    AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                      FROM   user_vm_permissions_view
                                      WHERE  user_id = v_user_id AND entity_id = v_vm_id))
    ORDER BY creation_date ASC;
END; $$;


ALTER FUNCTION public.getallfromsnapshotsbyvmid(v_vm_id uuid, v_user_id uuid, v_is_filtered boolean, v_fill_configuration boolean) OWNER TO engineer;

--
-- Name: storage_domain_dynamic; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE storage_domain_dynamic (
    id uuid NOT NULL,
    available_disk_size integer,
    used_disk_size integer,
    _update_date timestamp with time zone
);


ALTER TABLE public.storage_domain_dynamic OWNER TO engineer;

--
-- Name: getallfromstorage_domain_dynamic(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromstorage_domain_dynamic() RETURNS SETOF storage_domain_dynamic
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domain_dynamic;

END; $$;


ALTER FUNCTION public.getallfromstorage_domain_dynamic() OWNER TO engineer;

--
-- Name: getallfromstorage_domain_static(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromstorage_domain_static() RETURNS SETOF storage_domain_static
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domain_static;
END; $$;


ALTER FUNCTION public.getallfromstorage_domain_static() OWNER TO engineer;

--
-- Name: storage_domains; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW storage_domains AS
    SELECT storage_domain_static.id, storage_domain_static.storage, storage_domain_static.storage_name, storage_pool_iso_map.storage_pool_id, storage_domain_dynamic.available_disk_size, storage_domain_dynamic.used_disk_size, fn_get_disk_commited_value_by_storage(storage_domain_static.id) AS commited_disk_size, storage_pool_iso_map.status, storage_pool.name AS storage_pool_name, storage_domain_static.storage_type, storage_domain_static.storage_domain_type, storage_domain_static.storage_domain_format_type, storage_domain_static.last_time_used_as_master, storage_pool_iso_map.owner, fn_get_storage_domain_shared_status_by_domain_id(storage_domain_static.id, storage_pool_iso_map.status, storage_domain_static.storage_domain_type) AS storage_domain_shared_status, storage_domain_static.recoverable FROM (((storage_domain_static JOIN storage_domain_dynamic ON ((storage_domain_static.id = storage_domain_dynamic.id))) LEFT JOIN storage_pool_iso_map ON ((storage_domain_static.id = storage_pool_iso_map.storage_id))) LEFT JOIN storage_pool ON ((storage_pool_iso_map.storage_pool_id = storage_pool.id)));


ALTER TABLE public.storage_domains OWNER TO engineer;

--
-- Name: getallfromstorage_domains(uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromstorage_domains(v_user_id uuid, v_is_filtered boolean) RETURNS SETOF storage_domains
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domains
   WHERE (NOT v_is_filtered OR EXISTS (SELECT 1
                                       FROM user_storage_domain_permissions_view
                                       WHERE user_id = v_user_id AND entity_id = id));
END; $$;


ALTER FUNCTION public.getallfromstorage_domains(v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getallfromstorage_pool(uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromstorage_pool(v_user_id uuid, v_is_filtered boolean) RETURNS SETOF storage_pool
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_pool
   WHERE (NOT v_is_filtered OR EXISTS (SELECT 1
                                       FROM   user_storage_pool_permissions_view
                                       WHERE  user_id = v_user_id AND entity_id = id));
END; $$;


ALTER FUNCTION public.getallfromstorage_pool(v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getallfromstorage_pool_iso_map(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromstorage_pool_iso_map() RETURNS SETOF storage_pool_iso_map
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_pool_iso_map;

END; $$;


ALTER FUNCTION public.getallfromstorage_pool_iso_map() OWNER TO engineer;

--
-- Name: getallfromstorage_server_connections(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromstorage_server_connections() RETURNS SETOF storage_server_connections
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_server_connections;

END; $$;


ALTER FUNCTION public.getallfromstorage_server_connections() OWNER TO engineer;

--
-- Name: getallfromstoragedomainsbyconnectionid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromstoragedomainsbyconnectionid(v_connection_id character varying) RETURNS SETOF storage_domains
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domains
   WHERE storage = v_connection_id;
END; $$;


ALTER FUNCTION public.getallfromstoragedomainsbyconnectionid(v_connection_id character varying) OWNER TO engineer;

--
-- Name: tags; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE tags (
    tag_id uuid NOT NULL,
    tag_name character varying(50) DEFAULT ''::character varying NOT NULL,
    description character varying(4000),
    parent_id uuid,
    readonly boolean,
    type integer DEFAULT 0 NOT NULL,
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone,
    _update_date timestamp with time zone
);


ALTER TABLE public.tags OWNER TO engineer;

--
-- Name: getallfromtags(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromtags() RETURNS SETOF tags
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags.*
      FROM tags;
END; $$;


ALTER FUNCTION public.getallfromtags() OWNER TO engineer;

--
-- Name: tags_user_group_map; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE tags_user_group_map (
    tag_id uuid NOT NULL,
    group_id uuid NOT NULL,
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone
);


ALTER TABLE public.tags_user_group_map OWNER TO engineer;

--
-- Name: getallfromtags_user_group_map(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromtags_user_group_map() RETURNS SETOF tags_user_group_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags_user_group_map.*
      FROM tags_user_group_map;
END; $$;


ALTER FUNCTION public.getallfromtags_user_group_map() OWNER TO engineer;

--
-- Name: tags_user_map; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE tags_user_map (
    tag_id uuid NOT NULL,
    user_id uuid NOT NULL,
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone
);


ALTER TABLE public.tags_user_map OWNER TO engineer;

--
-- Name: getallfromtags_user_map(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromtags_user_map() RETURNS SETOF tags_user_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags_user_map.*
      FROM tags_user_map;
END; $$;


ALTER FUNCTION public.getallfromtags_user_map() OWNER TO engineer;

--
-- Name: tags_vds_map; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE tags_vds_map (
    tag_id uuid NOT NULL,
    vds_id uuid NOT NULL,
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone
);


ALTER TABLE public.tags_vds_map OWNER TO engineer;

--
-- Name: getallfromtags_vds_map(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromtags_vds_map() RETURNS SETOF tags_vds_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags_vds_map.*
      FROM tags_vds_map;
END; $$;


ALTER FUNCTION public.getallfromtags_vds_map() OWNER TO engineer;

--
-- Name: tags_vm_map; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE tags_vm_map (
    tag_id uuid NOT NULL,
    vm_id uuid NOT NULL,
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone,
    defaultdisplaytype integer DEFAULT 0
);


ALTER TABLE public.tags_vm_map OWNER TO engineer;

--
-- Name: getallfromtags_vm_map(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromtags_vm_map() RETURNS SETOF tags_vm_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags_vm_map.*
      FROM tags_vm_map;
END; $$;


ALTER FUNCTION public.getallfromtags_vm_map() OWNER TO engineer;

--
-- Name: tags_vm_pool_map; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE tags_vm_pool_map (
    tag_id uuid NOT NULL,
    vm_pool_id uuid NOT NULL,
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone
);


ALTER TABLE public.tags_vm_pool_map OWNER TO engineer;

--
-- Name: getallfromtags_vm_pool_map(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromtags_vm_pool_map() RETURNS SETOF tags_vm_pool_map
    LANGUAGE plpgsql
    AS $$
BEGIN

   RETURN QUERY SELECT tags_vm_pool_map.*
   FROM tags_vm_pool_map;

END; $$;


ALTER FUNCTION public.getallfromtags_vm_pool_map() OWNER TO engineer;

--
-- Name: user_sessions; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE user_sessions (
    session_id character(32) NOT NULL,
    user_id uuid NOT NULL,
    os character(10),
    browser character(10),
    client_type character(10),
    login_time timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone
);


ALTER TABLE public.user_sessions OWNER TO engineer;

--
-- Name: getallfromuser_sessions(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromuser_sessions() RETURNS SETOF user_sessions
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT user_sessions.*
      FROM user_sessions;
END; $$;


ALTER FUNCTION public.getallfromuser_sessions() OWNER TO engineer;

--
-- Name: users; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE users (
    user_id uuid NOT NULL,
    name character varying(255),
    surname character varying(255),
    domain character varying(255) NOT NULL,
    username character varying(255) NOT NULL,
    groups character varying NOT NULL,
    department character varying(255),
    role character varying(255),
    user_icon_path character varying(255),
    desktop_device character varying(255),
    email character varying(255),
    note character varying(255),
    status integer NOT NULL,
    session_count integer DEFAULT 0 NOT NULL,
    last_admin_check_status boolean DEFAULT false NOT NULL,
    group_ids text
);


ALTER TABLE public.users OWNER TO engineer;

--
-- Name: getallfromusers(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromusers() RETURNS SETOF users
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT users.*
      FROM users;
END; $$;


ALTER FUNCTION public.getallfromusers() OWNER TO engineer;

--
-- Name: vdc_options_seq; Type: SEQUENCE; Schema: public; Owner: engineer
--

CREATE SEQUENCE vdc_options_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.vdc_options_seq OWNER TO engineer;

--
-- Name: vdc_options_seq; Type: SEQUENCE SET; Schema: public; Owner: engineer
--

SELECT pg_catalog.setval('vdc_options_seq', 455, true);


--
-- Name: vdc_options; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vdc_options (
    option_id integer DEFAULT nextval('vdc_options_seq'::regclass) NOT NULL,
    option_name character varying(100) NOT NULL,
    option_value character varying(4000) NOT NULL,
    version character varying(40) DEFAULT 'general'::character varying NOT NULL
);


ALTER TABLE public.vdc_options OWNER TO engineer;

--
-- Name: getallfromvdcoption(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvdcoption() RETURNS SETOF vdc_options
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vdc_options.*
      FROM vdc_options;
END; $$;


ALTER FUNCTION public.getallfromvdcoption() OWNER TO engineer;

--
-- Name: vds_dynamic; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vds_dynamic (
    vds_id uuid NOT NULL,
    status integer NOT NULL,
    cpu_cores integer,
    cpu_model character varying(255),
    cpu_speed_mh numeric(18,0),
    if_total_speed character varying(40),
    kvm_enabled boolean,
    physical_mem_mb integer,
    mem_commited integer DEFAULT 0,
    vm_active integer DEFAULT 0,
    vm_count integer DEFAULT 0 NOT NULL,
    vm_migrating integer DEFAULT 0,
    reserved_mem integer,
    guest_overhead integer,
    software_version character varying(40),
    version_name character varying(40),
    build_name character varying(40),
    previous_status integer,
    cpu_flags character varying(4000),
    cpu_over_commit_time_stamp timestamp with time zone,
    vms_cores_count integer,
    pending_vcpus_count integer,
    cpu_sockets integer,
    net_config_dirty boolean,
    supported_cluster_levels character varying(40),
    host_os character varying(4000),
    kvm_version character varying(4000),
    spice_version character varying(4000),
    kernel_version character varying(4000),
    iscsi_initiator_name character varying(4000),
    transparent_hugepages_state integer DEFAULT 0 NOT NULL,
    anonymous_hugepages integer DEFAULT 0 NOT NULL,
    hooks character varying(4000) DEFAULT ''::character varying,
    _update_date timestamp with time zone,
    non_operational_reason integer DEFAULT 0 NOT NULL,
    pending_vmem_size integer DEFAULT 0 NOT NULL,
    supported_engines character varying(40),
    rpm_version character varying(256) DEFAULT NULL::character varying,
    libvirt_version character varying(256) DEFAULT NULL::character varying,
    cpu_threads integer,
    hw_manufacturer character varying(255),
    hw_product_name character varying(255),
    hw_version character varying(255),
    hw_serial_number character varying(255),
    hw_uuid character varying(255),
    hw_family character varying(255)
);


ALTER TABLE public.vds_dynamic OWNER TO engineer;

--
-- Name: vds_spm_id_map; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vds_spm_id_map (
    storage_pool_id uuid NOT NULL,
    vds_spm_id integer NOT NULL,
    vds_id uuid NOT NULL
);


ALTER TABLE public.vds_spm_id_map OWNER TO engineer;

--
-- Name: vds_statistics; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vds_statistics (
    vds_id uuid NOT NULL,
    cpu_idle numeric(18,0) DEFAULT 0,
    cpu_load numeric(18,0) DEFAULT 0,
    cpu_sys numeric(18,0) DEFAULT 0,
    cpu_user numeric(18,0) DEFAULT 0,
    usage_mem_percent integer DEFAULT 0,
    usage_cpu_percent integer DEFAULT 0,
    usage_network_percent integer,
    mem_available bigint,
    mem_shared bigint,
    swap_free bigint,
    swap_total bigint,
    ksm_cpu_percent integer DEFAULT 0,
    ksm_pages bigint,
    ksm_state boolean,
    _update_date timestamp with time zone
);


ALTER TABLE public.vds_statistics OWNER TO engineer;

--
-- Name: vds; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vds AS
    SELECT vds_groups.vds_group_id, vds_groups.name AS vds_group_name, vds_groups.description AS vds_group_description, vds_groups.selection_algorithm, vds_static.vds_id, vds_static.vds_name, vds_static.ip, vds_static.vds_unique_id, vds_static.host_name, vds_static.port, vds_static.vds_strength, vds_static.server_ssl_enabled, vds_static.vds_type, vds_static.pm_type, vds_static.pm_user, vds_static.pm_password, vds_static.pm_port, vds_static.pm_options, vds_static.pm_enabled, vds_static.pm_proxy_preferences, vds_static.pm_secondary_ip, vds_static.pm_secondary_options, vds_static.pm_secondary_port, vds_static.pm_secondary_password, vds_static.pm_secondary_user, vds_static.pm_secondary_type, vds_static.pm_secondary_concurrent, vds_static.vds_spm_priority, vds_dynamic.hooks, vds_dynamic.status, vds_dynamic.cpu_cores, vds_dynamic.cpu_threads, vds_dynamic.cpu_model, vds_dynamic.cpu_speed_mh, vds_dynamic.if_total_speed, vds_dynamic.kvm_enabled, vds_dynamic.physical_mem_mb, vds_dynamic.pending_vcpus_count, vds_dynamic.pending_vmem_size, vds_dynamic.mem_commited, vds_dynamic.vm_active, vds_dynamic.vm_count, vds_dynamic.vm_migrating, vds_dynamic.vms_cores_count, vds_dynamic.cpu_over_commit_time_stamp, vds_dynamic.net_config_dirty, vds_groups.high_utilization, vds_groups.low_utilization, vds_groups.max_vds_memory_over_commit, vds_groups.cpu_over_commit_duration_minutes, vds_groups.count_threads_as_cores, storage_pool.id AS storage_pool_id, storage_pool.name AS storage_pool_name, vds_dynamic.reserved_mem, vds_dynamic.guest_overhead, vds_dynamic.rpm_version, vds_dynamic.software_version, vds_dynamic.version_name, vds_dynamic.build_name, vds_dynamic.previous_status, vds_statistics.cpu_idle, vds_statistics.cpu_load, vds_statistics.cpu_sys, vds_statistics.cpu_user, vds_statistics.usage_mem_percent, vds_statistics.usage_cpu_percent, vds_statistics.usage_network_percent, vds_statistics.mem_available, vds_statistics.mem_shared, vds_statistics.swap_free, vds_statistics.swap_total, vds_statistics.ksm_cpu_percent, vds_statistics.ksm_pages, vds_statistics.ksm_state, vds_dynamic.cpu_flags, vds_groups.cpu_name AS vds_group_cpu_name, vds_dynamic.cpu_sockets, vds_spm_id_map.vds_spm_id, vds_static.otp_validity, CASE WHEN (storage_pool.spm_vds_id = vds_static.vds_id) THEN CASE WHEN (storage_pool.status = 5) THEN 1 ELSE 2 END ELSE 0 END AS spm_status, vds_dynamic.supported_cluster_levels, vds_dynamic.supported_engines, vds_groups.compatibility_version AS vds_group_compatibility_version, vds_dynamic.host_os, vds_dynamic.kvm_version, vds_dynamic.libvirt_version, vds_dynamic.spice_version, vds_dynamic.kernel_version, vds_dynamic.iscsi_initiator_name, vds_dynamic.transparent_hugepages_state, vds_dynamic.anonymous_hugepages, vds_dynamic.non_operational_reason, vds_static.recoverable, vds_static.sshkeyfingerprint, vds_dynamic.hw_manufacturer, vds_dynamic.hw_product_name, vds_dynamic.hw_version, vds_dynamic.hw_serial_number, vds_dynamic.hw_uuid, vds_dynamic.hw_family, vds_static.console_address FROM (((((vds_groups JOIN vds_static ON ((vds_groups.vds_group_id = vds_static.vds_group_id))) JOIN vds_dynamic ON ((vds_static.vds_id = vds_dynamic.vds_id))) JOIN vds_statistics ON ((vds_static.vds_id = vds_statistics.vds_id))) LEFT JOIN storage_pool ON ((vds_groups.storage_pool_id = storage_pool.id))) LEFT JOIN vds_spm_id_map ON ((vds_static.vds_id = vds_spm_id_map.vds_id)));


ALTER TABLE public.vds OWNER TO engineer;

--
-- Name: getallfromvds(uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvds(v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
BEGIN
BEGIN
      RETURN QUERY SELECT DISTINCT vds.*
      FROM vds
      WHERE (NOT v_is_filtered OR EXISTS (SELECT 1
                                          FROM user_vds_permissions_view
                                          WHERE user_id = v_user_id AND entity_id = vds_id));
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.getallfromvds(v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getallfromvds_spm_id_map(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvds_spm_id_map() RETURNS SETOF vds_spm_id_map
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vds_spm_id_map.*
   FROM vds_spm_id_map;

END; $$;


ALTER FUNCTION public.getallfromvds_spm_id_map() OWNER TO engineer;

--
-- Name: getallfromvdsdynamic(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvdsdynamic() RETURNS SETOF vds_dynamic
    LANGUAGE plpgsql
    AS $$
BEGIN
BEGIN
      RETURN QUERY SELECT vds_dynamic.*
      FROM vds_dynamic;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.getallfromvdsdynamic() OWNER TO engineer;

--
-- Name: getallfromvdsgroups(uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvdsgroups(v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vds_groups_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vds_groups_view.*
      FROM vds_groups_view
      WHERE (NOT v_is_filtered OR EXISTS (SELECT 1
                                          FROM   user_vds_groups_permissions_view
                                          WHERE  user_id = v_user_id and entity_id = vds_group_id));

END; $$;


ALTER FUNCTION public.getallfromvdsgroups(v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getallfromvdsstatic(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvdsstatic() RETURNS SETOF vds_static
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vds_static.*
   FROM vds_static;

   RETURN;
END; $$;


ALTER FUNCTION public.getallfromvdsstatic() OWNER TO engineer;

--
-- Name: getallfromvdsstatistics(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvdsstatistics() RETURNS SETOF vds_statistics
    LANGUAGE plpgsql
    AS $$
BEGIN
BEGIN
      RETURN QUERY SELECT vds_statistics.*
      FROM vds_statistics;
   END;


   RETURN;
END; $$;


ALTER FUNCTION public.getallfromvdsstatistics() OWNER TO engineer;

--
-- Name: vm_interface; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vm_interface (
    id uuid NOT NULL,
    network_name character varying(50),
    vm_guid uuid,
    vmt_guid uuid,
    mac_addr character varying(20),
    name character varying(50) NOT NULL,
    speed integer,
    type integer DEFAULT 0,
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone,
    _update_date timestamp with time zone,
    port_mirroring boolean DEFAULT false NOT NULL,
    linked boolean DEFAULT true NOT NULL
);


ALTER TABLE public.vm_interface OWNER TO engineer;

--
-- Name: vm_interface_statistics; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vm_interface_statistics (
    id uuid NOT NULL,
    vm_id uuid,
    rx_rate numeric(18,0),
    tx_rate numeric(18,0),
    rx_drop numeric(18,0),
    tx_drop numeric(18,0),
    iface_status integer,
    _update_date timestamp with time zone
);


ALTER TABLE public.vm_interface_statistics OWNER TO engineer;

--
-- Name: vm_interface_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vm_interface_view AS
    SELECT vm_interface_statistics.rx_rate, vm_interface_statistics.tx_rate, vm_interface_statistics.rx_drop, vm_interface_statistics.tx_drop, vm_interface_statistics.iface_status, vm_interface.type, vm_interface.speed, vm_interface.mac_addr, vm_interface.network_name, vm_interface.name, vm_static.vm_guid, vm_interface.vmt_guid, vm_static.vm_name, vm_interface.id, 0 AS boot_protocol, 0 AS is_vds, vm_device.is_plugged, vm_interface.port_mirroring, vm_interface.linked, vm_static.vds_group_id, vm_static.entity_type AS vm_entity_type FROM (((vm_interface_statistics JOIN vm_interface ON ((vm_interface_statistics.id = vm_interface.id))) JOIN vm_static ON ((vm_interface.vm_guid = vm_static.vm_guid))) JOIN vm_device ON (((vm_interface.vm_guid = vm_device.vm_id) AND (vm_interface.id = vm_device.device_id)))) UNION SELECT vm_interface_statistics.rx_rate, vm_interface_statistics.tx_rate, vm_interface_statistics.rx_drop, vm_interface_statistics.tx_drop, vm_interface_statistics.iface_status, vm_interface.type, vm_interface.speed, vm_interface.mac_addr, vm_interface.network_name, vm_interface.name, NULL::uuid AS vm_guid, vm_interface.vmt_guid, vm_templates.vm_name, vm_interface.id, 0 AS boot_protocol, 0 AS is_vds, vm_device.is_plugged, vm_interface.port_mirroring, vm_interface.linked, vm_templates.vds_group_id, vm_templates.entity_type AS vm_entity_type FROM (((vm_interface_statistics RIGHT JOIN vm_interface ON ((vm_interface_statistics.id = vm_interface.id))) JOIN vm_static vm_templates ON ((vm_interface.vmt_guid = vm_templates.vm_guid))) JOIN vm_device ON (((vm_interface.vmt_guid = vm_device.vm_id) AND (vm_interface.id = vm_device.device_id))));


ALTER TABLE public.vm_interface_view OWNER TO engineer;

--
-- Name: getallfromvm_interface(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvm_interface() RETURNS SETOF vm_interface_view
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT *
   FROM vm_interface_view;

END; $$;


ALTER FUNCTION public.getallfromvm_interface() OWNER TO engineer;

--
-- Name: getallfromvm_pool_map(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvm_pool_map() RETURNS SETOF vm_pool_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_pool_map.*
      FROM vm_pool_map;
END; $$;


ALTER FUNCTION public.getallfromvm_pool_map() OWNER TO engineer;

--
-- Name: getallfromvm_pools(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvm_pools() RETURNS SETOF getallfromvm_pools_rs
    LANGUAGE plpgsql
    AS $$
BEGIN
      -- BEGIN TRAN
BEGIN
         CREATE GLOBAL TEMPORARY TABLE tt_VM_POOL_GROUP
         (
            vm_pool_id UUID,
            assigned_vm_count INTEGER
         ) WITH OIDS;
         exception when others then
            truncate table tt_VM_POOL_GROUP;
      END;
      insert INTO tt_VM_POOL_GROUP(vm_pool_id,
					assigned_vm_count)
      select
      vm_pools_view.vm_pool_id,
			  count(vm_pool_map.vm_pool_id)
      from vm_pools_view
      left join vm_pool_map on vm_pools_view.vm_pool_id = vm_pool_map.vm_pool_id
      group by vm_pools_view.vm_pool_id,vm_pool_map.vm_pool_id;
      BEGIN
         CREATE GLOBAL TEMPORARY TABLE tt_VM_POOL_RUNNING
         (
            vm_pool_id UUID,
            vm_running_count INTEGER
         ) WITH OIDS;
         exception when others then
            truncate table tt_VM_POOL_RUNNING;
      END;
      insert INTO tt_VM_POOL_RUNNING(vm_pool_id,
					vm_running_count)
      select vm_pools_view.vm_pool_id, count(vm_pools_view.vm_pool_id)
      from vm_pools_view
      left join vm_pool_map on vm_pools_view.vm_pool_id = vm_pool_map.vm_pool_id
      left join vm_dynamic on vm_pool_map.vm_guid = vm_dynamic.vm_guid
      where vm_dynamic.status > 0
      group by vm_pools_view.vm_pool_id;
      BEGIN
         CREATE GLOBAL TEMPORARY TABLE tt_VM_POOL_PRERESULT
         (
            vm_pool_id UUID,
            assigned_vm_count INTEGER,
            vm_running_count INTEGER
         ) WITH OIDS;
         exception when others then
            truncate table tt_VM_POOL_PRERESULT;
      END;
      insert INTO tt_VM_POOL_PRERESULT(vm_pool_id,
					assigned_vm_count,
					vm_running_count)
      select pg.vm_pool_id, pg.assigned_vm_count, pr.vm_running_count
      from tt_VM_POOL_GROUP pg
      left join tt_VM_POOL_RUNNING pr on pg.vm_pool_id = pr.vm_pool_id;
      update tt_VM_POOL_PRERESULT
      set vm_running_count = 0
      where vm_running_count is NULL;
      BEGIN
         CREATE GLOBAL TEMPORARY TABLE tt_VM_POOL_RESULT
         (
            vm_pool_id UUID,
            assigned_vm_count INTEGER,
            vm_running_count INTEGER,
            vm_pool_description VARCHAR(4000),
            vm_pool_name VARCHAR(255),
            vm_pool_type INTEGER,
            parameters VARCHAR(200),
            prestarted_vms INTEGER,
            vds_group_id UUID,
            vds_group_name VARCHAR(40)
         ) WITH OIDS;
         exception when others then
            truncate table tt_VM_POOL_RESULT;
      END;
      insert INTO tt_VM_POOL_RESULT(vm_pool_id,
            assigned_vm_count,
            vm_running_count,
            vm_pool_description,
            vm_pool_name,
            vm_pool_type,
            parameters,
            prestarted_vms,
            vds_group_id,
            vds_group_name)
      select ppr.vm_pool_id, ppr.assigned_vm_count, ppr.vm_running_count,
  				 p.vm_pool_description, p.vm_pool_name, p.vm_pool_type, p.parameters, p.prestarted_vms,
					 p.vds_group_id, p.vds_group_name
      from tt_VM_POOL_PRERESULT ppr
      inner join vm_pools_view p on ppr.vm_pool_id = p.vm_pool_id;
      RETURN QUERY select *
      from tt_VM_POOL_RESULT;
END; $$;


ALTER FUNCTION public.getallfromvm_pools() OWNER TO engineer;

--
-- Name: vm_device_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vm_device_view AS
    SELECT vm_device.device_id, vm_device.vm_id, vm_device.type, vm_device.device, vm_device.address, vm_device.boot_order, vm_device.spec_params, vm_device.is_managed, vm_device.is_plugged, vm_device.is_readonly, vm_device.alias FROM vm_device;


ALTER TABLE public.vm_device_view OWNER TO engineer;

--
-- Name: getallfromvmdevice(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvmdevice() RETURNS SETOF vm_device_view
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   vm_device_view;
END; $$;


ALTER FUNCTION public.getallfromvmdevice() OWNER TO engineer;

--
-- Name: getallfromvmdynamic(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvmdynamic() RETURNS SETOF vm_dynamic
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_dynamic.*
      FROM vm_dynamic;
END; $$;


ALTER FUNCTION public.getallfromvmdynamic() OWNER TO engineer;

--
-- Name: getallfromvms(uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvms(v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT DISTINCT vms.*
   FROM vms
   WHERE (NOT v_is_filtered OR EXISTS (SELECT 1
                                       FROM user_vm_permissions_view
                                       WHERE user_id = v_user_id AND entity_id = vm_guid))
   ORDER BY vm_guid;
END; $$;


ALTER FUNCTION public.getallfromvms(v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getallfromvmstatic(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvmstatic() RETURNS SETOF vm_static
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vm_static.*
   FROM vm_static
   WHERE entity_type = 'VM';

END; $$;


ALTER FUNCTION public.getallfromvmstatic() OWNER TO engineer;

--
-- Name: getallfromvmstaticbystoragepoolid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvmstaticbystoragepoolid(v_sp_id uuid) RETURNS SETOF vm_static
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vm_static.*
   FROM vm_static INNER JOIN
        vm_dynamic ON vm_static.vm_guid = vm_dynamic.vm_guid INNER JOIN
        vds_groups ON vm_static.vds_group_id = vds_groups.vds_group_id LEFT OUTER JOIN
        storage_pool ON vm_static.vds_group_id = vds_groups.vds_group_id
        and vds_groups.storage_pool_id = storage_pool.id
   WHERE v_sp_id = storage_pool.id
   AND   entity_type = 'VM';

END; $$;


ALTER FUNCTION public.getallfromvmstaticbystoragepoolid(v_sp_id uuid) OWNER TO engineer;

--
-- Name: getallfromvmstatistics(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvmstatistics() RETURNS SETOF vm_statistics
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_statistics.*
      FROM vm_statistics;
END; $$;


ALTER FUNCTION public.getallfromvmstatistics() OWNER TO engineer;

--
-- Name: getallfromvmtemplates(uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallfromvmtemplates(v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vm_templates_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_templates.*
      FROM vm_templates_view vm_templates
      WHERE (NOT v_is_filtered OR EXISTS (SELECT 1
                                          FROM   user_vm_template_permissions_view
                                          WHERE  user_id = v_user_id AND entity_id = vmt_guid))
      ORDER BY name;
END; $$;


ALTER FUNCTION public.getallfromvmtemplates(v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getalljobidsbyentityid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getalljobidsbyentityid(v_entity_id uuid) RETURNS SETOF uuid
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT job_subject_entity.job_id
    FROM job_subject_entity
    WHERE entity_id = v_entity_id;
END; $$;


ALTER FUNCTION public.getalljobidsbyentityid(v_entity_id uuid) OWNER TO engineer;

--
-- Name: job; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE job (
    job_id uuid NOT NULL,
    action_type character varying(50) NOT NULL,
    description text NOT NULL,
    status character varying(32) NOT NULL,
    owner_id uuid,
    visible boolean DEFAULT true NOT NULL,
    start_time timestamp with time zone NOT NULL,
    end_time timestamp with time zone,
    last_update_time timestamp with time zone,
    correlation_id character varying(50) NOT NULL
);


ALTER TABLE public.job OWNER TO engineer;

--
-- Name: getalljobs(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getalljobs() RETURNS SETOF job
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT job.*
    FROM JOB
    where status != 'UNKNOWN';
END; $$;


ALTER FUNCTION public.getalljobs() OWNER TO engineer;

--
-- Name: getallnetworkbyclusterid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallnetworkbyclusterid(v_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF networkviewclustertype
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT
    DISTINCT
    network.id,
    network.name,
    network.description,
    network.type,
    network.addr,
    network.subnet,
    network.gateway,
    network.vlan_id,
    network.stp,
    network.storage_pool_id,
    network.mtu,
    network.vm_network,
    network_cluster.network_id,
    network_cluster.cluster_id,
    network_cluster.status,
    network_cluster.is_display,
    network_cluster.required
   FROM network
   INNER JOIN network_cluster
   ON network.id = network_cluster.network_id
   WHERE network_cluster.cluster_id = v_id
   AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                     FROM   user_network_permissions_view
                                     WHERE  user_id = v_user_id AND entity_id = network.id))
   ORDER BY network.name;
END; $$;


ALTER FUNCTION public.getallnetworkbyclusterid(v_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getallnetworkbystoragepoolid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallnetworkbystoragepoolid(v_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF network
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT *
   FROM network
   WHERE storage_pool_id = v_id
   AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                     FROM   user_network_permissions_view
                                     WHERE  user_id = v_user_id AND entity_id = network.id));

END; $$;


ALTER FUNCTION public.getallnetworkbystoragepoolid(v_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getallrolesbyadelementid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallrolesbyadelementid(v_ad_element_id uuid) RETURNS SETOF roles
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT roles.*
   FROM roles INNER JOIN
   permissions ON permissions.role_id = roles.id
   WHERE permissions.ad_element_id = v_ad_element_id
   or permissions.ad_element_id in(select * from getUserAndGroupsById(v_ad_element_id));

END; $$;


ALTER FUNCTION public.getallrolesbyadelementid(v_ad_element_id uuid) OWNER TO engineer;

--
-- Name: getallrolesbyuseridandgroupids(uuid, text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallrolesbyuseridandgroupids(v_user_id uuid, v_group_ids text) RETURNS SETOF roles
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT roles.*
   FROM roles INNER JOIN
   permissions ON permissions.role_id = roles.id
   WHERE permissions.ad_element_id = v_user_id
   or permissions.ad_element_id in(select id from getElementIdsByIdAndGroups(v_user_id, v_group_ids));

END; $$;


ALTER FUNCTION public.getallrolesbyuseridandgroupids(v_user_id uuid, v_group_ids text) OWNER TO engineer;

--
-- Name: step; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE step (
    step_id uuid NOT NULL,
    parent_step_id uuid,
    job_id uuid NOT NULL,
    step_type character varying(32) NOT NULL,
    description text NOT NULL,
    step_number integer NOT NULL,
    status character varying(32) NOT NULL,
    start_time timestamp with time zone NOT NULL,
    end_time timestamp with time zone,
    correlation_id character varying(50) NOT NULL,
    external_id uuid,
    external_system_type character varying(32)
);


ALTER TABLE public.step OWNER TO engineer;

--
-- Name: getallsteps(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallsteps() RETURNS SETOF step
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT step.*
    FROM step;
END; $$;


ALTER FUNCTION public.getallsteps() OWNER TO engineer;

--
-- Name: quota_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW quota_view AS
    SELECT q.id AS quota_id, q.storage_pool_id, storage_pool.name AS storage_pool_name, q.quota_name, q.description, q.threshold_vds_group_percentage, q.threshold_storage_percentage, q.grace_vds_group_percentage, q.grace_storage_percentage, storage_pool.quota_enforcement_type FROM storage_pool, quota q WHERE (storage_pool.id = q.storage_pool_id);


ALTER TABLE public.quota_view OWNER TO engineer;

--
-- Name: getallthinquota(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallthinquota() RETURNS SETOF quota_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM quota_view;
END; $$;


ALTER FUNCTION public.getallthinquota() OWNER TO engineer;

--
-- Name: getallthinquotasbystorageid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallthinquotasbystorageid(v_storage_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF quota_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT DISTINCT
    quota_id,
    storage_pool_id,
    storage_pool_name,
    quota_name,
    description,
    threshold_vds_group_percentage,
    threshold_storage_percentage,
    grace_vds_group_percentage,
    grace_storage_percentage,
    quota_enforcement_type
   FROM   quota_limitations_view
   WHERE  (storage_id = v_storage_id
   OR     (is_global AND
           NOT is_empty AND
           storage_size_gb IS NOT null AND
           storage_pool_id IN (SELECT storage_pool_id FROM storage_pool_iso_map
               WHERE  storage_id = v_storage_id)))
   AND (NOT v_is_filtered OR
          EXISTS (SELECT 1 FROM permissions p
                  JOIN user_flat_groups u ON
                  u.granted_id = p.ad_element_id WHERE
                  u.user_id = v_user_id AND
                  p.object_type_id = 17 AND -- quota object
                  p.role_id = 'def0000a-0000-0000-0000-def00000000a' AND -- consume quota
                  quota_id = p.object_id));
END; $$;


ALTER FUNCTION public.getallthinquotasbystorageid(v_storage_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getallthinquotasbyvdsgroupid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallthinquotasbyvdsgroupid(v_vds_group_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF quota_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT DISTINCT
    quota_id,
    storage_pool_id,
    storage_pool_name,
    quota_name,
    description,
    threshold_vds_group_percentage,
    threshold_storage_percentage,
    grace_vds_group_percentage,
    grace_storage_percentage,
    quota_enforcement_type
   FROM   quota_limitations_view
   WHERE  (vds_group_id = v_vds_group_id
   OR     (is_global AND
           NOT is_empty AND
           virtual_cpu IS NOT null AND
           storage_pool_id IN (SELECT storage_pool_id FROM vds_groups
               WHERE  vds_group_id = v_vds_group_id)))
   AND (NOT v_is_filtered OR
          EXISTS (SELECT 1 FROM permissions p
                  JOIN user_flat_groups u ON
                  u.granted_id = p.ad_element_id WHERE
                  u.user_id = v_user_id AND
                  p.object_type_id = 17 AND -- quota object
                  p.role_id = 'def0000a-0000-0000-0000-def00000000a' AND -- consume quota
                  quota_id = p.object_id));
END; $$;


ALTER FUNCTION public.getallthinquotasbyvdsgroupid(v_vds_group_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: vm_pools_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vm_pools_view AS
    SELECT vm_pools.vm_pool_id, vm_pools.vm_pool_name, vm_pools.vm_pool_description, vm_pools.vm_pool_type, vm_pools.parameters, vm_pools.prestarted_vms, vm_pools.vds_group_id, vds_groups.name AS vds_group_name FROM (vm_pools JOIN vds_groups ON ((vm_pools.vds_group_id = vds_groups.vds_group_id)));


ALTER TABLE public.vm_pools_view OWNER TO engineer;

--
-- Name: getallvm_poolsbyuser_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallvm_poolsbyuser_id(v_user_id uuid) RETURNS SETOF vm_pools_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT  DISTINCT vm_pools_view.*
      FROM         users_and_groups_to_vm_pool_map_view INNER JOIN
      vm_pools_view ON
      users_and_groups_to_vm_pool_map_view.vm_pool_id = vm_pools_view.vm_pool_id
      WHERE     (users_and_groups_to_vm_pool_map_view.user_id = v_user_id);
END; $$;


ALTER FUNCTION public.getallvm_poolsbyuser_id(v_user_id uuid) OWNER TO engineer;

--
-- Name: getallvm_poolsbyuser_id_with_groups_and_userroles(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallvm_poolsbyuser_id_with_groups_and_userroles(v_user_id uuid) RETURNS SETOF vm_pools_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT pools.*
	FROM vm_pools_view pools
    INNER JOIN user_vm_pool_permissions_view ON user_id = v_user_id AND entity_id = pools.vm_pool_id;
END; $$;


ALTER FUNCTION public.getallvm_poolsbyuser_id_with_groups_and_userroles(v_user_id uuid) OWNER TO engineer;

--
-- Name: getallvmsrelatedtoquotaid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallvmsrelatedtoquotaid(v_quota_id uuid) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vms.*
      FROM vms
      WHERE quota_id = v_quota_id
      UNION
      SELECT DISTINCT vms.*
      FROM vms
      INNER JOIN vm_device vd ON vd.vm_id = vms.vm_guid
      INNER JOIN images ON images.image_group_id = vd.device_id AND images.active = TRUE
      WHERE images.quota_id = v_quota_id;
END; $$;


ALTER FUNCTION public.getallvmsrelatedtoquotaid(v_quota_id uuid) OWNER TO engineer;

--
-- Name: getallvmtemplatesrelatedtoquotaid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getallvmtemplatesrelatedtoquotaid(v_quota_id uuid) RETURNS SETOF vm_templates_view
    LANGUAGE plpgsql
    AS $$
BEGIN
	RETURN QUERY SELECT vm_templates.*
      FROM vm_templates_view vm_templates
      WHERE quota_id = v_quota_id
      UNION
      SELECT DISTINCT vm_templates.*
      FROM vm_templates_view vm_templates
      INNER JOIN vm_device vd ON vd.vm_id = vm_templates.vmt_guid
      INNER JOIN images ON images.image_group_id = vd.device_id AND images.active = TRUE
      WHERE images.quota_id = v_quota_id;
END; $$;


ALTER FUNCTION public.getallvmtemplatesrelatedtoquotaid(v_quota_id uuid) OWNER TO engineer;

--
-- Name: getancestralimagebyimageguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getancestralimagebyimageguid(v_image_guid uuid) RETURNS SETOF images_storage_domain_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY WITH RECURSIVE ancestor_image(image_guid, parentid) AS (
         SELECT image_guid, parentid
         FROM images
         WHERE image_guid = v_image_guid
         UNION ALL
         SELECT i.image_guid, i.parentid
         FROM images i, ancestor_image ai
         WHERE i.image_guid = ai.parentid
      )
      SELECT i.*
      FROM ancestor_image ai, images_storage_domain_view i
      WHERE ai.parentid = '00000000-0000-0000-0000-000000000000'
      AND ai.image_guid = i.image_guid;
END; $$;


ALTER FUNCTION public.getancestralimagebyimageguid(v_image_guid uuid) OWNER TO engineer;

--
-- Name: getasync_tasksbytask_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getasync_tasksbytask_id(v_task_id uuid) RETURNS SETOF async_tasks
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM async_tasks
   WHERE task_id = v_task_id;

END; $$;


ALTER FUNCTION public.getasync_tasksbytask_id(v_task_id uuid) OWNER TO engineer;

--
-- Name: getasynctasksbyentityid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getasynctasksbyentityid(v_entity_id uuid) RETURNS SETOF iduuidtype
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT async_task_id from async_tasks_entities where entity_id = v_entity_id;
END; $$;


ALTER FUNCTION public.getasynctasksbyentityid(v_entity_id uuid) OWNER TO engineer;

--
-- Name: getasynctasksbystoragepoolid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getasynctasksbystoragepoolid(v_storage_pool_id uuid) RETURNS SETOF iduuidtype
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT async_tasks.task_id
   FROM  async_tasks
   WHERE storage_pool_id = v_storage_pool_id;
END; $$;


ALTER FUNCTION public.getasynctasksbystoragepoolid(v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getauditlogbyauditlogid(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getauditlogbyauditlogid(v_audit_log_id integer) RETURNS SETOF audit_log
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM audit_log
      WHERE audit_log_id = v_audit_log_id;
END; $$;


ALTER FUNCTION public.getauditlogbyauditlogid(v_audit_log_id integer) OWNER TO engineer;

--
-- Name: getauditlogbyoriginandcustomeventid(character varying, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getauditlogbyoriginandcustomeventid(v_origin character varying, v_custom_event_id integer) RETURNS SETOF audit_log
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM audit_log
      WHERE origin = v_origin and custom_event_id = v_custom_event_id;
END; $$;


ALTER FUNCTION public.getauditlogbyoriginandcustomeventid(v_origin character varying, v_custom_event_id integer) OWNER TO engineer;

--
-- Name: getauditlogbyvmname(character varying, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getauditlogbyvmname(v_vm_name character varying, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF audit_log
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM   audit_log
      WHERE  not deleted and vm_name = v_vm_name
      AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                        FROM   user_vm_permissions_view
                                        WHERE  user_id = v_user_id AND entity_id = vm_id));


END; $$;


ALTER FUNCTION public.getauditlogbyvmname(v_vm_name character varying, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getauditlogbyvmtemplatename(character varying, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getauditlogbyvmtemplatename(v_vm_template_name character varying, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF audit_log
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM   audit_log
      WHERE  not deleted and vm_template_name = v_vm_template_name
      AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                        FROM   user_vm_template_permissions_view
                                        WHERE  user_id = v_user_id AND entity_id = vm_template_id));


END; $$;


ALTER FUNCTION public.getauditlogbyvmtemplatename(v_vm_template_name character varying, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getauditloglaterthendate(timestamp with time zone); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getauditloglaterthendate(v_date timestamp with time zone) RETURNS SETOF audit_log
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM audit_log
      WHERE not deleted and LOG_TIME >= v_date;
END; $$;


ALTER FUNCTION public.getauditloglaterthendate(v_date timestamp with time zone) OWNER TO engineer;

--
-- Name: getbasediskbybasediskid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getbasediskbybasediskid(v_disk_id uuid) RETURNS SETOF base_disks
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   base_disks
    WHERE  disk_id = v_disk_id;
END; $$;


ALTER FUNCTION public.getbasediskbybasediskid(v_disk_id uuid) OWNER TO engineer;

--
-- Name: getbookmarkbybookmark_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getbookmarkbybookmark_id(v_bookmark_id uuid) RETURNS SETOF bookmarks
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM bookmarks
      WHERE bookmark_Id = v_bookmark_id;
END; $$;


ALTER FUNCTION public.getbookmarkbybookmark_id(v_bookmark_id uuid) OWNER TO engineer;

--
-- Name: getbookmarkbybookmark_name(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getbookmarkbybookmark_name(v_bookmark_name character varying) RETURNS SETOF bookmarks
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM bookmarks
      WHERE bookmark_name = v_bookmark_name;
END; $$;


ALTER FUNCTION public.getbookmarkbybookmark_name(v_bookmark_name character varying) OWNER TO engineer;

--
-- Name: gluster_volume_bricks; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE gluster_volume_bricks (
    volume_id uuid NOT NULL,
    server_id uuid NOT NULL,
    brick_dir character varying(4096) NOT NULL,
    status character varying(32) NOT NULL,
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone NOT NULL,
    _update_date timestamp with time zone,
    id uuid NOT NULL,
    brick_order integer DEFAULT 0
);


ALTER TABLE public.gluster_volume_bricks OWNER TO engineer;

--
-- Name: getbricksbyglustervolumeguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getbricksbyglustervolumeguid(v_volume_id uuid) RETURNS SETOF gluster_volume_bricks
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT *
    FROM  gluster_volume_bricks
    WHERE volume_id = v_volume_id
    ORDER BY brick_order;
END; $$;


ALTER FUNCTION public.getbricksbyglustervolumeguid(v_volume_id uuid) OWNER TO engineer;

--
-- Name: getconsumedpermissionsforquotaid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getconsumedpermissionsforquotaid(v_quota_id uuid) RETURNS SETOF permissions_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY    SELECT *
   FROM permissions_view
   WHERE role_id in (SELECT role_id FROM ROLES_groups where action_group_id = 901)
     AND object_id in(select id from  fn_get_entity_parents(v_quota_id,17));
END; $$;


ALTER FUNCTION public.getconsumedpermissionsforquotaid(v_quota_id uuid) OWNER TO engineer;

--
-- Name: getcustom_actionsbyaction_id(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getcustom_actionsbyaction_id(v_action_id integer) RETURNS SETOF custom_actions
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM custom_actions
      WHERE action_id = v_action_id;
END; $$;


ALTER FUNCTION public.getcustom_actionsbyaction_id(v_action_id integer) OWNER TO engineer;

--
-- Name: getcustom_actionsbynameandtab(character varying, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getcustom_actionsbynameandtab(v_action_name character varying, v_tab integer) RETURNS SETOF custom_actions
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM custom_actions
      WHERE tab = v_tab and action_name = v_action_name;
END; $$;


ALTER FUNCTION public.getcustom_actionsbynameandtab(v_action_name character varying, v_tab integer) OWNER TO engineer;

--
-- Name: getcustom_actionsbytab_id(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getcustom_actionsbytab_id(v_tab integer) RETURNS SETOF custom_actions
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM custom_actions
      WHERE tab = v_tab;
END; $$;


ALTER FUNCTION public.getcustom_actionsbytab_id(v_tab integer) OWNER TO engineer;

--
-- Name: getdbgeneration(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getdbgeneration(v_vm_guid uuid) RETURNS SETOF bigint
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT db_generation
      FROM vm_static
      WHERE vm_guid = v_vm_guid;
END; $$;


ALTER FUNCTION public.getdbgeneration(v_vm_guid uuid) OWNER TO engineer;

--
-- Name: getdirectpermissionsbyadelementid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getdirectpermissionsbyadelementid(v_ad_element_id uuid) RETURNS SETOF permissions_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM permissions_view
   WHERE permissions_view.ad_element_id = v_ad_element_id;

END; $$;


ALTER FUNCTION public.getdirectpermissionsbyadelementid(v_ad_element_id uuid) OWNER TO engineer;

--
-- Name: getdisk_image_dynamicbyimage_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getdisk_image_dynamicbyimage_id(v_image_id uuid) RETURNS SETOF disk_image_dynamic
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM disk_image_dynamic
   WHERE image_id = v_image_id;

END; $$;


ALTER FUNCTION public.getdisk_image_dynamicbyimage_id(v_image_id uuid) OWNER TO engineer;

--
-- Name: getdiskbydiskid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getdiskbydiskid(v_disk_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF all_disks
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   all_disks
    WHERE  image_group_id = v_disk_id
    AND    (NOT v_is_filtered OR EXISTS (SELECT 1
                                         FROM user_disk_permissions_view
                                         WHERE user_id = v_user_id AND entity_id = v_disk_id));
END; $$;


ALTER FUNCTION public.getdiskbydiskid(v_disk_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getdisklunmapbydisklunmapid(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getdisklunmapbydisklunmapid(v_disk_id uuid, v_lun_id character varying) RETURNS SETOF disk_lun_map
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   disk_lun_map
    WHERE  disk_id = v_disk_id
    AND    lun_id = v_lun_id;
END; $$;


ALTER FUNCTION public.getdisklunmapbydisklunmapid(v_disk_id uuid, v_lun_id character varying) OWNER TO engineer;

--
-- Name: getdisklunmapbylunid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getdisklunmapbylunid(v_lun_id character varying) RETURNS SETOF disk_lun_map
    LANGUAGE plpgsql
    AS $$
BEGIN
	RETURN QUERY
    SELECT *
    FROM   disk_lun_map
    WHERE  lun_id = v_lun_id;
END; $$;


ALTER FUNCTION public.getdisklunmapbylunid(v_lun_id character varying) OWNER TO engineer;

--
-- Name: getdisksvmguid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getdisksvmguid(v_vm_guid uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF all_disks
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT all_disks.*
      FROM all_disks
      LEFT JOIN vm_device on vm_device.device_id = all_disks.image_group_id
      WHERE vm_device.vm_id = v_vm_guid
      AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                        FROM   user_disk_permissions_view
                                        WHERE  user_id = v_user_id AND entity_id = all_disks.disk_id));

END; $$;


ALTER FUNCTION public.getdisksvmguid(v_vm_guid uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getelementidsbyidandgroups(uuid, text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getelementidsbyidandgroups(v_id uuid, v_group_ids text) RETURNS SETOF iduuidtype
    LANGUAGE plpgsql
    AS $$
BEGIN
  RETURN QUERY
  select * from fnsplitteruuid(v_group_ids)
  UNION
  select v_id
  UNION
  -- user is also member of 'Everyone'
  select 'EEE00000-0000-0000-0000-123456789EEE';
END; $$;


ALTER FUNCTION public.getelementidsbyidandgroups(v_id uuid, v_group_ids text) OWNER TO engineer;

--
-- Name: getevent_subscriberbysubscriber_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getevent_subscriberbysubscriber_id(v_subscriber_id uuid) RETURNS SETOF event_subscriber
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM event_subscriber
   WHERE subscriber_id = v_subscriber_id;

END; $$;


ALTER FUNCTION public.getevent_subscriberbysubscriber_id(v_subscriber_id uuid) OWNER TO engineer;

--
-- Name: geteventmapbyname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION geteventmapbyname(v_event_name character varying) RETURNS SETOF event_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      from event_map
      where event_up_name = v_event_name;
END; $$;


ALTER FUNCTION public.geteventmapbyname(v_event_name character varying) OWNER TO engineer;

--
-- Name: geteventnotificationmethodbyid(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION geteventnotificationmethodbyid(v_method_id integer) RETURNS SETOF event_notification_methods
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      from event_notification_methods
      where method_id = v_method_id;
END; $$;


ALTER FUNCTION public.geteventnotificationmethodbyid(v_method_id integer) OWNER TO engineer;

--
-- Name: geteventnotificationmethodbytype(character); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION geteventnotificationmethodbytype(v_method_type character) RETURNS SETOF event_notification_methods
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      from event_notification_methods
      where method_type = v_method_type;
END; $$;


ALTER FUNCTION public.geteventnotificationmethodbytype(v_method_type character) OWNER TO engineer;

--
-- Name: getfailingstorage_domains(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getfailingstorage_domains() RETURNS SETOF storage_domains
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY
    SELECT * FROM storage_domains WHERE recoverable AND status = 4; --inactive
END; $$;


ALTER FUNCTION public.getfailingstorage_domains() OWNER TO engineer;

--
-- Name: getfailingvdss(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getfailingvdss() RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY
    SELECT * FROM vds WHERE recoverable AND status = 10; --non operational
END; $$;


ALTER FUNCTION public.getfailingvdss() OWNER TO engineer;

--
-- Name: getforroleandadelementandobject_wgroupcheck(uuid, uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getforroleandadelementandobject_wgroupcheck(v_role_id uuid, v_ad_element_id uuid, v_object_id uuid) RETURNS SETOF permissions_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM permissions_view
   WHERE role_id = v_role_id and object_id = v_object_id and ad_element_id in (
         select * from getUserAndGroupsById(v_ad_element_id));
END; $$;


ALTER FUNCTION public.getforroleandadelementandobject_wgroupcheck(v_role_id uuid, v_ad_element_id uuid, v_object_id uuid) OWNER TO engineer;

--
-- Name: getglobalids(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getglobalids(v_name character varying) RETURNS uuid
    LANGUAGE plpgsql IMMUTABLE
    AS $$
   DECLARE
   v_id  UUID;
BEGIN
   if (v_name = 'system') then
      v_id := 'AAA00000-0000-0000-0000-123456789AAA';
   elsif (v_name = 'everyone') then
      v_id := 'EEE00000-0000-0000-0000-123456789EEE';
   -- bottom is an object which all the objects in the system are its parents
   -- useful to denote we want all objects when checking for permissions
   elsif (v_name = 'bottom') then
      v_id := 'BBB00000-0000-0000-0000-123456789BBB';
   end if;
   return  v_id;
END; $$;


ALTER FUNCTION public.getglobalids(v_name character varying) OWNER TO engineer;

--
-- Name: getglusterbrickbyid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getglusterbrickbyid(v_id uuid) RETURNS SETOF gluster_volume_bricks
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT *
    FROM gluster_volume_bricks
    WHERE id = v_id;
END; $$;


ALTER FUNCTION public.getglusterbrickbyid(v_id uuid) OWNER TO engineer;

--
-- Name: gluster_volume_options; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE gluster_volume_options (
    volume_id uuid NOT NULL,
    option_key character varying(8192) NOT NULL,
    option_val character varying(8192) NOT NULL,
    id uuid NOT NULL
);


ALTER TABLE public.gluster_volume_options OWNER TO engineer;

--
-- Name: getglusteroptionbyid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getglusteroptionbyid(v_id uuid) RETURNS SETOF gluster_volume_options
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT *
    FROM gluster_volume_options
    WHERE id = v_id;
END; $$;


ALTER FUNCTION public.getglusteroptionbyid(v_id uuid) OWNER TO engineer;

--
-- Name: getglustervolumebricksbyserverguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getglustervolumebricksbyserverguid(v_server_id uuid) RETURNS SETOF gluster_volume_bricks
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT *
FROM  gluster_volume_bricks
WHERE server_id = v_server_id
ORDER BY brick_order;
END; $$;


ALTER FUNCTION public.getglustervolumebricksbyserverguid(v_server_id uuid) OWNER TO engineer;

--
-- Name: gluster_volumes; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE gluster_volumes (
    id uuid NOT NULL,
    cluster_id uuid NOT NULL,
    vol_name character varying(1000) NOT NULL,
    vol_type character varying(32) NOT NULL,
    status character varying(32) NOT NULL,
    replica_count integer DEFAULT 0 NOT NULL,
    stripe_count integer DEFAULT 0 NOT NULL,
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone NOT NULL,
    _update_date timestamp with time zone
);


ALTER TABLE public.gluster_volumes OWNER TO engineer;

--
-- Name: getglustervolumebyid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getglustervolumebyid(v_volume_id uuid) RETURNS SETOF gluster_volumes
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT *
    FROM gluster_volumes
    WHERE id = v_volume_id;
END; $$;


ALTER FUNCTION public.getglustervolumebyid(v_volume_id uuid) OWNER TO engineer;

--
-- Name: getglustervolumebyname(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getglustervolumebyname(v_cluster_id uuid, v_vol_name character varying) RETURNS SETOF gluster_volumes
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT *
    FROM gluster_volumes
    WHERE cluster_id = v_cluster_id and vol_name = v_vol_name;
END; $$;


ALTER FUNCTION public.getglustervolumebyname(v_cluster_id uuid, v_vol_name character varying) OWNER TO engineer;

--
-- Name: getglustervolumesbyclusterguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getglustervolumesbyclusterguid(v_cluster_id uuid) RETURNS SETOF gluster_volumes
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT *
    FROM  gluster_volumes
    WHERE cluster_id = v_cluster_id;
END; $$;


ALTER FUNCTION public.getglustervolumesbyclusterguid(v_cluster_id uuid) OWNER TO engineer;

--
-- Name: getglustervolumesbyoption(uuid, character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getglustervolumesbyoption(v_cluster_id uuid, v_status character varying, v_option_key character varying, v_option_val character varying) RETURNS SETOF gluster_volumes
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT *
    FROM  gluster_volumes
    WHERE cluster_id = v_cluster_id AND status = v_status
    AND id IN (SELECT volume_id FROM gluster_volume_options
    WHERE option_key=v_option_key AND option_val=v_option_val);
END; $$;


ALTER FUNCTION public.getglustervolumesbyoption(v_cluster_id uuid, v_status character varying, v_option_key character varying, v_option_val character varying) OWNER TO engineer;

--
-- Name: getglustervolumesbystatusandtypes(uuid, character varying, text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getglustervolumesbystatusandtypes(v_cluster_id uuid, v_status character varying, v_vol_types text) RETURNS SETOF gluster_volumes
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT *
    FROM  gluster_volumes
    WHERE cluster_id = v_cluster_id AND status = v_status
    AND vol_type IN (SELECT ID FROM fnSplitter(v_vol_types));
END; $$;


ALTER FUNCTION public.getglustervolumesbystatusandtypes(v_cluster_id uuid, v_status character varying, v_vol_types text) OWNER TO engineer;

--
-- Name: getglustervolumesbystatustypesandoption(uuid, character varying, text, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getglustervolumesbystatustypesandoption(v_cluster_id uuid, v_status character varying, v_vol_types text, v_option_key character varying, v_option_val character varying) RETURNS SETOF gluster_volumes
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT *
    FROM  gluster_volumes
    WHERE cluster_id = v_cluster_id AND status = v_status
    AND vol_type IN (SELECT ID FROM fnSplitter(v_vol_types))
    AND id IN (SELECT volume_id FROM gluster_volume_options
    WHERE option_key=v_option_key AND option_val=v_option_val);
END; $$;


ALTER FUNCTION public.getglustervolumesbystatustypesandoption(v_cluster_id uuid, v_status character varying, v_vol_types text, v_option_key character varying, v_option_val character varying) OWNER TO engineer;

--
-- Name: getidsforovfdeletion(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getidsforovfdeletion(v_storage_pool_id uuid) RETURNS SETOF uuid
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT ovf.vm_guid as vm_guid
   FROM vm_ovf_generations ovf
   WHERE ovf.storage_pool_id = v_storage_pool_id AND ovf.vm_guid NOT IN (SELECT vm_guid FROM vm_static);
END; $$;


ALTER FUNCTION public.getidsforovfdeletion(v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getimage_storage_domain_mapbyimage_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getimage_storage_domain_mapbyimage_id(v_image_id uuid) RETURNS SETOF image_storage_domain_map
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM image_storage_domain_map
   WHERE image_id = v_image_id;

END; $$;


ALTER FUNCTION public.getimage_storage_domain_mapbyimage_id(v_image_id uuid) OWNER TO engineer;

--
-- Name: getimage_storage_domain_mapbystorage_domain_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getimage_storage_domain_mapbystorage_domain_id(v_storage_domain_id uuid) RETURNS SETOF image_storage_domain_map
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM image_storage_domain_map
   WHERE storage_domain_id = v_storage_domain_id;

END; $$;


ALTER FUNCTION public.getimage_storage_domain_mapbystorage_domain_id(v_storage_domain_id uuid) OWNER TO engineer;

--
-- Name: vm_images_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vm_images_view AS
    SELECT storage_for_image_view.storage_id, storage_for_image_view.storage_path, storage_for_image_view.storage_name, images_storage_domain_view.storage_pool_id, images_storage_domain_view.image_guid, images_storage_domain_view.creation_date, disk_image_dynamic.actual_size, disk_image_dynamic.read_rate, disk_image_dynamic.read_latency_seconds, disk_image_dynamic.write_latency_seconds, disk_image_dynamic.flush_latency_seconds, disk_image_dynamic.write_rate, images_storage_domain_view.size, images_storage_domain_view.it_guid, images_storage_domain_view.description, images_storage_domain_view.parentid, images_storage_domain_view.imagestatus, images_storage_domain_view.lastmodified, images_storage_domain_view.app_list, images_storage_domain_view.vm_snapshot_id, images_storage_domain_view.volume_type, images_storage_domain_view.image_group_id, images_storage_domain_view.active, images_storage_domain_view.volume_format, images_storage_domain_view.disk_interface, images_storage_domain_view.boot, images_storage_domain_view.wipe_after_delete, images_storage_domain_view.propagate_errors, images_storage_domain_view.entity_type, images_storage_domain_view.number_of_vms, images_storage_domain_view.vm_names, images_storage_domain_view.quota_id, images_storage_domain_view.quota_name, images_storage_domain_view.quota_enforcement_type, images_storage_domain_view.disk_id, images_storage_domain_view.disk_alias, images_storage_domain_view.disk_description, images_storage_domain_view.shareable FROM ((images_storage_domain_view JOIN disk_image_dynamic ON ((images_storage_domain_view.image_guid = disk_image_dynamic.image_id))) JOIN storage_for_image_view ON ((images_storage_domain_view.image_guid = storage_for_image_view.image_id))) WHERE (images_storage_domain_view.active = true);


ALTER TABLE public.vm_images_view OWNER TO engineer;

--
-- Name: getimagebyimageguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getimagebyimageguid(v_image_guid uuid) RETURNS SETOF vm_images_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM vm_images_view
      WHERE image_guid = v_image_guid;
END; $$;


ALTER FUNCTION public.getimagebyimageguid(v_image_guid uuid) OWNER TO engineer;

--
-- Name: getimagebyimageid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getimagebyimageid(v_image_guid uuid) RETURNS SETOF images
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   images
    WHERE  image_guid = v_image_guid;
END; $$;


ALTER FUNCTION public.getimagebyimageid(v_image_guid uuid) OWNER TO engineer;

--
-- Name: getimagesbyquotaid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getimagesbyquotaid(v_quota_id uuid) RETURNS SETOF images_storage_domain_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM images_storage_domain_view
      WHERE quota_id = v_quota_id;

END; $$;


ALTER FUNCTION public.getimagesbyquotaid(v_quota_id uuid) OWNER TO engineer;

--
-- Name: getimageswhichhavenodisk(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getimageswhichhavenodisk(v_vm_id uuid) RETURNS SETOF images_storage_domain_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT i.*
      FROM   images_storage_domain_view i
      JOIN   snapshots s ON (i.vm_snapshot_id = s.snapshot_id)
      WHERE  s.vm_id = v_vm_id
      AND    NOT EXISTS (
          SELECT 1
          FROM   base_disks d
          WHERE  d.disk_id = i.image_group_id);
END; $$;


ALTER FUNCTION public.getimageswhichhavenodisk(v_vm_id uuid) OWNER TO engineer;

--
-- Name: vds_interface; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vds_interface (
    id uuid NOT NULL,
    name character varying(50) NOT NULL,
    network_name character varying(50),
    vds_id uuid,
    mac_addr character varying(59),
    is_bond boolean DEFAULT false,
    bond_name character varying(50),
    bond_type integer,
    bond_opts character varying(4000),
    vlan_id integer,
    speed integer,
    addr character varying(20),
    subnet character varying(20),
    gateway character varying(20),
    boot_protocol integer,
    type integer DEFAULT 0,
    _create_date timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone,
    _update_date timestamp with time zone,
    mtu integer,
    bridged boolean DEFAULT true NOT NULL
);


ALTER TABLE public.vds_interface OWNER TO engineer;

--
-- Name: vds_interface_statistics; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vds_interface_statistics (
    id uuid NOT NULL,
    vds_id uuid,
    rx_rate numeric(18,0),
    tx_rate numeric(18,0),
    rx_drop numeric(18,0),
    tx_drop numeric(18,0),
    iface_status integer,
    _update_date timestamp with time zone
);


ALTER TABLE public.vds_interface_statistics OWNER TO engineer;

--
-- Name: vds_interface_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vds_interface_view AS
    SELECT vds_interface_statistics.rx_rate, vds_interface_statistics.tx_rate, vds_interface_statistics.rx_drop, vds_interface_statistics.tx_drop, vds_interface_statistics.iface_status, vds_interface.type, vds_interface.gateway, vds_interface.subnet, vds_interface.addr, vds_interface.speed, vds_interface.vlan_id, vds_interface.bond_type, vds_interface.bond_name, vds_interface.is_bond, vds_interface.bond_opts, vds_interface.mac_addr, vds_interface.network_name, vds_interface.name, vds_static.vds_id, vds_static.vds_name, vds_interface.id, vds_interface.boot_protocol, vds_interface.mtu, vds_interface.bridged, 1 AS is_vds FROM ((vds_interface_statistics JOIN vds_interface ON ((vds_interface_statistics.id = vds_interface.id))) JOIN vds_static ON ((vds_interface.vds_id = vds_static.vds_id)));


ALTER TABLE public.vds_interface_view OWNER TO engineer;

--
-- Name: getinterface_viewbyaddr(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getinterface_viewbyaddr(v_cluster_id uuid, v_addr character varying) RETURNS SETOF vds_interface_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT vds_interface_view.*
   FROM vds_interface_view
   INNER JOIN vds_static
   ON vds_interface_view.vds_id = vds_static.vds_id
   WHERE vds_interface_view.addr = v_addr
   AND vds_static.vds_group_id = v_cluster_id;
END; $$;


ALTER FUNCTION public.getinterface_viewbyaddr(v_cluster_id uuid, v_addr character varying) OWNER TO engineer;

--
-- Name: getinterface_viewbyvds_id(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getinterface_viewbyvds_id(v_vds_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vds_interface_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM vds_interface_view
   WHERE vds_id = v_vds_id
   AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                     FROM   user_vds_permissions_view
                                     WHERE  user_id = v_user_id AND entity_id = v_vds_id));

END; $$;


ALTER FUNCTION public.getinterface_viewbyvds_id(v_vds_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getjobbyjobid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getjobbyjobid(v_job_id uuid) RETURNS SETOF job
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT job.*
    FROM JOB
    WHERE job_id = v_job_id;
END; $$;


ALTER FUNCTION public.getjobbyjobid(v_job_id uuid) OWNER TO engineer;

--
-- Name: getjobsbycorrelationid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getjobsbycorrelationid(v_correlation_id character varying) RETURNS SETOF job
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT job.*
    FROM JOB
    WHERE correlation_id = v_correlation_id;
END; $$;


ALTER FUNCTION public.getjobsbycorrelationid(v_correlation_id character varying) OWNER TO engineer;

--
-- Name: getjobsbyoffsetandpagesize(integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getjobsbyoffsetandpagesize(v_position integer, v_page_size integer) RETURNS SETOF job
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    (SELECT job.*
    FROM JOB
    WHERE status = 'STARTED'
    ORDER BY last_update_time desc)
    UNION ALL
    (SELECT job.*
    FROM JOB
    WHERE status not in ('STARTED','UNKNOWN')
    ORDER BY last_update_time desc)
    OFFSET v_position LIMIT v_page_size;
END; $$;


ALTER FUNCTION public.getjobsbyoffsetandpagesize(v_position integer, v_page_size integer) OWNER TO engineer;

--
-- Name: job_subject_entity; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE job_subject_entity (
    job_id uuid NOT NULL,
    entity_id uuid NOT NULL,
    entity_type character varying(32) NOT NULL
);


ALTER TABLE public.job_subject_entity OWNER TO engineer;

--
-- Name: getjobsubjectentitybyjobid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getjobsubjectentitybyjobid(v_job_id uuid) RETURNS SETOF job_subject_entity
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT job_subject_entity.*
    FROM job_subject_entity
    WHERE job_id = v_job_id;
END; $$;


ALTER FUNCTION public.getjobsubjectentitybyjobid(v_job_id uuid) OWNER TO engineer;

--
-- Name: getlun_storage_server_connection_mapbylunbystorage_server_conn(character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getlun_storage_server_connection_mapbylunbystorage_server_conn(v_lun_id character varying, v_storage_server_connection character varying) RETURNS SETOF lun_storage_server_connection_map
    LANGUAGE plpgsql
    AS $$
BEGIN

   RETURN QUERY SELECT *
   FROM LUN_storage_server_connection_map lUN_storage_server_connection_map
   WHERE LUN_id = v_LUN_id AND storage_server_connection = v_storage_server_connection;

END; $$;


ALTER FUNCTION public.getlun_storage_server_connection_mapbylunbystorage_server_conn(v_lun_id character varying, v_storage_server_connection character varying) OWNER TO engineer;

--
-- Name: getlunbylunid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getlunbylunid(v_lun_id character varying) RETURNS SETOF luns_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM luns_view
   WHERE LUN_id = v_LUN_id;

END; $$;


ALTER FUNCTION public.getlunbylunid(v_lun_id character varying) OWNER TO engineer;

--
-- Name: getlunsbystorage_server_connection(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getlunsbystorage_server_connection(v_storage_server_connection character varying) RETURNS SETOF luns_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT luns_view.*
   FROM luns_view INNER JOIN
   LUN_storage_server_connection_map
   ON LUN_storage_server_connection_map.LUN_id = luns_view.LUN_id
   WHERE LUN_storage_server_connection_map.storage_server_connection = v_storage_server_connection;

END; $$;


ALTER FUNCTION public.getlunsbystorage_server_connection(v_storage_server_connection character varying) OWNER TO engineer;

--
-- Name: getlunsbyvolumegroupid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getlunsbyvolumegroupid(v_volume_group_id character varying) RETURNS SETOF luns_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM luns_view
   WHERE volume_group_id = v_volume_group_id;

END; $$;


ALTER FUNCTION public.getlunsbyvolumegroupid(v_volume_group_id character varying) OWNER TO engineer;

--
-- Name: getmacsbydatacenterid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getmacsbydatacenterid(v_data_center_id uuid) RETURNS SETOF character varying
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT mac_addr
   FROM vm_interface_view
   WHERE EXISTS (
      SELECT 1 FROM vm_static
      JOIN vds_groups ON vm_static.vds_group_id = vds_groups.vds_group_id
      WHERE vds_groups.storage_pool_id = v_data_center_id
      AND vm_static.vm_guid = vm_interface_view.vm_guid);
END; $$;


ALTER FUNCTION public.getmacsbydatacenterid(v_data_center_id uuid) OWNER TO engineer;

--
-- Name: getnamesofvmstaticdedicatedtovds(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getnamesofvmstaticdedicatedtovds(v_vds_id uuid) RETURNS SETOF getnamesofvmstaticdedicatedtovds_rs
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY
      SELECT vm_name
      FROM vm_static
      WHERE dedicated_vm_for_vds = v_vds_id
      AND   migration_support = 2
      AND   entity_type = 'VM';

END; $$;


ALTER FUNCTION public.getnamesofvmstaticdedicatedtovds(v_vds_id uuid) OWNER TO engineer;

--
-- Name: getnetwork_clusterbycluster_idandbynetwork_id(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getnetwork_clusterbycluster_idandbynetwork_id(v_cluster_id uuid, v_network_id uuid) RETURNS SETOF network_cluster
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM network_cluster
   WHERE cluster_id = v_cluster_id AND network_id = v_network_id;

END; $$;


ALTER FUNCTION public.getnetwork_clusterbycluster_idandbynetwork_id(v_cluster_id uuid, v_network_id uuid) OWNER TO engineer;

--
-- Name: getnetworkbyid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getnetworkbyid(v_id uuid) RETURNS SETOF network
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT *
   FROM network
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.getnetworkbyid(v_id uuid) OWNER TO engineer;

--
-- Name: getnetworkbyname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getnetworkbyname(v_networkname character varying) RETURNS SETOF network
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM network
   WHERE name = v_networkName;

END; $$;


ALTER FUNCTION public.getnetworkbyname(v_networkname character varying) OWNER TO engineer;

--
-- Name: getnetworkbynameandcluster(character varying, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getnetworkbynameandcluster(v_name character varying, v_cluster_id uuid) RETURNS SETOF network
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT network.*
   FROM network
   WHERE network.name = v_name
   AND EXISTS (SELECT 1
               FROM network_cluster
               WHERE network.id = network_cluster.network_id
               AND   network_cluster.cluster_id = v_cluster_id);

END; $$;


ALTER FUNCTION public.getnetworkbynameandcluster(v_name character varying, v_cluster_id uuid) OWNER TO engineer;

--
-- Name: getnetworkbynameanddatacenter(character varying, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getnetworkbynameanddatacenter(v_name character varying, v_storage_pool_id uuid) RETURNS SETOF network
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT network.*
   FROM network
   WHERE network.name = v_name
   AND   network.storage_pool_id = v_storage_pool_id;

END; $$;


ALTER FUNCTION public.getnetworkbynameanddatacenter(v_name character varying, v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getnfsstorage_server_connectionsbystoragepoolid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getnfsstorage_server_connectionsbystoragepoolid(v_storage_pool_id uuid) RETURNS SETOF storage_server_connections
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT distinct storage_server_connections.*
   FROM    storage_server_connections storage_server_connections
   INNER JOIN
   storage_domain_static_view ON
   storage_server_connections.id = storage_domain_static_view.storage
   WHERE     (storage_domain_static_view.storage_pool_id = v_storage_pool_id);
END; $$;


ALTER FUNCTION public.getnfsstorage_server_connectionsbystoragepoolid(v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getnoncountablequtoavmstatuses(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getnoncountablequtoavmstatuses() RETURNS SETOF integer
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN query select 0 union select 13 union select 14 union select 15;
--(Down(0), Suspended(13), ImageIllegal(14), ImageLocked(15))
END; $$;


ALTER FUNCTION public.getnoncountablequtoavmstatuses() OWNER TO engineer;

--
-- Name: getnvmtagsbyvmid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getnvmtagsbyvmid(v_vm_id uuid) RETURNS SETOF tags_vm_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY select * from tags_vm_map
      where tags_vm_map.vm_id = v_vm_id;
END; $$;


ALTER FUNCTION public.getnvmtagsbyvmid(v_vm_id uuid) OWNER TO engineer;

--
-- Name: getnvmtagsbyvmidanddefaulttag(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getnvmtagsbyvmidanddefaulttag(v_vm_id uuid) RETURNS SETOF tags_vm_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY select tags_vm_map.* from tags_vm_map
      inner join tags on tags.tag_id = tags_vm_map.tag_id
      where tags_vm_map.vm_id = v_vm_id
      and tags.type = 1;
END; $$;


ALTER FUNCTION public.getnvmtagsbyvmidanddefaulttag(v_vm_id uuid) OWNER TO engineer;

--
-- Name: getoptionsbyglustervolumeguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getoptionsbyglustervolumeguid(v_volume_id uuid) RETURNS SETOF gluster_volume_options
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT *
    FROM  gluster_volume_options
    WHERE volume_id = v_volume_id;
END; $$;


ALTER FUNCTION public.getoptionsbyglustervolumeguid(v_volume_id uuid) OWNER TO engineer;

--
-- Name: getorderedvmguidsforrunmultipleactions(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getorderedvmguidsforrunmultipleactions(v_vm_guids character varying) RETURNS SETOF getorderedvmguidsforrunmultipleactions_rs
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_ordered_guids GetOrderedVmGuidsForRunMultipleActions_rs;
BEGIN
   FOR v_ordered_guids IN EXECUTE 'SELECT vm_guid from vm_static where vm_guid in( ' || v_vm_guids || ' ) AND entity_type = ''VM''  order by auto_startup desc,priority desc, migration_support desc' LOOP
      RETURN NEXT v_ordered_guids;
   END LOOP;

END; $$;


ALTER FUNCTION public.getorderedvmguidsforrunmultipleactions(v_vm_guids character varying) OWNER TO engineer;

--
-- Name: getovfgeneration(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getovfgeneration(v_vm_id uuid) RETURNS SETOF bigint
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vm.ovf_generation
   FROM vm_ovf_generations vm
   WHERE vm.vm_guid = v_vm_id;
END; $$;


ALTER FUNCTION public.getovfgeneration(v_vm_id uuid) OWNER TO engineer;

--
-- Name: getpermissionbyroleid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getpermissionbyroleid(v_role_id uuid) RETURNS SETOF permissions
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   from permissions
   where role_id = v_role_id;
END; $$;


ALTER FUNCTION public.getpermissionbyroleid(v_role_id uuid) OWNER TO engineer;

--
-- Name: getpermissionsbyadelementid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getpermissionsbyadelementid(v_ad_element_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF permissions_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM permissions_view
   WHERE
   (permissions_view.ad_element_id = v_ad_element_id
    OR    ad_element_id IN (SELECT * FROM getUserAndGroupsById(v_ad_element_id)))
   AND (NOT v_is_filtered OR EXISTS (SELECT 1 FROM user_permissions_permissions_view WHERE user_id = v_user_id));

END; $$;


ALTER FUNCTION public.getpermissionsbyadelementid(v_ad_element_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getpermissionsbyentityid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getpermissionsbyentityid(v_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF permissions_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM permissions_view
   WHERE object_id = v_id
   AND   (NOT v_is_filtered OR EXISTS (SELECT 1
                                       FROM   GetUserPermissionsByEntityId(v_id, v_user_id, v_is_filtered)));
END; $$;


ALTER FUNCTION public.getpermissionsbyentityid(v_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getpermissionsbyid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getpermissionsbyid(v_id uuid) RETURNS SETOF permissions_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM permissions_view
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.getpermissionsbyid(v_id uuid) OWNER TO engineer;

--
-- Name: getpermissionsbyroleid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getpermissionsbyroleid(v_role_id uuid) RETURNS SETOF permissions_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM permissions_view
   WHERE role_id = v_role_id;

END; $$;


ALTER FUNCTION public.getpermissionsbyroleid(v_role_id uuid) OWNER TO engineer;

--
-- Name: getpermissionsbyroleidandadelementid(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getpermissionsbyroleidandadelementid(v_role_id uuid, v_ad_element_id uuid) RETURNS SETOF permissions_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM permissions_view
   WHERE role_id = v_role_id and ad_element_id = v_ad_element_id;

END; $$;


ALTER FUNCTION public.getpermissionsbyroleidandadelementid(v_role_id uuid, v_ad_element_id uuid) OWNER TO engineer;

--
-- Name: getpermissionsbyroleidandadelementidandobjectid(uuid, uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getpermissionsbyroleidandadelementidandobjectid(v_role_id uuid, v_ad_element_id uuid, v_object_id uuid) RETURNS SETOF permissions_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM permissions_view
   WHERE role_id = v_role_id and ad_element_id = v_ad_element_id and object_id = v_object_id;

END; $$;


ALTER FUNCTION public.getpermissionsbyroleidandadelementidandobjectid(v_role_id uuid, v_ad_element_id uuid, v_object_id uuid) OWNER TO engineer;

--
-- Name: getpermissionsbyroleidandobjectid(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getpermissionsbyroleidandobjectid(v_role_id uuid, v_object_id uuid) RETURNS SETOF permissions_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM permissions_view
   WHERE role_id = v_role_id and object_id = v_object_id;

END; $$;


ALTER FUNCTION public.getpermissionsbyroleidandobjectid(v_role_id uuid, v_object_id uuid) OWNER TO engineer;

--
-- Name: getpermissionstreebyentityid(uuid, integer, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getpermissionstreebyentityid(v_id uuid, v_object_type_id integer, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF permissions_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM   permissions_view p
   WHERE  object_id in(select id from  fn_get_entity_parents(v_id,v_object_type_id))
   AND    (NOT v_is_filtered OR EXISTS (SELECT 1
                                        FROM   user_flat_groups u
                                        WHERE  p.ad_element_id = u.granted_id
                                        AND    u.user_id       = v_user_id));

END; $$;


ALTER FUNCTION public.getpermissionstreebyentityid(v_id uuid, v_object_type_id integer, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getpluggedvminterfacesbymac(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getpluggedvminterfacesbymac(v_mac_address character varying) RETURNS SETOF vm_interface_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM vm_interface_view
   WHERE mac_addr = v_mac_address
   AND is_plugged = true;
END; $$;


ALTER FUNCTION public.getpluggedvminterfacesbymac(v_mac_address character varying) OWNER TO engineer;

--
-- Name: getquotabyadelementid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getquotabyadelementid(v_ad_element_id uuid, v_storage_pool_id uuid, v_recursive boolean) RETURNS SETOF quota_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT * FROM quota_view WHERE quota_view.quota_id IN
   (SELECT object_id
    FROM PERMISSIONS
    WHERE object_type_id = 17
    AND role_id in (SELECT role_id FROM ROLES_groups where action_group_id = 901)
    AND ad_element_id = v_ad_element_id OR
        (v_recursive AND ad_element_id IN (SELECT * FROM getUserAndGroupsById(v_ad_element_id))))
    AND (v_storage_pool_id = quota_view.storage_pool_id or v_storage_pool_id IS NULL);
  END; $$;


ALTER FUNCTION public.getquotabyadelementid(v_ad_element_id uuid, v_storage_pool_id uuid, v_recursive boolean) OWNER TO engineer;

--
-- Name: quota_limitation; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE quota_limitation (
    id uuid NOT NULL,
    quota_id uuid NOT NULL,
    storage_id uuid,
    vds_group_id uuid,
    virtual_cpu integer,
    mem_size_mb bigint,
    storage_size_gb bigint
);


ALTER TABLE public.quota_limitation OWNER TO engineer;

--
-- Name: quota_global_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW quota_global_view AS
    SELECT q_limit.quota_id, q.storage_pool_id, storage_pool.name AS storage_pool_name, q.quota_name, q.description, q.threshold_vds_group_percentage, q.threshold_storage_percentage, q.grace_vds_group_percentage, q.grace_storage_percentage, q_limit.virtual_cpu, (calculatevdsgroupusage(q_limit.quota_id, NULL::uuid)).virtual_cpu_usage AS virtual_cpu_usage, q_limit.mem_size_mb, (calculatevdsgroupusage(q_limit.quota_id, NULL::uuid)).mem_size_mb_usage AS mem_size_mb_usage, q_limit.storage_size_gb, calculatestorageusage(q_limit.quota_id, NULL::uuid) AS storage_size_gb_usage, storage_pool.quota_enforcement_type FROM storage_pool, (quota q LEFT JOIN quota_limitation q_limit ON ((q_limit.quota_id = q.id))) WHERE (((storage_pool.id = q.storage_pool_id) AND (q_limit.vds_group_id IS NULL)) AND (q_limit.storage_id IS NULL));


ALTER TABLE public.quota_global_view OWNER TO engineer;

--
-- Name: getquotabyquotaguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getquotabyquotaguid(v_id uuid) RETURNS SETOF quota_global_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM quota_global_view
   WHERE quota_id = v_id;
END; $$;


ALTER FUNCTION public.getquotabyquotaguid(v_id uuid) OWNER TO engineer;

--
-- Name: getquotabyquotaname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getquotabyquotaname(v_quota_name character varying) RETURNS SETOF quota_global_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM quota_global_view
   WHERE quota_name = v_quota_name;
END; $$;


ALTER FUNCTION public.getquotabyquotaname(v_quota_name character varying) OWNER TO engineer;

--
-- Name: getquotabystoragepoolguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getquotabystoragepoolguid(v_storage_pool_id uuid) RETURNS SETOF quota_global_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM  quota_global_view
   WHERE (storage_pool_id = v_storage_pool_id or v_storage_pool_id IS NULL);
END; $$;


ALTER FUNCTION public.getquotabystoragepoolguid(v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getquotacount(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getquotacount() RETURNS SETOF bigint
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT count(*) as num_quota
    FROM quota;
END; $$;


ALTER FUNCTION public.getquotacount() OWNER TO engineer;

--
-- Name: quota_storage_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW quota_storage_view AS
    SELECT q_limit.id AS quota_storage_id, q_limit.quota_id, q_limit.storage_id, storage_domain_static.storage_name, q_limit.storage_size_gb, calculatestorageusage(q_limit.quota_id, q_limit.storage_id) AS storage_size_gb_usage FROM quota_limitation q_limit, quota q, storage_domain_static WHERE ((((q_limit.quota_id = q.id) AND (q_limit.vds_group_id IS NULL)) AND (q_limit.storage_id IS NOT NULL)) AND (storage_domain_static.id = q_limit.storage_id));


ALTER TABLE public.quota_storage_view OWNER TO engineer;

--
-- Name: getquotastoragebyquotaguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getquotastoragebyquotaguid(v_id uuid) RETURNS SETOF quota_storage_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM  quota_storage_view
   WHERE quota_id = v_id;
END; $$;


ALTER FUNCTION public.getquotastoragebyquotaguid(v_id uuid) OWNER TO engineer;

--
-- Name: getquotastoragebystorageguid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getquotastoragebystorageguid(v_storage_id uuid, v_id uuid, v_allow_empty boolean) RETURNS SETOF quota_storage_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM
   (SELECT  COALESCE(q_storage_view.quota_storage_id, q_g_view.quota_id) as quota_storage_id,
            q_g_view.quota_id as quota_id,
            q_storage_view.storage_id,
            q_storage_view.storage_name,
            COALESCE(q_storage_view.storage_size_gb, q_g_view.storage_size_gb) as storage_size_gb,
            COALESCE(q_storage_view.storage_size_gb_usage, q_g_view.storage_size_gb_usage) as storage_size_gb_usage
    FROM  quota_global_view q_g_view
    LEFT OUTER JOIN quota_storage_view q_storage_view ON q_g_view.quota_id = q_storage_view.quota_id
    AND  (v_storage_id = q_storage_view.storage_id OR v_storage_id IS NULL)
   WHERE q_g_view.quota_id = v_id) sub
   WHERE (v_allow_empty OR storage_size_gb IS NOT NULL);
END; $$;


ALTER FUNCTION public.getquotastoragebystorageguid(v_storage_id uuid, v_id uuid, v_allow_empty boolean) OWNER TO engineer;

--
-- Name: quota_vds_group_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW quota_vds_group_view AS
    SELECT q_limit.id AS quota_vds_group_id, q_limit.quota_id, q_limit.vds_group_id, vds_groups.name AS vds_group_name, q_limit.virtual_cpu, (calculatevdsgroupusage(q_limit.quota_id, q_limit.vds_group_id)).virtual_cpu_usage AS virtual_cpu_usage, q_limit.mem_size_mb, (calculatevdsgroupusage(q_limit.quota_id, q_limit.vds_group_id)).mem_size_mb_usage AS mem_size_mb_usage FROM quota_limitation q_limit, quota q, vds_groups WHERE ((((q_limit.quota_id = q.id) AND (q_limit.vds_group_id IS NOT NULL)) AND (q_limit.storage_id IS NULL)) AND (vds_groups.vds_group_id = q_limit.vds_group_id));


ALTER TABLE public.quota_vds_group_view OWNER TO engineer;

--
-- Name: getquotavdsgroupbyquotaguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getquotavdsgroupbyquotaguid(v_id uuid) RETURNS SETOF quota_vds_group_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT quota_vds_group_view.*
   FROM  quota_vds_group_view
   WHERE quota_id = v_id;
END; $$;


ALTER FUNCTION public.getquotavdsgroupbyquotaguid(v_id uuid) OWNER TO engineer;

--
-- Name: getquotavdsgroupbyvdsgroupguid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getquotavdsgroupbyvdsgroupguid(v_vds_group_id uuid, v_id uuid, v_allow_empty boolean) RETURNS SETOF quota_vds_group_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM (SELECT COALESCE(q_vds_view.quota_vds_group_id, q_g_view.quota_id) as quota_vds_group_id,
                q_g_view.quota_id as quota_id,
                q_vds_view.vds_group_id as vds_group_id,
                q_vds_view.vds_group_name as vds_group_name,
                COALESCE(q_vds_view.virtual_cpu,q_g_view.virtual_cpu) as virtual_cpu,
                COALESCE(q_vds_view.virtual_cpu_usage, q_g_view.virtual_cpu_usage) as virtual_cpu_usage,
                COALESCE(q_vds_view.mem_size_mb,q_g_view.mem_size_mb) as mem_size_mb,
                COALESCE(q_vds_view.mem_size_mb_usage, q_g_view.mem_size_mb_usage) as mem_size_mb_usage
         FROM   quota_global_view q_g_view
         LEFT OUTER JOIN quota_vds_group_view q_vds_view ON q_g_view.quota_id = q_vds_view.quota_id
         AND   (v_vds_group_id = q_vds_view.vds_group_id OR v_vds_group_id IS NULL)
         WHERE q_g_view.quota_id = v_id) sub
   WHERE v_allow_empty OR virtual_cpu IS NOT NULL OR mem_size_mb IS NOT NULL;
END; $$;


ALTER FUNCTION public.getquotavdsgroupbyvdsgroupguid(v_vds_group_id uuid, v_id uuid, v_allow_empty boolean) OWNER TO engineer;

--
-- Name: repo_file_meta_data; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE repo_file_meta_data (
    repo_domain_id uuid NOT NULL,
    repo_file_name character varying(256) NOT NULL,
    size bigint DEFAULT 0,
    date_created timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone,
    last_refreshed bigint DEFAULT 0,
    file_type integer DEFAULT 0
);


ALTER TABLE public.repo_file_meta_data OWNER TO engineer;

--
-- Name: getrepo_files_by_storage_domain(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getrepo_files_by_storage_domain(v_storage_domain_id uuid, v_file_type integer) RETURNS SETOF repo_file_meta_data
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT repo_file_meta_data.*
   FROM repo_file_meta_data
   WHERE repo_domain_id = v_storage_domain_id
   AND repo_file_meta_data.file_type = v_file_type
   ORDER BY repo_file_meta_data.last_refreshed;
END; $$;


ALTER FUNCTION public.getrepo_files_by_storage_domain(v_storage_domain_id uuid, v_file_type integer) OWNER TO engineer;

--
-- Name: storage_domain_file_repos; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW storage_domain_file_repos AS
    SELECT storage_domain_static.id AS storage_domain_id, storage_domain_static.storage_domain_type, storage_pool_iso_map.storage_pool_id, storage_pool_iso_map.status AS storage_domain_status, repo_file_meta_data.repo_file_name, repo_file_meta_data.size, repo_file_meta_data.date_created, repo_file_meta_data.last_refreshed, repo_file_meta_data.file_type, vds_dynamic.status AS vds_status, storage_pool.status AS storage_pool_status FROM ((((storage_domain_static JOIN storage_pool_iso_map ON ((storage_domain_static.id = storage_pool_iso_map.storage_id))) JOIN storage_pool ON ((storage_pool.id = storage_pool_iso_map.storage_pool_id))) JOIN vds_dynamic ON ((vds_dynamic.vds_id = storage_pool.spm_vds_id))) LEFT JOIN repo_file_meta_data ON ((storage_pool_iso_map.storage_id = repo_file_meta_data.repo_domain_id)));


ALTER TABLE public.storage_domain_file_repos OWNER TO engineer;

--
-- Name: getrepo_files_by_storage_domain_and_storage_pool(uuid, uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getrepo_files_by_storage_domain_and_storage_pool(v_storage_pool_id uuid, v_storage_domain_id uuid, v_file_type integer) RETURNS SETOF storage_domain_file_repos
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT storage_domain_file_repos.*
   FROM storage_domain_file_repos
   WHERE storage_domain_id = v_storage_domain_id
   AND storage_pool_id = v_storage_pool_id
   AND storage_domain_file_repos.file_type = v_file_type
   ORDER BY storage_domain_file_repos.last_refreshed;
END; $$;


ALTER FUNCTION public.getrepo_files_by_storage_domain_and_storage_pool(v_storage_pool_id uuid, v_storage_domain_id uuid, v_file_type integer) OWNER TO engineer;

--
-- Name: getrepo_files_in_all_storage_pools(integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getrepo_files_in_all_storage_pools(v_storage_domain_type integer, v_storage_pool_status integer, v_vds_status integer, v_storage_domain_status integer) RETURNS SETOF getrepo_files_in_all_storage_pools_rs
    LANGUAGE plpgsql
    AS $$
BEGIN
 RETURN QUERY SELECT distinct b.storage_domain_id,c.last_refreshed,b.file_type
   FROM storage_domain_file_repos b
   LEFT OUTER JOIN
   (SELECT storage_domain_id,file_type,min(last_refreshed) as last_refreshed
      FROM storage_domain_file_repos a
   	  Group by storage_domain_id,file_type) as c ON b.storage_domain_id = c.storage_domain_id
                                                 AND b.file_type = c.file_type
   WHERE b.storage_domain_type = v_storage_domain_type
     and b.storage_pool_status = v_storage_pool_status
     and b.storage_domain_status = v_storage_domain_status
	 and b.vds_status = v_vds_status;
END; $$;


ALTER FUNCTION public.getrepo_files_in_all_storage_pools(v_storage_domain_type integer, v_storage_pool_status integer, v_vds_status integer, v_storage_domain_status integer) OWNER TO engineer;

--
-- Name: getrole_children(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getrole_children(v_role_id uuid) RETURNS SETOF roles_relations
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM roles_relations
   WHERE role_container_id = v_role_id;

END; $$;


ALTER FUNCTION public.getrole_children(v_role_id uuid) OWNER TO engineer;

--
-- Name: getroleactiongroupsbyroleid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getroleactiongroupsbyroleid(v_id uuid) RETURNS SETOF roles_groups
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM roles_groups
   WHERE role_id = v_id;
END; $$;


ALTER FUNCTION public.getroleactiongroupsbyroleid(v_id uuid) OWNER TO engineer;

--
-- Name: getrolebyname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getrolebyname(v_name character varying) RETURNS SETOF roles
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM roles
   WHERE name = v_name;

END; $$;


ALTER FUNCTION public.getrolebyname(v_name character varying) OWNER TO engineer;

--
-- Name: getroles_relationsbyrole_container_idandbyrole_id(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getroles_relationsbyrole_container_idandbyrole_id(v_role_container_id uuid, v_role_id uuid) RETURNS SETOF roles_relations
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM roles_relations
   WHERE role_container_id = v_role_container_id AND role_id = v_role_id;

END; $$;


ALTER FUNCTION public.getroles_relationsbyrole_container_idandbyrole_id(v_role_container_id uuid, v_role_id uuid) OWNER TO engineer;

--
-- Name: getrolesbyadelementid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getrolesbyadelementid(v_ad_element_id uuid) RETURNS SETOF roles
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT roles.*
   FROM roles
   inner join permissions permissions on roles.id = permissions.role_id
   WHERE ad_element_id = v_ad_element_id;
END; $$;


ALTER FUNCTION public.getrolesbyadelementid(v_ad_element_id uuid) OWNER TO engineer;

--
-- Name: getrolsbyid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getrolsbyid(v_id uuid) RETURNS SETOF roles
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM roles
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.getrolsbyid(v_id uuid) OWNER TO engineer;

--
-- Name: getsnapshotbyguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getsnapshotbyguid(v_image_guid uuid) RETURNS SETOF images_storage_domain_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM images_storage_domain_view images_storage_domain_view
      WHERE image_guid = v_image_guid;
END; $$;


ALTER FUNCTION public.getsnapshotbyguid(v_image_guid uuid) OWNER TO engineer;

--
-- Name: getsnapshotbyparentguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getsnapshotbyparentguid(v_parent_guid uuid) RETURNS SETOF images_storage_domain_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM images_storage_domain_view images_storage_domain_view
      WHERE ParentId = v_parent_guid;
END; $$;


ALTER FUNCTION public.getsnapshotbyparentguid(v_parent_guid uuid) OWNER TO engineer;

--
-- Name: getsnapshotbysnapshotid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getsnapshotbysnapshotid(v_snapshot_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF snapshots
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   snapshots
    WHERE  snapshot_id = v_snapshot_id AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                        FROM   user_vm_permissions_view
                                        WHERE  user_id = v_user_id AND entity_id = (SELECT vm_id
                                        FROM snapshots where snapshot_id = v_snapshot_id)));
END; $$;


ALTER FUNCTION public.getsnapshotbysnapshotid(v_snapshot_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getsnapshotbyvmidandtype(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getsnapshotbyvmidandtype(v_vm_id uuid, v_snapshot_type character varying) RETURNS SETOF snapshots
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   snapshots
    WHERE  vm_id = v_vm_id
    AND    snapshot_type = v_snapshot_type
    ORDER BY creation_date ASC
    LIMIT 1;
END; $$;


ALTER FUNCTION public.getsnapshotbyvmidandtype(v_vm_id uuid, v_snapshot_type character varying) OWNER TO engineer;

--
-- Name: getsnapshotidsbyvmidandtype(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getsnapshotidsbyvmidandtype(v_vm_id uuid, v_snapshot_type character varying) RETURNS SETOF iduuidtype
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT snapshot_id
    FROM   snapshots
    WHERE  vm_id = v_vm_id
    AND    snapshot_type = v_snapshot_type
    ORDER BY creation_date ASC;
END; $$;


ALTER FUNCTION public.getsnapshotidsbyvmidandtype(v_vm_id uuid, v_snapshot_type character varying) OWNER TO engineer;

--
-- Name: getsnapshotidsbyvmidandtypeandstatus(uuid, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getsnapshotidsbyvmidandtypeandstatus(v_vm_id uuid, v_snapshot_type character varying, v_status character varying) RETURNS SETOF iduuidtype
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT snapshot_id
    FROM   snapshots
    WHERE  vm_id = v_vm_id
    AND    snapshot_type = v_snapshot_type
    AND    status = v_status
    ORDER BY creation_date ASC;
END; $$;


ALTER FUNCTION public.getsnapshotidsbyvmidandtypeandstatus(v_vm_id uuid, v_snapshot_type character varying, v_status character varying) OWNER TO engineer;

--
-- Name: getsnapshotsbyimagegroupid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getsnapshotsbyimagegroupid(v_image_group_id uuid) RETURNS SETOF images_storage_domain_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM images_storage_domain_view images_storage_domain_view
      WHERE image_group_id = v_image_group_id;
END; $$;


ALTER FUNCTION public.getsnapshotsbyimagegroupid(v_image_group_id uuid) OWNER TO engineer;

--
-- Name: getsnapshotsbystoragedomainid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getsnapshotsbystoragedomainid(v_storage_domain_id uuid) RETURNS SETOF images_storage_domain_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM images_storage_domain_view images_storage_domain_view
      WHERE storage_id = v_storage_domain_id;
END; $$;


ALTER FUNCTION public.getsnapshotsbystoragedomainid(v_storage_domain_id uuid) OWNER TO engineer;

--
-- Name: getsnapshotsbyvmsnapshotid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getsnapshotsbyvmsnapshotid(v_vm_snapshot_id uuid) RETURNS SETOF images_storage_domain_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM images_storage_domain_view images_storage_domain_view
      WHERE vm_snapshot_id = v_vm_snapshot_id;
END; $$;


ALTER FUNCTION public.getsnapshotsbyvmsnapshotid(v_vm_snapshot_id uuid) OWNER TO engineer;

--
-- Name: getstepbystepid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstepbystepid(v_step_id uuid) RETURNS SETOF step
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT step.*
    FROM step
    WHERE step_id = v_step_id;
END; $$;


ALTER FUNCTION public.getstepbystepid(v_step_id uuid) OWNER TO engineer;

--
-- Name: getstepsbyjobid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstepsbyjobid(v_job_id uuid) RETURNS SETOF step
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT step.*
    FROM step
    WHERE job_id = v_job_id
    ORDER BY parent_step_id nulls first, step_number;
END; $$;


ALTER FUNCTION public.getstepsbyjobid(v_job_id uuid) OWNER TO engineer;

--
-- Name: getstepsbyparentstepid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstepsbyparentstepid(v_parent_step_id uuid) RETURNS SETOF step
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT step.*
    FROM step
    WHERE parent_step_id = v_parent_step_id
    ORDER BY step_number;
END; $$;


ALTER FUNCTION public.getstepsbyparentstepid(v_parent_step_id uuid) OWNER TO engineer;

--
-- Name: getstorage_domain_by_id_with_permitted_action(uuid, integer, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domain_by_id_with_permitted_action(v_user_id uuid, v_action_group_id integer, v_storage_id uuid) RETURNS SETOF storage_domains
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domains
   WHERE id = v_storage_id
   AND (SELECT get_entity_permissions(v_user_id, v_action_group_id, id, 11)) IS NOT NULL;

END; $$;


ALTER FUNCTION public.getstorage_domain_by_id_with_permitted_action(v_user_id uuid, v_action_group_id integer, v_storage_id uuid) OWNER TO engineer;

--
-- Name: getstorage_domain_by_type_and_storagepoolid(integer, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domain_by_type_and_storagepoolid(v_storage_domain_type integer, v_storage_pool_id uuid) RETURNS SETOF storage_domains
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domains
   WHERE storage_pool_id = v_storage_pool_id
   AND storage_domain_type = v_storage_domain_type;
END; $$;


ALTER FUNCTION public.getstorage_domain_by_type_and_storagepoolid(v_storage_domain_type integer, v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getstorage_domain_dynamicbyid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domain_dynamicbyid(v_id uuid) RETURNS SETOF storage_domain_dynamic
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domain_dynamic
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.getstorage_domain_dynamicbyid(v_id uuid) OWNER TO engineer;

--
-- Name: getstorage_domain_staticbyid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domain_staticbyid(v_id uuid) RETURNS SETOF storage_domain_static
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domain_static
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.getstorage_domain_staticbyid(v_id uuid) OWNER TO engineer;

--
-- Name: getstorage_domain_staticbyname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domain_staticbyname(v_name character varying) RETURNS SETOF storage_domain_static
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domain_static
   WHERE storage_name = v_name;

END; $$;


ALTER FUNCTION public.getstorage_domain_staticbyname(v_name character varying) OWNER TO engineer;

--
-- Name: getstorage_domain_staticbystorage_pool_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domain_staticbystorage_pool_id(v_storage_pool_id uuid) RETURNS SETOF storage_domain_static_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domain_static_view
   WHERE storage_pool_id = v_storage_pool_id;

END; $$;


ALTER FUNCTION public.getstorage_domain_staticbystorage_pool_id(v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getstorage_domain_staticbystorage_pool_type(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domain_staticbystorage_pool_type(v_storage_pool_type integer) RETURNS SETOF storage_domain_static
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domain_static
   WHERE storage_type = v_storage_pool_type;

END; $$;


ALTER FUNCTION public.getstorage_domain_staticbystorage_pool_type(v_storage_pool_type integer) OWNER TO engineer;

--
-- Name: getstorage_domain_staticbystorage_type_and_storage_pool_id(integer, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domain_staticbystorage_type_and_storage_pool_id(v_storage_type integer, v_storage_pool_id uuid) RETURNS SETOF storage_domains
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domains
   WHERE storage_pool_id = v_storage_pool_id and storage_type = v_storage_type;

END; $$;


ALTER FUNCTION public.getstorage_domain_staticbystorage_type_and_storage_pool_id(v_storage_type integer, v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getstorage_domains_by_connection(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domains_by_connection(v_connection character varying) RETURNS SETOF storage_domains
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domains
   WHERE storage IN (
      SELECT id
      FROM storage_server_connections
      WHERE connection = v_connection);

END; $$;


ALTER FUNCTION public.getstorage_domains_by_connection(v_connection character varying) OWNER TO engineer;

--
-- Name: storage_domains_without_storage_pools; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW storage_domains_without_storage_pools AS
    SELECT DISTINCT storage_domain_static.id, storage_domain_static.storage, storage_domain_static.storage_name, storage_domain_static.storage_type, storage_domain_static.storage_domain_type, storage_domain_static.storage_domain_format_type, storage_domain_static.last_time_used_as_master, NULL::text AS owner, NULL::text AS storage_pool_id, NULL::text AS storage_pool_name, storage_domain_dynamic.available_disk_size, storage_domain_dynamic.used_disk_size, fn_get_disk_commited_value_by_storage(storage_domain_static.id) AS commited_disk_size, NULL::text AS status, fn_get_storage_domain_shared_status_by_domain_id(storage_domain_static.id, storage_pool_iso_map.status, storage_domain_static.storage_domain_type) AS storage_domain_shared_status, storage_domain_static.recoverable FROM ((storage_domain_static JOIN storage_domain_dynamic ON ((storage_domain_static.id = storage_domain_dynamic.id))) LEFT JOIN storage_pool_iso_map ON ((storage_domain_static.id = storage_pool_iso_map.storage_id)));


ALTER TABLE public.storage_domains_without_storage_pools OWNER TO engineer;

--
-- Name: getstorage_domains_by_id(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domains_by_id(v_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF storage_domains_without_storage_pools
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domains_without_storage_pools
   WHERE id = v_id
   AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                     FROM   user_storage_domain_permissions_view
                                     WHERE  user_id = v_user_id AND entity_id = v_id));

END; $$;


ALTER FUNCTION public.getstorage_domains_by_id(v_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getstorage_domains_by_id_and_by_storage_pool_id(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domains_by_id_and_by_storage_pool_id(v_id uuid, v_storage_pool_id uuid) RETURNS SETOF storage_domains
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domains
   WHERE id = v_id and storage_pool_id = v_storage_pool_id;

END; $$;


ALTER FUNCTION public.getstorage_domains_by_id_and_by_storage_pool_id(v_id uuid, v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getstorage_domains_by_storage_pool_id_and_connection(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domains_by_storage_pool_id_and_connection(v_storage_pool_id uuid, v_connection character varying) RETURNS SETOF storage_domains
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domains
   WHERE storage_pool_id = v_storage_pool_id
   AND storage IN (
      SELECT id
      FROM storage_server_connections
      WHERE connection = v_connection);
END; $$;


ALTER FUNCTION public.getstorage_domains_by_storage_pool_id_and_connection(v_storage_pool_id uuid, v_connection character varying) OWNER TO engineer;

--
-- Name: getstorage_domains_by_storage_pool_id_with_permitted_action(uuid, integer, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domains_by_storage_pool_id_with_permitted_action(v_user_id uuid, v_action_group_id integer, v_storage_pool_id uuid) RETURNS SETOF storage_domains
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domains
   WHERE storage_pool_id = v_storage_pool_id
   AND (SELECT get_entity_permissions(v_user_id, v_action_group_id, id, 11)) IS NOT NULL;

END; $$;


ALTER FUNCTION public.getstorage_domains_by_storage_pool_id_with_permitted_action(v_user_id uuid, v_action_group_id integer, v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getstorage_domains_by_storagepoolid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domains_by_storagepoolid(v_storage_pool_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF storage_domains
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domains
   WHERE storage_pool_id = v_storage_pool_id
   AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                     FROM   user_storage_domain_permissions_view
                                     WHERE  user_id = v_user_id AND entity_id = id));



END; $$;


ALTER FUNCTION public.getstorage_domains_by_storagepoolid(v_storage_pool_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getstorage_domains_list_by_imageid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domains_list_by_imageid(v_image_id uuid) RETURNS SETOF storage_domains
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY SELECT *
    FROM storage_domains
    WHERE id in (SELECT storage_domain_id
                 FROM image_storage_domain_map
                 WHERE image_id = v_image_id);
END; $$;


ALTER FUNCTION public.getstorage_domains_list_by_imageid(v_image_id uuid) OWNER TO engineer;

--
-- Name: getstorage_domains_list_by_storagedomainid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_domains_list_by_storagedomainid(v_storage_domain_id uuid) RETURNS SETOF storage_domains
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_domains
   WHERE storage_domains.id = v_storage_domain_id;

END; $$;


ALTER FUNCTION public.getstorage_domains_list_by_storagedomainid(v_storage_domain_id uuid) OWNER TO engineer;

--
-- Name: getstorage_pool_iso_mapbystorage_idandbystorage_pool_id(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_pool_iso_mapbystorage_idandbystorage_pool_id(v_storage_id uuid, v_storage_pool_id uuid) RETURNS SETOF storage_pool_iso_map
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_pool_iso_map
   WHERE storage_id = v_storage_id AND storage_pool_id = v_storage_pool_id;

END; $$;


ALTER FUNCTION public.getstorage_pool_iso_mapbystorage_idandbystorage_pool_id(v_storage_id uuid, v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getstorage_pool_iso_mapsbybystorage_pool_id(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_pool_iso_mapsbybystorage_pool_id(v_storage_id uuid, v_storage_pool_id uuid) RETURNS SETOF storage_pool_iso_map
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_pool_iso_map
   WHERE storage_pool_id = v_storage_pool_id;

END; $$;


ALTER FUNCTION public.getstorage_pool_iso_mapsbybystorage_pool_id(v_storage_id uuid, v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getstorage_pool_iso_mapsbystorage_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_pool_iso_mapsbystorage_id(v_storage_id uuid) RETURNS SETOF storage_pool_iso_map
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_pool_iso_map
   WHERE storage_id = v_storage_id;

END; $$;


ALTER FUNCTION public.getstorage_pool_iso_mapsbystorage_id(v_storage_id uuid) OWNER TO engineer;

--
-- Name: getstorage_poolbyid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_poolbyid(v_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF storage_pool
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_pool
   WHERE id = v_id
   AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                     FROM   user_storage_pool_permissions_view
                                     WHERE  user_id = v_user_id AND entity_id = v_id));



END; $$;


ALTER FUNCTION public.getstorage_poolbyid(v_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getstorage_poolbyname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_poolbyname(v_name character varying) RETURNS SETOF storage_pool
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_pool
   WHERE name = v_name;
END; $$;


ALTER FUNCTION public.getstorage_poolbyname(v_name character varying) OWNER TO engineer;

--
-- Name: getstorage_poolsbystoragedomainid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_poolsbystoragedomainid(v_storage_domain_id uuid) RETURNS SETOF storage_pool
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT storage_pool.*
   FROM storage_pool
   inner join storage_pool_iso_map on storage_pool.id = storage_pool_iso_map.storage_pool_id
   WHERE storage_pool_iso_map.storage_id = v_storage_domain_id;

END; $$;


ALTER FUNCTION public.getstorage_poolsbystoragedomainid(v_storage_domain_id uuid) OWNER TO engineer;

--
-- Name: getstorage_poolsbytype(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_poolsbytype(v_storage_pool_type integer) RETURNS SETOF storage_pool
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_pool
   WHERE storage_pool_type = v_storage_pool_type;
END; $$;


ALTER FUNCTION public.getstorage_poolsbytype(v_storage_pool_type integer) OWNER TO engineer;

--
-- Name: getstorage_poolsbyvdsgroupid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_poolsbyvdsgroupid(v_clusterid uuid) RETURNS SETOF storage_pool
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_pool
   WHERE storage_pool.id in(select storage_pool_id
      FROM vds_groups
      WHERE vds_group_id = v_clusterId);

END; $$;


ALTER FUNCTION public.getstorage_poolsbyvdsgroupid(v_clusterid uuid) OWNER TO engineer;

--
-- Name: getstorage_poolsbyvdsid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_poolsbyvdsid(v_vdsid uuid) RETURNS SETOF storage_pool
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_clusterId  UUID;
BEGIN
select   vds_group_id INTO v_clusterId FROM Vds_static WHERE vds_id = v_vdsId;
   RETURN QUERY SELECT *
   FROM storage_pool
   WHERE storage_pool.id in(select storage_pool_id
      FROM vds_groups
      WHERE vds_group_id = v_clusterId);

END; $$;


ALTER FUNCTION public.getstorage_poolsbyvdsid(v_vdsid uuid) OWNER TO engineer;

--
-- Name: getstorage_server_connectionsbyconnection(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_server_connectionsbyconnection(v_connection character varying) RETURNS SETOF storage_server_connections
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_server_connections
   WHERE connection = v_connection;

END; $$;


ALTER FUNCTION public.getstorage_server_connectionsbyconnection(v_connection character varying) OWNER TO engineer;

--
-- Name: getstorage_server_connectionsbyid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_server_connectionsbyid(v_id character varying) RETURNS SETOF storage_server_connections
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_server_connections
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.getstorage_server_connectionsbyid(v_id character varying) OWNER TO engineer;

--
-- Name: getstorage_server_connectionsbyiqn(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_server_connectionsbyiqn(v_iqn character varying) RETURNS SETOF storage_server_connections
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_server_connections
   WHERE iqn = v_iqn;

END; $$;


ALTER FUNCTION public.getstorage_server_connectionsbyiqn(v_iqn character varying) OWNER TO engineer;

--
-- Name: getstorage_server_connectionsbyiqnandconnection(character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_server_connectionsbyiqnandconnection(v_iqn character varying, v_connection character varying) RETURNS SETOF storage_server_connections
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_server_connections
   WHERE iqn = v_iqn and (connection = v_connection or connection is NULL);

END; $$;


ALTER FUNCTION public.getstorage_server_connectionsbyiqnandconnection(v_iqn character varying, v_connection character varying) OWNER TO engineer;

--
-- Name: getstorage_server_connectionsbykey(character varying, character varying, character varying, character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_server_connectionsbykey(v_iqn character varying, v_connection character varying, v_port character varying, v_portal character varying, v_username character varying, v_password character varying) RETURNS SETOF storage_server_connections
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_server_connections
   WHERE (iqn = v_iqn or iqn is NULL) and
			(connection = v_connection) and
			(port = v_port or port is NULL) and
			(portal = v_portal or portal is NULL) and
			(user_name = v_username or user_name is NULL) and
			(password = v_password or password is NULL);

END; $$;


ALTER FUNCTION public.getstorage_server_connectionsbykey(v_iqn character varying, v_connection character varying, v_port character varying, v_portal character varying, v_username character varying, v_password character varying) OWNER TO engineer;

--
-- Name: getstorage_server_connectionsbylunid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_server_connectionsbylunid(v_lunid character varying) RETURNS SETOF storage_server_connections
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT storage_server_connections.*
   FROM  storage_server_connections storage_server_connections
   INNER JOIN lun_storage_server_connection_map ON
   lun_storage_server_connection_map.storage_server_connection = storage_server_connections.id
   WHERE     (lun_storage_server_connection_map.lun_id = v_lunId);
END; $$;


ALTER FUNCTION public.getstorage_server_connectionsbylunid(v_lunid character varying) OWNER TO engineer;

--
-- Name: getstorage_server_connectionsbystoragetype(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_server_connectionsbystoragetype(v_storage_type integer) RETURNS SETOF storage_server_connections
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM storage_server_connections
   WHERE storage_type = v_storage_type;

END; $$;


ALTER FUNCTION public.getstorage_server_connectionsbystoragetype(v_storage_type integer) OWNER TO engineer;

--
-- Name: getstorage_server_connectionsbyvolumegroupid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstorage_server_connectionsbyvolumegroupid(v_volume_group_id character varying) RETURNS SETOF storage_server_connections
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT storage_server_connections.*
   FROM
   LUN_storage_server_connection_map  LUN_storage_server_connection_map
   INNER JOIN
   LUNs ON LUN_storage_server_connection_map.LUN_id = LUNs.LUN_id INNER JOIN
   storage_domain_static ON LUNs.volume_group_id = storage_domain_static.storage INNER JOIN
   storage_server_connections ON
   LUN_storage_server_connection_map.storage_server_connection = storage_server_connections.id
   WHERE     (storage_domain_static.storage = v_volume_group_id);
END; $$;


ALTER FUNCTION public.getstorage_server_connectionsbyvolumegroupid(v_volume_group_id character varying) OWNER TO engineer;

--
-- Name: getstoragedomainidsbystoragepoolidandstatus(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstoragedomainidsbystoragepoolidandstatus(v_storage_pool_id uuid, v_status integer) RETURNS SETOF getstoragedomainidsbystoragepoolidandstatus_rs
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY
   SELECT storage_id
   FROM   storage_pool_iso_map
   WHERE  storage_pool_id = v_storage_pool_id
   AND    status = v_status;

END; $$;


ALTER FUNCTION public.getstoragedomainidsbystoragepoolidandstatus(v_storage_pool_id uuid, v_status integer) OWNER TO engineer;

--
-- Name: getstoragepoolsbyclusterservice(boolean, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getstoragepoolsbyclusterservice(v_supports_virt_service boolean, v_supports_gluster_service boolean) RETURNS SETOF storage_pool
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT sp.* FROM storage_pool SP
   WHERE EXISTS (SELECT 1 FROM vds_groups vg
       WHERE ((v_supports_virt_service = TRUE AND vg.virt_service = TRUE) OR
              (v_supports_gluster_service = TRUE AND vg.gluster_service = TRUE)) AND vg.storage_pool_id = sp.id);
END; $$;


ALTER FUNCTION public.getstoragepoolsbyclusterservice(v_supports_virt_service boolean, v_supports_gluster_service boolean) OWNER TO engineer;

--
-- Name: getsystem_statistics(character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getsystem_statistics(v_entity character varying, v_status character varying) RETURNS getsystem_statistics_rs
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_i Getsystem_statistics_rs;
   v_sql  VARCHAR(4000);
   v_sys_entity VARCHAR(10);
BEGIN
   v_sys_entity := v_entity;
   v_sql := NULL;

   v_sys_entity := upper(v_sys_entity);
   if (v_sys_entity = 'VM') then
      v_sql := 'select count(vm_guid) from vm_dynamic';
   else
      if (v_sys_entity = 'HOST') then
         v_sql := 'select count(vds_id)  from vds_dynamic';
      else
         if (v_sys_entity = 'USER') then
            v_sql := 'select count(user_id) from users';
         else
            if (v_sys_entity = 'TSD') then
               v_sql := 'select count(id) from storage_domain_static';
            else
               if (v_sys_entity = 'ASD') then
                  v_sql := 'select count(storage_id) from storage_pool_iso_map';
               end if;
            end if;
         end if;
      end if;
   end if;

   if (v_status != '' and v_sys_entity != 'TSD') then
      v_sql := coalesce(v_sql,'') || ' where status in (' || coalesce(v_status,'') || ')';
   end if;
   EXECUTE v_sql INTO v_i;
   RETURN v_i;
END; $$;


ALTER FUNCTION public.getsystem_statistics(v_entity character varying, v_status character varying) OWNER TO engineer;

--
-- Name: tags_user_group_map_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW tags_user_group_map_view AS
    SELECT tags.tag_id, tags.tag_name, tags.parent_id, tags.readonly, tags.type, tags_user_group_map.group_id FROM (tags_user_group_map JOIN tags ON ((tags_user_group_map.tag_id = tags.tag_id)));


ALTER TABLE public.tags_user_group_map_view OWNER TO engineer;

--
-- Name: gettags_user_group_mapbytagname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettags_user_group_mapbytagname(v_tag_name character varying) RETURNS SETOF tags_user_group_map_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags_user_group_map_view.*
      FROM tags_user_group_map_view
      WHERE tag_name = v_tag_name;
END; $$;


ALTER FUNCTION public.gettags_user_group_mapbytagname(v_tag_name character varying) OWNER TO engineer;

--
-- Name: tags_user_map_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW tags_user_map_view AS
    SELECT tags.tag_id, tags.tag_name, tags.parent_id, tags.readonly, tags.type, tags_user_map.user_id FROM (tags JOIN tags_user_map ON ((tags.tag_id = tags_user_map.tag_id)));


ALTER TABLE public.tags_user_map_view OWNER TO engineer;

--
-- Name: gettags_user_mapbytagname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettags_user_mapbytagname(v_tag_name character varying) RETURNS SETOF tags_user_map_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags_user_map_view.*
      FROM tags_user_map_view
      WHERE tag_name = v_tag_name;
END; $$;


ALTER FUNCTION public.gettags_user_mapbytagname(v_tag_name character varying) OWNER TO engineer;

--
-- Name: tags_vds_map_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW tags_vds_map_view AS
    SELECT tags.tag_id, tags.tag_name, tags.parent_id, tags.readonly, tags.type, tags_vds_map.vds_id FROM (tags JOIN tags_vds_map ON ((tags.tag_id = tags_vds_map.tag_id)));


ALTER TABLE public.tags_vds_map_view OWNER TO engineer;

--
-- Name: gettags_vds_mapbytagname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettags_vds_mapbytagname(v_tag_name character varying) RETURNS SETOF tags_vds_map_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags_vds_map_view.*
      FROM tags_vds_map_view
      WHERE tag_name = v_tag_name;
END; $$;


ALTER FUNCTION public.gettags_vds_mapbytagname(v_tag_name character varying) OWNER TO engineer;

--
-- Name: tags_vm_map_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW tags_vm_map_view AS
    SELECT tags.tag_id, tags.tag_name, tags.parent_id, tags.readonly, tags.type, tags_vm_map.vm_id FROM (tags JOIN tags_vm_map ON ((tags.tag_id = tags_vm_map.tag_id)));


ALTER TABLE public.tags_vm_map_view OWNER TO engineer;

--
-- Name: gettags_vm_mapbytagname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettags_vm_mapbytagname(v_tag_name character varying) RETURNS SETOF tags_vm_map_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags_vm_map_view.*
      FROM tags_vm_map_view
      WHERE tag_name = v_tag_name;
END; $$;


ALTER FUNCTION public.gettags_vm_mapbytagname(v_tag_name character varying) OWNER TO engineer;

--
-- Name: gettags_vm_pool_mapbytag_idandbyvm_pool_id(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettags_vm_pool_mapbytag_idandbyvm_pool_id(v_tag_id uuid, v_vm_pool_id uuid) RETURNS SETOF tags_vm_pool_map
    LANGUAGE plpgsql
    AS $$
BEGIN

   RETURN QUERY SELECT tags_vm_pool_map.*
   FROM tags_vm_pool_map
   WHERE tag_id = v_tag_id AND vm_pool_id = v_vm_pool_id;

END; $$;


ALTER FUNCTION public.gettags_vm_pool_mapbytag_idandbyvm_pool_id(v_tag_id uuid, v_vm_pool_id uuid) OWNER TO engineer;

--
-- Name: gettagsbyparent_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettagsbyparent_id(v_parent_id uuid) RETURNS SETOF tags
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags.*
      FROM tags
      WHERE parent_id = v_parent_id;
END; $$;


ALTER FUNCTION public.gettagsbyparent_id(v_parent_id uuid) OWNER TO engineer;

--
-- Name: gettagsbytag_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettagsbytag_id(v_tag_id uuid) RETURNS SETOF tags
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags.*
      FROM tags
      WHERE tag_id = v_tag_id;
END; $$;


ALTER FUNCTION public.gettagsbytag_id(v_tag_id uuid) OWNER TO engineer;

--
-- Name: gettagsbytag_name(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettagsbytag_name(v_tag_name character varying) RETURNS SETOF tags
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags.*
      FROM tags
      WHERE tag_name = v_tag_name;
END; $$;


ALTER FUNCTION public.gettagsbytag_name(v_tag_name character varying) OWNER TO engineer;

--
-- Name: gettagsbyusergroupid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettagsbyusergroupid(v_group_ids character varying) RETURNS SETOF tags_user_group_map_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT tags_user_group_map_view.*
      FROM tags_user_group_map_view
      WHERE group_id in(select * from fnSplitterUuid(v_group_ids));
END; $$;


ALTER FUNCTION public.gettagsbyusergroupid(v_group_ids character varying) OWNER TO engineer;

--
-- Name: gettagsbyuserid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettagsbyuserid(v_user_ids character varying) RETURNS SETOF tags_user_map_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT tags_user_map_view.*
      FROM tags_user_map_view
      WHERE user_id in(select * from fnSplitterUuid(v_user_ids));
END; $$;


ALTER FUNCTION public.gettagsbyuserid(v_user_ids character varying) OWNER TO engineer;

--
-- Name: gettagsbyvdsid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettagsbyvdsid(v_vds_ids character varying) RETURNS SETOF tags_vds_map_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT tags_vds_map_view.*
      FROM tags_vds_map_view
      WHERE vds_id in(select * from fnSplitterUuid(v_vds_ids));
END; $$;


ALTER FUNCTION public.gettagsbyvdsid(v_vds_ids character varying) OWNER TO engineer;

--
-- Name: gettagsbyvmid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettagsbyvmid(v_vm_ids character varying) RETURNS SETOF tags_vm_map_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT tags_vm_map_view.*
      FROM tags_vm_map_view
      WHERE vm_id in(select * from fnSplitterUuid(v_vm_ids));
END; $$;


ALTER FUNCTION public.gettagsbyvmid(v_vm_ids character varying) OWNER TO engineer;

--
-- Name: tags_vm_pool_map_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW tags_vm_pool_map_view AS
    SELECT tags.tag_id, tags.tag_name, tags.parent_id, tags.readonly, tags.type, tags_vm_pool_map.vm_pool_id FROM (tags JOIN tags_vm_pool_map ON ((tags.tag_id = tags_vm_pool_map.tag_id)));


ALTER TABLE public.tags_vm_pool_map_view OWNER TO engineer;

--
-- Name: gettagsbyvmpoolid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettagsbyvmpoolid(v_vm_pool_ids character varying) RETURNS SETOF tags_vm_pool_map_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT tags_vm_pool_map_view.*
      FROM tags_vm_pool_map_view
      WHERE vm_pool_id in(select * from fnSplitterUuid(v_vm_pool_ids));
END; $$;


ALTER FUNCTION public.gettagsbyvmpoolid(v_vm_pool_ids character varying) OWNER TO engineer;

--
-- Name: gettaguserbytagidandbyuserid(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettaguserbytagidandbyuserid(v_tag_id uuid, v_user_id uuid) RETURNS SETOF tags_user_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags_user_map.*
      FROM tags_user_map
      WHERE tag_id = v_tag_id AND user_id = v_user_id;
END; $$;


ALTER FUNCTION public.gettaguserbytagidandbyuserid(v_tag_id uuid, v_user_id uuid) OWNER TO engineer;

--
-- Name: gettagusergroupbygroupidandbytagid(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettagusergroupbygroupidandbytagid(v_group_id uuid, v_tag_id uuid) RETURNS SETOF tags_user_group_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags_user_group_map.*
      FROM tags_user_group_map
      WHERE group_id = v_group_id AND tag_id = v_tag_id;
END; $$;


ALTER FUNCTION public.gettagusergroupbygroupidandbytagid(v_group_id uuid, v_tag_id uuid) OWNER TO engineer;

--
-- Name: gettagvdsbytagidandbyvdsid(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettagvdsbytagidandbyvdsid(v_tag_id uuid, v_vds_id uuid) RETURNS SETOF tags_vds_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags_vds_map.*
      FROM tags_vds_map
      WHERE tag_id = v_tag_id AND vds_id = v_vds_id;
END; $$;


ALTER FUNCTION public.gettagvdsbytagidandbyvdsid(v_tag_id uuid, v_vds_id uuid) OWNER TO engineer;

--
-- Name: gettagvmbytagidandbyvmid(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettagvmbytagidandbyvmid(v_tag_id uuid, v_vm_id uuid) RETURNS SETOF tags_vm_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT tags_vm_map.*
      FROM tags_vm_map
      WHERE tag_id = v_tag_id AND vm_id = v_vm_id;
END; $$;


ALTER FUNCTION public.gettagvmbytagidandbyvmid(v_tag_id uuid, v_vm_id uuid) OWNER TO engineer;

--
-- Name: gettimeleasedusersvmsbygroupidandpoolid(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettimeleasedusersvmsbygroupidandpoolid(v_groupid uuid, v_vm_pool_id uuid) RETURNS SETOF tags_vm_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY select tags_vm_map.* from tags_vm_map
      inner join vm_pool_map on vm_pool_map.vm_guid = tags_vm_map.vm_id
      inner join tags_permissions_map on tags_permissions_map.tag_id = tags_vm_map.tag_id
      inner join permissions on permissions.id = tags_permissions_map.permission_id
      where permissions.ad_element_id
      in(select users.user_id from users
         where (users.groups LIKE '%' ||(select ad_groups.name from ad_groups where ad_groups.id = v_groupId)
         || '%'))
      and
      vm_pool_map.vm_pool_id = v_vm_pool_id;
END; $$;


ALTER FUNCTION public.gettimeleasedusersvmsbygroupidandpoolid(v_groupid uuid, v_vm_pool_id uuid) OWNER TO engineer;

--
-- Name: gluster_volume_transport_types; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE gluster_volume_transport_types (
    volume_id uuid NOT NULL,
    transport_type character varying(32) NOT NULL
);


ALTER TABLE public.gluster_volume_transport_types OWNER TO engineer;

--
-- Name: gettransporttypesbyglustervolumeguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION gettransporttypesbyglustervolumeguid(v_volume_id uuid) RETURNS SETOF gluster_volume_transport_types
    LANGUAGE plpgsql
    AS $$
BEGIN
       RETURN QUERY SELECT *
       FROM  gluster_volume_transport_types
       WHERE volume_id = v_volume_id;
END; $$;


ALTER FUNCTION public.gettransporttypesbyglustervolumeguid(v_volume_id uuid) OWNER TO engineer;

--
-- Name: getupandprioritizedvds(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getupandprioritizedvds(v_storage_pool_id uuid) RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
BEGIN
BEGIN
      RETURN QUERY SELECT vds.*
      FROM vds vds, vds_groups vdsgroup
      WHERE (vds.status = 3) AND (vds.storage_pool_id = v_storage_pool_id) AND (vds_spm_priority IS NULL OR vds_spm_priority > -1)
      AND vds.vds_group_id = vdsgroup.vds_group_id AND vdsgroup.virt_service = true
      ORDER BY vds_spm_priority DESC, RANDOM();
   END;
   RETURN;
END; $$;


ALTER FUNCTION public.getupandprioritizedvds(v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getuser_sessionsbysession_idandbyuser_id(character, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getuser_sessionsbysession_idandbyuser_id(v_session_id character, v_user_id uuid) RETURNS SETOF user_sessions
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT user_sessions.*
      FROM user_sessions
      WHERE session_id = v_session_id AND user_id = v_user_id;
END; $$;


ALTER FUNCTION public.getuser_sessionsbysession_idandbyuser_id(v_session_id character, v_user_id uuid) OWNER TO engineer;

--
-- Name: getuserandgroupsbyid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getuserandgroupsbyid(v_id uuid) RETURNS SETOF iduuidtype
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY
   select ID from ad_groups,users where users.user_id = v_id
   and ad_groups.id in(select * from fnsplitteruuid(users.group_ids))
   UNION
   select v_id
   UNION
   -- user is also member of 'Everyone'
   select 'EEE00000-0000-0000-0000-123456789EEE';
END; $$;


ALTER FUNCTION public.getuserandgroupsbyid(v_id uuid) OWNER TO engineer;

--
-- Name: getuserbyuserid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getuserbyuserid(v_user_id uuid) RETURNS SETOF users
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT users.*
      FROM users
      WHERE user_id = v_user_id;
END; $$;


ALTER FUNCTION public.getuserbyuserid(v_user_id uuid) OWNER TO engineer;

--
-- Name: getuserbyusername(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getuserbyusername(v_username character varying) RETURNS SETOF users
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT users.*
      FROM users
      WHERE username = v_username;
END; $$;


ALTER FUNCTION public.getuserbyusername(v_username character varying) OWNER TO engineer;

--
-- Name: getusergrouptagsbytagids(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getusergrouptagsbytagids(v_tag_ids character varying) RETURNS SETOF tags_user_group_map_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT tags_user_group_map_view.*
      FROM tags_user_group_map_view
      WHERE tag_id in(select * from fnSplitterUuid(v_tag_ids));
END; $$;


ALTER FUNCTION public.getusergrouptagsbytagids(v_tag_ids character varying) OWNER TO engineer;

--
-- Name: getuserpermissionsbyentityid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getuserpermissionsbyentityid(v_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF permissions_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM permissions_view p
   WHERE object_id = v_id
   AND   (NOT v_is_filtered OR EXISTS (SELECT 1
                                       FROM   user_flat_groups u
                                       WHERE  p.ad_element_id = u.granted_id
                                       AND    u.user_id       = v_user_id));
END; $$;


ALTER FUNCTION public.getuserpermissionsbyentityid(v_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getusersbyvmguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getusersbyvmguid(v_vm_guid uuid) RETURNS SETOF users
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT users.*
      FROM users
      inner join permissions
      on users.user_id = permissions.ad_element_id
      WHERE permissions.object_type_id = 2
      and	permissions.object_id = v_vm_guid;
END; $$;


ALTER FUNCTION public.getusersbyvmguid(v_vm_guid uuid) OWNER TO engineer;

--
-- Name: getusertagsbytagids(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getusertagsbytagids(v_tag_ids character varying) RETURNS SETOF tags_user_map_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT tags_user_map_view.*
      FROM tags_user_map_view
      WHERE tag_id in(select * from fnSplitterUuid(v_tag_ids));
END; $$;


ALTER FUNCTION public.getusertagsbytagids(v_tag_ids character varying) OWNER TO engineer;

--
-- Name: getvdcoptionbyid(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdcoptionbyid(v_option_id integer) RETURNS SETOF vdc_options
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vdc_options.*
      FROM vdc_options
      WHERE option_id = v_option_id;
END; $$;


ALTER FUNCTION public.getvdcoptionbyid(v_option_id integer) OWNER TO engineer;

--
-- Name: getvdcoptionbyname(character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdcoptionbyname(v_option_name character varying, v_version character varying) RETURNS SETOF vdc_options
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vdc_options.*
      FROM vdc_options
      WHERE OPTION_NAME = v_option_name and version = v_version;
END; $$;


ALTER FUNCTION public.getvdcoptionbyname(v_option_name character varying, v_version character varying) OWNER TO engineer;

--
-- Name: getvds_spm_id_mapbystorage_pool_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvds_spm_id_mapbystorage_pool_id(v_storage_pool_id uuid) RETURNS SETOF vds_spm_id_map
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vds_spm_id_map.*
   FROM vds_spm_id_map
   WHERE storage_pool_id = v_storage_pool_id;

END; $$;


ALTER FUNCTION public.getvds_spm_id_mapbystorage_pool_id(v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getvds_spm_id_mapbystorage_pool_idandbyvds_spm_id(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvds_spm_id_mapbystorage_pool_idandbyvds_spm_id(v_storage_pool_id uuid, v_vds_spm_id integer) RETURNS SETOF vds_spm_id_map
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vds_spm_id_map.*
   FROM vds_spm_id_map
   WHERE storage_pool_id = v_storage_pool_id AND vds_spm_id = v_vds_spm_id;

END; $$;


ALTER FUNCTION public.getvds_spm_id_mapbystorage_pool_idandbyvds_spm_id(v_storage_pool_id uuid, v_vds_spm_id integer) OWNER TO engineer;

--
-- Name: getvds_spm_id_mapbyvds_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvds_spm_id_mapbyvds_id(v_vds_id uuid) RETURNS SETOF vds_spm_id_map
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vds_spm_id_map.*
   FROM vds_spm_id_map
   WHERE vds_id = v_vds_id;

END; $$;


ALTER FUNCTION public.getvds_spm_id_mapbyvds_id(v_vds_id uuid) OWNER TO engineer;

--
-- Name: getvdsbyhostname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsbyhostname(v_host_name character varying) RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
BEGIN
BEGIN
      RETURN QUERY SELECT DISTINCT vds.*
      FROM vds
      WHERE host_name = v_host_name;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.getvdsbyhostname(v_host_name character varying) OWNER TO engineer;

--
-- Name: getvdsbyip(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsbyip(v_ip character varying) RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
BEGIN
BEGIN
      RETURN QUERY SELECT DISTINCT vds.*
      FROM vds
      WHERE ip = v_ip;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.getvdsbyip(v_ip character varying) OWNER TO engineer;

--
-- Name: getvdsbyname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsbyname(v_vds_name character varying) RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
BEGIN
BEGIN
      RETURN QUERY SELECT DISTINCT vds.*
      FROM vds
      WHERE vds_name = v_vds_name;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.getvdsbyname(v_vds_name character varying) OWNER TO engineer;

--
-- Name: getvdsbynetworkid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsbynetworkid(v_network_id uuid) RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM vds
   WHERE EXISTS (
      SELECT 1
      FROM vds_interface
      INNER JOIN network
      ON network.name = vds_interface.network_name
      INNER JOIN network_cluster
      ON network.id = network_cluster.network_id
      WHERE network_id = v_network_id
      AND vds.vds_group_id = network_cluster.cluster_id
      AND vds_interface.vds_id = vds.vds_id);
END; $$;


ALTER FUNCTION public.getvdsbynetworkid(v_network_id uuid) OWNER TO engineer;

--
-- Name: getvdsbystoragepoolid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsbystoragepoolid(v_storage_pool_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
BEGIN
   BEGIN
      RETURN QUERY SELECT DISTINCT vds.*
      FROM   vds
      WHERE  storage_pool_id = v_storage_pool_id
      AND    (NOT v_is_filtered OR EXISTS (SELECT 1
                                           FROM   user_vds_permissions_view
                                           WHERE  user_id = v_user_id AND entity_id = vds_id));
   END;
   RETURN;
END; $$;


ALTER FUNCTION public.getvdsbystoragepoolid(v_storage_pool_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvdsbystoragepoolidwithstatus(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsbystoragepoolidwithstatus(v_storage_pool_id uuid, v_status integer) RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
BEGIN
    BEGIN
        RETURN QUERY SELECT vds.*
        FROM vds
        WHERE (status = v_status) AND (storage_pool_id = v_storage_pool_id);
    END;
    RETURN;
END; $$;


ALTER FUNCTION public.getvdsbystoragepoolidwithstatus(v_storage_pool_id uuid, v_status integer) OWNER TO engineer;

--
-- Name: getvdsbytype(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsbytype(v_vds_type integer) RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
BEGIN
BEGIN
      RETURN QUERY SELECT DISTINCT vds.*
      FROM vds
      WHERE vds_type = v_vds_type;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.getvdsbytype(v_vds_type integer) OWNER TO engineer;

--
-- Name: getvdsbyuniqueid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsbyuniqueid(v_vds_unique_id character varying) RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
BEGIN
BEGIN
      RETURN QUERY SELECT DISTINCT vds.*
      FROM vds
      WHERE vds_unique_id = v_vds_unique_id;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.getvdsbyuniqueid(v_vds_unique_id character varying) OWNER TO engineer;

--
-- Name: getvdsbyvdsgroupid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsbyvdsgroupid(v_vds_group_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
BEGIN
	-- this sp returns all vds for a given cluster
   BEGIN
      if (v_is_filtered) then
          RETURN QUERY SELECT DISTINCT (rec).*
          FROM fn_db_mask_object('vds') as q (rec vds)
          WHERE (rec).vds_group_id = v_vds_group_id
          AND EXISTS (SELECT 1
              FROM   user_vds_permissions_view
              WHERE  user_id = v_user_id AND entity_id = (rec).vds_id);
      else
          RETURN QUERY SELECT DISTINCT vds.*
          FROM vds
          WHERE vds_group_id = v_vds_group_id;
      end if;
    END;
    RETURN;
END; $$;


ALTER FUNCTION public.getvdsbyvdsgroupid(v_vds_group_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvdsbyvdsid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsbyvdsid(v_vds_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
DECLARE
v_columns text[];
BEGIN
    BEGIN
      if (v_is_filtered) then
          RETURN QUERY SELECT DISTINCT (rec).*
          FROM fn_db_mask_object('vds') as q (rec vds)
          WHERE (rec).vds_id = v_vds_id
          AND EXISTS (SELECT 1
              FROM   user_vds_permissions_view
              WHERE  user_id = v_user_id AND entity_id = v_vds_id);
      else
          RETURN QUERY SELECT DISTINCT vds.*
          FROM vds
          WHERE vds_id = v_vds_id;
      end if;
    END;

   RETURN;
END; $$;


ALTER FUNCTION public.getvdsbyvdsid(v_vds_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvdsdynamicbyvdsid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsdynamicbyvdsid(v_vds_id uuid) RETURNS SETOF vds_dynamic
    LANGUAGE plpgsql
    AS $$
BEGIN
BEGIN
      RETURN QUERY SELECT vds_dynamic.*
      FROM vds_dynamic
      WHERE vds_id = v_vds_id;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.getvdsdynamicbyvdsid(v_vds_id uuid) OWNER TO engineer;

--
-- Name: getvdsforvdsgroupwithstatus(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsforvdsgroupwithstatus(v_vds_group_id uuid, v_status integer) RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
BEGIN
    BEGIN
        RETURN QUERY SELECT vds.*
        FROM vds
        WHERE (status = v_status) AND (vds_group_id = v_vds_group_id);
    END;
    RETURN;
END; $$;


ALTER FUNCTION public.getvdsforvdsgroupwithstatus(v_vds_group_id uuid, v_status integer) OWNER TO engineer;

--
-- Name: getvdsgroupbyvdsgroupid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsgroupbyvdsgroupid(v_vds_group_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vds_groups_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vds_groups_view.*
      FROM vds_groups_view
      WHERE vds_group_id = v_vds_group_id
      AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                        FROM   user_vds_groups_permissions_view
                                        WHERE  user_id = v_user_id AND entity_id = v_vds_group_id));

END; $$;


ALTER FUNCTION public.getvdsgroupbyvdsgroupid(v_vds_group_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvdsgroupbyvdsgroupname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsgroupbyvdsgroupname(v_vds_group_name character varying) RETURNS SETOF vds_groups_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vds_groups_view.*
      FROM vds_groups_view
      WHERE name = v_vds_group_name;
END; $$;


ALTER FUNCTION public.getvdsgroupbyvdsgroupname(v_vds_group_name character varying) OWNER TO engineer;

--
-- Name: getvdsgroupforuserbyvdsgroupname(character varying, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsgroupforuserbyvdsgroupname(v_vds_group_name character varying, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vds_groups_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vds_groups_view.*
      FROM vds_groups_view
      WHERE name = v_vds_group_name
      AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                        FROM   user_vds_groups_permissions_view
                                        WHERE  user_id = v_user_id AND entity_id = vds_group_id));
END; $$;


ALTER FUNCTION public.getvdsgroupforuserbyvdsgroupname(v_vds_group_name character varying, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvdsgroupsbystoragepoolid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsgroupsbystoragepoolid(v_storage_pool_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vds_groups_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vds_groups_view.*
      FROM vds_groups_view
      WHERE storage_pool_id = v_storage_pool_id
      AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                        FROM   user_vds_groups_permissions_view
                                        WHERE  user_id = v_user_id AND entity_id = vds_group_id));
END; $$;


ALTER FUNCTION public.getvdsgroupsbystoragepoolid(v_storage_pool_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvdsgroupwithrunningvms(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsgroupwithrunningvms(v_vds_group_id uuid) RETURNS SETOF vds_groups_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vds_groups_view.*
      FROM vds_groups_view
      WHERE vds_group_id = v_vds_group_id and vds_group_id in(select vds_group_id from vms where vms.status NOT IN(0,13,14));
END; $$;


ALTER FUNCTION public.getvdsgroupwithrunningvms(v_vds_group_id uuid) OWNER TO engineer;

--
-- Name: getvdsinterfacebyid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsinterfacebyid(v_vds_interface_id uuid) RETURNS SETOF vds_interface_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM vds_interface_view
   WHERE id = v_vds_interface_id;
END; $$;


ALTER FUNCTION public.getvdsinterfacebyid(v_vds_interface_id uuid) OWNER TO engineer;

--
-- Name: getvdsinterfacesbynetworkid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsinterfacesbynetworkid(v_network_id uuid) RETURNS SETOF vds_interface_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT vds_interface_view.*
   FROM vds_interface_view
   INNER JOIN vds
   ON vds.vds_id = vds_interface_view.vds_id
   INNER JOIN network_cluster
   ON network_cluster.cluster_id = vds.vds_group_id
   INNER JOIN network
   ON network.id = network_cluster.network_id
   AND network.name = vds_interface_view.network_name
   WHERE network.id = v_network_id;
END; $$;


ALTER FUNCTION public.getvdsinterfacesbynetworkid(v_network_id uuid) OWNER TO engineer;

--
-- Name: getvdsmanagedinterfacebyvdsid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsmanagedinterfacebyvdsid(v_vds_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vds_interface_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM vds_interface_view
   -- Checking if the 2nd bit in the type column is set, meaning that the interface is managed
   WHERE vds_id = v_vds_id AND (type & 2) = 2
   AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                     FROM   user_vds_permissions_view
                                     WHERE  user_id = v_user_id AND entity_id = v_vds_id));

END; $$;


ALTER FUNCTION public.getvdsmanagedinterfacebyvdsid(v_vds_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvdsstaticbyhostname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsstaticbyhostname(v_host_name character varying) RETURNS SETOF vds_static
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vds_static.*
   FROM vds_static
   WHERE host_name = v_host_name;

   RETURN;
END; $$;


ALTER FUNCTION public.getvdsstaticbyhostname(v_host_name character varying) OWNER TO engineer;

--
-- Name: getvdsstaticbyip(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsstaticbyip(v_ip character varying) RETURNS SETOF vds_static
    LANGUAGE plpgsql
    AS $$
BEGIN
BEGIN
      RETURN QUERY SELECT vds_static.*
      FROM vds_static
      WHERE ip = v_ip;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.getvdsstaticbyip(v_ip character varying) OWNER TO engineer;

--
-- Name: getvdsstaticbyvdsgroupid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsstaticbyvdsgroupid(v_vds_group_id uuid) RETURNS SETOF vds_static
    LANGUAGE plpgsql
    AS $$
BEGIN
BEGIN
      RETURN QUERY SELECT vds_static.*
      FROM vds_static vds_static
      WHERE vds_group_id = v_vds_group_id;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.getvdsstaticbyvdsgroupid(v_vds_group_id uuid) OWNER TO engineer;

--
-- Name: getvdsstaticbyvdsid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsstaticbyvdsid(v_vds_id uuid) RETURNS SETOF vds_static
    LANGUAGE plpgsql
    AS $$
BEGIN
BEGIN
      RETURN QUERY SELECT vds_static.*
      FROM vds_static
      WHERE vds_id = v_vds_id;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.getvdsstaticbyvdsid(v_vds_id uuid) OWNER TO engineer;

--
-- Name: getvdsstaticbyvdsname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsstaticbyvdsname(v_vds_name character varying) RETURNS SETOF vds_static
    LANGUAGE plpgsql
    AS $$
BEGIN
BEGIN
      RETURN QUERY SELECT vds_static.*
      FROM vds_static
      WHERE vds_name = v_vds_name;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.getvdsstaticbyvdsname(v_vds_name character varying) OWNER TO engineer;

--
-- Name: getvdsstatisticsbyvdsid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdsstatisticsbyvdsid(v_vds_id uuid) RETURNS SETOF vds_statistics
    LANGUAGE plpgsql
    AS $$
BEGIN
BEGIN
      RETURN QUERY SELECT vds_statistics.*
      FROM vds_statistics
      WHERE vds_id = v_vds_id;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.getvdsstatisticsbyvdsid(v_vds_id uuid) OWNER TO engineer;

--
-- Name: getvdstagsbytagids(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdstagsbytagids(v_tag_ids character varying) RETURNS SETOF tags_vds_map_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT tags_vds_map_view.*
      FROM tags_vds_map_view
      WHERE tag_id in(select * from fnSplitterUuid(v_tag_ids));
END; $$;


ALTER FUNCTION public.getvdstagsbytagids(v_tag_ids character varying) OWNER TO engineer;

--
-- Name: getvdswithoutmigratingvmsbyvdsgroupid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdswithoutmigratingvmsbyvdsgroupid(v_vds_group_id uuid) RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
BEGIN


	-- this sp returns all vds in given cluster that have no pending vms and no vms in migration states
	BEGIN
      RETURN QUERY SELECT DISTINCT vds.*
      FROM vds
      WHERE vds_group_id = v_vds_group_id and
      pending_vcpus_count = 0
      and	vds.status = 3
      and	vds_id not in(select distinct RUN_ON_VDS from vm_dynamic
         where status in(5,6,11,12));
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.getvdswithoutmigratingvmsbyvdsgroupid(v_vds_group_id uuid) OWNER TO engineer;

--
-- Name: getvdswithoutnetwork(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvdswithoutnetwork(v_network_id uuid) RETURNS SETOF vds
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT vds.*
   FROM vds
   INNER JOIN network_cluster
   ON vds.vds_group_id = network_cluster.cluster_id
   WHERE network_cluster.network_id = v_network_id
   AND NOT EXISTS (
      SELECT 1
      FROM vds_interface
      INNER JOIN network
      ON network.name = vds_interface.network_name
      INNER JOIN network_cluster
      ON network.id = network_cluster.network_id
      WHERE network_cluster.network_id = v_network_id
      AND vds.vds_group_id = network_cluster.cluster_id
      AND vds_interface.vds_id = vds.vds_id);
END; $$;


ALTER FUNCTION public.getvdswithoutnetwork(v_network_id uuid) OWNER TO engineer;

--
-- Name: getvm_interface_statisticsbyid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvm_interface_statisticsbyid(v_id uuid) RETURNS SETOF vm_interface_statistics
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT *
   FROM vm_interface_statistics
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.getvm_interface_statisticsbyid(v_id uuid) OWNER TO engineer;

--
-- Name: getvm_interfacebyid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvm_interfacebyid(v_id uuid) RETURNS SETOF vm_interface_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM vm_interface_view
   WHERE id = v_id;

END; $$;


ALTER FUNCTION public.getvm_interfacebyid(v_id uuid) OWNER TO engineer;

--
-- Name: getvm_interfacebytemplate_id(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvm_interfacebytemplate_id(v_template_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vm_interface_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM vm_interface_view
   WHERE vmt_guid = v_template_id
   AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                     FROM   user_vm_template_permissions_view
                                     WHERE  user_id = v_user_id AND entity_id = v_template_id));

END; $$;


ALTER FUNCTION public.getvm_interfacebytemplate_id(v_template_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvm_interfacebyvm_guidandbyvmt_guid(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvm_interfacebyvm_guidandbyvmt_guid(v_vm_guid uuid, v_vmt_guid uuid) RETURNS SETOF vm_interface
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM vm_interface
   WHERE VM_GUID = v_vm_guid AND VMT_GUID = v_vmt_guid;

END; $$;


ALTER FUNCTION public.getvm_interfacebyvm_guidandbyvmt_guid(v_vm_guid uuid, v_vmt_guid uuid) OWNER TO engineer;

--
-- Name: getvm_interfacebyvm_id(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvm_interfacebyvm_id(v_vm_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vm_interface_view
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT *
   FROM vm_interface_view
   WHERE vm_guid = v_vm_id
   AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                     FROM   user_vm_permissions_view
                                     WHERE  user_id = v_user_id AND entity_id = v_vm_id));

END; $$;


ALTER FUNCTION public.getvm_interfacebyvm_id(v_vm_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvm_pool_mapbyvm_guid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvm_pool_mapbyvm_guid(v_vm_guid uuid) RETURNS SETOF vm_pool_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_pool_map.*
      FROM vm_pool_map
      WHERE vm_guid = v_vm_guid;
END; $$;


ALTER FUNCTION public.getvm_pool_mapbyvm_guid(v_vm_guid uuid) OWNER TO engineer;

--
-- Name: getvm_pool_mapbyvm_pool_id(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvm_pool_mapbyvm_pool_id(v_vm_pool_id uuid) RETURNS SETOF vm_pool_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_pool_map.*
      FROM vm_pool_map INNER JOIN vm_static
      ON vm_pool_map.vm_guid = vm_static.vm_guid
      WHERE vm_pool_id = v_vm_pool_id
      ORDER BY vm_static.VM_NAME;
END; $$;


ALTER FUNCTION public.getvm_pool_mapbyvm_pool_id(v_vm_pool_id uuid) OWNER TO engineer;

--
-- Name: getvm_poolsbyadgroup_names(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvm_poolsbyadgroup_names(v_ad_group_names character varying) RETURNS SETOF vm_pools_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT vm_pools_view.*
      FROM         ad_groups INNER JOIN
      users_and_groups_to_vm_pool_map_view ON
      ad_groups.id = users_and_groups_to_vm_pool_map_view.user_id INNER JOIN
      vm_pools_view ON users_and_groups_to_vm_pool_map_view.vm_pool_id = vm_pools_view.vm_pool_id
      WHERE     (ad_groups.name in(select Id from fnSplitter(v_ad_group_names)));
END; $$;


ALTER FUNCTION public.getvm_poolsbyadgroup_names(v_ad_group_names character varying) OWNER TO engineer;

--
-- Name: vm_pools_full_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vm_pools_full_view AS
    SELECT vmp.vm_pool_id, vmp.vm_pool_name, vmp.vm_pool_description, vmp.vm_pool_type, vmp.parameters, vmp.prestarted_vms, vmp.vds_group_id, vmp.vds_group_name, (SELECT count(vm_pool_map.vm_pool_id) AS expr1 FROM (vm_pools_view v1 LEFT JOIN vm_pool_map ON (((v1.vm_pool_id = vm_pool_map.vm_pool_id) AND (v1.vm_pool_id = vmp.vm_pool_id))))) AS assigned_vm_count, (SELECT count(v2.vm_pool_id) AS expr1 FROM ((vm_pools v2 LEFT JOIN vm_pool_map vm_pool_map_1 ON (((v2.vm_pool_id = vm_pool_map_1.vm_pool_id) AND (v2.vm_pool_id = vmp.vm_pool_id)))) LEFT JOIN vm_dynamic ON ((vm_pool_map_1.vm_guid = vm_dynamic.vm_guid))) WHERE (vm_dynamic.status <> ALL (ARRAY[0, 15])) GROUP BY v2.vm_pool_id) AS vm_running_count FROM vm_pools_view vmp;


ALTER TABLE public.vm_pools_full_view OWNER TO engineer;

--
-- Name: getvm_poolsbyvm_pool_id(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvm_poolsbyvm_pool_id(v_vm_pool_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vm_pools_full_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_pools_full_view.*
      FROM vm_pools_full_view
      WHERE vm_pool_id = v_vm_pool_id
      AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                        FROM   user_vm_pool_permissions_view
                                        WHERE  user_id = v_user_id AND entity_id = v_vm_pool_id));
END; $$;


ALTER FUNCTION public.getvm_poolsbyvm_pool_id(v_vm_pool_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvm_poolsbyvm_pool_name(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvm_poolsbyvm_pool_name(v_vm_pool_name character varying) RETURNS SETOF vm_pools_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_pools_view.*
      FROM vm_pools_view
      WHERE vm_pool_name = v_vm_pool_name;
END; $$;


ALTER FUNCTION public.getvm_poolsbyvm_pool_name(v_vm_pool_name character varying) OWNER TO engineer;

--
-- Name: getvmbyhibernationimageid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmbyhibernationimageid(v_image_id character varying) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT vms.*
      FROM vms
      WHERE hibernation_vol_handle like '%' || coalesce(v_image_id,'') || '%';
END; $$;


ALTER FUNCTION public.getvmbyhibernationimageid(v_image_id character varying) OWNER TO engineer;

--
-- Name: getvmbyvmguid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmbyvmguid(v_vm_guid uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT DISTINCT vms.*
   FROM vms
   WHERE vm_guid = v_vm_guid
   AND   (NOT v_is_filtered OR EXISTS (SELECT 1
                                       FROM   user_vm_permissions_view
                                       WHERE  user_id = v_user_id AND entity_id = v_vm_guid));
END; $$;


ALTER FUNCTION public.getvmbyvmguid(v_vm_guid uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvmbyvmnamefordatacenter(uuid, character varying, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmbyvmnamefordatacenter(v_data_center_id uuid, v_vm_name character varying, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT DISTINCT vms.*
   FROM vms
   WHERE vm_name = v_vm_name
   AND   (v_data_center_id is null OR storage_pool_id = v_data_center_id)
   AND   (NOT v_is_filtered OR EXISTS (SELECT 1
                                       FROM   user_vm_permissions_view
                                       WHERE  user_id = v_user_id AND entity_id = vms.vm_guid));
END; $$;


ALTER FUNCTION public.getvmbyvmnamefordatacenter(v_data_center_id uuid, v_vm_name character varying, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvmdatafrompoolbypoolid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmdatafrompoolbypoolid(v_pool_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
     RETURN QUERY SELECT vms.*
     FROM vms WHERE vm_pool_id = v_pool_id
     AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                       FROM   user_vm_pool_permissions_view
                                       WHERE  user_id = v_user_id AND entity_id = v_pool_id))
     -- Limiting results to 1 since we only need a single VM from the pool to retrieve the pool data
     LIMIT 1;
END; $$;


ALTER FUNCTION public.getvmdatafrompoolbypoolid(v_pool_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvmdevicebydeviceid(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmdevicebydeviceid(v_device_id uuid, v_vm_id uuid) RETURNS SETOF vm_device_view
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   vm_device_view
    WHERE  device_id = v_device_id
    AND (v_vm_id IS NULL OR vm_id = v_vm_id);
END; $$;


ALTER FUNCTION public.getvmdevicebydeviceid(v_device_id uuid, v_vm_id uuid) OWNER TO engineer;

--
-- Name: getvmdevicebyvmid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmdevicebyvmid(v_vm_id uuid) RETURNS SETOF vm_device_view
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   vm_device_view
    WHERE  vm_id = v_vm_id order by device_id;
END; $$;


ALTER FUNCTION public.getvmdevicebyvmid(v_vm_id uuid) OWNER TO engineer;

--
-- Name: getvmdevicebyvmidandtype(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmdevicebyvmidandtype(v_vm_id uuid, v_type character varying) RETURNS SETOF vm_device_view
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   vm_device_view
    WHERE  vm_id = v_vm_id and type = v_type
    ORDER BY NULLIF(alias,'') NULLS LAST;
END; $$;


ALTER FUNCTION public.getvmdevicebyvmidandtype(v_vm_id uuid, v_type character varying) OWNER TO engineer;

--
-- Name: getvmdevicebyvmidtypeanddevice(uuid, character varying, character varying, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmdevicebyvmidtypeanddevice(v_vm_id uuid, v_type character varying, v_device character varying, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vm_device_view
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    SELECT *
    FROM   vm_device_view
    WHERE  vm_id = v_vm_id and type = v_type and device = v_device
    AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                      FROM   user_vm_permissions_view
                                      WHERE  user_id = v_user_id AND entity_id = v_vm_id))
    ORDER BY NULLIF(alias,'') NULLS LAST;

END; $$;


ALTER FUNCTION public.getvmdevicebyvmidtypeanddevice(v_vm_id uuid, v_type character varying, v_device character varying, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvmdynamicbyvmguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmdynamicbyvmguid(v_vm_guid uuid) RETURNS SETOF vm_dynamic
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_dynamic.*
      FROM vm_dynamic
      WHERE vm_guid = v_vm_guid;
END; $$;


ALTER FUNCTION public.getvmdynamicbyvmguid(v_vm_guid uuid) OWNER TO engineer;

--
-- Name: vm_guest_agent_interfaces; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vm_guest_agent_interfaces (
    vm_id uuid NOT NULL,
    interface_name text,
    mac_address character varying(59),
    ipv4_addresses text,
    ipv6_addresses text
);


ALTER TABLE public.vm_guest_agent_interfaces OWNER TO engineer;

--
-- Name: getvmguestagentinterfacesbyvmid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmguestagentinterfacesbyvmid(v_vm_id uuid, v_user_id uuid, v_filtered boolean) RETURNS SETOF vm_guest_agent_interfaces
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT *
   FROM vm_guest_agent_interfaces
   WHERE vm_id = v_vm_id
   AND (NOT v_filtered OR EXISTS (SELECT 1
                                  FROM   user_vm_permissions_view
                                  WHERE  user_id = v_user_id AND entity_id = v_vm_id));
END; $$;


ALTER FUNCTION public.getvmguestagentinterfacesbyvmid(v_vm_id uuid, v_user_id uuid, v_filtered boolean) OWNER TO engineer;

--
-- Name: getvmimagebyimageguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmimagebyimageguid(v_image_guid uuid) RETURNS SETOF vm_images_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM vm_images_view
      WHERE image_guid = v_image_guid;
END; $$;


ALTER FUNCTION public.getvmimagebyimageguid(v_image_guid uuid) OWNER TO engineer;

--
-- Name: getvminterfacesbynetworkid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvminterfacesbynetworkid(v_network_id uuid) RETURNS SETOF vm_interface_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT vm_interface_view.*
   FROM vm_interface_view
   INNER JOIN network_cluster
   ON network_cluster.cluster_id = vm_interface_view.vds_group_id
   INNER JOIN network
   ON network.id = network_cluster.network_id
   AND network.name = vm_interface_view.network_name
   WHERE network.id = v_network_id
   AND vm_interface_view.vm_entity_type = 'VM';
END; $$;


ALTER FUNCTION public.getvminterfacesbynetworkid(v_network_id uuid) OWNER TO engineer;

--
-- Name: getvmmapsinvmpoolbyvmpoolidandstatus(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmmapsinvmpoolbyvmpoolidandstatus(v_vm_pool_id uuid, v_status integer) RETURNS SETOF vm_pool_map
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_pool_id, vm_pool_map.vm_guid
      FROM vm_pool_map, vm_dynamic
      WHERE vm_pool_map.vm_guid = vm_dynamic.vm_guid
      AND vm_pool_id = v_vm_pool_id
      AND vm_dynamic.status = v_status;
END; $$;


ALTER FUNCTION public.getvmmapsinvmpoolbyvmpoolidandstatus(v_vm_pool_id uuid, v_status integer) OWNER TO engineer;

--
-- Name: getvmsbyadgroupnames(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmsbyadgroupnames(v_ad_group_names character varying) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY select distinct vms.* from vms
   inner join permissions on vms.vm_guid = permissions.object_id
   inner join ad_groups on ad_groups.id = permissions.ad_element_id
   WHERE     (ad_groups.name in(select Id from fnSplitter(v_ad_group_names)));
END; $$;


ALTER FUNCTION public.getvmsbyadgroupnames(v_ad_group_names character varying) OWNER TO engineer;

--
-- Name: vms_with_plug_info; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vms_with_plug_info AS
    SELECT vms.vm_name, vms.vm_mem_size_mb, vms.nice_level, vms.vmt_guid, vms.vm_os, vms.vm_description, vms.vds_group_id, vms.vm_domain, vms.vm_creation_date, vms.auto_startup, vms.is_stateless, vms.is_smartcard_enabled, vms.is_delete_protected, vms.dedicated_vm_for_vds, vms.fail_back, vms.default_boot_sequence, vms.vm_type, vms.vds_group_name, vms.selection_algorithm, vms.transparent_hugepages, vms.storage_pool_id, vms.storage_pool_name, vms.vds_group_description, vms.vmt_name, vms.vmt_mem_size_mb, vms.vmt_os, vms.vmt_creation_date, vms.vmt_child_count, vms.vmt_num_of_sockets, vms.vmt_cpu_per_socket, vms.vmt_num_of_cpus, vms.vmt_description, vms.status, vms.vm_ip, vms.vm_host, vms.vm_pid, vms.last_start_time, vms.guest_cur_user_name, vms.console_cur_user_name, vms.guest_last_login_time, vms.guest_last_logout_time, vms.guest_os, vms.console_user_id, vms.guest_agent_nics_hash, vms.run_on_vds, vms.migrating_to_vds, vms.app_list, vms.display, vms.hibernation_vol_handle, vms.vm_pool_name, vms.vm_pool_id, vms.vm_guid, vms.num_of_monitors, vms.allow_console_reconnect, vms.is_initialized, vms.is_auto_suspend, vms.num_of_sockets, vms.cpu_per_socket, vms.usb_policy, vms.acpi_enable, vms.session, vms.num_of_cpus, vms.quota_id, vms.quota_name, vms.quota_enforcement_type, vms.display_ip, vms.display_type, vms.kvm_enable, vms.boot_sequence, vms.display_secure_port, vms.utc_diff, vms.last_vds_run_on, vms.client_ip, vms.guest_requested_memory, vms.time_zone, vms.cpu_user, vms.cpu_sys, vms.elapsed_time, vms.usage_network_percent, vms.usage_mem_percent, vms.usage_cpu_percent, vms.run_on_vds_name, vms.vds_group_cpu_name, vms.default_display_type, vms.priority, vms.iso_path, vms.origin, vms.vds_group_compatibility_version, vms.initrd_url, vms.kernel_url, vms.kernel_params, vms.pause_status, vms.exit_message, vms.exit_status, vms.migration_support, vms.predefined_properties, vms.userdefined_properties, vms.min_allocated_mem, vms.hash, vms.cpu_pinning, vms.db_generation, vms.host_cpu_flags, vd.device_id, vd.is_plugged FROM (vms JOIN vm_device vd ON ((vd.vm_id = vms.vm_guid)));


ALTER TABLE public.vms_with_plug_info OWNER TO engineer;

--
-- Name: getvmsbydiskid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmsbydiskid(v_disk_guid uuid) RETURNS SETOF vms_with_plug_info
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT vms_with_plug_info.*
      FROM vms_with_plug_info
      WHERE device_id = v_disk_guid;
END; $$;


ALTER FUNCTION public.getvmsbydiskid(v_disk_guid uuid) OWNER TO engineer;

--
-- Name: getvmsbyids(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmsbyids(v_vms_ids character varying) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vm.*
             FROM vms vm
             WHERE vm.vm_guid IN (SELECT * from fnSplitterUuid(v_vms_ids));
END; $$;


ALTER FUNCTION public.getvmsbyids(v_vms_ids character varying) OWNER TO engineer;

--
-- Name: getvmsbynetworkid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmsbynetworkid(v_network_id uuid) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM vms
   WHERE EXISTS (
      SELECT 1
      FROM vm_interface
      INNER JOIN network
      ON network.name = vm_interface.network_name
      INNER JOIN network_cluster
      ON network.id = network_cluster.network_id
      WHERE network_id = v_network_id
      AND vms.vds_group_id = network_cluster.cluster_id
      AND vm_interface.vm_guid = vms.vm_guid);
END; $$;


ALTER FUNCTION public.getvmsbynetworkid(v_network_id uuid) OWNER TO engineer;

--
-- Name: getvmsbystoragedomainid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmsbystoragedomainid(v_storage_domain_id uuid) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT vms.*
      FROM vms
      INNER JOIN vm_device vd ON vd.vm_id = vms.vm_guid
      INNER JOIN images ON images.image_group_id = vd.device_id AND images.active = TRUE
      inner join image_storage_domain_map on images.image_guid = image_storage_domain_map.image_id
      where image_storage_domain_map.storage_domain_id = v_storage_domain_id;
END; $$;


ALTER FUNCTION public.getvmsbystoragedomainid(v_storage_domain_id uuid) OWNER TO engineer;

--
-- Name: getvmsbyuserid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmsbyuserid(v_user_id uuid) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY select vms.* from vms
   inner join permissions on vms.vm_guid = permissions.object_id
   WHERE permissions.ad_element_id = v_user_id;
END; $$;


ALTER FUNCTION public.getvmsbyuserid(v_user_id uuid) OWNER TO engineer;

--
-- Name: getvmsbyuseridwithgroupsanduserroles(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmsbyuseridwithgroupsanduserroles(v_user_id uuid) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT DISTINCT vms.*
   from vms
   inner join permissions_view as perms on vms.vm_guid = perms.object_id
   WHERE (perms.ad_element_id = v_user_id
   or perms.ad_element_id in(select id from getUserAndGroupsById(v_user_id)))
   and perms.role_type = 2;

END; $$;


ALTER FUNCTION public.getvmsbyuseridwithgroupsanduserroles(v_user_id uuid) OWNER TO engineer;

--
-- Name: getvmsbyvmpoolid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmsbyvmpoolid(v_vm_pool_id uuid) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vms.*
      FROM vms
      WHERE vm_pool_id = v_vm_pool_id;
END; $$;


ALTER FUNCTION public.getvmsbyvmpoolid(v_vm_pool_id uuid) OWNER TO engineer;

--
-- Name: getvmsbyvmtguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmsbyvmtguid(v_vmt_guid uuid) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT DISTINCT vms.*
   FROM vms
   WHERE vmt_guid = v_vmt_guid;
END; $$;


ALTER FUNCTION public.getvmsbyvmtguid(v_vmt_guid uuid) OWNER TO engineer;

--
-- Name: getvmsdedicatedtopowerclientbyvdsid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmsdedicatedtopowerclientbyvdsid(v_dedicated_vm_for_vds uuid) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT DISTINCT vms.*
   FROM vms inner join
   vds_static on vms.dedicated_vm_for_vds = vds_static.vds_id
   WHERE vms.dedicated_vm_for_vds = v_dedicated_vm_for_vds
   and vds_static.vds_type = 1;
END; $$;


ALTER FUNCTION public.getvmsdedicatedtopowerclientbyvdsid(v_dedicated_vm_for_vds uuid) OWNER TO engineer;

--
-- Name: getvmsdynamicrunningonvds(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmsdynamicrunningonvds(v_vds_id uuid) RETURNS SETOF vm_dynamic
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_dynamic.*
      FROM vm_dynamic
      WHERE RUN_ON_VDS = v_vds_id;
END; $$;


ALTER FUNCTION public.getvmsdynamicrunningonvds(v_vds_id uuid) OWNER TO engineer;

--
-- Name: getvmsidsforovfupdate(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmsidsforovfupdate(v_storage_pool_id uuid) RETURNS SETOF uuid
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vm.vm_guid as vm_guid
   FROM vms vm, vm_ovf_generations ovf_gen
   WHERE vm.vm_guid = ovf_gen.vm_guid
         AND vm.db_generation >  ovf_gen.ovf_generation
         AND vm.storage_pool_id = v_storage_pool_id;
END; $$;


ALTER FUNCTION public.getvmsidsforovfupdate(v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getvmsmigratingtovds(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmsmigratingtovds(v_vds_id uuid) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT DISTINCT vms.*
   FROM vms
   WHERE migrating_to_vds = v_vds_id
   AND status = 6;

END; $$;


ALTER FUNCTION public.getvmsmigratingtovds(v_vds_id uuid) OWNER TO engineer;

--
-- Name: getvmsrunningonvds(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmsrunningonvds(v_vds_id uuid) RETURNS SETOF vms
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT DISTINCT vms.*
   FROM vms
   WHERE run_on_vds = v_vds_id;

END; $$;


ALTER FUNCTION public.getvmsrunningonvds(v_vds_id uuid) OWNER TO engineer;

--
-- Name: getvmstaticbygroupidandnetwork(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmstaticbygroupidandnetwork(v_groupid uuid, v_networkname character varying) RETURNS SETOF vm_static
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT
   vm_static.* from vm_static
   inner join vm_interface_view
   on vm_static.vm_guid = vm_interface_view.vm_guid
   and network_name = v_networkName
   and vm_static.vds_group_id = v_groupId;


END; $$;


ALTER FUNCTION public.getvmstaticbygroupidandnetwork(v_groupid uuid, v_networkname character varying) OWNER TO engineer;

--
-- Name: getvmstaticbyname(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmstaticbyname(v_vm_name character varying) RETURNS SETOF vm_static
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vm_static.*
   FROM vm_static
   WHERE VM_NAME = v_vm_name
   AND   entity_type = 'VM';

END; $$;


ALTER FUNCTION public.getvmstaticbyname(v_vm_name character varying) OWNER TO engineer;

--
-- Name: getvmstaticbyvdsgroup(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmstaticbyvdsgroup(v_vds_group_id uuid) RETURNS SETOF vm_static
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vm_static.*
   FROM vm_static
   WHERE vds_group_id = v_vds_group_id
   AND   entity_type = 'VM';

END; $$;


ALTER FUNCTION public.getvmstaticbyvdsgroup(v_vds_group_id uuid) OWNER TO engineer;

--
-- Name: getvmstaticbyvmguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmstaticbyvmguid(v_vm_guid uuid) RETURNS SETOF vm_static
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vm_static.*
   FROM vm_static
   WHERE vm_guid = v_vm_guid
   AND   entity_type = 'VM';

END; $$;


ALTER FUNCTION public.getvmstaticbyvmguid(v_vm_guid uuid) OWNER TO engineer;

--
-- Name: getvmstaticwithfailbackbyvdsid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmstaticwithfailbackbyvdsid(v_vds_id uuid) RETURNS SETOF vm_static
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vm_static.*
   FROM vm_static
   WHERE dedicated_vm_for_vds = v_vds_id and fail_back = TRUE
   AND   entity_type = 'VM';

END; $$;


ALTER FUNCTION public.getvmstaticwithfailbackbyvdsid(v_vds_id uuid) OWNER TO engineer;

--
-- Name: getvmstatisticsbyvmguid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmstatisticsbyvmguid(v_vm_guid uuid) RETURNS SETOF vm_statistics
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_statistics.*
      FROM vm_statistics
      WHERE vm_guid = v_vm_guid;
END; $$;


ALTER FUNCTION public.getvmstatisticsbyvmguid(v_vm_guid uuid) OWNER TO engineer;

--
-- Name: getvmtagsbytagid(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmtagsbytagid(v_tag_ids character varying) RETURNS SETOF tags_vm_map_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT tags_vm_map_view.*
      FROM tags_vm_map_view
      WHERE tag_id in(select * from fnSplitterUuid(v_tag_ids));
END; $$;


ALTER FUNCTION public.getvmtagsbytagid(v_tag_ids character varying) OWNER TO engineer;

--
-- Name: getvmtemplatebyvdsgroupid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmtemplatebyvdsgroupid(v_vds_group_id uuid) RETURNS SETOF vm_templates_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_templates.*
      FROM vm_templates_view vm_templates
      WHERE vds_group_id = v_vds_group_id;
END; $$;


ALTER FUNCTION public.getvmtemplatebyvdsgroupid(v_vds_group_id uuid) OWNER TO engineer;

--
-- Name: getvmtemplatebyvmtguid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmtemplatebyvmtguid(v_vmt_guid uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vm_templates_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_templates.*
      FROM vm_templates_view vm_templates
      WHERE vmt_guid = v_vmt_guid
      AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                        FROM   user_vm_template_permissions_view
                                        WHERE  user_id = v_user_id AND entity_id = v_vmt_guid));
END; $$;


ALTER FUNCTION public.getvmtemplatebyvmtguid(v_vmt_guid uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvmtemplatebyvmtname(character varying, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmtemplatebyvmtname(v_vmt_name character varying, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vm_templates_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT vm_templates.*
      FROM vm_templates_view vm_templates
      WHERE name = v_vmt_name
      AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                        FROM   user_vm_template_permissions_view
                                        WHERE  user_id = v_user_id AND entity_id = vmt_guid));
END; $$;


ALTER FUNCTION public.getvmtemplatebyvmtname(v_vmt_name character varying, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvmtemplateinterfacesbynetworkid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmtemplateinterfacesbynetworkid(v_network_id uuid) RETURNS SETOF vm_interface_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT vm_interface_view.*
   FROM vm_interface_view
   INNER JOIN network_cluster
   ON network_cluster.cluster_id = vm_interface_view.vds_group_id
   INNER JOIN network
   ON network.id = network_cluster.network_id
   AND network.name = vm_interface_view.network_name
   WHERE network.id = v_network_id
   AND vm_interface_view.vm_entity_type = 'TEMPLATE';
END; $$;


ALTER FUNCTION public.getvmtemplateinterfacesbynetworkid(v_network_id uuid) OWNER TO engineer;

--
-- Name: getvmtemplatesbyids(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmtemplatesbyids(v_vm_templates_ids character varying) RETURNS SETOF vm_templates_view
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT vm_templates.*
   FROM vm_templates_view vm_templates
   WHERE vm_templates.vmt_guid IN (SELECT * FROM fnSplitterUuid(v_vm_templates_ids));
END; $$;


ALTER FUNCTION public.getvmtemplatesbyids(v_vm_templates_ids character varying) OWNER TO engineer;

--
-- Name: vm_templates_with_plug_info; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vm_templates_with_plug_info AS
    SELECT vm_templates_view.vmt_guid, vm_templates_view.name, vm_templates_view.mem_size_mb, vm_templates_view.os, vm_templates_view.creation_date, vm_templates_view.child_count, vm_templates_view.num_of_sockets, vm_templates_view.cpu_per_socket, vm_templates_view.num_of_cpus, vm_templates_view.description, vm_templates_view.vds_group_id, vm_templates_view.domain, vm_templates_view.num_of_monitors, vm_templates_view.allow_console_reconnect, vm_templates_view.status, vm_templates_view.usb_policy, vm_templates_view.time_zone, vm_templates_view.is_auto_suspend, vm_templates_view.fail_back, vm_templates_view.vds_group_name, vm_templates_view.vm_type, vm_templates_view.nice_level, vm_templates_view.storage_pool_id, vm_templates_view.storage_pool_name, vm_templates_view.quota_enforcement_type, vm_templates_view.default_boot_sequence, vm_templates_view.default_display_type, vm_templates_view.priority, vm_templates_view.auto_startup, vm_templates_view.is_stateless, vm_templates_view.is_smartcard_enabled, vm_templates_view.is_delete_protected, vm_templates_view.iso_path, vm_templates_view.origin, vm_templates_view.initrd_url, vm_templates_view.kernel_url, vm_templates_view.kernel_params, vm_templates_view.quota_id, vm_templates_view.quota_name, vm_templates_view.db_generation, vm_templates_view.migration_support, vm_templates_view.dedicated_vm_for_vds, vm_templates_view.is_disabled, vm_templates_view.min_allocated_mem, images.image_guid, images.image_group_id, vd.is_plugged FROM ((vm_templates_view JOIN vm_device vd ON ((vd.vm_id = vm_templates_view.vmt_guid))) JOIN images ON (((images.image_group_id = vd.device_id) AND (images.active = true))));


ALTER TABLE public.vm_templates_with_plug_info OWNER TO engineer;

--
-- Name: getvmtemplatesbyimageid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmtemplatesbyimageid(v_image_guid uuid) RETURNS SETOF vm_templates_with_plug_info
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT *
      FROM vm_templates_with_plug_info t
      WHERE t.image_guid = v_image_guid;
END; $$;


ALTER FUNCTION public.getvmtemplatesbyimageid(v_image_guid uuid) OWNER TO engineer;

--
-- Name: getvmtemplatesbynetworkid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmtemplatesbynetworkid(v_network_id uuid) RETURNS SETOF vm_templates_view
    LANGUAGE plpgsql
    AS $$
BEGIN
   RETURN QUERY SELECT *
   FROM vm_templates_view
   WHERE EXISTS (
      SELECT 1
      FROM vm_interface
      INNER JOIN network
      ON network.name = vm_interface.network_name
      INNER JOIN network_cluster
      ON network.id = network_cluster.network_id
      WHERE network.id = v_network_id
      AND vm_templates_view.vds_group_id = network_cluster.cluster_id
      AND vm_interface.vmt_guid = vm_templates_view.vmt_guid);
END; $$;


ALTER FUNCTION public.getvmtemplatesbynetworkid(v_network_id uuid) OWNER TO engineer;

--
-- Name: getvmtemplatesbystoragedomainid(uuid, uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmtemplatesbystoragedomainid(v_storage_domain_id uuid, v_user_id uuid, v_is_filtered boolean) RETURNS SETOF vm_templates_view
    LANGUAGE plpgsql
    AS $$
BEGIN
      RETURN QUERY SELECT DISTINCT vm_templates.*
      FROM vm_templates_view vm_templates
      INNER JOIN vm_device vd ON vd.vm_id = vm_templates.vmt_guid
      INNER JOIN images i ON i.image_group_id = vd.device_id AND i.active = TRUE
      where i.image_guid in(select image_id from image_storage_domain_map where storage_domain_id = v_storage_domain_id)
      AND (NOT v_is_filtered OR EXISTS (SELECT 1
                                      FROM   user_vm_template_permissions_view
                                      WHERE  user_id = v_user_id AND entity_id = vm_templates.vmt_guid));
END; $$;


ALTER FUNCTION public.getvmtemplatesbystoragedomainid(v_storage_domain_id uuid, v_user_id uuid, v_is_filtered boolean) OWNER TO engineer;

--
-- Name: getvmtemplatesidsforovfupdate(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmtemplatesidsforovfupdate(v_storage_pool_id uuid) RETURNS SETOF uuid
    LANGUAGE plpgsql
    AS $$
BEGIN
RETURN QUERY SELECT templates.vmt_guid as vm_guid
   FROM vm_templates_view templates, vm_ovf_generations generations
   WHERE generations.vm_guid = templates.vmt_guid
   AND templates.db_generation > generations.ovf_generation
   AND templates.storage_pool_id = v_storage_pool_id;
END; $$;


ALTER FUNCTION public.getvmtemplatesidsforovfupdate(v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: getvmunmanageddevicesbyvmid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION getvmunmanageddevicesbyvmid(v_vm_id uuid) RETURNS SETOF vm_device_view
    LANGUAGE plpgsql
    AS $$
BEGIN
    RETURN QUERY
    select vm_device_view.* from vm_device_view
    where vm_id = v_vm_id and
          is_managed = false;
END; $$;


ALTER FUNCTION public.getvmunmanageddevicesbyvmid(v_vm_id uuid) OWNER TO engineer;

--
-- Name: incrementdbgeneration(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION incrementdbgeneration(v_vm_guid uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vm_static
      SET db_generation  = db_generation + 1
      WHERE vm_guid = v_vm_guid;
END; $$;


ALTER FUNCTION public.incrementdbgeneration(v_vm_guid uuid) OWNER TO engineer;

--
-- Name: incrementdbgenerationforallinstoragepool(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION incrementdbgenerationforallinstoragepool(v_storage_pool_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
     curs CURSOR FOR SELECT vms.vm_guid FROM vm_static vms
                     WHERE vms.vds_group_id IN (SELECT vgs.vds_group_id FROM vds_groups vgs
                                                WHERE vgs.storage_pool_id=v_storage_pool_id)
                     ORDER BY vm_guid;
     id UUID;
BEGIN
      OPEN curs;
      LOOP
         FETCH curs INTO id;
         IF NOT FOUND THEN
            EXIT;
         END IF;
         UPDATE vm_static SET db_generation  = db_generation + 1 WHERE vm_guid = id;
      END LOOP;
END; $$;


ALTER FUNCTION public.incrementdbgenerationforallinstoragepool(v_storage_pool_id uuid) OWNER TO engineer;

--
-- Name: insert_entity_snapshot(uuid, uuid, character varying, character varying, character varying, text, character varying, integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insert_entity_snapshot(v_id uuid, v_command_id uuid, v_command_type character varying, v_entity_id character varying, v_entity_type character varying, v_entity_snapshot text, v_snapshot_class character varying, v_snapshot_type integer, v_insertion_order integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
	BEGIN
		INSERT INTO business_entity_snapshot(id, command_id, command_type, entity_id,entity_type,entity_snapshot, snapshot_class, snapshot_type,insertion_order)
				VALUES(v_id, v_command_id, v_command_type, v_entity_id,v_entity_type,v_entity_snapshot, v_snapshot_class, v_snapshot_type,v_insertion_order);
	END;

   RETURN;
END; $$;


ALTER FUNCTION public.insert_entity_snapshot(v_id uuid, v_command_id uuid, v_command_type character varying, v_entity_id character varying, v_entity_type character varying, v_entity_snapshot text, v_snapshot_class character varying, v_snapshot_type integer, v_insertion_order integer) OWNER TO engineer;

--
-- Name: insert_roles_groups(integer, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insert_roles_groups(v_action_group_id integer, v_role_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO roles_groups(action_group_id, role_id)
	VALUES(v_action_group_id, v_role_id);
END; $$;


ALTER FUNCTION public.insert_roles_groups(v_action_group_id integer, v_role_id uuid) OWNER TO engineer;

--
-- Name: insertaction_version_map(integer, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertaction_version_map(v_action_type integer, v_cluster_minimal_version character varying, v_storage_pool_minimal_version character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO action_version_map(action_type, cluster_minimal_version, storage_pool_minimal_version)
	VALUES(v_action_type, v_cluster_minimal_version, v_storage_pool_minimal_version);
END; $$;


ALTER FUNCTION public.insertaction_version_map(v_action_type integer, v_cluster_minimal_version character varying, v_storage_pool_minimal_version character varying) OWNER TO engineer;

--
-- Name: insertad_groups(uuid, character varying, integer, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertad_groups(v_id uuid, v_name character varying, v_status integer, v_domain character varying, v_distinguishedname character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO ad_groups(id, name,status,domain,distinguishedname)
	VALUES(v_id, v_name,v_status,v_domain,v_distinguishedname);
END; $$;


ALTER FUNCTION public.insertad_groups(v_id uuid, v_name character varying, v_status integer, v_domain character varying, v_distinguishedname character varying) OWNER TO engineer;

--
-- Name: insertasync_tasks(integer, integer, integer, uuid, text, character varying, text, character varying, uuid, uuid, character varying, timestamp without time zone, uuid, integer, text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertasync_tasks(v_action_type integer, v_result integer, v_status integer, v_task_id uuid, v_action_parameters text, v_action_params_class character varying, v_task_parameters text, v_task_params_class character varying, v_step_id uuid, v_command_id uuid, v_entity_type character varying, v_started_at timestamp without time zone, v_storage_pool_id uuid, v_async_task_type integer, v_entity_ids text) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO async_tasks(action_type, result, status, task_id, action_parameters,action_params_class, task_parameters, task_params_class, step_id, command_id, started_at,storage_pool_id, task_type)
	VALUES(v_action_type, v_result, v_status, v_task_id, v_action_parameters,v_action_params_class, v_task_parameters, v_task_params_class, v_step_id, v_command_id, v_started_at, v_storage_pool_id, v_async_task_type);
INSERT INTO async_tasks_entities (async_task_id,entity_id,entity_type)
	SELECT v_task_id,fnsplitteruuid(v_entity_ids),v_entity_type;
END; $$;


ALTER FUNCTION public.insertasync_tasks(v_action_type integer, v_result integer, v_status integer, v_task_id uuid, v_action_parameters text, v_action_params_class character varying, v_task_parameters text, v_task_params_class character varying, v_step_id uuid, v_command_id uuid, v_entity_type character varying, v_started_at timestamp without time zone, v_storage_pool_id uuid, v_async_task_type integer, v_entity_ids text) OWNER TO engineer;

--
-- Name: insertauditlog(integer, timestamp with time zone, integer, character varying, integer, text, uuid, character varying, uuid, character varying, uuid, character varying, uuid, character varying, uuid, character varying, uuid, character varying, uuid, character varying, uuid, character varying, character varying, uuid, uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertauditlog(INOUT v_audit_log_id integer, v_log_time timestamp with time zone, v_log_type integer, v_log_type_name character varying, v_severity integer, v_message text, v_user_id uuid, v_user_name character varying, v_vds_id uuid, v_vds_name character varying, v_vm_id uuid, v_vm_name character varying, v_vm_template_id uuid, v_vm_template_name character varying, v_storage_pool_id uuid, v_storage_pool_name character varying, v_storage_domain_id uuid, v_storage_domain_name character varying, v_vds_group_id uuid, v_vds_group_name character varying, v_quota_id uuid, v_quota_name character varying, v_correlation_id character varying, v_job_id uuid, v_gluster_volume_id uuid, v_gluster_volume_name character varying) RETURNS integer
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_min_alret_severity  INTEGER;
BEGIN
      v_min_alret_severity := 10;
	-- insert regular log messages (non alerts)
      if (v_severity < v_min_alret_severity) then

INSERT INTO audit_log(LOG_TIME, log_type, log_type_name, severity,message, user_id, USER_NAME, vds_id, VDS_NAME, vm_id, VM_NAME,vm_template_id,VM_TEMPLATE_NAME,storage_pool_id,STORAGE_POOL_NAME,storage_domain_id,STORAGE_DOMAIN_NAME,vds_group_id,vds_group_name, correlation_id, job_id, quota_id, quota_name, gluster_volume_id, gluster_volume_name)
		VALUES(v_log_time, v_log_type, v_log_type_name, v_severity, v_message, v_user_id, v_user_name, v_vds_id, v_vds_name, v_vm_id, v_vm_name,v_vm_template_id,v_vm_template_name,v_storage_pool_id,v_storage_pool_name,v_storage_domain_id,v_storage_domain_name,v_vds_group_id,v_vds_group_name, v_correlation_id, v_job_id, v_quota_id, v_quota_name, v_gluster_volume_id, v_gluster_volume_name);

         v_audit_log_id := CURRVAL('audit_log_seq');
      else
         if (not exists(select audit_log_id from audit_log where vds_name = v_vds_name and log_type = v_log_type)) then

INSERT INTO audit_log(LOG_TIME, log_type, log_type_name, severity,message, user_id, USER_NAME, vds_id, VDS_NAME, vm_id, VM_NAME,vm_template_id,VM_TEMPLATE_NAME,storage_pool_id,STORAGE_POOL_NAME,storage_domain_id,STORAGE_DOMAIN_NAME,vds_group_id,vds_group_name, correlation_id, job_id, quota_id, quota_name, gluster_volume_id, gluster_volume_name)
			VALUES(v_log_time, v_log_type, v_log_type_name, v_severity, v_message, v_user_id, v_user_name, v_vds_id, v_vds_name, v_vm_id, v_vm_name,v_vm_template_id,v_vm_template_name,v_storage_pool_id,v_storage_pool_name,v_storage_domain_id,v_storage_domain_name,v_vds_group_id,v_vds_group_name, v_correlation_id, v_job_id, v_quota_id, v_quota_name, v_gluster_volume_id, v_gluster_volume_name);

            v_audit_log_id := CURRVAL('audit_log_seq');
         else
            select   audit_log_id INTO v_audit_log_id from audit_log where vds_name = v_vds_name and log_type = v_log_type;
         end if;
      end if;
END; $$;


ALTER FUNCTION public.insertauditlog(INOUT v_audit_log_id integer, v_log_time timestamp with time zone, v_log_type integer, v_log_type_name character varying, v_severity integer, v_message text, v_user_id uuid, v_user_name character varying, v_vds_id uuid, v_vds_name character varying, v_vm_id uuid, v_vm_name character varying, v_vm_template_id uuid, v_vm_template_name character varying, v_storage_pool_id uuid, v_storage_pool_name character varying, v_storage_domain_id uuid, v_storage_domain_name character varying, v_vds_group_id uuid, v_vds_group_name character varying, v_quota_id uuid, v_quota_name character varying, v_correlation_id character varying, v_job_id uuid, v_gluster_volume_id uuid, v_gluster_volume_name character varying) OWNER TO engineer;

--
-- Name: insertbasedisk(uuid, character varying, boolean, character varying, character varying, character varying, boolean, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertbasedisk(v_disk_id uuid, v_disk_interface character varying, v_wipe_after_delete boolean, v_propagate_errors character varying, v_disk_alias character varying, v_disk_description character varying, v_shareable boolean, v_boot boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    INSERT INTO base_disks(
        disk_id,
        disk_interface,
        wipe_after_delete,
        propagate_errors,
        disk_alias,
        disk_description,
        shareable,
        boot)
    VALUES(
        v_disk_id,
        v_disk_interface,
        v_wipe_after_delete,
        v_propagate_errors,
        v_disk_alias,
        v_disk_description,
        v_shareable,
        v_boot);
END; $$;


ALTER FUNCTION public.insertbasedisk(v_disk_id uuid, v_disk_interface character varying, v_wipe_after_delete boolean, v_propagate_errors character varying, v_disk_alias character varying, v_disk_description character varying, v_shareable boolean, v_boot boolean) OWNER TO engineer;

--
-- Name: insertbookmark(uuid, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertbookmark(v_bookmark_id uuid, v_bookmark_name character varying, v_bookmark_value character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO bookmarks(bookmark_Id,bookmark_name, bookmark_value)
	VALUES(v_bookmark_id, v_bookmark_name, v_bookmark_value);
END; $$;


ALTER FUNCTION public.insertbookmark(v_bookmark_id uuid, v_bookmark_name character varying, v_bookmark_value character varying) OWNER TO engineer;

--
-- Name: insertcustom_actions(integer, character varying, character varying, integer, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertcustom_actions(INOUT v_action_id integer, v_action_name character varying, v_path character varying, v_tab integer, v_description character varying) RETURNS integer
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO custom_actions(action_name, path, tab, description)
	VALUES(v_action_name, v_path, v_tab, v_description);

      v_action_id := CURRVAL('custom_actions_seq');
END; $$;


ALTER FUNCTION public.insertcustom_actions(INOUT v_action_id integer, v_action_name character varying, v_path character varying, v_tab integer, v_description character varying) OWNER TO engineer;

--
-- Name: insertdisk_image_dynamic(uuid, integer, integer, bigint, numeric, numeric, numeric); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertdisk_image_dynamic(v_image_id uuid, v_read_rate integer, v_write_rate integer, v_actual_size bigint, v_read_latency_seconds numeric, v_write_latency_seconds numeric, v_flush_latency_seconds numeric) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO disk_image_dynamic(image_id, read_rate, write_rate, actual_size, read_latency_seconds, write_latency_seconds, flush_latency_seconds)
	VALUES(v_image_id, v_read_rate, v_write_rate, v_actual_size, v_read_latency_seconds, v_write_latency_seconds, v_flush_latency_seconds);
END; $$;


ALTER FUNCTION public.insertdisk_image_dynamic(v_image_id uuid, v_read_rate integer, v_write_rate integer, v_actual_size bigint, v_read_latency_seconds numeric, v_write_latency_seconds numeric, v_flush_latency_seconds numeric) OWNER TO engineer;

--
-- Name: insertdisklunmap(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertdisklunmap(v_disk_id uuid, v_lun_id character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    INSERT INTO disk_lun_map(
        disk_id,
        lun_id)
    VALUES(
        v_disk_id,
        v_lun_id);
END; $$;


ALTER FUNCTION public.insertdisklunmap(v_disk_id uuid, v_lun_id character varying) OWNER TO engineer;

--
-- Name: insertevent_notification_hist(bigint, character varying, character, character, timestamp with time zone, boolean, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertevent_notification_hist(v_audit_log_id bigint, v_event_name character varying, v_method_type character, v_reason character, v_sent_at timestamp with time zone, v_status boolean, v_subscriber_id character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO event_notification_hist(audit_log_id, event_name, method_type, reason, sent_at, status, subscriber_id)
	VALUES(v_audit_log_id, v_event_name, v_method_type, v_reason, v_sent_at, v_status, v_subscriber_id::uuid);
END; $$;


ALTER FUNCTION public.insertevent_notification_hist(v_audit_log_id bigint, v_event_name character varying, v_method_type character, v_reason character, v_sent_at timestamp with time zone, v_status boolean, v_subscriber_id character varying) OWNER TO engineer;

--
-- Name: insertevent_subscriber(character varying, integer, character varying, uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertevent_subscriber(v_event_up_name character varying, v_method_id integer, v_method_address character varying, v_subscriber_id uuid, v_tag_name character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      if not exists(select * from  event_subscriber where
      subscriber_id = v_subscriber_id and
      event_up_name = v_event_up_name and
      method_id = v_method_id and
      tag_name = v_tag_name) then

INSERT INTO event_subscriber(event_up_name, method_id, method_address, subscriber_id, tag_name)
			VALUES(v_event_up_name, v_method_id, v_method_address, v_subscriber_id,v_tag_name);
      end if;
END; $$;


ALTER FUNCTION public.insertevent_subscriber(v_event_up_name character varying, v_method_id integer, v_method_address character varying, v_subscriber_id uuid, v_tag_name character varying) OWNER TO engineer;

--
-- Name: insertexternalauditlog(integer, timestamp with time zone, integer, character varying, integer, text, uuid, character varying, uuid, character varying, uuid, character varying, uuid, character varying, uuid, character varying, uuid, character varying, uuid, character varying, uuid, character varying, character varying, uuid, uuid, character varying, character varying, integer, integer, text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertexternalauditlog(INOUT v_audit_log_id integer, v_log_time timestamp with time zone, v_log_type integer, v_log_type_name character varying, v_severity integer, v_message text, v_user_id uuid, v_user_name character varying, v_vds_id uuid, v_vds_name character varying, v_vm_id uuid, v_vm_name character varying, v_vm_template_id uuid, v_vm_template_name character varying, v_storage_pool_id uuid, v_storage_pool_name character varying, v_storage_domain_id uuid, v_storage_domain_name character varying, v_vds_group_id uuid, v_vds_group_name character varying, v_quota_id uuid, v_quota_name character varying, v_correlation_id character varying, v_job_id uuid, v_gluster_volume_id uuid, v_gluster_volume_name character varying, v_origin character varying, v_custom_event_id integer, v_event_flood_in_sec integer, v_custom_data text) RETURNS integer
    LANGUAGE plpgsql
    AS $$
DECLARE
    v_max_message_length INTEGER;
    v_truncated_message text;
BEGIN

   -- truncate message if exceeds configured max length. truncated messages will be ended
   -- with "..." to indicate that message is incomplete due to size limits.

   v_truncated_message := v_message;
   v_max_message_length := cast(option_value as int) FROM vdc_options WHERE option_name = 'MaxAuditLogMessageLength' and version = 'general';
   IF (v_max_message_length IS NOT NULL and length(v_message) > v_max_message_length) THEN
      v_truncated_message := substr(v_message, 1, v_max_message_length -3) || '...';
   END IF;
   INSERT INTO audit_log(LOG_TIME, log_type, log_type_name, severity,message, user_id, USER_NAME, vds_id, VDS_NAME, vm_id, VM_NAME,vm_template_id,VM_TEMPLATE_NAME,storage_pool_id,STORAGE_POOL_NAME,storage_domain_id,STORAGE_DOMAIN_NAME,vds_group_id,vds_group_name, correlation_id, job_id, quota_id, quota_name, gluster_volume_id, gluster_volume_name,origin, custom_event_id, event_flood_in_sec, custom_data )
		VALUES(v_log_time, v_log_type, v_log_type_name, v_severity, v_truncated_message, v_user_id, v_user_name, v_vds_id, v_vds_name, v_vm_id, v_vm_name,v_vm_template_id,v_vm_template_name,v_storage_pool_id,v_storage_pool_name,v_storage_domain_id,v_storage_domain_name,v_vds_group_id,v_vds_group_name, v_correlation_id, v_job_id, v_quota_id, v_quota_name, v_gluster_volume_id, v_gluster_volume_name,v_origin, v_custom_event_id, v_event_flood_in_sec, v_custom_data);

   v_audit_log_id := CURRVAL('audit_log_seq');
END; $$;


ALTER FUNCTION public.insertexternalauditlog(INOUT v_audit_log_id integer, v_log_time timestamp with time zone, v_log_type integer, v_log_type_name character varying, v_severity integer, v_message text, v_user_id uuid, v_user_name character varying, v_vds_id uuid, v_vds_name character varying, v_vm_id uuid, v_vm_name character varying, v_vm_template_id uuid, v_vm_template_name character varying, v_storage_pool_id uuid, v_storage_pool_name character varying, v_storage_domain_id uuid, v_storage_domain_name character varying, v_vds_group_id uuid, v_vds_group_name character varying, v_quota_id uuid, v_quota_name character varying, v_correlation_id character varying, v_job_id uuid, v_gluster_volume_id uuid, v_gluster_volume_name character varying, v_origin character varying, v_custom_event_id integer, v_event_flood_in_sec integer, v_custom_data text) OWNER TO engineer;

--
-- Name: insertglustervolume(uuid, uuid, character varying, character varying, character varying, integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertglustervolume(v_id uuid, v_cluster_id uuid, v_vol_name character varying, v_vol_type character varying, v_status character varying, v_replica_count integer, v_stripe_count integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    INSERT INTO gluster_volumes (id, cluster_id, vol_name, vol_type,
        status, replica_count, stripe_count)
    VALUES (v_id,  v_cluster_id, v_vol_name, v_vol_type,
        v_status, v_replica_count,  v_stripe_count);
END; $$;


ALTER FUNCTION public.insertglustervolume(v_id uuid, v_cluster_id uuid, v_vol_name character varying, v_vol_type character varying, v_status character varying, v_replica_count integer, v_stripe_count integer) OWNER TO engineer;

--
-- Name: insertglustervolumeaccessprotocol(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertglustervolumeaccessprotocol(v_volume_id uuid, v_access_protocol character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    INSERT INTO gluster_volume_access_protocols (volume_id, access_protocol)
    VALUES (v_volume_id, v_access_protocol);
END; $$;


ALTER FUNCTION public.insertglustervolumeaccessprotocol(v_volume_id uuid, v_access_protocol character varying) OWNER TO engineer;

--
-- Name: insertglustervolumebrick(uuid, uuid, uuid, character varying, integer, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertglustervolumebrick(v_id uuid, v_volume_id uuid, v_server_id uuid, v_brick_dir character varying, v_brick_order integer, v_status character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    INSERT INTO gluster_volume_bricks (id, volume_id, server_id, brick_dir, brick_order, status)
    VALUES (v_id, v_volume_id, v_server_id, v_brick_dir, v_brick_order, v_status);
END; $$;


ALTER FUNCTION public.insertglustervolumebrick(v_id uuid, v_volume_id uuid, v_server_id uuid, v_brick_dir character varying, v_brick_order integer, v_status character varying) OWNER TO engineer;

--
-- Name: insertglustervolumeoption(uuid, uuid, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertglustervolumeoption(v_id uuid, v_volume_id uuid, v_option_key character varying, v_option_val character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    INSERT INTO gluster_volume_options (id, volume_id, option_key, option_val)
    VALUES (v_id, v_volume_id, v_option_key, v_option_val);
END; $$;


ALTER FUNCTION public.insertglustervolumeoption(v_id uuid, v_volume_id uuid, v_option_key character varying, v_option_val character varying) OWNER TO engineer;

--
-- Name: insertglustervolumetransporttype(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertglustervolumetransporttype(v_volume_id uuid, v_transport_type character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    INSERT INTO gluster_volume_transport_types (volume_id, transport_type)
    VALUES (v_volume_id, v_transport_type);
END; $$;


ALTER FUNCTION public.insertglustervolumetransporttype(v_volume_id uuid, v_transport_type character varying) OWNER TO engineer;

--
-- Name: insertimage(timestamp with time zone, uuid, uuid, bigint, uuid, integer, timestamp with time zone, uuid, integer, integer, uuid, boolean, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertimage(v_creation_date timestamp with time zone, v_image_guid uuid, v_it_guid uuid, v_size bigint, v_parentid uuid, v_imagestatus integer, v_lastmodified timestamp with time zone, v_vm_snapshot_id uuid, v_volume_type integer, v_volume_format integer, v_image_group_id uuid, v_active boolean, v_quota_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    INSERT INTO images(
        creation_date,
        image_guid,
        it_guid,
        size,
        ParentId,
        imageStatus,
        lastModified,
        vm_snapshot_id,
        volume_type,
        image_group_id,
        volume_format,
        active,
        quota_id)
    VALUES(
        v_creation_date,
        v_image_guid,
        v_it_guid,
        v_size,
        v_ParentId,
        v_imageStatus,
        v_lastModified,
        v_vm_snapshot_id,
        v_volume_type,
        v_image_group_id,
        v_volume_format,
        v_active,
        v_quota_id);
END; $$;


ALTER FUNCTION public.insertimage(v_creation_date timestamp with time zone, v_image_guid uuid, v_it_guid uuid, v_size bigint, v_parentid uuid, v_imagestatus integer, v_lastmodified timestamp with time zone, v_vm_snapshot_id uuid, v_volume_type integer, v_volume_format integer, v_image_group_id uuid, v_active boolean, v_quota_id uuid) OWNER TO engineer;

--
-- Name: insertimage_storage_domain_map(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertimage_storage_domain_map(v_image_id uuid, v_storage_domain_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO image_storage_domain_map(image_id, storage_domain_id)
	VALUES(v_image_id, v_storage_domain_id);
END; $$;


ALTER FUNCTION public.insertimage_storage_domain_map(v_image_id uuid, v_storage_domain_id uuid) OWNER TO engineer;

--
-- Name: insertjob(uuid, character varying, text, character varying, uuid, boolean, timestamp with time zone, timestamp with time zone, timestamp with time zone, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertjob(v_job_id uuid, v_action_type character varying, v_description text, v_status character varying, v_owner_id uuid, v_visible boolean, v_start_time timestamp with time zone, v_end_time timestamp with time zone, v_last_update_time timestamp with time zone, v_correlation_id character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    INSERT INTO job(
        job_id,
        action_type,
        description,
        status,
        owner_id,
        visible,
        start_time,
        end_time,
        last_update_time,
        correlation_id)
    VALUES (
        v_job_id,
        v_action_type,
        v_description,
        v_status,
        v_owner_id,
        v_visible,
        v_start_time,
        v_end_time,
        v_last_update_time,
        v_correlation_id);
END; $$;


ALTER FUNCTION public.insertjob(v_job_id uuid, v_action_type character varying, v_description text, v_status character varying, v_owner_id uuid, v_visible boolean, v_start_time timestamp with time zone, v_end_time timestamp with time zone, v_last_update_time timestamp with time zone, v_correlation_id character varying) OWNER TO engineer;

--
-- Name: insertjobsubjectentity(uuid, uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertjobsubjectentity(v_job_id uuid, v_entity_id uuid, v_entity_type character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    INSERT INTO job_subject_entity(
        job_id,
        entity_id,
        entity_type)
    VALUES (
        v_job_id,
        v_entity_id,
        v_entity_type);
END; $$;


ALTER FUNCTION public.insertjobsubjectentity(v_job_id uuid, v_entity_id uuid, v_entity_type character varying) OWNER TO engineer;

--
-- Name: insertlun_storage_server_connection_map(character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertlun_storage_server_connection_map(v_lun_id character varying, v_storage_server_connection character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO LUN_storage_server_connection_map(LUN_id, storage_server_connection)
	VALUES(v_LUN_id, v_storage_server_connection);
END; $$;


ALTER FUNCTION public.insertlun_storage_server_connection_map(v_lun_id character varying, v_storage_server_connection character varying) OWNER TO engineer;

--
-- Name: insertluns(character varying, character varying, character varying, character varying, integer, character varying, character varying, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertluns(v_lun_id character varying, v_physical_volume_id character varying, v_volume_group_id character varying, v_serial character varying, v_lun_mapping integer, v_vendor_id character varying, v_product_id character varying, v_device_size integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO LUNs(LUN_id, physical_volume_id, volume_group_id, serial, lun_mapping, vendor_id, product_id, device_size)
	VALUES(v_LUN_id, v_physical_volume_id, v_volume_group_id, v_serial, v_lun_mapping, v_vendor_id, v_product_id, v_device_size);
END; $$;


ALTER FUNCTION public.insertluns(v_lun_id character varying, v_physical_volume_id character varying, v_volume_group_id character varying, v_serial character varying, v_lun_mapping integer, v_vendor_id character varying, v_product_id character varying, v_device_size integer) OWNER TO engineer;

--
-- Name: insertnetwork(character varying, character varying, uuid, character varying, character varying, character varying, integer, integer, boolean, uuid, integer, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertnetwork(v_addr character varying, v_description character varying, v_id uuid, v_name character varying, v_subnet character varying, v_gateway character varying, v_type integer, v_vlan_id integer, v_stp boolean, v_storage_pool_id uuid, v_mtu integer, v_vm_network boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO network(addr, description, id, name, subnet, gateway, type, vlan_id, stp, storage_pool_id, mtu, vm_network)
	VALUES(v_addr, v_description, v_id, v_name, v_subnet, v_gateway, v_type, v_vlan_id, v_stp, v_storage_pool_id, v_mtu, v_vm_network );
END; $$;


ALTER FUNCTION public.insertnetwork(v_addr character varying, v_description character varying, v_id uuid, v_name character varying, v_subnet character varying, v_gateway character varying, v_type integer, v_vlan_id integer, v_stp boolean, v_storage_pool_id uuid, v_mtu integer, v_vm_network boolean) OWNER TO engineer;

--
-- Name: insertnetwork_cluster(uuid, uuid, integer, boolean, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertnetwork_cluster(v_cluster_id uuid, v_network_id uuid, v_status integer, v_is_display boolean, v_required boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO network_cluster(cluster_id, network_id, status, is_display, required)
	VALUES(v_cluster_id, v_network_id, v_status, v_is_display, v_required);
END; $$;


ALTER FUNCTION public.insertnetwork_cluster(v_cluster_id uuid, v_network_id uuid, v_status integer, v_is_display boolean, v_required boolean) OWNER TO engineer;

--
-- Name: insertorupdateasynctasks(integer, integer, integer, uuid, text, character varying, text, character varying, uuid, uuid, character varying, timestamp without time zone, uuid, integer, text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertorupdateasynctasks(v_action_type integer, v_result integer, v_status integer, v_task_id uuid, v_action_parameters text, v_action_params_class character varying, v_task_parameters text, v_task_params_class character varying, v_step_id uuid, v_command_id uuid, v_entity_type character varying, v_started_at timestamp without time zone, v_storage_pool_id uuid, v_async_task_type integer, v_entity_ids text) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      IF NOT EXISTS (SELECT 1 from async_tasks where async_tasks.task_id = v_task_id) THEN
            PERFORM Insertasync_tasks(v_action_type, v_result, v_status, v_task_id, v_action_parameters,
            v_action_params_class, v_task_parameters, v_task_params_class, v_step_id, v_command_id, v_entity_type, v_started_at, v_storage_pool_id, v_async_task_type, v_entity_ids);
      ELSE
            PERFORM Updateasync_tasks(v_action_type, v_result, v_status, v_task_id, v_action_parameters,  v_action_params_class, v_task_parameters, v_task_params_class, v_step_id, v_command_id);
      END IF;
END; $$;


ALTER FUNCTION public.insertorupdateasynctasks(v_action_type integer, v_result integer, v_status integer, v_task_id uuid, v_action_parameters text, v_action_params_class character varying, v_task_parameters text, v_task_params_class character varying, v_step_id uuid, v_command_id uuid, v_entity_type character varying, v_started_at timestamp without time zone, v_storage_pool_id uuid, v_async_task_type integer, v_entity_ids text) OWNER TO engineer;

--
-- Name: insertpermission(uuid, uuid, uuid, uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertpermission(v_ad_element_id uuid, v_id uuid, v_role_id uuid, v_object_id uuid, v_object_type_id integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO permissions(ad_element_id, id, role_id, object_id, object_type_id)
	VALUES(v_ad_element_id, v_id, v_role_id, v_object_id, v_object_type_id);
END; $$;


ALTER FUNCTION public.insertpermission(v_ad_element_id uuid, v_id uuid, v_role_id uuid, v_object_id uuid, v_object_type_id integer) OWNER TO engineer;

--
-- Name: insertquota(uuid, uuid, character varying, character varying, integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertquota(v_id uuid, v_storage_pool_id uuid, v_quota_name character varying, v_description character varying, v_threshold_vds_group_percentage integer, v_threshold_storage_percentage integer, v_grace_vds_group_percentage integer, v_grace_storage_percentage integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO quota(id, storage_pool_id, quota_name, description, threshold_vds_group_percentage, threshold_storage_percentage, grace_vds_group_percentage, grace_storage_percentage)
   VALUES(v_id,  v_storage_pool_id, v_quota_name,  v_description,  v_threshold_vds_group_percentage ,  v_threshold_storage_percentage,  v_grace_vds_group_percentage,  v_grace_storage_percentage);
END; $$;


ALTER FUNCTION public.insertquota(v_id uuid, v_storage_pool_id uuid, v_quota_name character varying, v_description character varying, v_threshold_vds_group_percentage integer, v_threshold_storage_percentage integer, v_grace_vds_group_percentage integer, v_grace_storage_percentage integer) OWNER TO engineer;

--
-- Name: insertquotalimitation(uuid, uuid, uuid, uuid, integer, bigint, bigint); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertquotalimitation(v_id uuid, v_quota_id uuid, v_storage_id uuid, v_vds_group_id uuid, v_virtual_cpu integer, v_mem_size_mb bigint, v_storage_size_gb bigint) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO quota_limitation(id, quota_id, storage_id, vds_group_id, virtual_cpu, mem_size_mb, storage_size_gb)
   VALUES(v_id, v_quota_id, v_storage_id, v_vds_group_id, v_virtual_cpu, v_mem_size_mb, v_storage_size_gb);

END; $$;


ALTER FUNCTION public.insertquotalimitation(v_id uuid, v_quota_id uuid, v_storage_id uuid, v_vds_group_id uuid, v_virtual_cpu integer, v_mem_size_mb bigint, v_storage_size_gb bigint) OWNER TO engineer;

--
-- Name: insertrepo_domain_file_meta_data(uuid, character varying, bigint, timestamp with time zone, bigint, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertrepo_domain_file_meta_data(v_repo_domain_id uuid, v_repo_file_name character varying, v_size bigint, v_date_created timestamp with time zone, v_last_refreshed bigint, v_file_type integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

INSERT INTO repo_file_meta_data(repo_domain_id, repo_file_name, size, date_created, last_refreshed, file_type)
    VALUES(v_repo_domain_id, v_repo_file_name, v_size, v_date_created, v_last_refreshed, v_file_type);

END; $$;


ALTER FUNCTION public.insertrepo_domain_file_meta_data(v_repo_domain_id uuid, v_repo_file_name character varying, v_size bigint, v_date_created timestamp with time zone, v_last_refreshed bigint, v_file_type integer) OWNER TO engineer;

--
-- Name: insertrole(character varying, uuid, character varying, boolean, integer, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertrole(v_description character varying, v_id uuid, v_name character varying, v_is_readonly boolean, v_role_type integer, v_allows_viewing_children boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO roles(description, id, name, is_readonly, role_type, allows_viewing_children)
	VALUES(v_description, v_id, v_name, v_is_readonly, v_role_type, v_allows_viewing_children);
END; $$;


ALTER FUNCTION public.insertrole(v_description character varying, v_id uuid, v_name character varying, v_is_readonly boolean, v_role_type integer, v_allows_viewing_children boolean) OWNER TO engineer;

--
-- Name: insertroles_relations(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertroles_relations(v_role_container_id uuid, v_role_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO roles_relations(role_container_id, role_id)
	VALUES(v_role_container_id, v_role_id);
END; $$;


ALTER FUNCTION public.insertroles_relations(v_role_container_id uuid, v_role_id uuid) OWNER TO engineer;

--
-- Name: insertsnapshot(uuid, uuid, character varying, character varying, character varying, timestamp with time zone, text, text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertsnapshot(v_snapshot_id uuid, v_vm_id uuid, v_snapshot_type character varying, v_status character varying, v_description character varying, v_creation_date timestamp with time zone, v_app_list text, v_vm_configuration text) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    INSERT INTO snapshots(
        snapshot_id,
        status,
        vm_id,
        snapshot_type,
        description,
        creation_date,
        app_list,
        vm_configuration)
    VALUES(
        v_snapshot_id,
        v_status,
        v_vm_id,
        v_snapshot_type,
        v_description,
        v_creation_date,
        v_app_list,
        v_vm_configuration);
END; $$;


ALTER FUNCTION public.insertsnapshot(v_snapshot_id uuid, v_vm_id uuid, v_snapshot_type character varying, v_status character varying, v_description character varying, v_creation_date timestamp with time zone, v_app_list text, v_vm_configuration text) OWNER TO engineer;

--
-- Name: insertstep(uuid, uuid, uuid, character varying, text, integer, character varying, timestamp with time zone, timestamp with time zone, character varying, uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertstep(v_step_id uuid, v_parent_step_id uuid, v_job_id uuid, v_step_type character varying, v_description text, v_step_number integer, v_status character varying, v_start_time timestamp with time zone, v_end_time timestamp with time zone, v_correlation_id character varying, v_external_id uuid, v_external_system_type character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    INSERT INTO step(
        step_id,
        parent_step_id,
        job_id,
        step_type,
        description,
        step_number,
        status,
        start_time,
        end_time,
        correlation_id,
        external_id,
        external_system_type)
    VALUES (
        v_step_id,
        v_parent_step_id,
        v_job_id,
        v_step_type,
        v_description,
        v_step_number,
        v_status,
        v_start_time,
        v_end_time,
        v_correlation_id,
        v_external_id,
        v_external_system_type);
END; $$;


ALTER FUNCTION public.insertstep(v_step_id uuid, v_parent_step_id uuid, v_job_id uuid, v_step_type character varying, v_description text, v_step_number integer, v_status character varying, v_start_time timestamp with time zone, v_end_time timestamp with time zone, v_correlation_id character varying, v_external_id uuid, v_external_system_type character varying) OWNER TO engineer;

--
-- Name: insertstorage_domain_dynamic(integer, uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertstorage_domain_dynamic(v_available_disk_size integer, v_id uuid, v_used_disk_size integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO storage_domain_dynamic(available_disk_size, id, used_disk_size)
	VALUES(v_available_disk_size, v_id, v_used_disk_size);
END; $$;


ALTER FUNCTION public.insertstorage_domain_dynamic(v_available_disk_size integer, v_id uuid, v_used_disk_size integer) OWNER TO engineer;

--
-- Name: insertstorage_domain_static(uuid, character varying, character varying, integer, integer, character varying, bigint); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertstorage_domain_static(v_id uuid, v_storage character varying, v_storage_name character varying, v_storage_type integer, v_storage_domain_type integer, v_storage_domain_format_type character varying, v_last_time_used_as_master bigint) RETURNS void
    LANGUAGE plpgsql
    AS $$
   BEGIN
INSERT INTO storage_domain_static(id, storage,storage_name, storage_type, storage_domain_type, storage_domain_format_type, last_time_used_as_master)
	VALUES(v_id, v_storage, v_storage_name, v_storage_type, v_storage_domain_type, v_storage_domain_format_type, v_last_time_used_as_master);
END; $$;


ALTER FUNCTION public.insertstorage_domain_static(v_id uuid, v_storage character varying, v_storage_name character varying, v_storage_type integer, v_storage_domain_type integer, v_storage_domain_format_type character varying, v_last_time_used_as_master bigint) OWNER TO engineer;

--
-- Name: insertstorage_pool(character varying, uuid, character varying, integer, integer, integer, uuid, character varying, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertstorage_pool(v_description character varying, v_id uuid, v_name character varying, v_storage_pool_type integer, v_status integer, v_master_domain_version integer, v_spm_vds_id uuid, v_compatibility_version character varying, v_quota_enforcement_type integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO storage_pool(description, id, name, storage_pool_type,status,master_domain_version,spm_vds_id,compatibility_version,quota_enforcement_type)
	VALUES(v_description, v_id, v_name, v_storage_pool_type,v_status,v_master_domain_version,v_spm_vds_id,v_compatibility_version,v_quota_enforcement_type);
END; $$;


ALTER FUNCTION public.insertstorage_pool(v_description character varying, v_id uuid, v_name character varying, v_storage_pool_type integer, v_status integer, v_master_domain_version integer, v_spm_vds_id uuid, v_compatibility_version character varying, v_quota_enforcement_type integer) OWNER TO engineer;

--
-- Name: insertstorage_pool_iso_map(uuid, uuid, integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertstorage_pool_iso_map(v_storage_id uuid, v_storage_pool_id uuid, v_status integer, v_owner integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO storage_pool_iso_map(storage_id, storage_pool_id, status, owner)
	VALUES(v_storage_id, v_storage_pool_id, v_status, v_owner);
END; $$;


ALTER FUNCTION public.insertstorage_pool_iso_map(v_storage_id uuid, v_storage_pool_id uuid, v_status integer, v_owner integer) OWNER TO engineer;

--
-- Name: insertstorage_server_connections(character varying, character varying, character varying, character varying, character varying, text, integer, character varying, character varying, character varying, character varying, smallint, smallint); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertstorage_server_connections(v_connection character varying, v_id character varying, v_iqn character varying, v_port character varying, v_portal character varying, v_password text, v_storage_type integer, v_user_name character varying, v_mount_options character varying, v_vfs_type character varying, v_nfs_version character varying, v_nfs_timeo smallint, v_nfs_retrans smallint) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO storage_server_connections(connection, id, iqn, port,portal,
	password, storage_type, user_name,mount_options,vfs_type,nfs_version,nfs_timeo,nfs_retrans)
	VALUES(v_connection, v_id, v_iqn,v_port,v_portal, v_password, v_storage_type, v_user_name,v_mount_options,v_vfs_type,v_nfs_version,v_nfs_timeo,v_nfs_retrans);
END; $$;


ALTER FUNCTION public.insertstorage_server_connections(v_connection character varying, v_id character varying, v_iqn character varying, v_port character varying, v_portal character varying, v_password text, v_storage_type integer, v_user_name character varying, v_mount_options character varying, v_vfs_type character varying, v_nfs_version character varying, v_nfs_timeo smallint, v_nfs_retrans smallint) OWNER TO engineer;

--
-- Name: inserttags(character varying, uuid, character varying, uuid, boolean, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION inserttags(v_description character varying, v_tag_id uuid, v_tag_name character varying, v_parent_id uuid, v_readonly boolean, v_type integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      INSERT INTO tags(tag_id,description, tag_name,parent_id,readonly,type)
	VALUES(v_tag_id,v_description, v_tag_name,v_parent_id,v_readonly,v_type);
END; $$;


ALTER FUNCTION public.inserttags(v_description character varying, v_tag_id uuid, v_tag_name character varying, v_parent_id uuid, v_readonly boolean, v_type integer) OWNER TO engineer;

--
-- Name: inserttags_user_group_map(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION inserttags_user_group_map(v_group_id uuid, v_tag_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO tags_user_group_map(group_id, tag_id)
	VALUES(v_group_id, v_tag_id);
END; $$;


ALTER FUNCTION public.inserttags_user_group_map(v_group_id uuid, v_tag_id uuid) OWNER TO engineer;

--
-- Name: inserttags_user_map(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION inserttags_user_map(v_tag_id uuid, v_user_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO tags_user_map(tag_id, user_id)
	VALUES(v_tag_id, v_user_id);
END; $$;


ALTER FUNCTION public.inserttags_user_map(v_tag_id uuid, v_user_id uuid) OWNER TO engineer;

--
-- Name: inserttags_vds_map(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION inserttags_vds_map(v_tag_id uuid, v_vds_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO tags_vds_map(tag_id, vds_id)
	VALUES(v_tag_id, v_vds_id);
END; $$;


ALTER FUNCTION public.inserttags_vds_map(v_tag_id uuid, v_vds_id uuid) OWNER TO engineer;

--
-- Name: inserttags_vm_map(uuid, uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION inserttags_vm_map(v_tag_id uuid, v_vm_id uuid, v_defaultdisplaytype integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO tags_vm_map(tag_id, vm_id, DefaultDisplayType)
	VALUES(v_tag_id, v_vm_id, v_DefaultDisplayType);
END; $$;


ALTER FUNCTION public.inserttags_vm_map(v_tag_id uuid, v_vm_id uuid, v_defaultdisplaytype integer) OWNER TO engineer;

--
-- Name: inserttags_vm_pool_map(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION inserttags_vm_pool_map(v_tag_id uuid, v_vm_pool_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO tags_vm_pool_map(tag_id, vm_pool_id)
	VALUES(v_tag_id, v_vm_pool_id);
END; $$;


ALTER FUNCTION public.inserttags_vm_pool_map(v_tag_id uuid, v_vm_pool_id uuid) OWNER TO engineer;

--
-- Name: insertuser(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, character varying, character varying, uuid, integer, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertuser(v_department character varying, v_desktop_device character varying, v_domain character varying, v_email character varying, v_groups character varying, v_name character varying, v_note character varying, v_role character varying, v_status integer, v_surname character varying, v_user_icon_path character varying, v_user_id uuid, v_session_count integer, v_username character varying, v_group_ids character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO users(department, desktop_device, domain, email, groups, name, note, role, status, surname, user_icon_path, user_id, session_count, username, group_ids)
	VALUES(v_department, v_desktop_device, v_domain, v_email, v_groups, v_name, v_note, v_role, v_status, v_surname, v_user_icon_path, v_user_id, v_session_count, v_username, v_group_ids);
END; $$;


ALTER FUNCTION public.insertuser(v_department character varying, v_desktop_device character varying, v_domain character varying, v_email character varying, v_groups character varying, v_name character varying, v_note character varying, v_role character varying, v_status integer, v_surname character varying, v_user_icon_path character varying, v_user_id uuid, v_session_count integer, v_username character varying, v_group_ids character varying) OWNER TO engineer;

--
-- Name: insertuser_sessions(character, character, timestamp with time zone, character, character, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertuser_sessions(v_browser character, v_client_type character, v_login_time timestamp with time zone, v_os character, v_session_id character, v_user_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      if (not exists(select session_id from user_sessions
      where session_id = v_session_id and user_id = v_user_id)) then

INSERT INTO user_sessions(browser, client_type, login_time, os, session_id, user_id)
				VALUES(v_browser, v_client_type, v_login_time, v_os, v_session_id, v_user_id);

         UPDATE users
         SET session_count = session_count+1
         WHERE
         user_id = v_user_id;
      end if;
END; $$;


ALTER FUNCTION public.insertuser_sessions(v_browser character, v_client_type character, v_login_time timestamp with time zone, v_os character, v_session_id character, v_user_id uuid) OWNER TO engineer;

--
-- Name: insertvdcoption(character varying, character varying, character varying, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvdcoption(v_option_name character varying, v_option_value character varying, v_version character varying, INOUT v_option_id integer) RETURNS integer
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO vdc_options(OPTION_NAME, option_value, version)
	VALUES(v_option_name, v_option_value, v_version);

      v_option_id := CURRVAL('vdc_options_seq');
END; $$;


ALTER FUNCTION public.insertvdcoption(v_option_name character varying, v_option_value character varying, v_version character varying, INOUT v_option_id integer) OWNER TO engineer;

--
-- Name: insertvds(uuid, character varying, character varying, character varying, integer, uuid, character varying, boolean, integer, integer, character varying, character varying, character varying, integer, character varying, boolean, character varying, character varying, character varying, character varying, text, integer, character varying, boolean, integer, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvds(v_vds_id uuid, v_host_name character varying, v_ip character varying, v_vds_unique_id character varying, v_port integer, v_vds_group_id uuid, v_vds_name character varying, v_server_ssl_enabled boolean, v_vds_type integer, v_vds_strength integer, v_pm_type character varying, v_pm_user character varying, v_pm_password character varying, v_pm_port integer, v_pm_options character varying, v_pm_enabled boolean, v_pm_proxy_preferences character varying, v_pm_secondary_ip character varying, v_pm_secondary_type character varying, v_pm_secondary_user character varying, v_pm_secondary_password text, v_pm_secondary_port integer, v_pm_secondary_options character varying, v_pm_secondary_concurrent boolean, v_vds_spm_priority integer, v_console_address character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   BEGIN
      INSERT INTO vds_static(vds_id,host_name, ip, vds_unique_id, port, vds_group_id, vds_name, server_SSL_enabled,
                             vds_type,vds_strength,pm_type,pm_user,pm_password, pm_port, pm_options, pm_enabled,
                             pm_secondary_ip, pm_secondary_type, pm_secondary_user,
                             pm_secondary_password, pm_secondary_port, pm_secondary_options, pm_secondary_concurrent,
                             pm_proxy_preferences, vds_spm_priority, console_address)
	VALUES(v_vds_id,v_host_name, v_ip, v_vds_unique_id, v_port, v_vds_group_id, v_vds_name, v_server_SSL_enabled,
               v_vds_type, v_vds_strength,v_pm_type,v_pm_user,v_pm_password,v_pm_port, v_pm_options, v_pm_enabled,
               pm_secondary_ip, pm_secondary_type, pm_secondary_user,
               pm_secondary_password, pm_secondary_port, pm_secondary_options, pm_secondary_concurrent,v_pm_proxy_preferences,
               v_vds_spm_priority, v_console_address);

      INSERT INTO vds_dynamic(vds_id, status) VALUES(v_vds_id, 0);

      INSERT INTO vds_statistics(vds_id) VALUES(v_vds_id);
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.insertvds(v_vds_id uuid, v_host_name character varying, v_ip character varying, v_vds_unique_id character varying, v_port integer, v_vds_group_id uuid, v_vds_name character varying, v_server_ssl_enabled boolean, v_vds_type integer, v_vds_strength integer, v_pm_type character varying, v_pm_user character varying, v_pm_password character varying, v_pm_port integer, v_pm_options character varying, v_pm_enabled boolean, v_pm_proxy_preferences character varying, v_pm_secondary_ip character varying, v_pm_secondary_type character varying, v_pm_secondary_user character varying, v_pm_secondary_password text, v_pm_secondary_port integer, v_pm_secondary_options character varying, v_pm_secondary_concurrent boolean, v_vds_spm_priority integer, v_console_address character varying) OWNER TO engineer;

--
-- Name: insertvds_interface(character varying, character varying, integer, character varying, uuid, boolean, character varying, character varying, character varying, character varying, integer, character varying, integer, integer, uuid, integer, integer, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvds_interface(v_addr character varying, v_bond_name character varying, v_bond_type integer, v_gateway character varying, v_id uuid, v_is_bond boolean, v_bond_opts character varying, v_mac_addr character varying, v_name character varying, v_network_name character varying, v_speed integer, v_subnet character varying, v_boot_protocol integer, v_type integer, v_vds_id uuid, v_vlan_id integer, v_mtu integer, v_bridged boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO vds_interface(addr, bond_name, bond_type, gateway, id, is_bond, bond_opts, mac_addr, name, network_name, speed, subnet, boot_protocol, type, VDS_ID, vlan_id, mtu, bridged)
	VALUES(v_addr, v_bond_name, v_bond_type, v_gateway, v_id, v_is_bond, v_bond_opts, v_mac_addr, v_name, v_network_name, v_speed, v_subnet, v_boot_protocol, v_type, v_vds_id, v_vlan_id, v_mtu, v_bridged);
END; $$;


ALTER FUNCTION public.insertvds_interface(v_addr character varying, v_bond_name character varying, v_bond_type integer, v_gateway character varying, v_id uuid, v_is_bond boolean, v_bond_opts character varying, v_mac_addr character varying, v_name character varying, v_network_name character varying, v_speed integer, v_subnet character varying, v_boot_protocol integer, v_type integer, v_vds_id uuid, v_vlan_id integer, v_mtu integer, v_bridged boolean) OWNER TO engineer;

--
-- Name: insertvds_interface_statistics(uuid, numeric, numeric, numeric, numeric, integer, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvds_interface_statistics(v_id uuid, v_rx_drop numeric, v_rx_rate numeric, v_tx_drop numeric, v_tx_rate numeric, v_iface_status integer, v_vds_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO vds_interface_statistics(id, rx_drop, rx_rate, tx_drop, tx_rate, vds_id, iface_status)
	VALUES(v_id, v_rx_drop, v_rx_rate, v_tx_drop, v_tx_rate, v_vds_id,v_iface_status);
END; $$;


ALTER FUNCTION public.insertvds_interface_statistics(v_id uuid, v_rx_drop numeric, v_rx_rate numeric, v_tx_drop numeric, v_tx_rate numeric, v_iface_status integer, v_vds_id uuid) OWNER TO engineer;

--
-- Name: insertvds_spm_id_map(uuid, uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvds_spm_id_map(v_storage_pool_id uuid, v_vds_id uuid, v_vds_spm_id integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO vds_spm_id_map(storage_pool_id, vds_id, vds_spm_id)
	VALUES(v_storage_pool_id, v_vds_id, v_vds_spm_id);
END; $$;


ALTER FUNCTION public.insertvds_spm_id_map(v_storage_pool_id uuid, v_vds_id uuid, v_vds_spm_id integer) OWNER TO engineer;

--
-- Name: insertvdsdynamic(integer, integer, character varying, numeric, character varying, boolean, integer, integer, integer, uuid, integer, integer, integer, integer, integer, integer, character varying, character varying, character varying, character varying, integer, character varying, timestamp with time zone, integer, integer, integer, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvdsdynamic(v_cpu_cores integer, v_cpu_threads integer, v_cpu_model character varying, v_cpu_speed_mh numeric, v_if_total_speed character varying, v_kvm_enabled boolean, v_mem_commited integer, v_physical_mem_mb integer, v_status integer, v_vds_id uuid, v_vm_active integer, v_vm_count integer, v_vms_cores_count integer, v_vm_migrating integer, v_reserved_mem integer, v_guest_overhead integer, v_rpm_version character varying, v_software_version character varying, v_version_name character varying, v_build_name character varying, v_previous_status integer, v_cpu_flags character varying, v_cpu_over_commit_time_stamp timestamp with time zone, v_pending_vcpus_count integer, v_pending_vmem_size integer, v_cpu_sockets integer, v_net_config_dirty boolean, v_supported_cluster_levels character varying, v_supported_engines character varying, v_host_os character varying, v_kvm_version character varying, v_libvirt_version character varying, v_spice_version character varying, v_kernel_version character varying, v_iscsi_initiator_name character varying, v_transparent_hugepages_state integer, v_anonymous_hugepages integer, v_hooks character varying, v_hw_manufacturer character varying, v_hw_product_name character varying, v_hw_version character varying, v_hw_serial_number character varying, v_hw_uuid character varying, v_hw_family character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   BEGIN
INSERT INTO vds_dynamic(cpu_cores, cpu_threads, cpu_model, cpu_speed_mh, if_total_speed, kvm_enabled, mem_commited, physical_mem_mb,	status, vds_id, vm_active, vm_count, vm_migrating, reserved_mem, guest_overhead, rpm_version, software_version, version_name, build_name, previous_status, cpu_flags, cpu_over_commit_time_stamp, vms_cores_count, pending_vcpus_count, pending_vmem_size, cpu_sockets,net_config_dirty, supported_cluster_levels, supported_engines, host_os, kvm_version, libvirt_version, spice_version, kernel_version, iscsi_initiator_name, transparent_hugepages_state, anonymous_hugepages,hooks, hw_manufacturer, hw_product_name, hw_version, hw_serial_number, hw_uuid, hw_family)
	VALUES(v_cpu_cores,	v_cpu_threads, v_cpu_model,	v_cpu_speed_mh,	v_if_total_speed, v_kvm_enabled, v_mem_commited, v_physical_mem_mb,	v_status, v_vds_id, v_vm_active, v_vm_count, v_vm_migrating,	v_reserved_mem, v_guest_overhead, v_rpm_version, v_software_version, v_version_name, v_build_name, v_previous_status, v_cpu_flags, v_cpu_over_commit_time_stamp, v_vms_cores_count,v_pending_vcpus_count, v_pending_vmem_size, v_cpu_sockets, v_net_config_dirty, v_supported_cluster_levels, v_supported_engines, v_host_os, v_kvm_version, v_libvirt_version, v_spice_version, v_kernel_version, v_iscsi_initiator_name, v_transparent_hugepages_state, v_anonymous_hugepages,v_hooks, v_hw_manufacturer, v_hw_product_name, v_hw_version, v_hw_serial_number, v_hw_uuid, v_hw_family);
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.insertvdsdynamic(v_cpu_cores integer, v_cpu_threads integer, v_cpu_model character varying, v_cpu_speed_mh numeric, v_if_total_speed character varying, v_kvm_enabled boolean, v_mem_commited integer, v_physical_mem_mb integer, v_status integer, v_vds_id uuid, v_vm_active integer, v_vm_count integer, v_vms_cores_count integer, v_vm_migrating integer, v_reserved_mem integer, v_guest_overhead integer, v_rpm_version character varying, v_software_version character varying, v_version_name character varying, v_build_name character varying, v_previous_status integer, v_cpu_flags character varying, v_cpu_over_commit_time_stamp timestamp with time zone, v_pending_vcpus_count integer, v_pending_vmem_size integer, v_cpu_sockets integer, v_net_config_dirty boolean, v_supported_cluster_levels character varying, v_supported_engines character varying, v_host_os character varying, v_kvm_version character varying, v_libvirt_version character varying, v_spice_version character varying, v_kernel_version character varying, v_iscsi_initiator_name character varying, v_transparent_hugepages_state integer, v_anonymous_hugepages integer, v_hooks character varying, v_hw_manufacturer character varying, v_hw_product_name character varying, v_hw_version character varying, v_hw_serial_number character varying, v_hw_uuid character varying, v_hw_family character varying) OWNER TO engineer;

--
-- Name: insertvdsgroups(uuid, character varying, character varying, character varying, integer, integer, integer, integer, uuid, integer, boolean, character varying, boolean, integer, boolean, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvdsgroups(v_vds_group_id uuid, v_description character varying, v_name character varying, v_cpu_name character varying, v_selection_algorithm integer, v_high_utilization integer, v_low_utilization integer, v_cpu_over_commit_duration_minutes integer, v_storage_pool_id uuid, v_max_vds_memory_over_commit integer, v_count_threads_as_cores boolean, v_compatibility_version character varying, v_transparent_hugepages boolean, v_migrate_on_error integer, v_virt_service boolean, v_gluster_service boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      INSERT INTO vds_groups(vds_group_id,description, name, cpu_name, selection_algorithm, high_utilization, low_utilization,
	cpu_over_commit_duration_minutes, storage_pool_id,  max_vds_memory_over_commit, count_threads_as_cores, compatibility_version,
    transparent_hugepages, migrate_on_error, virt_service, gluster_service)
	VALUES(v_vds_group_id,v_description, v_name, v_cpu_name, v_selection_algorithm, v_high_utilization, v_low_utilization,
	v_cpu_over_commit_duration_minutes, v_storage_pool_id,  v_max_vds_memory_over_commit, v_count_threads_as_cores, v_compatibility_version,
    v_transparent_hugepages, v_migrate_on_error, v_virt_service, v_gluster_service);
END; $$;


ALTER FUNCTION public.insertvdsgroups(v_vds_group_id uuid, v_description character varying, v_name character varying, v_cpu_name character varying, v_selection_algorithm integer, v_high_utilization integer, v_low_utilization integer, v_cpu_over_commit_duration_minutes integer, v_storage_pool_id uuid, v_max_vds_memory_over_commit integer, v_count_threads_as_cores boolean, v_compatibility_version character varying, v_transparent_hugepages boolean, v_migrate_on_error integer, v_virt_service boolean, v_gluster_service boolean) OWNER TO engineer;

--
-- Name: insertvdsstatic(uuid, character varying, character varying, character varying, integer, uuid, character varying, boolean, integer, integer, character varying, character varying, character varying, integer, character varying, boolean, character varying, character varying, character varying, character varying, text, integer, character varying, boolean, integer, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvdsstatic(v_vds_id uuid, v_host_name character varying, v_ip character varying, v_vds_unique_id character varying, v_port integer, v_vds_group_id uuid, v_vds_name character varying, v_server_ssl_enabled boolean, v_vds_type integer, v_vds_strength integer, v_pm_type character varying, v_pm_user character varying, v_pm_password character varying, v_pm_port integer, v_pm_options character varying, v_pm_enabled boolean, v_pm_proxy_preferences character varying, v_pm_secondary_ip character varying, v_pm_secondary_type character varying, v_pm_secondary_user character varying, v_pm_secondary_password text, v_pm_secondary_port integer, v_pm_secondary_options character varying, v_pm_secondary_concurrent boolean, v_vds_spm_priority integer, v_sshkeyfingerprint character varying, v_console_address character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
   IF v_vds_unique_id IS NULL OR NOT EXISTS(SELECT vds_name FROM vds_static WHERE vds_unique_id = v_vds_unique_id) then
      BEGIN
         INSERT INTO vds_static(vds_id,host_name, ip, vds_unique_id, port, vds_group_id, vds_name, server_SSL_enabled,
                               vds_type,vds_strength,pm_type,pm_user,pm_password,pm_port,pm_options,pm_enabled,
                               pm_proxy_preferences, pm_secondary_ip, pm_secondary_type, pm_secondary_user,
                               pm_secondary_password, pm_secondary_port, pm_secondary_options, pm_secondary_concurrent,
                               vds_spm_priority, sshKeyFingerprint, console_address)
			VALUES(v_vds_id,v_host_name, v_ip, v_vds_unique_id, v_port, v_vds_group_id, v_vds_name, v_server_SSL_enabled,
                               v_vds_type,v_vds_strength,v_pm_type,v_pm_user,v_pm_password,v_pm_port,v_pm_options,v_pm_enabled,
                               v_pm_proxy_preferences, v_pm_secondary_ip, v_pm_secondary_type, v_pm_secondary_user,
                               v_pm_secondary_password, v_pm_secondary_port, v_pm_secondary_options, v_pm_secondary_concurrent,
                               v_vds_spm_priority, v_sshKeyFingerprint, v_console_address);
      END;
   end if;
   RETURN;
END; $$;


ALTER FUNCTION public.insertvdsstatic(v_vds_id uuid, v_host_name character varying, v_ip character varying, v_vds_unique_id character varying, v_port integer, v_vds_group_id uuid, v_vds_name character varying, v_server_ssl_enabled boolean, v_vds_type integer, v_vds_strength integer, v_pm_type character varying, v_pm_user character varying, v_pm_password character varying, v_pm_port integer, v_pm_options character varying, v_pm_enabled boolean, v_pm_proxy_preferences character varying, v_pm_secondary_ip character varying, v_pm_secondary_type character varying, v_pm_secondary_user character varying, v_pm_secondary_password text, v_pm_secondary_port integer, v_pm_secondary_options character varying, v_pm_secondary_concurrent boolean, v_vds_spm_priority integer, v_sshkeyfingerprint character varying, v_console_address character varying) OWNER TO engineer;

--
-- Name: insertvdsstatistics(numeric, numeric, numeric, numeric, integer, integer, integer, uuid, bigint, bigint, bigint, bigint, integer, bigint, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvdsstatistics(v_cpu_idle numeric, v_cpu_load numeric, v_cpu_sys numeric, v_cpu_user numeric, v_usage_cpu_percent integer, v_usage_mem_percent integer, v_usage_network_percent integer, v_vds_id uuid, v_mem_available bigint, v_mem_shared bigint, v_swap_free bigint, v_swap_total bigint, v_ksm_cpu_percent integer, v_ksm_pages bigint, v_ksm_state boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   BEGIN
INSERT INTO vds_statistics(cpu_idle, cpu_load, cpu_sys, cpu_user, usage_cpu_percent, usage_mem_percent, usage_network_percent, vds_id, mem_available, mem_shared,swap_free,swap_total,ksm_cpu_percent,ksm_pages,ksm_state)
	VALUES(v_cpu_idle, v_cpu_load, v_cpu_sys, v_cpu_user, v_usage_cpu_percent, v_usage_mem_percent, v_usage_network_percent, v_vds_id, v_mem_available, v_mem_shared,v_swap_free,v_swap_total,v_ksm_cpu_percent,v_ksm_pages,v_ksm_state);
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.insertvdsstatistics(v_cpu_idle numeric, v_cpu_load numeric, v_cpu_sys numeric, v_cpu_user numeric, v_usage_cpu_percent integer, v_usage_mem_percent integer, v_usage_network_percent integer, v_vds_id uuid, v_mem_available bigint, v_mem_shared bigint, v_swap_free bigint, v_swap_total bigint, v_ksm_cpu_percent integer, v_ksm_pages bigint, v_ksm_state boolean) OWNER TO engineer;

--
-- Name: insertvm(character varying, integer, integer, uuid, uuid, character varying, uuid, integer, boolean, boolean, boolean, integer, integer, integer, character varying, boolean, boolean, boolean, boolean, uuid, boolean, integer, integer, integer, integer, integer, character varying, integer, character varying, character varying, character varying, integer, character varying, character varying, integer, character varying, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvm(v_description character varying, v_mem_size_mb integer, v_os integer, v_vds_group_id uuid, v_vm_guid uuid, v_vm_name character varying, v_vmt_guid uuid, v_num_of_monitors integer, v_allow_console_reconnect boolean, v_is_initialized boolean, v_is_auto_suspend boolean, v_num_of_sockets integer, v_cpu_per_socket integer, v_usb_policy integer, v_time_zone character varying, v_auto_startup boolean, v_is_stateless boolean, v_is_smartcard_enabled boolean, v_is_delete_protected boolean, v_dedicated_vm_for_vds uuid, v_fail_back boolean, v_vm_type integer, v_nice_level integer, v_default_boot_sequence integer, v_default_display_type integer, v_priority integer, v_iso_path character varying, v_origin integer, v_initrd_url character varying, v_kernel_url character varying, v_kernel_params character varying, v_migration_support integer, v_predefined_properties character varying, v_userdefined_properties character varying, v_min_allocated_mem integer, v_cpu_pinning character varying, v_host_cpu_flags boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO vm_static(description, mem_size_mb, os, vds_group_id, vm_guid, VM_NAME, vmt_guid, num_of_monitors, allow_console_reconnect, is_initialized, is_auto_suspend, num_of_sockets, cpu_per_socket, usb_policy, time_zone,auto_startup,is_stateless,dedicated_vm_for_vds,fail_back,vm_type,nice_level,default_boot_sequence,default_display_type,priority,iso_path,origin,initrd_url,kernel_url,kernel_params,migration_support,predefined_properties,userdefined_properties,min_allocated_mem,cpu_pinning,is_smartcard_enabled,is_delete_protected,host_cpu_flags)
	VALUES(v_description, v_mem_size_mb, v_os, v_vds_group_id, v_vm_guid, v_vm_name, v_vmt_guid, v_num_of_monitors, v_num_of_monitors, v_is_initialized, v_is_auto_suspend, v_num_of_sockets, v_cpu_per_socket, v_usb_policy, v_time_zone,v_auto_startup,v_is_stateless,v_dedicated_vm_for_vds,v_fail_back,v_vm_type,v_nice_level,v_default_boot_sequence,v_default_display_type,v_priority,v_iso_path,v_origin,v_initrd_url,v_kernel_url,v_kernel_params,v_migration_support,v_predefined_properties,v_userdefined_properties,v_min_allocated_mem,v_cpu_pinning,v_is_smartcard_enabled,v_is_delete_protected,v_host_cpu_flags);

      INSERT INTO vm_dynamic(vm_guid, status) VALUES(v_vm_guid, 0);

      INSERT INTO vm_statistics(vm_guid) VALUES(v_vm_guid);

      INSERT INTO vm_ovf_generations(vm_guid, storage_pool_id) VALUES (v_vm_guid, (select storage_pool_id from vds_groups vg where vg.vds_group_id = v_vds_group_id));

      UPDATE vm_static
      SET child_count =(SELECT COUNT(*) FROM vm_static WHERE vmt_guid = v_vmt_guid)
      WHERE vm_guid = v_vmt_guid;
END; $$;


ALTER FUNCTION public.insertvm(v_description character varying, v_mem_size_mb integer, v_os integer, v_vds_group_id uuid, v_vm_guid uuid, v_vm_name character varying, v_vmt_guid uuid, v_num_of_monitors integer, v_allow_console_reconnect boolean, v_is_initialized boolean, v_is_auto_suspend boolean, v_num_of_sockets integer, v_cpu_per_socket integer, v_usb_policy integer, v_time_zone character varying, v_auto_startup boolean, v_is_stateless boolean, v_is_smartcard_enabled boolean, v_is_delete_protected boolean, v_dedicated_vm_for_vds uuid, v_fail_back boolean, v_vm_type integer, v_nice_level integer, v_default_boot_sequence integer, v_default_display_type integer, v_priority integer, v_iso_path character varying, v_origin integer, v_initrd_url character varying, v_kernel_url character varying, v_kernel_params character varying, v_migration_support integer, v_predefined_properties character varying, v_userdefined_properties character varying, v_min_allocated_mem integer, v_cpu_pinning character varying, v_host_cpu_flags boolean) OWNER TO engineer;

--
-- Name: insertvm_interface(uuid, character varying, character varying, character varying, integer, uuid, uuid, integer, boolean, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvm_interface(v_id uuid, v_mac_addr character varying, v_name character varying, v_network_name character varying, v_speed integer, v_vm_guid uuid, v_vmt_guid uuid, v_type integer, v_port_mirroring boolean, v_linked boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO vm_interface(id, mac_addr, name, network_name, speed, VM_GUID, VMT_GUID, type, port_mirroring, linked)
	VALUES(v_id, v_mac_addr, v_name, v_network_name, v_speed, v_vm_guid, v_vmt_guid, v_type, v_port_mirroring, v_linked);
END; $$;


ALTER FUNCTION public.insertvm_interface(v_id uuid, v_mac_addr character varying, v_name character varying, v_network_name character varying, v_speed integer, v_vm_guid uuid, v_vmt_guid uuid, v_type integer, v_port_mirroring boolean, v_linked boolean) OWNER TO engineer;

--
-- Name: insertvm_interface_statistics(uuid, numeric, numeric, numeric, numeric, integer, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvm_interface_statistics(v_id uuid, v_rx_drop numeric, v_rx_rate numeric, v_tx_drop numeric, v_tx_rate numeric, v_iface_status integer, v_vm_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO vm_interface_statistics(id, rx_drop, rx_rate, tx_drop, tx_rate, vm_id, iface_status)
	VALUES(v_id, v_rx_drop, v_rx_rate, v_tx_drop, v_tx_rate, v_vm_id,v_iface_status);
END; $$;


ALTER FUNCTION public.insertvm_interface_statistics(v_id uuid, v_rx_drop numeric, v_rx_rate numeric, v_tx_drop numeric, v_tx_rate numeric, v_iface_status integer, v_vm_id uuid) OWNER TO engineer;

--
-- Name: insertvm_pool_map(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvm_pool_map(v_vm_guid uuid, v_vm_pool_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO vm_pool_map(vm_guid, vm_pool_id)
	VALUES(v_vm_guid, v_vm_pool_id);
END; $$;


ALTER FUNCTION public.insertvm_pool_map(v_vm_guid uuid, v_vm_pool_id uuid) OWNER TO engineer;

--
-- Name: insertvm_pools(character varying, uuid, character varying, integer, character varying, integer, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvm_pools(v_vm_pool_description character varying, v_vm_pool_id uuid, v_vm_pool_name character varying, v_vm_pool_type integer, v_parameters character varying, v_prestarted_vms integer, v_vds_group_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      INSERT INTO vm_pools(vm_pool_id,vm_pool_description, vm_pool_name, vm_pool_type,parameters, prestarted_vms, vds_group_id)
      VALUES(v_vm_pool_id,v_vm_pool_description, v_vm_pool_name,v_vm_pool_type,v_parameters, v_prestarted_vms, v_vds_group_id);
END; $$;


ALTER FUNCTION public.insertvm_pools(v_vm_pool_description character varying, v_vm_pool_id uuid, v_vm_pool_name character varying, v_vm_pool_type integer, v_parameters character varying, v_prestarted_vms integer, v_vds_group_id uuid) OWNER TO engineer;

--
-- Name: insertvmdevice(uuid, uuid, character varying, character varying, character varying, integer, text, boolean, boolean, boolean, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvmdevice(v_device_id uuid, v_vm_id uuid, v_device character varying, v_type character varying, v_address character varying, v_boot_order integer, v_spec_params text, v_is_managed boolean, v_is_plugged boolean, v_is_readonly boolean, v_alias character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    INSERT INTO vm_device(
        device_id,
        vm_id ,
        device ,
        type,
        address ,
        boot_order ,
        spec_params,
        is_managed,
        is_plugged,
        is_readonly,
        alias)
    VALUES(
        v_device_id ,
        v_vm_id ,
        v_device ,
        v_type ,
        v_address ,
        v_boot_order ,
        v_spec_params,
        v_is_managed,
        v_is_plugged,
        v_is_readonly,
        v_alias);
END; $$;


ALTER FUNCTION public.insertvmdevice(v_device_id uuid, v_vm_id uuid, v_device character varying, v_type character varying, v_address character varying, v_boot_order integer, v_spec_params text, v_is_managed boolean, v_is_plugged boolean, v_is_readonly boolean, v_alias character varying) OWNER TO engineer;

--
-- Name: insertvmdynamic(character varying, character varying, character varying, timestamp with time zone, timestamp with time zone, uuid, character varying, uuid, uuid, integer, uuid, character varying, character varying, timestamp with time zone, integer, integer, boolean, integer, character varying, integer, boolean, integer, integer, integer, uuid, character varying, integer, character varying, integer, integer, character varying, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvmdynamic(v_app_list character varying, v_guest_cur_user_name character varying, v_console_cur_user_name character varying, v_guest_last_login_time timestamp with time zone, v_guest_last_logout_time timestamp with time zone, v_console_user_id uuid, v_guest_os character varying, v_migrating_to_vds uuid, v_run_on_vds uuid, v_status integer, v_vm_guid uuid, v_vm_host character varying, v_vm_ip character varying, v_last_start_time timestamp with time zone, v_vm_pid integer, v_display integer, v_acpi_enable boolean, v_session integer, v_display_ip character varying, v_display_type integer, v_kvm_enable boolean, v_boot_sequence integer, v_display_secure_port integer, v_utc_diff integer, v_last_vds_run_on uuid, v_client_ip character varying, v_guest_requested_memory integer, v_hibernation_vol_handle character varying, v_exit_status integer, v_pause_status integer, v_exit_message character varying, v_guest_agent_nics_hash integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO vm_dynamic(app_list, guest_cur_user_name, console_cur_user_name, guest_last_login_time, guest_last_logout_time, console_user_id, guest_os, migrating_to_vds, RUN_ON_VDS, status, vm_guid, vm_host, vm_ip, last_start_time, vm_pid, display, acpi_enable, session, display_ip, display_type, kvm_enable, boot_sequence, display_secure_port, utc_diff, last_vds_run_on, client_ip, guest_requested_memory, hibernation_vol_handle,exit_status,pause_status,exit_message, guest_agent_nics_hash)
	VALUES(v_app_list, v_guest_cur_user_name, v_console_cur_user_name, v_guest_last_login_time, v_guest_last_logout_time, v_console_user_id, v_guest_os, v_migrating_to_vds, v_run_on_vds, v_status, v_vm_guid, v_vm_host, v_vm_ip, v_last_start_time, v_vm_pid, v_display, v_acpi_enable, v_session, v_display_ip, v_display_type, v_kvm_enable, v_boot_sequence, v_display_secure_port, v_utc_diff, v_last_vds_run_on, v_client_ip, v_guest_requested_memory, v_hibernation_vol_handle, v_exit_status, v_pause_status, v_exit_message, v_guest_agent_nics_hash);
END; $$;


ALTER FUNCTION public.insertvmdynamic(v_app_list character varying, v_guest_cur_user_name character varying, v_console_cur_user_name character varying, v_guest_last_login_time timestamp with time zone, v_guest_last_logout_time timestamp with time zone, v_console_user_id uuid, v_guest_os character varying, v_migrating_to_vds uuid, v_run_on_vds uuid, v_status integer, v_vm_guid uuid, v_vm_host character varying, v_vm_ip character varying, v_last_start_time timestamp with time zone, v_vm_pid integer, v_display integer, v_acpi_enable boolean, v_session integer, v_display_ip character varying, v_display_type integer, v_kvm_enable boolean, v_boot_sequence integer, v_display_secure_port integer, v_utc_diff integer, v_last_vds_run_on uuid, v_client_ip character varying, v_guest_requested_memory integer, v_hibernation_vol_handle character varying, v_exit_status integer, v_pause_status integer, v_exit_message character varying, v_guest_agent_nics_hash integer) OWNER TO engineer;

--
-- Name: insertvmguestagentinterface(uuid, character varying, character varying, text, text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvmguestagentinterface(v_vm_id uuid, v_interface_name character varying, v_mac_address character varying, v_ipv4_addresses text, v_ipv6_addresses text) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO vm_guest_agent_interfaces(vm_id, interface_name, mac_address, ipv4_addresses, ipv6_addresses)
       VALUES(v_vm_id, v_interface_name, v_mac_address, v_ipv4_addresses, v_ipv6_addresses);
END; $$;


ALTER FUNCTION public.insertvmguestagentinterface(v_vm_id uuid, v_interface_name character varying, v_mac_address character varying, v_ipv4_addresses text, v_ipv6_addresses text) OWNER TO engineer;

--
-- Name: insertvmstatic(character varying, integer, integer, uuid, uuid, character varying, uuid, character varying, timestamp with time zone, integer, boolean, boolean, boolean, integer, integer, integer, character varying, boolean, boolean, boolean, boolean, uuid, boolean, integer, integer, integer, integer, integer, character varying, integer, character varying, character varying, character varying, integer, character varying, character varying, integer, uuid, character varying, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvmstatic(v_description character varying, v_mem_size_mb integer, v_os integer, v_vds_group_id uuid, v_vm_guid uuid, v_vm_name character varying, v_vmt_guid uuid, v_domain character varying, v_creation_date timestamp with time zone, v_num_of_monitors integer, v_allow_console_reconnect boolean, v_is_initialized boolean, v_is_auto_suspend boolean, v_num_of_sockets integer, v_cpu_per_socket integer, v_usb_policy integer, v_time_zone character varying, v_auto_startup boolean, v_is_stateless boolean, v_is_smartcard_enabled boolean, v_is_delete_protected boolean, v_dedicated_vm_for_vds uuid, v_fail_back boolean, v_vm_type integer, v_nice_level integer, v_default_boot_sequence integer, v_default_display_type integer, v_priority integer, v_iso_path character varying, v_origin integer, v_initrd_url character varying, v_kernel_url character varying, v_kernel_params character varying, v_migration_support integer, v_predefined_properties character varying, v_userdefined_properties character varying, v_min_allocated_mem integer, v_quota_id uuid, v_cpu_pinning character varying, v_host_cpu_flags boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO vm_static(description, mem_size_mb, os, vds_group_id, vm_guid, VM_NAME, vmt_guid,domain,creation_date,num_of_monitors,allow_console_reconnect,is_initialized,is_auto_suspend,num_of_sockets,cpu_per_socket,usb_policy, time_zone,auto_startup,is_stateless,dedicated_vm_for_vds, fail_back, default_boot_sequence, vm_type, nice_level, default_display_type, priority,iso_path,origin,initrd_url,kernel_url,kernel_params,migration_support,predefined_properties,userdefined_properties,min_allocated_mem, entity_type, quota_id, cpu_pinning, is_smartcard_enabled,is_delete_protected,host_cpu_flags)
	VALUES(v_description,  v_mem_size_mb, v_os, v_vds_group_id, v_vm_guid, v_vm_name, v_vmt_guid, v_domain, v_creation_date, v_num_of_monitors, v_allow_console_reconnect, v_is_initialized, v_is_auto_suspend, v_num_of_sockets, v_cpu_per_socket, v_usb_policy, v_time_zone, v_auto_startup,v_is_stateless,v_dedicated_vm_for_vds,v_fail_back, v_default_boot_sequence, v_vm_type, v_nice_level, v_default_display_type, v_priority,v_iso_path,v_origin,v_initrd_url,v_kernel_url,v_kernel_params,v_migration_support,v_predefined_properties,v_userdefined_properties,v_min_allocated_mem, 'VM', v_quota_id, v_cpu_pinning, v_is_smartcard_enabled,v_is_delete_protected,v_host_cpu_flags);
-- perform deletion from vm_ovf_generations to ensure that no record exists when performing insert to avoid PK violation.
DELETE FROM vm_ovf_generations gen WHERE gen.vm_guid = v_vm_guid;
INSERT INTO vm_ovf_generations(vm_guid, storage_pool_id) VALUES (v_vm_guid, (SELECT storage_pool_id FROM vds_groups vg WHERE vg.vds_group_id = v_vds_group_id));
END; $$;


ALTER FUNCTION public.insertvmstatic(v_description character varying, v_mem_size_mb integer, v_os integer, v_vds_group_id uuid, v_vm_guid uuid, v_vm_name character varying, v_vmt_guid uuid, v_domain character varying, v_creation_date timestamp with time zone, v_num_of_monitors integer, v_allow_console_reconnect boolean, v_is_initialized boolean, v_is_auto_suspend boolean, v_num_of_sockets integer, v_cpu_per_socket integer, v_usb_policy integer, v_time_zone character varying, v_auto_startup boolean, v_is_stateless boolean, v_is_smartcard_enabled boolean, v_is_delete_protected boolean, v_dedicated_vm_for_vds uuid, v_fail_back boolean, v_vm_type integer, v_nice_level integer, v_default_boot_sequence integer, v_default_display_type integer, v_priority integer, v_iso_path character varying, v_origin integer, v_initrd_url character varying, v_kernel_url character varying, v_kernel_params character varying, v_migration_support integer, v_predefined_properties character varying, v_userdefined_properties character varying, v_min_allocated_mem integer, v_quota_id uuid, v_cpu_pinning character varying, v_host_cpu_flags boolean) OWNER TO engineer;

--
-- Name: insertvmstatistics(numeric, numeric, numeric, integer, integer, integer, text, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvmstatistics(v_cpu_sys numeric, v_cpu_user numeric, v_elapsed_time numeric, v_usage_cpu_percent integer, v_usage_mem_percent integer, v_usage_network_percent integer, v_disks_usage text, v_vm_guid uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT INTO vm_statistics(cpu_sys, cpu_user, elapsed_time, usage_cpu_percent, usage_mem_percent, usage_network_percent, disks_usage, vm_guid)
	VALUES(v_cpu_sys, v_cpu_user, v_elapsed_time, v_usage_cpu_percent, v_usage_mem_percent, v_usage_network_percent, v_disks_usage, v_vm_guid);
END; $$;


ALTER FUNCTION public.insertvmstatistics(v_cpu_sys numeric, v_cpu_user numeric, v_elapsed_time numeric, v_usage_cpu_percent integer, v_usage_mem_percent integer, v_usage_network_percent integer, v_disks_usage text, v_vm_guid uuid) OWNER TO engineer;

--
-- Name: insertvmtemplate(integer, timestamp with time zone, character varying, integer, character varying, integer, integer, integer, uuid, uuid, character varying, integer, boolean, integer, integer, character varying, boolean, boolean, integer, integer, integer, integer, integer, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, character varying, uuid, integer, uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION insertvmtemplate(v_child_count integer, v_creation_date timestamp with time zone, v_description character varying, v_mem_size_mb integer, v_name character varying, v_num_of_sockets integer, v_cpu_per_socket integer, v_os integer, v_vmt_guid uuid, v_vds_group_id uuid, v_domain character varying, v_num_of_monitors integer, v_allow_console_reconnect boolean, v_status integer, v_usb_policy integer, v_time_zone character varying, v_fail_back boolean, v_is_auto_suspend boolean, v_vm_type integer, v_nice_level integer, v_default_boot_sequence integer, v_default_display_type integer, v_priority integer, v_auto_startup boolean, v_is_stateless boolean, v_is_smartcard_enabled boolean, v_is_delete_protected boolean, v_is_disabled boolean, v_iso_path character varying, v_origin integer, v_initrd_url character varying, v_kernel_url character varying, v_kernel_params character varying, v_quota_id uuid, v_migration_support integer, v_dedicated_vm_for_vds uuid, v_min_allocated_mem integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
INSERT
INTO vm_static(
    vmt_guid,
    child_count,
    creation_date,
    description,
    mem_size_mb,
    vm_name,
    num_of_sockets,
    cpu_per_socket,
    os,
    vm_guid,
    vds_group_id,
    domain,
    num_of_monitors,
    allow_console_reconnect,
    template_status,
    usb_policy,
    time_zone,
    fail_back,
    is_auto_suspend,
    vm_type,
    nice_level,
    default_boot_sequence,
    default_display_type,
    priority,
    auto_startup,
    is_stateless,
    iso_path,
    origin,
    initrd_url,
    kernel_url,
    kernel_params,
    entity_type,
    quota_id,
    migration_support,
    is_disabled,
    dedicated_vm_for_vds,
    is_smartcard_enabled,
    is_delete_protected,
    min_allocated_mem)
VALUES(
    -- This field is meaningless for templates for the time being, however we want to keep it not null for VMs.
    -- Thus, since templates are top level elements they "point" to the 'Blank' template.
    '00000000-0000-0000-0000-000000000000',
    v_child_count,
    v_creation_date,
    v_description,
    v_mem_size_mb,
    v_name,
    v_num_of_sockets,
    v_cpu_per_socket,
    v_os,
    v_vmt_guid,
    v_vds_group_id,
    v_domain,
    v_num_of_monitors,
    v_allow_console_reconnect,
    v_status,
    v_usb_policy,
    v_time_zone,
    v_fail_back,
    v_is_auto_suspend,
    v_vm_type,
    v_nice_level,
    v_default_boot_sequence,
    v_default_display_type,
    v_priority,
    v_auto_startup,
    v_is_stateless,
    v_iso_path,
    v_origin,
    v_initrd_url,
    v_kernel_url,
    v_kernel_params,
    'TEMPLATE',
    v_quota_id,
    v_migration_support,
    v_is_disabled,
    v_dedicated_vm_for_vds,
    v_is_smartcard_enabled,
    v_is_delete_protected,
    v_min_allocated_mem);
-- perform deletion from vm_ovf_generations to ensure that no record exists when performing insert to avoid PK violation.
DELETE FROM vm_ovf_generations gen WHERE gen.vm_guid = v_vmt_guid;
INSERT INTO vm_ovf_generations(vm_guid, storage_pool_id)
VALUES (v_vmt_guid, (SELECT storage_pool_id
                     FROM vds_groups vg
                     WHERE vg.vds_group_id = v_vds_group_id));
END; $$;


ALTER FUNCTION public.insertvmtemplate(v_child_count integer, v_creation_date timestamp with time zone, v_description character varying, v_mem_size_mb integer, v_name character varying, v_num_of_sockets integer, v_cpu_per_socket integer, v_os integer, v_vmt_guid uuid, v_vds_group_id uuid, v_domain character varying, v_num_of_monitors integer, v_allow_console_reconnect boolean, v_status integer, v_usb_policy integer, v_time_zone character varying, v_fail_back boolean, v_is_auto_suspend boolean, v_vm_type integer, v_nice_level integer, v_default_boot_sequence integer, v_default_display_type integer, v_priority integer, v_auto_startup boolean, v_is_stateless boolean, v_is_smartcard_enabled boolean, v_is_delete_protected boolean, v_is_disabled boolean, v_iso_path character varying, v_origin integer, v_initrd_url character varying, v_kernel_url character varying, v_kernel_params character varying, v_quota_id uuid, v_migration_support integer, v_dedicated_vm_for_vds uuid, v_min_allocated_mem integer) OWNER TO engineer;

--
-- Name: inst_add_iso_storage_domain(uuid, character varying, uuid, character varying, integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION inst_add_iso_storage_domain(v_storage_domain_id uuid, v_name character varying, v_connection_id uuid, v_connection character varying, v_available integer, v_used integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
BEGIN
    if not exists (select 1 from storage_server_connections where connection = v_connection) then
        -- Insert storage server connection info
        perform Insertstorage_server_connections(v_connection,cast(v_connection_id as varchar(250)),NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL);
        -- Insert storage domain static info
        perform Insertstorage_domain_static(v_storage_domain_id,cast(v_connection_id as varchar(250)),v_name,1,2,'0',0);
        -- Insert storage domain dynamic  info
        perform Insertstorage_domain_dynamic(v_available,v_storage_domain_id,v_used);
    end if;
    exception
        when others then
	    RAISE EXCEPTION 'NUM:%, DETAILS:%', SQLSTATE, SQLERRM;
END; $$;


ALTER FUNCTION public.inst_add_iso_storage_domain(v_storage_domain_id uuid, v_name character varying, v_connection_id uuid, v_connection character varying, v_available integer, v_used integer) OWNER TO engineer;

--
-- Name: inst_update_default_storage_pool_type(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION inst_update_default_storage_pool_type(v_storage_pool_type integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      if (v_storage_pool_type > 0 and v_storage_pool_type < 7) then
         UPDATE storage_pool
         SET storage_pool_type = v_storage_pool_type, _update_date = LOCALTIMESTAMP
         WHERE storage_pool.name = 'Default' and not exists
         (select 1 from storage_domains where storage_domains.storage_pool_name = 'Default');
      end if;
END; $$;


ALTER FUNCTION public.inst_update_default_storage_pool_type(v_storage_pool_type integer) OWNER TO engineer;

--
-- Name: isloggingenabled(text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION isloggingenabled(errorcode text) RETURNS boolean
    LANGUAGE plpgsql
    AS $$
-- determine if logging errors is enabled.
-- define in your postgresql.conf:
-- custom_variable_classes = 'engine'
-- set engine.logging = 'true';
-- or this could be in a config table

-- NOTE: We should look at checking error codes as not all are suitable for exceptions some are just notice or info
declare
    result boolean := false;
    prop text;
begin
    -- check for log setting in postgresql.conf
    select current_setting('engine.logging') into prop;
    if prop = 'true' then
result = true;
    end if;
    return result;
exception
    when others then
result = true;  -- default to log if not specified
return result;
end;
$$;


ALTER FUNCTION public.isloggingenabled(errorcode text) OWNER TO engineer;

--
-- Name: ismaterializedviewrefreshed(name); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION ismaterializedviewrefreshed(v_matview name) RETURNS boolean
    LANGUAGE plpgsql
    AS $$
DECLARE
     v_entry materialized_views%ROWTYPE;
     v_is_refreshed boolean;
 BEGIN
     SELECT * INTO v_entry FROM materialized_views WHERE mv_name = v_matview;
     IF NOT FOUND THEN
         RAISE EXCEPTION 'Materialized view % does not exist.', v_matview;
    END IF;

    -- check if materialized View should refresh
    v_is_refreshed := (((CURRENT_TIMESTAMP - to_interval(refresh_rate_in_sec)) <= last_refresh) and
                      ((CURRENT_TIMESTAMP - to_interval(min_refresh_rate_in_sec)) <= last_refresh)) or
                      not active from materialized_views
                       where mv_name = v_matview;
    RETURN v_is_refreshed;
 END; $$;


ALTER FUNCTION public.ismaterializedviewrefreshed(v_matview name) OWNER TO engineer;

--
-- Name: ismemballoonenabled(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION ismemballoonenabled(v_vm_id uuid) RETURNS boolean
    LANGUAGE plpgsql
    AS $$
declare
    result boolean := false;
begin
    if exists (select 1 from vm_device where vm_id = v_vm_id and type = 'balloon' and device = 'memballoon') then
        result := true;
    end if;
    return result;
end;
$$;


ALTER FUNCTION public.ismemballoonenabled(v_vm_id uuid) OWNER TO engineer;

--
-- Name: isquotainuse(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION isquotainuse(v_quota_id uuid) RETURNS boolean
    LANGUAGE plpgsql
    AS $$
DECLARE
    result boolean := FALSE;
BEGIN
    if EXISTS (SELECT quota_id
                    FROM images
                    WHERE quota_id = v_quota_id
    UNION SELECT quota_id
              FROM vm_static
              WHERE quota_id = v_quota_id) then
        result := TRUE;
    END if;
    return result;
END; $$;


ALTER FUNCTION public.isquotainuse(v_quota_id uuid) OWNER TO engineer;

--
-- Name: refreshallmaterializedviews(boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION refreshallmaterializedviews(v_force boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
    v_cur CURSOR FOR SELECT * FROM materialized_views;
    v_record materialized_views%ROWTYPE;
BEGIN
       OPEN v_cur;
       -- loop on all entries in materialized_views and refresh only needed snapshots
       LOOP
           FETCH v_cur INTO v_record;
           EXIT WHEN NOT FOUND;
           IF ((v_force and v_record.min_refresh_rate_in_sec = 0) or not IsMaterializedViewRefreshed(v_record.mv_name)) THEN
              perform RefreshMaterializedView(v_record.mv_name);
           END IF;
       END LOOP;
       CLOSE v_cur;
END; $$;


ALTER FUNCTION public.refreshallmaterializedviews(v_force boolean) OWNER TO engineer;

--
-- Name: refreshmaterializedview(name); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION refreshmaterializedview(v_matview name) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
     v_entry materialized_views%ROWTYPE;
     v_drop_index_sp NAME;
     v_create_index_sp NAME;
     v_start_time TIMESTAMP WITH TIME ZONE;
     v_avg_cost_ms int;
 BEGIN
     SELECT * INTO v_entry FROM materialized_views WHERE mv_name = v_matview;
     IF NOT FOUND THEN
         RAISE EXCEPTION 'Materialized view % does not exist.', v_matview;
    END IF;

    -- get start time
    v_start_time:=CURRENT_TIMESTAMP;
    -- SP for Drop / create Index should follow naming convention Mt[Drop|Create]<v_matview>Indexes
    v_drop_index_sp := 'MtDrop' || v_matview || 'Indexes';
    v_create_index_sp := 'MtCreate' || v_matview || 'Indexes';

    IF NOT EXISTS (select 1 from information_schema.routines where routine_name ilike v_drop_index_sp) THEN
        v_drop_index_sp := NULL;
    END IF;

    IF NOT EXISTS (select 1 from information_schema.routines where routine_name ilike v_create_index_sp) THEN
        v_create_index_sp := NULL;
    END IF;

    -- Lock materialized_views table until refresh completes to prevent duplicate refreshes by other threads
    LOCK TABLE materialized_views;
    -- taking a lock on the snapshot materialized view until it refreshed
    EXECUTE 'LOCK TABLE ' || v_matview;
    -- drop indexes on the snapshot materialized view if exists
    IF (v_drop_index_sp IS NOT NULL) THEN
        EXECUTE 'select ' || v_drop_index_sp || '()';
    END IF;
    -- refresh the view
    EXECUTE 'TRUNCATE TABLE ' || v_matview;
    EXECUTE 'INSERT INTO ' || v_matview
        || ' SELECT * FROM ' || v_entry.v_name;
    -- restore  indexes on the snapshot materialized view if exists
    IF (v_create_index_sp IS NOT NULL) THEN
        EXECUTE 'select ' || v_create_index_sp || '()';
    END IF;
    -- update last refresh time and average cost in [ms]
    IF (v_entry.avg_cost_ms = 0) THEN
        v_avg_cost_ms:=EXTRACT(EPOCH FROM current_timestamp - v_start_time) * 1000;
    ELSE
        v_avg_cost_ms:=((EXTRACT(EPOCH FROM current_timestamp - v_start_time) * 1000) + v_entry.avg_cost_ms)/2;
    END IF;
    update materialized_views set last_refresh = CURRENT_TIMESTAMP,
                                  avg_cost_ms = v_avg_cost_ms
                              where  mv_name = v_matview;
    RETURN;
 END; $$;


ALTER FUNCTION public.refreshmaterializedview(v_matview name) OWNER TO engineer;

--
-- Name: removeallvmtagsbyvmid(uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION removeallvmtagsbyvmid(v_vm_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      delete FROM tags_vm_map
      where vm_id = v_vm_id;
END; $$;


ALTER FUNCTION public.removeallvmtagsbyvmid(v_vm_id uuid) OWNER TO engineer;

--
-- Name: set_network_exclusively_as_display(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION set_network_exclusively_as_display(v_cluster_id uuid, v_network_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   UPDATE network_cluster
   SET is_display = true
   WHERE cluster_id = v_cluster_id AND network_id = v_network_id;

   IF FOUND THEN
       UPDATE network_cluster
       SET is_display = false
       WHERE cluster_id = v_cluster_id AND network_id != v_network_id;
   END IF;

END; $$;


ALTER FUNCTION public.set_network_exclusively_as_display(v_cluster_id uuid, v_network_id uuid) OWNER TO engineer;

--
-- Name: to_interval(integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION to_interval(sec integer) RETURNS interval
    LANGUAGE plpgsql IMMUTABLE STRICT
    AS $$
BEGIN
  RETURN (sec || ' seconds')::INTERVAL;
END;
$$;


ALTER FUNCTION public.to_interval(sec integer) OWNER TO engineer;

--
-- Name: updatead_groups(uuid, character varying, integer, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatead_groups(v_id uuid, v_name character varying, v_status integer, v_domain character varying, v_distinguishedname character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE ad_groups
      SET name = v_name,status = v_status,domain = v_domain,distinguishedname =v_distinguishedname
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updatead_groups(v_id uuid, v_name character varying, v_status integer, v_domain character varying, v_distinguishedname character varying) OWNER TO engineer;

--
-- Name: updateasync_tasks(integer, integer, integer, uuid, text, character varying, text, character varying, uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateasync_tasks(v_action_type integer, v_result integer, v_status integer, v_task_id uuid, v_action_parameters text, v_action_params_class character varying, v_task_parameters text, v_task_params_class character varying, v_step_id uuid, v_command_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE async_tasks
      SET action_type = v_action_type,
          result = v_result,
          status = v_status,
          action_parameters = v_action_parameters,
          action_params_class = v_action_params_class,
          task_parameters = v_task_parameters,
          task_params_class = v_task_params_class,
          step_id = v_step_id,
          command_id = v_command_id
      WHERE task_id = v_task_id;
END; $$;


ALTER FUNCTION public.updateasync_tasks(v_action_type integer, v_result integer, v_status integer, v_task_id uuid, v_action_parameters text, v_action_params_class character varying, v_task_parameters text, v_task_params_class character varying, v_step_id uuid, v_command_id uuid) OWNER TO engineer;

--
-- Name: updatebasedisk(uuid, character varying, boolean, character varying, character varying, character varying, boolean, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatebasedisk(v_disk_id uuid, v_disk_interface character varying, v_wipe_after_delete boolean, v_propagate_errors character varying, v_disk_alias character varying, v_disk_description character varying, v_shareable boolean, v_boot boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE base_disks
    SET    disk_interface = v_disk_interface,
           wipe_after_delete = v_wipe_after_delete,
           propagate_errors = v_propagate_errors,
           disk_alias = v_disk_alias,
           disk_description = v_disk_description,
           shareable = v_shareable,
           boot = v_boot
    WHERE  disk_id = v_disk_id;
END; $$;


ALTER FUNCTION public.updatebasedisk(v_disk_id uuid, v_disk_interface character varying, v_wipe_after_delete boolean, v_propagate_errors character varying, v_disk_alias character varying, v_disk_description character varying, v_shareable boolean, v_boot boolean) OWNER TO engineer;

--
-- Name: updatebookmark(uuid, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatebookmark(v_bookmark_id uuid, v_bookmark_name character varying, v_bookmark_value character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE bookmarks
      SET bookmark_name = v_bookmark_name,bookmark_value = v_bookmark_value
      WHERE bookmark_Id = v_bookmark_id;
END; $$;


ALTER FUNCTION public.updatebookmark(v_bookmark_id uuid, v_bookmark_name character varying, v_bookmark_value character varying) OWNER TO engineer;

--
-- Name: updateconsoleuserwithoptimisticlocking(uuid, uuid, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateconsoleuserwithoptimisticlocking(v_vm_guid uuid, v_console_user_id uuid, v_guest_cur_user_name character varying, v_console_cur_user_name character varying, OUT v_updated boolean) RETURNS boolean
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE vm_dynamic SET
        console_user_id = v_console_user_id,
        guest_cur_user_name = v_guest_cur_user_name,
        console_cur_user_name = v_console_cur_user_name
    WHERE
        vm_guid = v_vm_guid AND
        (console_user_id = v_console_user_id OR console_user_id IS NULL);
    v_updated := FOUND;
END; $$;


ALTER FUNCTION public.updateconsoleuserwithoptimisticlocking(v_vm_guid uuid, v_console_user_id uuid, v_guest_cur_user_name character varying, v_console_cur_user_name character varying, OUT v_updated boolean) OWNER TO engineer;

--
-- Name: updatecustom_actions(integer, character varying, character varying, integer, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatecustom_actions(v_action_id integer, v_action_name character varying, v_path character varying, v_tab integer, v_description character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE custom_actions
      SET action_name = v_action_name,path = v_path,tab = v_tab,description = v_description
      WHERE action_id = v_action_id;
END; $$;


ALTER FUNCTION public.updatecustom_actions(v_action_id integer, v_action_name character varying, v_path character varying, v_tab integer, v_description character varying) OWNER TO engineer;

--
-- Name: updatedisk_image_dynamic(uuid, integer, integer, bigint, numeric, numeric, numeric); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatedisk_image_dynamic(v_image_id uuid, v_read_rate integer, v_write_rate integer, v_actual_size bigint, v_read_latency_seconds numeric, v_write_latency_seconds numeric, v_flush_latency_seconds numeric) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE disk_image_dynamic
      SET read_rate = v_read_rate,write_rate = v_write_rate,actual_size = v_actual_size,read_latency_seconds = v_read_latency_seconds,write_latency_seconds = v_write_latency_seconds,flush_latency_seconds = v_flush_latency_seconds, _update_date = LOCALTIMESTAMP
      WHERE image_id = v_image_id;
END; $$;


ALTER FUNCTION public.updatedisk_image_dynamic(v_image_id uuid, v_read_rate integer, v_write_rate integer, v_actual_size bigint, v_read_latency_seconds numeric, v_write_latency_seconds numeric, v_flush_latency_seconds numeric) OWNER TO engineer;

--
-- Name: updateevent_subscriber(character varying, integer, integer, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateevent_subscriber(v_event_up_name character varying, v_old_method_id integer, v_new_method_id integer, v_subscriber_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      update event_subscriber set method_id = v_new_method_id
      where event_up_name = v_event_up_name
      and method_id = v_old_method_id
      and subscriber_id = v_subscriber_id;
END; $$;


ALTER FUNCTION public.updateevent_subscriber(v_event_up_name character varying, v_old_method_id integer, v_new_method_id integer, v_subscriber_id uuid) OWNER TO engineer;

--
-- Name: updateglustervolume(uuid, uuid, character varying, character varying, character varying, integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateglustervolume(v_id uuid, v_cluster_id uuid, v_vol_name character varying, v_vol_type character varying, v_status character varying, v_replica_count integer, v_stripe_count integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE gluster_volumes
    SET cluster_id = v_cluster_id,
        vol_name = v_vol_name,
        vol_type = v_vol_type,
        status = v_status,
        replica_count = v_replica_count,
        stripe_count = v_stripe_count,
        _update_date = LOCALTIMESTAMP
    WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updateglustervolume(v_id uuid, v_cluster_id uuid, v_vol_name character varying, v_vol_type character varying, v_status character varying, v_replica_count integer, v_stripe_count integer) OWNER TO engineer;

--
-- Name: updateglustervolumebrick(uuid, uuid, uuid, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateglustervolumebrick(v_id uuid, v_new_id uuid, v_new_server_id uuid, v_new_brick_dir character varying, v_new_status character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE gluster_volume_bricks
    SET    id = v_new_id,
           server_id = v_new_server_id,
           brick_dir = v_new_brick_dir,
           status = v_new_status,
           _update_date = LOCALTIMESTAMP
    WHERE  id = v_id;
END; $$;


ALTER FUNCTION public.updateglustervolumebrick(v_id uuid, v_new_id uuid, v_new_server_id uuid, v_new_brick_dir character varying, v_new_status character varying) OWNER TO engineer;

--
-- Name: updateglustervolumebrickorder(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateglustervolumebrickorder(v_id uuid, v_brick_order integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE  gluster_volume_bricks
    SET     brick_order = v_brick_order,
            _update_date = LOCALTIMESTAMP
    WHERE   id = v_id;
END; $$;


ALTER FUNCTION public.updateglustervolumebrickorder(v_id uuid, v_brick_order integer) OWNER TO engineer;

--
-- Name: updateglustervolumebrickstatus(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateglustervolumebrickstatus(v_id uuid, v_status character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE  gluster_volume_bricks
    SET     status = v_status,
            _update_date = LOCALTIMESTAMP
    WHERE   id = v_id;
END; $$;


ALTER FUNCTION public.updateglustervolumebrickstatus(v_id uuid, v_status character varying) OWNER TO engineer;

--
-- Name: updateglustervolumeoption(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateglustervolumeoption(v_id uuid, v_option_val character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE gluster_volume_options
    SET option_val = v_option_val
    WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updateglustervolumeoption(v_id uuid, v_option_val character varying) OWNER TO engineer;

--
-- Name: updateglustervolumestatus(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateglustervolumestatus(v_volume_id uuid, v_status character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE gluster_volumes
    SET
        status = v_status,
        _update_date = LOCALTIMESTAMP
    WHERE id = v_volume_id;
END; $$;


ALTER FUNCTION public.updateglustervolumestatus(v_volume_id uuid, v_status character varying) OWNER TO engineer;

--
-- Name: updateglustervolumestatusbyname(uuid, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateglustervolumestatusbyname(v_cluster_id uuid, v_vol_name character varying, v_status character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE gluster_volumes
    SET
        status = v_status,
        _update_date = LOCALTIMESTAMP
    WHERE cluster_id = v_cluster_id
    AND   vol_name = v_vol_name;
END; $$;


ALTER FUNCTION public.updateglustervolumestatusbyname(v_cluster_id uuid, v_vol_name character varying, v_status character varying) OWNER TO engineer;

--
-- Name: updateimage(timestamp with time zone, uuid, uuid, bigint, uuid, integer, timestamp with time zone, uuid, integer, integer, uuid, boolean, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateimage(v_creation_date timestamp with time zone, v_image_guid uuid, v_it_guid uuid, v_size bigint, v_parentid uuid, v_imagestatus integer, v_lastmodified timestamp with time zone, v_vm_snapshot_id uuid, v_volume_type integer, v_volume_format integer, v_image_group_id uuid, v_active boolean, v_quota_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE images
    SET    creation_date = v_creation_date,
           it_guid = v_it_guid,
           size = v_size,
           ParentId = v_ParentId,
           imageStatus = v_imageStatus,
           lastModified = v_lastModified,
           vm_snapshot_id = v_vm_snapshot_id,
           volume_type = v_volume_type,
           image_group_id = v_image_group_id,
           volume_format = v_volume_format,
           active = v_active,
           quota_id = v_quota_id,
           _update_date = LOCALTIMESTAMP
    WHERE  image_guid = v_image_guid;
END; $$;


ALTER FUNCTION public.updateimage(v_creation_date timestamp with time zone, v_image_guid uuid, v_it_guid uuid, v_size bigint, v_parentid uuid, v_imagestatus integer, v_lastmodified timestamp with time zone, v_vm_snapshot_id uuid, v_volume_type integer, v_volume_format integer, v_image_group_id uuid, v_active boolean, v_quota_id uuid) OWNER TO engineer;

--
-- Name: updateimagestatus(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateimagestatus(v_image_id uuid, v_status integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE images
    SET    imageStatus = v_status
    WHERE  image_guid = v_image_id;
END; $$;


ALTER FUNCTION public.updateimagestatus(v_image_id uuid, v_status integer) OWNER TO engineer;

--
-- Name: updateimagevmsnapshotid(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateimagevmsnapshotid(v_image_id uuid, v_vm_snapshot_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE images
    SET    vm_snapshot_id = v_vm_snapshot_id
    WHERE  image_guid = v_image_id;
END; $$;


ALTER FUNCTION public.updateimagevmsnapshotid(v_image_id uuid, v_vm_snapshot_id uuid) OWNER TO engineer;

--
-- Name: updateisinitialized(uuid, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateisinitialized(v_vm_guid uuid, v_is_initialized boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vm_static
      SET is_initialized = v_is_initialized
      WHERE vm_guid = v_vm_guid
      AND   entity_type = 'VM';
END; $$;


ALTER FUNCTION public.updateisinitialized(v_vm_guid uuid, v_is_initialized boolean) OWNER TO engineer;

--
-- Name: updatejob(uuid, character varying, text, character varying, uuid, boolean, timestamp with time zone, timestamp with time zone, timestamp with time zone, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatejob(v_job_id uuid, v_action_type character varying, v_description text, v_status character varying, v_owner_id uuid, v_visible boolean, v_start_time timestamp with time zone, v_end_time timestamp with time zone, v_last_update_time timestamp with time zone, v_correlation_id character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    update job
    SET action_type = v_action_type,
        description = v_description,
        status = v_status,
        owner_id = v_owner_id,
        visible = v_visible,
        start_time = v_start_time,
        end_time = v_end_time,
        last_update_time = v_last_update_time,
        correlation_id = v_correlation_id
    WHERE job_id = v_job_id;
END; $$;


ALTER FUNCTION public.updatejob(v_job_id uuid, v_action_type character varying, v_description text, v_status character varying, v_owner_id uuid, v_visible boolean, v_start_time timestamp with time zone, v_end_time timestamp with time zone, v_last_update_time timestamp with time zone, v_correlation_id character varying) OWNER TO engineer;

--
-- Name: updatejoblastupdatetime(uuid, timestamp with time zone); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatejoblastupdatetime(v_job_id uuid, v_last_update_time timestamp with time zone) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    update job
    SET last_update_time = v_last_update_time
    WHERE job_id = v_job_id;
END; $$;


ALTER FUNCTION public.updatejoblastupdatetime(v_job_id uuid, v_last_update_time timestamp with time zone) OWNER TO engineer;

--
-- Name: updatejobstepscompleted(uuid, character varying, timestamp with time zone); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatejobstepscompleted(v_job_id uuid, v_status character varying, v_end_time timestamp with time zone) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE step
    SET status = v_status,
        end_time = v_end_time
    WHERE job_id = v_job_id
    AND   status = 'STARTED'
    AND   STATUS != v_status;
END; $$;


ALTER FUNCTION public.updatejobstepscompleted(v_job_id uuid, v_status character varying, v_end_time timestamp with time zone) OWNER TO engineer;

--
-- Name: updatelastadmincheckstatus(character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatelastadmincheckstatus(v_userids character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
   DECLARE
   v_id  UUID;
   v_tempId  VARCHAR(4000);
   myCursor cursor for select id from fnSplitter(v_userIds);
   v_result  INTEGER;
BEGIN
	-- get users and its groups
	-- get their permission based on ad_element_id.
	-- if one permissions role's type is ADMIN(1) then set the user last_admin_check_status to 1
   OPEN myCursor;
   FETCH myCursor into v_tempId;
   WHILE FOUND LOOP
      v_id := CAST(v_tempId AS UUID);
      select   count(*) INTO v_result from users where user_id in(select ad_element_id as user_id from permissions,roles
         where permissions.role_id = roles.id
         and ad_element_id in((select id from ad_groups,users where users.user_id = v_id
               and ad_groups.id in(select * from fnsplitteruuid(users.group_ids))
               union
               select v_id))
         and (roles.role_type = 1 or permissions.role_id = '00000000-0000-0000-0000-000000000001'));
      update users set last_admin_check_status =
      case
      when v_result = 0 then FALSE
      else TRUE
      end
      where user_id = v_id;
      FETCH myCursor into v_tempId;
   END LOOP;
   CLOSE myCursor;
END; $$;


ALTER FUNCTION public.updatelastadmincheckstatus(v_userids character varying) OWNER TO engineer;

--
-- Name: updatelun_storage_server_connection_map(character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatelun_storage_server_connection_map(v_lun_id character varying, v_storage_server_connection character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
END; $$;


ALTER FUNCTION public.updatelun_storage_server_connection_map(v_lun_id character varying, v_storage_server_connection character varying) OWNER TO engineer;

--
-- Name: updatelunsvolumegroupid(character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatelunsvolumegroupid(v_lun_id character varying, v_volume_group_id character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
UPDATE LUNs set volume_group_id = v_volume_group_id where LUN_id = v_LUN_ID;
END; $$;


ALTER FUNCTION public.updatelunsvolumegroupid(v_lun_id character varying, v_volume_group_id character varying) OWNER TO engineer;

--
-- Name: updatematerializedviewminrefreshrate(name, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatematerializedviewminrefreshrate(v_matview name, v_min_refresh_rate integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
     v_entry materialized_views%ROWTYPE;
 BEGIN
     SELECT * INTO v_entry FROM materialized_views WHERE mv_name = v_matview;
     IF NOT FOUND THEN
         RAISE EXCEPTION 'Materialized view % does not exist.', v_matview;
    END IF;

    update materialized_views set min_refresh_rate_in_sec = v_min_refresh_rate
    where  mv_name = v_matview;
    RETURN;
 END; $$;


ALTER FUNCTION public.updatematerializedviewminrefreshrate(v_matview name, v_min_refresh_rate integer) OWNER TO engineer;

--
-- Name: updatematerializedviewrefreshrate(name, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatematerializedviewrefreshrate(v_matview name, v_refresh_rate integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
     v_entry materialized_views%ROWTYPE;
 BEGIN
     SELECT * INTO v_entry FROM materialized_views WHERE mv_name = v_matview;
     IF NOT FOUND THEN
         RAISE EXCEPTION 'Materialized view % does not exist.', v_matview;
    END IF;

    update materialized_views set refresh_rate_in_sec = v_refresh_rate
    where  mv_name = v_matview;
    RETURN;
 END; $$;


ALTER FUNCTION public.updatematerializedviewrefreshrate(v_matview name, v_refresh_rate integer) OWNER TO engineer;

--
-- Name: updatenetwork(character varying, character varying, uuid, character varying, character varying, character varying, integer, integer, boolean, uuid, integer, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatenetwork(v_addr character varying, v_description character varying, v_id uuid, v_name character varying, v_subnet character varying, v_gateway character varying, v_type integer, v_vlan_id integer, v_stp boolean, v_storage_pool_id uuid, v_mtu integer, v_vm_network boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE network
      SET addr = v_addr,description = v_description,name = v_name,subnet = v_subnet,
      gateway = v_gateway,type = v_type,vlan_id = v_vlan_id,
      stp = v_stp,storage_pool_id = v_storage_pool_id, mtu = v_mtu,
      vm_network = v_vm_network
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updatenetwork(v_addr character varying, v_description character varying, v_id uuid, v_name character varying, v_subnet character varying, v_gateway character varying, v_type integer, v_vlan_id integer, v_stp boolean, v_storage_pool_id uuid, v_mtu integer, v_vm_network boolean) OWNER TO engineer;

--
-- Name: updatenetwork_cluster(uuid, uuid, integer, boolean, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatenetwork_cluster(v_cluster_id uuid, v_network_id uuid, v_status integer, v_is_display boolean, v_required boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
   UPDATE network_cluster
   SET status = v_status,is_display = v_is_display, required = v_required
   WHERE cluster_id = v_cluster_id AND network_id = v_network_id;
END; $$;


ALTER FUNCTION public.updatenetwork_cluster(v_cluster_id uuid, v_network_id uuid, v_status integer, v_is_display boolean, v_required boolean) OWNER TO engineer;

--
-- Name: updatenetwork_cluster_status(uuid, uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatenetwork_cluster_status(v_cluster_id uuid, v_network_id uuid, v_status integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
   UPDATE network_cluster
   SET status = v_status
   WHERE cluster_id = v_cluster_id AND network_id = v_network_id;
END; $$;


ALTER FUNCTION public.updatenetwork_cluster_status(v_cluster_id uuid, v_network_id uuid, v_status integer) OWNER TO engineer;

--
-- Name: updateovfgenerations(character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateovfgenerations(v_vms_ids character varying, v_vms_db_generations character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
curs_vmids CURSOR FOR SELECT * FROM fnSplitterUuid(v_vms_ids);
curs_newovfgen CURSOR FOR SELECT * FROM fnSplitter(v_vms_db_generations);
id UUID;
new_ovf_gen BIGINT;
BEGIN
 OPEN curs_vmids;
 OPEN curs_newovfgen;
LOOP
    FETCH curs_vmids INTO id;
    FETCH curs_newovfgen INTO new_ovf_gen;
    IF NOT FOUND THEN
     EXIT;
    END IF;
    UPDATE vm_ovf_generations
    SET ovf_generation = new_ovf_gen WHERE vm_guid = id;
END LOOP;
CLOSE curs_vmids;
CLOSE curs_newovfgen;
END; $$;


ALTER FUNCTION public.updateovfgenerations(v_vms_ids character varying, v_vms_db_generations character varying) OWNER TO engineer;

--
-- Name: updatequotaforimageandsnapshots(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatequotaforimageandsnapshots(v_image_group_id uuid, v_quota_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
UPDATE images
    SET quota_id = v_quota_id
    WHERE image_group_id = v_image_group_id;
END; $$;


ALTER FUNCTION public.updatequotaforimageandsnapshots(v_image_group_id uuid, v_quota_id uuid) OWNER TO engineer;

--
-- Name: updatequotametadata(uuid, uuid, character varying, character varying, integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatequotametadata(v_id uuid, v_storage_pool_id uuid, v_quota_name character varying, v_description character varying, v_threshold_vds_group_percentage integer, v_threshold_storage_percentage integer, v_grace_vds_group_percentage integer, v_grace_storage_percentage integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
UPDATE quota
   SET storage_pool_id = v_storage_pool_id,
   quota_name = v_quota_name,
   description = v_description,
   _update_date = LOCALTIMESTAMP,
   threshold_vds_group_percentage = v_threshold_vds_group_percentage,
   threshold_storage_percentage = v_threshold_storage_percentage,
   grace_vds_group_percentage = v_grace_vds_group_percentage,
   grace_storage_percentage = v_grace_storage_percentage
   WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updatequotametadata(v_id uuid, v_storage_pool_id uuid, v_quota_name character varying, v_description character varying, v_threshold_vds_group_percentage integer, v_threshold_storage_percentage integer, v_grace_vds_group_percentage integer, v_grace_storage_percentage integer) OWNER TO engineer;

--
-- Name: updatereplicacount(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatereplicacount(v_volume_id uuid, v_replica_count integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
UPDATE gluster_volumes
SET
replica_count = v_replica_count,
_update_date = LOCALTIMESTAMP
WHERE id = v_volume_id;
END; $$;


ALTER FUNCTION public.updatereplicacount(v_volume_id uuid, v_replica_count integer) OWNER TO engineer;

--
-- Name: updaterole(character varying, uuid, character varying, boolean, integer, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updaterole(v_description character varying, v_id uuid, v_name character varying, v_is_readonly boolean, v_role_type integer, v_allows_viewing_children boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE roles
      SET description    = v_description,
          name           = v_name,
          is_readonly    = v_is_readonly,
          role_type      = v_role_type,
          allows_viewing_children = v_allows_viewing_children
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updaterole(v_description character varying, v_id uuid, v_name character varying, v_is_readonly boolean, v_role_type integer, v_allows_viewing_children boolean) OWNER TO engineer;

--
-- Name: updateroles_relations(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateroles_relations(v_role_container_id uuid, v_role_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
END; $$;


ALTER FUNCTION public.updateroles_relations(v_role_container_id uuid, v_role_id uuid) OWNER TO engineer;

--
-- Name: updatesnapshot(uuid, uuid, character varying, character varying, character varying, timestamp with time zone, text, text); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatesnapshot(v_snapshot_id uuid, v_vm_id uuid, v_snapshot_type character varying, v_status character varying, v_description character varying, v_creation_date timestamp with time zone, v_app_list text, v_vm_configuration text) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE snapshots
    SET    status = v_status,
           vm_id = v_vm_id,
           snapshot_type = v_snapshot_type,
           description = v_description,
           creation_date = v_creation_date,
           app_list = v_app_list,
           vm_configuration = v_vm_configuration,
           _update_date = NOW()
    WHERE  snapshot_id = v_snapshot_id;
END; $$;


ALTER FUNCTION public.updatesnapshot(v_snapshot_id uuid, v_vm_id uuid, v_snapshot_type character varying, v_status character varying, v_description character varying, v_creation_date timestamp with time zone, v_app_list text, v_vm_configuration text) OWNER TO engineer;

--
-- Name: updatesnapshotid(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatesnapshotid(v_snapshot_id uuid, v_new_snapshot_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE snapshots
    SET    snapshot_id = v_new_snapshot_id
    WHERE  snapshot_id = v_snapshot_id;
END; $$;


ALTER FUNCTION public.updatesnapshotid(v_snapshot_id uuid, v_new_snapshot_id uuid) OWNER TO engineer;

--
-- Name: updatesnapshotstatus(uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatesnapshotstatus(v_snapshot_id uuid, v_status character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE snapshots
    SET    status = v_status
    WHERE  snapshot_id = v_snapshot_id;
END; $$;


ALTER FUNCTION public.updatesnapshotstatus(v_snapshot_id uuid, v_status character varying) OWNER TO engineer;

--
-- Name: updatestartedexecutionentitiestounknown(timestamp with time zone); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatestartedexecutionentitiestounknown(v_end_time timestamp with time zone) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

update job
set status = 'UNKNOWN',
    end_time = v_end_time,
    last_update_time = v_end_time
where job.status = 'STARTED'
and job_id not in (select job_id
                   from step
                   where external_id is not null);

update step
set status = 'UNKNOWN',
    end_time = v_end_time
where status = 'STARTED'
and job_id not in (select step.job_id
                   from step step
                   where step.external_id is not null);

END; $$;


ALTER FUNCTION public.updatestartedexecutionentitiestounknown(v_end_time timestamp with time zone) OWNER TO engineer;

--
-- Name: updatestep(uuid, uuid, uuid, character varying, text, integer, character varying, timestamp with time zone, timestamp with time zone, character varying, uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatestep(v_step_id uuid, v_parent_step_id uuid, v_job_id uuid, v_step_type character varying, v_description text, v_step_number integer, v_status character varying, v_start_time timestamp with time zone, v_end_time timestamp with time zone, v_correlation_id character varying, v_external_id uuid, v_external_system_type character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE step
    SET parent_step_id = v_parent_step_id,
        job_id = v_job_id,
        step_type = v_step_type,
        description = v_description,
        step_number = v_step_number,
        status = v_status,
        start_time = v_start_time,
        end_time = v_end_time,
        correlation_id = v_correlation_id,
        external_id = v_external_id,
        external_system_type = v_external_system_type
    WHERE step_id = v_step_id;
END; $$;


ALTER FUNCTION public.updatestep(v_step_id uuid, v_parent_step_id uuid, v_job_id uuid, v_step_type character varying, v_description text, v_step_number integer, v_status character varying, v_start_time timestamp with time zone, v_end_time timestamp with time zone, v_correlation_id character varying, v_external_id uuid, v_external_system_type character varying) OWNER TO engineer;

--
-- Name: updatestepexternalidandtype(uuid, uuid, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatestepexternalidandtype(v_step_id uuid, v_external_id uuid, v_external_system_type character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE step
    SET external_id = v_external_id,
        external_system_type = v_external_system_type
    WHERE step_id = v_step_id;
END; $$;


ALTER FUNCTION public.updatestepexternalidandtype(v_step_id uuid, v_external_id uuid, v_external_system_type character varying) OWNER TO engineer;

--
-- Name: updatestepstatusandendtime(uuid, character varying, timestamp with time zone); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatestepstatusandendtime(v_step_id uuid, v_status character varying, v_end_time timestamp with time zone) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE step
    SET status = v_status,
        end_time = v_end_time
    WHERE step_id = v_step_id;
END; $$;


ALTER FUNCTION public.updatestepstatusandendtime(v_step_id uuid, v_status character varying, v_end_time timestamp with time zone) OWNER TO engineer;

--
-- Name: updatestorage_domain_dynamic(integer, uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatestorage_domain_dynamic(v_available_disk_size integer, v_id uuid, v_used_disk_size integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE storage_domain_dynamic
      SET available_disk_size = v_available_disk_size,used_disk_size = v_used_disk_size, _update_date = LOCALTIMESTAMP
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updatestorage_domain_dynamic(v_available_disk_size integer, v_id uuid, v_used_disk_size integer) OWNER TO engineer;

--
-- Name: updatestorage_domain_static(uuid, character varying, character varying, integer, integer, integer, bigint); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatestorage_domain_static(v_id uuid, v_storage character varying, v_storage_name character varying, v_storage_type integer, v_storage_domain_type integer, v_storage_domain_format_type integer, v_last_time_used_as_master bigint) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE storage_domain_static
      SET storage = v_storage, storage_name = v_storage_name, storage_type = v_storage_type,
      storage_domain_type = v_storage_domain_type, _update_date = LOCALTIMESTAMP,
      storage_domain_format_type = v_storage_domain_format_type,
      last_time_used_as_master = v_last_time_used_as_master
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updatestorage_domain_static(v_id uuid, v_storage character varying, v_storage_name character varying, v_storage_type integer, v_storage_domain_type integer, v_storage_domain_format_type integer, v_last_time_used_as_master bigint) OWNER TO engineer;

--
-- Name: updatestorage_pool(character varying, uuid, character varying, integer, integer, character varying, integer, uuid, character varying, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatestorage_pool(v_description character varying, v_id uuid, v_name character varying, v_storage_pool_type integer, v_status integer, v_storage_pool_format_type character varying, v_master_domain_version integer, v_spm_vds_id uuid, v_compatibility_version character varying, v_quota_enforcement_type integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE storage_pool
      SET description = v_description,name = v_name,storage_pool_type = v_storage_pool_type,
      status = v_status,storage_pool_format_type = v_storage_pool_format_type,master_domain_version = v_master_domain_version,
      spm_vds_id = v_spm_vds_id,compatibility_version = v_compatibility_version,
      _update_date = LOCALTIMESTAMP,quota_enforcement_type=v_quota_enforcement_type
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updatestorage_pool(v_description character varying, v_id uuid, v_name character varying, v_storage_pool_type integer, v_status integer, v_storage_pool_format_type character varying, v_master_domain_version integer, v_spm_vds_id uuid, v_compatibility_version character varying, v_quota_enforcement_type integer) OWNER TO engineer;

--
-- Name: updatestorage_pool_iso_map(uuid, uuid, integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatestorage_pool_iso_map(v_storage_id uuid, v_storage_pool_id uuid, v_status integer, v_owner integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE storage_pool_iso_map
      SET status = v_status,owner = v_owner
      WHERE storage_id = v_storage_id and storage_pool_id = v_storage_pool_id;
END; $$;


ALTER FUNCTION public.updatestorage_pool_iso_map(v_storage_id uuid, v_storage_pool_id uuid, v_status integer, v_owner integer) OWNER TO engineer;

--
-- Name: updatestorage_pool_iso_map_status(uuid, uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatestorage_pool_iso_map_status(v_storage_id uuid, v_storage_pool_id uuid, v_status integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
   UPDATE storage_pool_iso_map
   SET status = v_status
   WHERE storage_pool_id = v_storage_pool_id AND storage_id = v_storage_id;
END; $$;


ALTER FUNCTION public.updatestorage_pool_iso_map_status(v_storage_id uuid, v_storage_pool_id uuid, v_status integer) OWNER TO engineer;

--
-- Name: updatestorage_pool_partial(character varying, uuid, character varying, integer, character varying, character varying, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatestorage_pool_partial(v_description character varying, v_id uuid, v_name character varying, v_storage_pool_type integer, v_storage_pool_format_type character varying, v_compatibility_version character varying, v_quota_enforcement_type integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE storage_pool
      SET description = v_description,name = v_name,storage_pool_type = v_storage_pool_type,
      storage_pool_format_type = v_storage_pool_format_type,compatibility_version = v_compatibility_version,
      _update_date = LOCALTIMESTAMP,quota_enforcement_type = v_quota_enforcement_type
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updatestorage_pool_partial(v_description character varying, v_id uuid, v_name character varying, v_storage_pool_type integer, v_storage_pool_format_type character varying, v_compatibility_version character varying, v_quota_enforcement_type integer) OWNER TO engineer;

--
-- Name: updatestorage_pool_status(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatestorage_pool_status(v_id uuid, v_status integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE storage_pool
      SET
      status = v_status,
      _update_date = LOCALTIMESTAMP
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updatestorage_pool_status(v_id uuid, v_status integer) OWNER TO engineer;

--
-- Name: updatestorage_server_connections(character varying, character varying, character varying, text, integer, character varying, character varying, character varying, character varying, character varying, character varying, smallint, smallint); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatestorage_server_connections(v_connection character varying, v_id character varying, v_iqn character varying, v_password text, v_storage_type integer, v_port character varying, v_portal character varying, v_user_name character varying, v_mount_options character varying, v_vfs_type character varying, v_nfs_version character varying, v_nfs_timeo smallint, v_nfs_retrans smallint) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE storage_server_connections
      SET connection = v_connection,iqn = v_iqn,password = v_password,port = v_port,
      portal = v_portal,storage_type = v_storage_type,user_name = v_user_name,mount_options = v_mount_options, vfs_type = v_vfs_type, nfs_version = v_nfs_version, nfs_timeo = v_nfs_timeo, nfs_retrans = v_nfs_retrans
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updatestorage_server_connections(v_connection character varying, v_id character varying, v_iqn character varying, v_password text, v_storage_type integer, v_port character varying, v_portal character varying, v_user_name character varying, v_mount_options character varying, v_vfs_type character varying, v_nfs_version character varying, v_nfs_timeo smallint, v_nfs_retrans smallint) OWNER TO engineer;

--
-- Name: updatestripecount(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatestripecount(v_volume_id uuid, v_stripe_count integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
UPDATE gluster_volumes
SET
stripe_count = v_stripe_count,
_update_date = LOCALTIMESTAMP
WHERE id = v_volume_id;
END; $$;


ALTER FUNCTION public.updatestripecount(v_volume_id uuid, v_stripe_count integer) OWNER TO engineer;

--
-- Name: updatetags(character varying, uuid, character varying, uuid, boolean, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatetags(v_description character varying, v_tag_id uuid, v_tag_name character varying, v_parent_id uuid, v_readonly boolean, v_type integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE tags
      SET description = v_description,tag_name = v_tag_name,parent_id = v_parent_id,
      readonly	= v_readonly,type = v_type,_update_date = LOCALTIMESTAMP
      WHERE tag_id = v_tag_id;
END; $$;


ALTER FUNCTION public.updatetags(v_description character varying, v_tag_id uuid, v_tag_name character varying, v_parent_id uuid, v_readonly boolean, v_type integer) OWNER TO engineer;

--
-- Name: updatetags_vm_pool_map(integer, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatetags_vm_pool_map(v_tag_id integer, v_vm_pool_id integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
END; $$;


ALTER FUNCTION public.updatetags_vm_pool_map(v_tag_id integer, v_vm_pool_id integer) OWNER TO engineer;

--
-- Name: updateuser(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, character varying, character varying, uuid, integer, character varying, boolean, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updateuser(v_department character varying, v_desktop_device character varying, v_domain character varying, v_email character varying, v_groups character varying, v_name character varying, v_note character varying, v_role character varying, v_status integer, v_surname character varying, v_user_icon_path character varying, v_user_id uuid, v_session_count integer, v_username character varying, v_last_admin_check_status boolean, v_group_ids character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE users
      SET department = v_department,desktop_device = v_desktop_device,domain = v_domain,
      email = v_email,groups = v_groups,name = v_name,note = v_note,
      role = v_role,status = v_status,surname = v_surname,user_icon_path = v_user_icon_path,
      username = v_username,session_count = v_session_count,
      last_admin_check_status = v_last_admin_check_status,
      group_ids = v_group_ids
      WHERE user_id = v_user_id;
END; $$;


ALTER FUNCTION public.updateuser(v_department character varying, v_desktop_device character varying, v_domain character varying, v_email character varying, v_groups character varying, v_name character varying, v_note character varying, v_role character varying, v_status integer, v_surname character varying, v_user_icon_path character varying, v_user_id uuid, v_session_count integer, v_username character varying, v_last_admin_check_status boolean, v_group_ids character varying) OWNER TO engineer;

--
-- Name: updatevdcoption(character varying, character varying, integer, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevdcoption(v_option_name character varying, v_option_value character varying, v_option_id integer, v_version character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vdc_options
      SET OPTION_NAME = v_option_name,option_value = v_option_value,version = v_version
      WHERE option_id = v_option_id;
END; $$;


ALTER FUNCTION public.updatevdcoption(v_option_name character varying, v_option_value character varying, v_option_id integer, v_version character varying) OWNER TO engineer;

--
-- Name: updatevds_interface(character varying, character varying, integer, character varying, uuid, boolean, character varying, character varying, character varying, character varying, integer, character varying, integer, integer, uuid, integer, integer, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevds_interface(v_addr character varying, v_bond_name character varying, v_bond_type integer, v_gateway character varying, v_id uuid, v_is_bond boolean, v_bond_opts character varying, v_mac_addr character varying, v_name character varying, v_network_name character varying, v_speed integer, v_subnet character varying, v_boot_protocol integer, v_type integer, v_vds_id uuid, v_vlan_id integer, v_mtu integer, v_bridged boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vds_interface
      SET addr = v_addr,bond_name = v_bond_name,bond_type = v_bond_type,gateway = v_gateway,
      is_bond = v_is_bond,bond_opts = v_bond_opts,mac_addr = v_mac_addr,
      name = v_name,network_name = v_network_name,speed = v_speed,
      subnet = v_subnet,boot_protocol = v_boot_protocol,
      type = v_type,VDS_ID = v_vds_id,vlan_id = v_vlan_id,_update_date = LOCALTIMESTAMP, mtu = v_mtu,
      bridged = v_bridged
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updatevds_interface(v_addr character varying, v_bond_name character varying, v_bond_type integer, v_gateway character varying, v_id uuid, v_is_bond boolean, v_bond_opts character varying, v_mac_addr character varying, v_name character varying, v_network_name character varying, v_speed integer, v_subnet character varying, v_boot_protocol integer, v_type integer, v_vds_id uuid, v_vlan_id integer, v_mtu integer, v_bridged boolean) OWNER TO engineer;

--
-- Name: updatevds_interface_statistics(uuid, numeric, numeric, numeric, numeric, integer, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevds_interface_statistics(v_id uuid, v_rx_drop numeric, v_rx_rate numeric, v_tx_drop numeric, v_tx_rate numeric, v_iface_status integer, v_vds_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vds_interface_statistics
      SET rx_drop = v_rx_drop,rx_rate = v_rx_rate,tx_drop = v_tx_drop,tx_rate = v_tx_rate,
      vds_id = v_vds_id,iface_status = v_iface_status, _update_date = LOCALTIMESTAMP
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updatevds_interface_statistics(v_id uuid, v_rx_drop numeric, v_rx_rate numeric, v_tx_drop numeric, v_tx_rate numeric, v_iface_status integer, v_vds_id uuid) OWNER TO engineer;

--
-- Name: updatevdsdynamic(integer, integer, character varying, numeric, character varying, boolean, integer, integer, integer, uuid, integer, integer, integer, integer, integer, integer, character varying, character varying, character varying, character varying, integer, character varying, timestamp with time zone, integer, integer, integer, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, character varying, integer, character varying, character varying, character varying, character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevdsdynamic(v_cpu_cores integer, v_cpu_threads integer, v_cpu_model character varying, v_cpu_speed_mh numeric, v_if_total_speed character varying, v_kvm_enabled boolean, v_mem_commited integer, v_physical_mem_mb integer, v_status integer, v_vds_id uuid, v_vm_active integer, v_vm_count integer, v_vms_cores_count integer, v_vm_migrating integer, v_reserved_mem integer, v_guest_overhead integer, v_rpm_version character varying, v_software_version character varying, v_version_name character varying, v_build_name character varying, v_previous_status integer, v_cpu_flags character varying, v_cpu_over_commit_time_stamp timestamp with time zone, v_pending_vcpus_count integer, v_pending_vmem_size integer, v_cpu_sockets integer, v_net_config_dirty boolean, v_supported_cluster_levels character varying, v_supported_engines character varying, v_host_os character varying, v_kvm_version character varying, v_libvirt_version character varying, v_spice_version character varying, v_kernel_version character varying, v_iscsi_initiator_name character varying, v_transparent_hugepages_state integer, v_anonymous_hugepages integer, v_hooks character varying, v_non_operational_reason integer, v_hw_manufacturer character varying, v_hw_product_name character varying, v_hw_version character varying, v_hw_serial_number character varying, v_hw_uuid character varying, v_hw_family character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   BEGIN
      UPDATE vds_dynamic
      SET cpu_cores = v_cpu_cores,cpu_threads = v_cpu_threads,
      cpu_model = v_cpu_model,cpu_speed_mh = v_cpu_speed_mh,
      if_total_speed = v_if_total_speed,kvm_enabled = v_kvm_enabled,
      mem_commited = v_mem_commited,physical_mem_mb = v_physical_mem_mb,
      status = v_status,vm_active = v_vm_active,vm_count = v_vm_count,
      vm_migrating = v_vm_migrating,reserved_mem = v_reserved_mem,
      guest_overhead = v_guest_overhead,rpm_version = v_rpm_version, software_version = v_software_version,
      version_name = v_version_name,build_name = v_build_name,previous_status = v_previous_status,
      cpu_flags = v_cpu_flags,cpu_over_commit_time_stamp = v_cpu_over_commit_time_stamp,
      vms_cores_count = v_vms_cores_count,pending_vcpus_count = v_pending_vcpus_count,
      pending_vmem_size = v_pending_vmem_size,
      cpu_sockets = v_cpu_sockets,net_config_dirty = v_net_config_dirty,
      supported_cluster_levels = v_supported_cluster_levels,
      supported_engines = v_supported_engines,host_os = v_host_os,
      kvm_version = v_kvm_version,libvirt_version = v_libvirt_version,spice_version = v_spice_version,
      kernel_version = v_kernel_version,iscsi_initiator_name = v_iscsi_initiator_name,
      transparent_hugepages_state = v_transparent_hugepages_state,
      anonymous_hugepages = v_anonymous_hugepages,hooks = v_hooks,
      _update_date = LOCALTIMESTAMP,non_operational_reason = v_non_operational_reason,
      hw_manufacturer = v_hw_manufacturer, hw_product_name = v_hw_product_name,
      hw_version = v_hw_version, hw_serial_number = v_hw_serial_number,
      hw_uuid = v_hw_uuid, hw_family = v_hw_family
      WHERE vds_id = v_vds_id;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.updatevdsdynamic(v_cpu_cores integer, v_cpu_threads integer, v_cpu_model character varying, v_cpu_speed_mh numeric, v_if_total_speed character varying, v_kvm_enabled boolean, v_mem_commited integer, v_physical_mem_mb integer, v_status integer, v_vds_id uuid, v_vm_active integer, v_vm_count integer, v_vms_cores_count integer, v_vm_migrating integer, v_reserved_mem integer, v_guest_overhead integer, v_rpm_version character varying, v_software_version character varying, v_version_name character varying, v_build_name character varying, v_previous_status integer, v_cpu_flags character varying, v_cpu_over_commit_time_stamp timestamp with time zone, v_pending_vcpus_count integer, v_pending_vmem_size integer, v_cpu_sockets integer, v_net_config_dirty boolean, v_supported_cluster_levels character varying, v_supported_engines character varying, v_host_os character varying, v_kvm_version character varying, v_libvirt_version character varying, v_spice_version character varying, v_kernel_version character varying, v_iscsi_initiator_name character varying, v_transparent_hugepages_state integer, v_anonymous_hugepages integer, v_hooks character varying, v_non_operational_reason integer, v_hw_manufacturer character varying, v_hw_product_name character varying, v_hw_version character varying, v_hw_serial_number character varying, v_hw_uuid character varying, v_hw_family character varying) OWNER TO engineer;

--
-- Name: updatevdsdynamicstatus(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevdsdynamicstatus(v_vds_guid uuid, v_status integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vds_dynamic
      SET
      status = v_status
      WHERE vds_id = v_vds_guid;
END; $$;


ALTER FUNCTION public.updatevdsdynamicstatus(v_vds_guid uuid, v_status integer) OWNER TO engineer;

--
-- Name: updatevdsgroup(character varying, character varying, uuid, character varying, integer, integer, integer, integer, uuid, integer, boolean, character varying, boolean, integer, boolean, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevdsgroup(v_description character varying, v_name character varying, v_vds_group_id uuid, v_cpu_name character varying, v_selection_algorithm integer, v_high_utilization integer, v_low_utilization integer, v_cpu_over_commit_duration_minutes integer, v_storage_pool_id uuid, v_max_vds_memory_over_commit integer, v_count_threads_as_cores boolean, v_compatibility_version character varying, v_transparent_hugepages boolean, v_migrate_on_error integer, v_virt_service boolean, v_gluster_service boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vds_groups
      SET description = v_description,name = v_name,cpu_name = v_cpu_name,selection_algorithm = v_selection_algorithm,
      high_utilization = v_high_utilization,
      low_utilization = v_low_utilization,cpu_over_commit_duration_minutes = v_cpu_over_commit_duration_minutes,
      storage_pool_id = v_storage_pool_id,_update_date = LOCALTIMESTAMP,
      max_vds_memory_over_commit = v_max_vds_memory_over_commit,
      count_threads_as_cores = v_count_threads_as_cores,
      compatibility_version = v_compatibility_version,transparent_hugepages = v_transparent_hugepages,
      migrate_on_error = v_migrate_on_error,
      virt_service = v_virt_service, gluster_service = v_gluster_service
      WHERE vds_group_id = v_vds_group_id;
END; $$;


ALTER FUNCTION public.updatevdsgroup(v_description character varying, v_name character varying, v_vds_group_id uuid, v_cpu_name character varying, v_selection_algorithm integer, v_high_utilization integer, v_low_utilization integer, v_cpu_over_commit_duration_minutes integer, v_storage_pool_id uuid, v_max_vds_memory_over_commit integer, v_count_threads_as_cores boolean, v_compatibility_version character varying, v_transparent_hugepages boolean, v_migrate_on_error integer, v_virt_service boolean, v_gluster_service boolean) OWNER TO engineer;

--
-- Name: updatevdsstatic(character varying, character varying, character varying, integer, uuid, uuid, character varying, boolean, integer, integer, character varying, character varying, character varying, integer, character varying, boolean, character varying, character varying, character varying, character varying, text, integer, character varying, boolean, bigint, integer, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevdsstatic(v_host_name character varying, v_ip character varying, v_vds_unique_id character varying, v_port integer, v_vds_group_id uuid, v_vds_id uuid, v_vds_name character varying, v_server_ssl_enabled boolean, v_vds_type integer, v_vds_strength integer, v_pm_type character varying, v_pm_user character varying, v_pm_password character varying, v_pm_port integer, v_pm_options character varying, v_pm_enabled boolean, v_pm_proxy_preferences character varying, v_pm_secondary_ip character varying, v_pm_secondary_type character varying, v_pm_secondary_user character varying, v_pm_secondary_password text, v_pm_secondary_port integer, v_pm_secondary_options character varying, v_pm_secondary_concurrent boolean, v_otp_validity bigint, v_vds_spm_priority integer, v_sshkeyfingerprint character varying, v_console_address character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   BEGIN
      UPDATE vds_static
      SET host_name = v_host_name,ip = v_ip,vds_unique_id = v_vds_unique_id,
      port = v_port,vds_group_id = v_vds_group_id,vds_name = v_vds_name,server_SSL_enabled = v_server_SSL_enabled,
      vds_type = v_vds_type,
      _update_date = LOCALTIMESTAMP,vds_strength = v_vds_strength,
      pm_type = v_pm_type,pm_user = v_pm_user,pm_password = v_pm_password,
      pm_port = v_pm_port,pm_options = v_pm_options,pm_enabled = v_pm_enabled, pm_proxy_preferences = v_pm_proxy_preferences,
      pm_secondary_ip = v_pm_secondary_ip, pm_secondary_type = v_pm_secondary_type,
      pm_secondary_user = v_pm_secondary_user, pm_secondary_password = v_pm_secondary_password,
      pm_secondary_port = v_pm_secondary_port, pm_secondary_options = v_pm_secondary_options,
      pm_secondary_concurrent = v_pm_secondary_concurrent,
      otp_validity = v_otp_validity, vds_spm_priority = v_vds_spm_priority, sshKeyFingerprint = v_sshKeyFingerprint,
      console_address = v_console_address
      WHERE vds_id = v_vds_id;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.updatevdsstatic(v_host_name character varying, v_ip character varying, v_vds_unique_id character varying, v_port integer, v_vds_group_id uuid, v_vds_id uuid, v_vds_name character varying, v_server_ssl_enabled boolean, v_vds_type integer, v_vds_strength integer, v_pm_type character varying, v_pm_user character varying, v_pm_password character varying, v_pm_port integer, v_pm_options character varying, v_pm_enabled boolean, v_pm_proxy_preferences character varying, v_pm_secondary_ip character varying, v_pm_secondary_type character varying, v_pm_secondary_user character varying, v_pm_secondary_password text, v_pm_secondary_port integer, v_pm_secondary_options character varying, v_pm_secondary_concurrent boolean, v_otp_validity bigint, v_vds_spm_priority integer, v_sshkeyfingerprint character varying, v_console_address character varying) OWNER TO engineer;

--
-- Name: updatevdsstatistics(numeric, numeric, numeric, numeric, integer, integer, integer, uuid, bigint, bigint, bigint, bigint, integer, bigint, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevdsstatistics(v_cpu_idle numeric, v_cpu_load numeric, v_cpu_sys numeric, v_cpu_user numeric, v_usage_cpu_percent integer, v_usage_mem_percent integer, v_usage_network_percent integer, v_vds_id uuid, v_mem_available bigint, v_mem_shared bigint, v_swap_free bigint, v_swap_total bigint, v_ksm_cpu_percent integer, v_ksm_pages bigint, v_ksm_state boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN

   BEGIN
      UPDATE vds_statistics
      SET cpu_idle = v_cpu_idle,cpu_load = v_cpu_load,cpu_sys = v_cpu_sys,
      cpu_user = v_cpu_user,usage_cpu_percent = v_usage_cpu_percent,usage_mem_percent = v_usage_mem_percent,
      usage_network_percent = v_usage_network_percent,
      mem_available = v_mem_available,mem_shared = v_mem_shared,
      swap_free = v_swap_free,swap_total = v_swap_total,ksm_cpu_percent = v_ksm_cpu_percent,
      ksm_pages = v_ksm_pages,ksm_state = v_ksm_state, _update_date = LOCALTIMESTAMP
      WHERE vds_id = v_vds_id;
   END;

   RETURN;
END; $$;


ALTER FUNCTION public.updatevdsstatistics(v_cpu_idle numeric, v_cpu_load numeric, v_cpu_sys numeric, v_cpu_user numeric, v_usage_cpu_percent integer, v_usage_mem_percent integer, v_usage_network_percent integer, v_vds_id uuid, v_mem_available bigint, v_mem_shared bigint, v_swap_free bigint, v_swap_total bigint, v_ksm_cpu_percent integer, v_ksm_pages bigint, v_ksm_state boolean) OWNER TO engineer;

--
-- Name: updatevm_interface(uuid, character varying, character varying, character varying, integer, uuid, uuid, integer, boolean, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevm_interface(v_id uuid, v_mac_addr character varying, v_name character varying, v_network_name character varying, v_speed integer, v_vm_guid uuid, v_vmt_guid uuid, v_type integer, v_port_mirroring boolean, v_linked boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vm_interface
      SET mac_addr = v_mac_addr,name = v_name,network_name = v_network_name,
      speed = v_speed,VM_GUID = v_vm_guid,VMT_GUID = v_vmt_guid,type = v_type,
      _update_date = LOCALTIMESTAMP, port_mirroring = v_port_mirroring, linked = v_linked
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updatevm_interface(v_id uuid, v_mac_addr character varying, v_name character varying, v_network_name character varying, v_speed integer, v_vm_guid uuid, v_vmt_guid uuid, v_type integer, v_port_mirroring boolean, v_linked boolean) OWNER TO engineer;

--
-- Name: updatevm_interface_statistics(uuid, numeric, numeric, numeric, numeric, integer, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevm_interface_statistics(v_id uuid, v_rx_drop numeric, v_rx_rate numeric, v_tx_drop numeric, v_tx_rate numeric, v_iface_status integer, v_vm_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vm_interface_statistics
      SET rx_drop = v_rx_drop,rx_rate = v_rx_rate,tx_drop = v_tx_drop,tx_rate = v_tx_rate,
      vm_id = v_vm_id,iface_status = v_iface_status, _update_date = LOCALTIMESTAMP
      WHERE id = v_id;
END; $$;


ALTER FUNCTION public.updatevm_interface_statistics(v_id uuid, v_rx_drop numeric, v_rx_rate numeric, v_tx_drop numeric, v_tx_rate numeric, v_iface_status integer, v_vm_id uuid) OWNER TO engineer;

--
-- Name: updatevm_pool_map(uuid, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevm_pool_map(v_vm_guid uuid, v_vm_pool_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vm_pool_map
      SET vm_pool_id = v_vm_pool_id
      WHERE vm_guid = v_vm_guid;
END; $$;


ALTER FUNCTION public.updatevm_pool_map(v_vm_guid uuid, v_vm_pool_id uuid) OWNER TO engineer;

--
-- Name: updatevm_pools(character varying, uuid, character varying, integer, character varying, integer, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevm_pools(v_vm_pool_description character varying, v_vm_pool_id uuid, v_vm_pool_name character varying, v_vm_pool_type integer, v_parameters character varying, v_prestarted_vms integer, v_vds_group_id uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vm_pools
      SET vm_pool_description = v_vm_pool_description,vm_pool_name = v_vm_pool_name,
      vm_pool_type = v_vm_pool_type,parameters = v_parameters, prestarted_vms = v_prestarted_vms, vds_group_id = v_vds_group_id
      WHERE vm_pool_id = v_vm_pool_id;
END; $$;


ALTER FUNCTION public.updatevm_pools(v_vm_pool_description character varying, v_vm_pool_id uuid, v_vm_pool_name character varying, v_vm_pool_type integer, v_parameters character varying, v_prestarted_vms integer, v_vds_group_id uuid) OWNER TO engineer;

--
-- Name: updatevmdevice(uuid, uuid, character varying, character varying, character varying, integer, text, boolean, boolean, boolean, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevmdevice(v_device_id uuid, v_vm_id uuid, v_device character varying, v_type character varying, v_address character varying, v_boot_order integer, v_spec_params text, v_is_managed boolean, v_is_plugged boolean, v_is_readonly boolean, v_alias character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE vm_device
    SET
           device = v_device,
           type = v_type,
           address = v_address,
           boot_order = v_boot_order,
           spec_params = v_spec_params,
           is_managed = v_is_managed,
           is_plugged = v_is_plugged,
           is_readonly = v_is_readonly,
           alias = v_alias,
           _update_date = current_timestamp
    WHERE  device_id = v_device_id and vm_id = v_vm_id;
END; $$;


ALTER FUNCTION public.updatevmdevice(v_device_id uuid, v_vm_id uuid, v_device character varying, v_type character varying, v_address character varying, v_boot_order integer, v_spec_params text, v_is_managed boolean, v_is_plugged boolean, v_is_readonly boolean, v_alias character varying) OWNER TO engineer;

--
-- Name: updatevmdeviceforhotplugdisk(uuid, uuid, integer, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevmdeviceforhotplugdisk(v_device_id uuid, v_vm_id uuid, v_boot_order integer, v_is_plugged boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE vm_device
    SET
           boot_order = v_boot_order,
           is_plugged = v_is_plugged,
           _update_date = current_timestamp
    WHERE  device_id = v_device_id and vm_id = v_vm_id;
END; $$;


ALTER FUNCTION public.updatevmdeviceforhotplugdisk(v_device_id uuid, v_vm_id uuid, v_boot_order integer, v_is_plugged boolean) OWNER TO engineer;

--
-- Name: updatevmdeviceruntimeinfo(uuid, uuid, character varying, character varying); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevmdeviceruntimeinfo(v_device_id uuid, v_vm_id uuid, v_address character varying, v_alias character varying) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
    UPDATE vm_device
    SET
           address = v_address,
           alias = v_alias,
           _update_date = current_timestamp
    WHERE  device_id = v_device_id and vm_id = v_vm_id;
END; $$;


ALTER FUNCTION public.updatevmdeviceruntimeinfo(v_device_id uuid, v_vm_id uuid, v_address character varying, v_alias character varying) OWNER TO engineer;

--
-- Name: updatevmdynamic(character varying, character varying, character varying, timestamp with time zone, timestamp with time zone, uuid, character varying, uuid, uuid, integer, uuid, character varying, character varying, timestamp with time zone, integer, integer, boolean, integer, character varying, integer, boolean, integer, integer, integer, uuid, character varying, integer, character varying, integer, integer, character varying, character varying, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevmdynamic(v_app_list character varying, v_guest_cur_user_name character varying, v_console_cur_user_name character varying, v_guest_last_login_time timestamp with time zone, v_guest_last_logout_time timestamp with time zone, v_console_user_id uuid, v_guest_os character varying, v_migrating_to_vds uuid, v_run_on_vds uuid, v_status integer, v_vm_guid uuid, v_vm_host character varying, v_vm_ip character varying, v_last_start_time timestamp with time zone, v_vm_pid integer, v_display integer, v_acpi_enable boolean, v_session integer, v_display_ip character varying, v_display_type integer, v_kvm_enable boolean, v_boot_sequence integer, v_display_secure_port integer, v_utc_diff integer, v_last_vds_run_on uuid, v_client_ip character varying, v_guest_requested_memory integer, v_hibernation_vol_handle character varying, v_exit_status integer, v_pause_status integer, v_exit_message character varying, v_hash character varying, v_guest_agent_nics_hash integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vm_dynamic
      SET app_list = v_app_list,guest_cur_user_name = v_guest_cur_user_name,
      console_cur_user_name = v_console_cur_user_name,
      guest_last_login_time = v_guest_last_login_time,
      guest_last_logout_time = v_guest_last_logout_time,
      console_user_id = v_console_user_id,
      guest_os = v_guest_os,migrating_to_vds = v_migrating_to_vds,RUN_ON_VDS = v_run_on_vds,
      status = v_status,vm_host = v_vm_host,vm_ip = v_vm_ip,
      last_start_time = v_last_start_time,
      vm_pid = v_vm_pid,display = v_display,acpi_enable = v_acpi_enable,
      session = v_session,display_ip = v_display_ip,
      display_type = v_display_type,kvm_enable = v_kvm_enable,boot_sequence = v_boot_sequence,
      display_secure_port = v_display_secure_port,
      utc_diff = v_utc_diff,last_vds_run_on = v_last_vds_run_on,client_ip = v_client_ip,
      guest_requested_memory = v_guest_requested_memory,
      hibernation_vol_handle = v_hibernation_vol_handle,exit_status = v_exit_status,
      pause_status = v_pause_status,exit_message = v_exit_message, hash=v_hash, guest_agent_nics_hash = v_guest_agent_nics_hash
      WHERE vm_guid = v_vm_guid;
END; $$;


ALTER FUNCTION public.updatevmdynamic(v_app_list character varying, v_guest_cur_user_name character varying, v_console_cur_user_name character varying, v_guest_last_login_time timestamp with time zone, v_guest_last_logout_time timestamp with time zone, v_console_user_id uuid, v_guest_os character varying, v_migrating_to_vds uuid, v_run_on_vds uuid, v_status integer, v_vm_guid uuid, v_vm_host character varying, v_vm_ip character varying, v_last_start_time timestamp with time zone, v_vm_pid integer, v_display integer, v_acpi_enable boolean, v_session integer, v_display_ip character varying, v_display_type integer, v_kvm_enable boolean, v_boot_sequence integer, v_display_secure_port integer, v_utc_diff integer, v_last_vds_run_on uuid, v_client_ip character varying, v_guest_requested_memory integer, v_hibernation_vol_handle character varying, v_exit_status integer, v_pause_status integer, v_exit_message character varying, v_hash character varying, v_guest_agent_nics_hash integer) OWNER TO engineer;

--
-- Name: updatevmdynamicstatus(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevmdynamicstatus(v_vm_guid uuid, v_status integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vm_dynamic
      SET
      status = v_status
      WHERE vm_guid = v_vm_guid;
END; $$;


ALTER FUNCTION public.updatevmdynamicstatus(v_vm_guid uuid, v_status integer) OWNER TO engineer;

--
-- Name: updatevmstatic(character varying, integer, integer, uuid, uuid, character varying, uuid, character varying, timestamp with time zone, integer, boolean, boolean, boolean, integer, integer, integer, character varying, boolean, boolean, boolean, boolean, uuid, boolean, integer, integer, integer, integer, integer, character varying, integer, character varying, character varying, character varying, integer, character varying, character varying, integer, uuid, character varying, boolean); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevmstatic(v_description character varying, v_mem_size_mb integer, v_os integer, v_vds_group_id uuid, v_vm_guid uuid, v_vm_name character varying, v_vmt_guid uuid, v_domain character varying, v_creation_date timestamp with time zone, v_num_of_monitors integer, v_allow_console_reconnect boolean, v_is_initialized boolean, v_is_auto_suspend boolean, v_num_of_sockets integer, v_cpu_per_socket integer, v_usb_policy integer, v_time_zone character varying, v_auto_startup boolean, v_is_stateless boolean, v_is_smartcard_enabled boolean, v_is_delete_protected boolean, v_dedicated_vm_for_vds uuid, v_fail_back boolean, v_vm_type integer, v_nice_level integer, v_default_boot_sequence integer, v_default_display_type integer, v_priority integer, v_iso_path character varying, v_origin integer, v_initrd_url character varying, v_kernel_url character varying, v_kernel_params character varying, v_migration_support integer, v_predefined_properties character varying, v_userdefined_properties character varying, v_min_allocated_mem integer, v_quota_id uuid, v_cpu_pinning character varying, v_host_cpu_flags boolean) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vm_static
      SET description = v_description,mem_size_mb = v_mem_size_mb,os = v_os,vds_group_id = v_vds_group_id,
      VM_NAME = v_vm_name,vmt_guid = v_vmt_guid,
      domain = v_domain,creation_date = v_creation_date,num_of_monitors = v_num_of_monitors,
      allow_console_reconnect = v_allow_console_reconnect,
      is_initialized = v_is_initialized,is_auto_suspend = v_is_auto_suspend,
      num_of_sockets = v_num_of_sockets,cpu_per_socket = v_cpu_per_socket,
      usb_policy = v_usb_policy,time_zone = v_time_zone,auto_startup = v_auto_startup,
      is_stateless = v_is_stateless,dedicated_vm_for_vds = v_dedicated_vm_for_vds,
      fail_back = v_fail_back,vm_type = v_vm_type,
      _update_date = LOCALTIMESTAMP,default_boot_sequence = v_default_boot_sequence,
      default_display_type = v_default_display_type,
      priority = v_priority,iso_path = v_iso_path,origin = v_origin,
      initrd_url = v_initrd_url,kernel_url = v_kernel_url,
      kernel_params = v_kernel_params,migration_support = v_migration_support,
      predefined_properties = v_predefined_properties,userdefined_properties = v_userdefined_properties,
      min_allocated_mem = v_min_allocated_mem, quota_id = v_quota_id, cpu_pinning = v_cpu_pinning, is_smartcard_enabled = v_is_smartcard_enabled,
      is_delete_protected = v_is_delete_protected, host_cpu_flags = v_host_cpu_flags
      WHERE vm_guid = v_vm_guid
      AND   entity_type = 'VM';
END; $$;


ALTER FUNCTION public.updatevmstatic(v_description character varying, v_mem_size_mb integer, v_os integer, v_vds_group_id uuid, v_vm_guid uuid, v_vm_name character varying, v_vmt_guid uuid, v_domain character varying, v_creation_date timestamp with time zone, v_num_of_monitors integer, v_allow_console_reconnect boolean, v_is_initialized boolean, v_is_auto_suspend boolean, v_num_of_sockets integer, v_cpu_per_socket integer, v_usb_policy integer, v_time_zone character varying, v_auto_startup boolean, v_is_stateless boolean, v_is_smartcard_enabled boolean, v_is_delete_protected boolean, v_dedicated_vm_for_vds uuid, v_fail_back boolean, v_vm_type integer, v_nice_level integer, v_default_boot_sequence integer, v_default_display_type integer, v_priority integer, v_iso_path character varying, v_origin integer, v_initrd_url character varying, v_kernel_url character varying, v_kernel_params character varying, v_migration_support integer, v_predefined_properties character varying, v_userdefined_properties character varying, v_min_allocated_mem integer, v_quota_id uuid, v_cpu_pinning character varying, v_host_cpu_flags boolean) OWNER TO engineer;

--
-- Name: updatevmstatistics(numeric, numeric, numeric, integer, integer, integer, text, uuid); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevmstatistics(v_cpu_sys numeric, v_cpu_user numeric, v_elapsed_time numeric, v_usage_cpu_percent integer, v_usage_mem_percent integer, v_usage_network_percent integer, v_disks_usage text, v_vm_guid uuid) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vm_statistics
      SET cpu_sys = v_cpu_sys,cpu_user = v_cpu_user,elapsed_time = v_elapsed_time,
      usage_cpu_percent = v_usage_cpu_percent,usage_mem_percent = v_usage_mem_percent,
      usage_network_percent = v_usage_network_percent,disks_usage = v_disks_usage, _update_date = LOCALTIMESTAMP
      WHERE vm_guid = v_vm_guid;
END; $$;


ALTER FUNCTION public.updatevmstatistics(v_cpu_sys numeric, v_cpu_user numeric, v_elapsed_time numeric, v_usage_cpu_percent integer, v_usage_mem_percent integer, v_usage_network_percent integer, v_disks_usage text, v_vm_guid uuid) OWNER TO engineer;

--
-- Name: updatevmtagsdefaultdisplaytype(uuid, uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevmtagsdefaultdisplaytype(v_tag_id uuid, v_vm_id uuid, v_defaultdisplaytype integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      update tags_vm_map
      set DefaultDisplayType = v_DefaultDisplayType
      where tags_vm_map.tag_id = v_tag_id
      and tags_vm_map.vm_id = v_vm_id;
END; $$;


ALTER FUNCTION public.updatevmtagsdefaultdisplaytype(v_tag_id uuid, v_vm_id uuid, v_defaultdisplaytype integer) OWNER TO engineer;

--
-- Name: updatevmtemplate(integer, timestamp with time zone, character varying, integer, character varying, integer, integer, integer, uuid, uuid, character varying, integer, boolean, integer, integer, character varying, boolean, boolean, integer, integer, integer, integer, integer, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, character varying, uuid, integer, uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevmtemplate(v_child_count integer, v_creation_date timestamp with time zone, v_description character varying, v_mem_size_mb integer, v_name character varying, v_num_of_sockets integer, v_cpu_per_socket integer, v_os integer, v_vmt_guid uuid, v_vds_group_id uuid, v_domain character varying, v_num_of_monitors integer, v_allow_console_reconnect boolean, v_status integer, v_usb_policy integer, v_time_zone character varying, v_fail_back boolean, v_is_auto_suspend boolean, v_vm_type integer, v_nice_level integer, v_default_boot_sequence integer, v_default_display_type integer, v_priority integer, v_auto_startup boolean, v_is_stateless boolean, v_is_smartcard_enabled boolean, v_is_delete_protected boolean, v_is_disabled boolean, v_iso_path character varying, v_origin integer, v_initrd_url character varying, v_kernel_url character varying, v_kernel_params character varying, v_quota_id uuid, v_migration_support integer, v_dedicated_vm_for_vds uuid, v_min_allocated_mem integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vm_static
      SET child_count = v_child_count,creation_date = v_creation_date,description = v_description,
      mem_size_mb = v_mem_size_mb,vm_name = v_name,num_of_sockets = v_num_of_sockets,
      cpu_per_socket = v_cpu_per_socket,os = v_os,
      vds_group_id = v_vds_group_id,domain = v_domain,num_of_monitors = v_num_of_monitors,
      allow_console_reconnect = v_allow_console_reconnect,
      template_status = v_status,usb_policy = v_usb_policy,time_zone = v_time_zone,
      fail_back = v_fail_back,is_auto_suspend = v_is_auto_suspend,
      vm_type = v_vm_type,
      nice_level = v_nice_level,default_boot_sequence = v_default_boot_sequence,
      default_display_type = v_default_display_type,
      priority = v_priority,auto_startup = v_auto_startup,is_stateless = v_is_stateless,
      iso_path = v_iso_path,origin = v_origin,initrd_url = v_initrd_url,
      kernel_url = v_kernel_url,kernel_params = v_kernel_params, _update_date = CURRENT_TIMESTAMP, quota_id = v_quota_id,
      migration_support = v_migration_support, dedicated_vm_for_vds = v_dedicated_vm_for_vds, is_smartcard_enabled = v_is_smartcard_enabled,
      is_delete_protected = v_is_delete_protected, is_disabled = v_is_disabled,
      min_allocated_mem = v_min_allocated_mem
      WHERE vm_guid = v_vmt_guid
      AND   entity_type = 'TEMPLATE';
END; $$;


ALTER FUNCTION public.updatevmtemplate(v_child_count integer, v_creation_date timestamp with time zone, v_description character varying, v_mem_size_mb integer, v_name character varying, v_num_of_sockets integer, v_cpu_per_socket integer, v_os integer, v_vmt_guid uuid, v_vds_group_id uuid, v_domain character varying, v_num_of_monitors integer, v_allow_console_reconnect boolean, v_status integer, v_usb_policy integer, v_time_zone character varying, v_fail_back boolean, v_is_auto_suspend boolean, v_vm_type integer, v_nice_level integer, v_default_boot_sequence integer, v_default_display_type integer, v_priority integer, v_auto_startup boolean, v_is_stateless boolean, v_is_smartcard_enabled boolean, v_is_delete_protected boolean, v_is_disabled boolean, v_iso_path character varying, v_origin integer, v_initrd_url character varying, v_kernel_url character varying, v_kernel_params character varying, v_quota_id uuid, v_migration_support integer, v_dedicated_vm_for_vds uuid, v_min_allocated_mem integer) OWNER TO engineer;

--
-- Name: updatevmtemplatestatus(uuid, integer); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION updatevmtemplatestatus(v_vmt_guid uuid, v_status integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
BEGIN
      UPDATE vm_static
      SET    template_status = v_status
      WHERE  vm_guid = v_vmt_guid
      AND    entity_type = 'TEMPLATE';
END; $$;


ALTER FUNCTION public.updatevmtemplatestatus(v_vmt_guid uuid, v_status integer) OWNER TO engineer;

--
-- Name: uuid_generate_v1(); Type: FUNCTION; Schema: public; Owner: engineer
--

CREATE FUNCTION uuid_generate_v1() RETURNS uuid
    LANGUAGE plpgsql
    AS $$
declare
    v_val bigint;
    v_4_part char(4);
    v_8_part char(8);
    v_12_part char(12);
    v_4_part_max int;
begin
    -- The only part we should use modulo is the 4 digit part, all the
    -- rest are really big numbers (i.e 16^8 - 1 and 16^12 - 1)
    v_4_part_max = 65535; -- this is 16^4 -1
    v_val := nextval('uuid_sequence');
    v_4_part := lpad(to_hex(v_val % v_4_part_max), 4, '0');
    v_8_part := lpad(to_hex(v_val), 8, '0');
    v_12_part := lpad(to_hex(v_val), 12, '0');
    return v_8_part || v_4_part || v_4_part || v_4_part || v_12_part;
end; $$;


ALTER FUNCTION public.uuid_generate_v1() OWNER TO engineer;

--
-- Name: async_tasks_entities; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE async_tasks_entities (
    async_task_id uuid NOT NULL,
    entity_id uuid NOT NULL,
    entity_type character varying(128)
);


ALTER TABLE public.async_tasks_entities OWNER TO engineer;

--
-- Name: desktop_vms; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW desktop_vms AS
    SELECT vms.vm_name, vms.vm_mem_size_mb, vms.nice_level, vms.vmt_guid, vms.vm_os, vms.vm_description, vms.vds_group_id, vms.vm_domain, vms.vm_creation_date, vms.auto_startup, vms.is_stateless, vms.is_smartcard_enabled, vms.is_delete_protected, vms.dedicated_vm_for_vds, vms.fail_back, vms.default_boot_sequence, vms.vm_type, vms.vds_group_name, vms.selection_algorithm, vms.transparent_hugepages, vms.storage_pool_id, vms.storage_pool_name, vms.vds_group_description, vms.vmt_name, vms.vmt_mem_size_mb, vms.vmt_os, vms.vmt_creation_date, vms.vmt_child_count, vms.vmt_num_of_sockets, vms.vmt_cpu_per_socket, vms.vmt_num_of_cpus, vms.vmt_description, vms.status, vms.vm_ip, vms.vm_host, vms.vm_pid, vms.last_start_time, vms.guest_cur_user_name, vms.console_cur_user_name, vms.guest_last_login_time, vms.guest_last_logout_time, vms.guest_os, vms.console_user_id, vms.guest_agent_nics_hash, vms.run_on_vds, vms.migrating_to_vds, vms.app_list, vms.display, vms.hibernation_vol_handle, vms.vm_pool_name, vms.vm_pool_id, vms.vm_guid, vms.num_of_monitors, vms.allow_console_reconnect, vms.is_initialized, vms.is_auto_suspend, vms.num_of_sockets, vms.cpu_per_socket, vms.usb_policy, vms.acpi_enable, vms.session, vms.num_of_cpus, vms.quota_id, vms.quota_name, vms.quota_enforcement_type, vms.display_ip, vms.display_type, vms.kvm_enable, vms.boot_sequence, vms.display_secure_port, vms.utc_diff, vms.last_vds_run_on, vms.client_ip, vms.guest_requested_memory, vms.time_zone, vms.cpu_user, vms.cpu_sys, vms.elapsed_time, vms.usage_network_percent, vms.usage_mem_percent, vms.usage_cpu_percent, vms.run_on_vds_name, vms.vds_group_cpu_name, vms.default_display_type, vms.priority, vms.iso_path, vms.origin, vms.vds_group_compatibility_version, vms.initrd_url, vms.kernel_url, vms.kernel_params, vms.pause_status, vms.exit_message, vms.exit_status, vms.migration_support, vms.predefined_properties, vms.userdefined_properties, vms.min_allocated_mem, vms.hash, vms.cpu_pinning, vms.db_generation, vms.host_cpu_flags FROM vms WHERE (vms.vm_type = 0);


ALTER TABLE public.desktop_vms OWNER TO engineer;

--
-- Name: dwh_history_timekeeping; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE dwh_history_timekeeping (
    var_name character varying(50) NOT NULL,
    var_value character varying(255),
    var_datetime timestamp with time zone
);


ALTER TABLE public.dwh_history_timekeeping OWNER TO engineer;

--
-- Name: dwh_add_tags_relations_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_add_tags_relations_history_view AS
    ((((SELECT tags.tag_id AS entity_id, tags.parent_id, (18)::smallint AS entity_type, tags._create_date AS attach_date, tags._update_date AS move_date FROM tags WHERE ((tags._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text))) OR (tags._update_date > (SELECT history_timekeeping_1.var_datetime FROM dwh_history_timekeeping history_timekeeping_1 WHERE ((history_timekeeping_1.var_name)::text = 'lastSync'::text)))) UNION ALL SELECT tags_vds_map.vds_id AS entity_id, tags_vds_map.tag_id AS parent_id, (3)::smallint AS entity_type, tags_vds_map._create_date AS attach_date, NULL::unknown AS move_date FROM tags_vds_map WHERE (tags_vds_map._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text)))) UNION ALL SELECT tags_vm_pool_map.vm_pool_id AS entity_id, tags_vm_pool_map.tag_id AS parent_id, (5)::smallint AS entity_type, tags_vm_pool_map._create_date AS attach_date, NULL::unknown AS move_date FROM tags_vm_pool_map WHERE (tags_vm_pool_map._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text)))) UNION ALL SELECT tags_vm_map.vm_id AS entity_id, tags_vm_map.tag_id AS parent_id, (2)::smallint AS entity_type, tags_vm_map._create_date AS attach_date, NULL::unknown AS move_date FROM tags_vm_map WHERE (tags_vm_map._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text)))) UNION ALL SELECT tags_user_map.user_id AS entity_id, tags_user_map.tag_id AS parent_id, (15)::smallint AS entity_type, tags_user_map._create_date AS attach_date, NULL::unknown AS move_date FROM tags_user_map WHERE (tags_user_map._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text)))) UNION ALL SELECT tags_user_group_map.group_id AS entity_id, tags_user_group_map.tag_id AS parent_id, (17)::smallint AS entity_type, tags_user_group_map._create_date AS attach_date, NULL::unknown AS move_date FROM tags_user_group_map WHERE (tags_user_group_map._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text)));


ALTER TABLE public.dwh_add_tags_relations_history_view OWNER TO engineer;

--
-- Name: dwh_cluster_configuration_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_cluster_configuration_history_view AS
    SELECT vds_groups.vds_group_id AS cluster_id, vds_groups.name AS cluster_name, vds_groups.description AS cluster_description, vds_groups.storage_pool_id AS datacenter_id, vds_groups.cpu_name, vds_groups.compatibility_version, vds_groups._create_date AS create_date, vds_groups._update_date AS update_date FROM vds_groups WHERE ((vds_groups._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text))) OR (vds_groups._update_date > (SELECT history_timekeeping_1.var_datetime FROM dwh_history_timekeeping history_timekeeping_1 WHERE ((history_timekeeping_1.var_name)::text = 'lastSync'::text))));


ALTER TABLE public.dwh_cluster_configuration_history_view OWNER TO engineer;

--
-- Name: dwh_datacenter_configuration_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_datacenter_configuration_history_view AS
    SELECT storage_pool.id AS datacenter_id, storage_pool.name AS datacenter_name, storage_pool.description AS datacenter_description, (storage_pool.storage_pool_type)::smallint AS storage_type, storage_pool._create_date AS create_date, storage_pool._update_date AS update_date FROM storage_pool WHERE ((storage_pool._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text))) OR (storage_pool._update_date > (SELECT history_timekeeping_1.var_datetime FROM dwh_history_timekeeping history_timekeeping_1 WHERE ((history_timekeeping_1.var_name)::text = 'lastSync'::text))));


ALTER TABLE public.dwh_datacenter_configuration_history_view OWNER TO engineer;

--
-- Name: dwh_datacenter_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_datacenter_history_view AS
    SELECT storage_pool.id AS datacenter_id, (storage_pool.status)::smallint AS datacenter_status FROM storage_pool;


ALTER TABLE public.dwh_datacenter_history_view OWNER TO engineer;

--
-- Name: dwh_datacenter_storage_map_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_datacenter_storage_map_history_view AS
    SELECT DISTINCT storage_pool_iso_map.storage_pool_id AS datacenter_id, storage_pool_iso_map.storage_id AS storage_domain_id FROM storage_pool_iso_map;


ALTER TABLE public.dwh_datacenter_storage_map_history_view OWNER TO engineer;

--
-- Name: dwh_disk_vm_map_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_disk_vm_map_history_view AS
    SELECT images.image_guid AS vm_disk_id, vm_device.vm_id FROM (vm_device JOIN images ON ((vm_device.device_id = images.image_group_id))) WHERE (images.active = true);


ALTER TABLE public.dwh_disk_vm_map_history_view OWNER TO engineer;

--
-- Name: dwh_host_configuration_full_check_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_host_configuration_full_check_view AS
    SELECT a.vds_id AS host_id, a.vds_unique_id AS host_unique_id, a.vds_name AS host_name, a.vds_group_id AS cluster_id, (a.vds_type)::smallint AS host_type, a.host_name AS fqdn_or_ip, b.physical_mem_mb AS memory_size_mb, (c.swap_total)::integer AS swap_size_mb, b.cpu_model, (b.cpu_cores)::smallint AS number_of_cores, (b.cpu_sockets)::smallint AS number_of_sockets, b.cpu_speed_mh, b.host_os, a.ip AS pm_ip_address, b.kernel_version, b.kvm_version, b.libvirt_version, CASE substr((b.software_version)::text, 1, 3) WHEN '4.4'::text THEN (('2.1'::text || substr((b.software_version)::text, 4, length((b.software_version)::text))))::character varying WHEN '4.5'::text THEN (('2.2'::text || substr((b.software_version)::text, 4, length((b.software_version)::text))))::character varying WHEN '4.9'::text THEN (('2.3'::text || substr((b.software_version)::text, 4, length((b.software_version)::text))))::character varying ELSE b.software_version END AS vdsm_version, a.port AS vdsm_port, a._create_date AS create_date, a._update_date AS update_date FROM ((vds_static a JOIN vds_dynamic b ON ((a.vds_id = b.vds_id))) JOIN vds_statistics c ON ((c.vds_id = a.vds_id)));


ALTER TABLE public.dwh_host_configuration_full_check_view OWNER TO engineer;

--
-- Name: dwh_host_configuration_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_host_configuration_history_view AS
    SELECT a.vds_id AS host_id, a.vds_unique_id AS host_unique_id, a.vds_name AS host_name, a.vds_group_id AS cluster_id, (a.vds_type)::smallint AS host_type, a.host_name AS fqdn_or_ip, b.physical_mem_mb AS memory_size_mb, (c.swap_total)::integer AS swap_size_mb, b.cpu_model, (b.cpu_cores)::smallint AS number_of_cores, (b.cpu_sockets)::smallint AS number_of_sockets, b.cpu_speed_mh, b.host_os, a.ip AS pm_ip_address, b.kernel_version, b.kvm_version, b.libvirt_version, b.software_version AS vdsm_version, a.port AS vdsm_port, a._create_date AS create_date, a._update_date AS update_date FROM ((vds_static a JOIN vds_dynamic b ON ((a.vds_id = b.vds_id))) JOIN vds_statistics c ON ((c.vds_id = a.vds_id))) WHERE ((a._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text))) OR (a._update_date > (SELECT history_timekeeping_1.var_datetime FROM dwh_history_timekeeping history_timekeeping_1 WHERE ((history_timekeeping_1.var_name)::text = 'lastSync'::text))));


ALTER TABLE public.dwh_host_configuration_history_view OWNER TO engineer;

--
-- Name: dwh_host_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_host_history_view AS
    SELECT b.vds_id AS host_id, (b.status)::smallint AS host_status, (c.usage_mem_percent)::smallint AS memory_usage_percent, (c.usage_cpu_percent)::smallint AS cpu_usage_percent, (c.ksm_cpu_percent)::smallint AS ksm_cpu_percent, (c.cpu_load)::integer AS cpu_load, (c.cpu_sys)::smallint AS system_cpu_usage_percent, (c.cpu_user)::smallint AS user_cpu_usage_percent, ((c.swap_total - c.swap_free))::integer AS swap_used_mb, (b.vm_active)::smallint AS vm_active, (b.vm_count)::smallint AS total_vms, b.vms_cores_count AS total_vms_vcpus FROM vds_dynamic b, vds_statistics c WHERE (b.vds_id = c.vds_id);


ALTER TABLE public.dwh_host_history_view OWNER TO engineer;

--
-- Name: dwh_host_interface_configuration_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_host_interface_configuration_history_view AS
    SELECT a.id AS host_interface_id, a.name AS host_interface_name, a.vds_id AS host_id, (a.type)::smallint AS host_interface_type, a.speed AS host_interface_speed_bps, a.mac_addr AS mac_address, a.network_name, a.addr AS ip_address, a.gateway, a.is_bond AS bond, a.bond_name, a.vlan_id, a._create_date AS create_date, a._update_date AS update_date FROM vds_interface a WHERE (((a._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text))) OR (a._update_date > (SELECT history_timekeeping_1.var_datetime FROM dwh_history_timekeeping history_timekeeping_1 WHERE ((history_timekeeping_1.var_name)::text = 'lastSync'::text)))) AND ((a.is_bond IS NULL) OR ((a.is_bond = true) AND ((a.name)::text IN (SELECT b.bond_name FROM vds_interface b WHERE ((b.is_bond IS NULL) AND (b.vds_id = a.vds_id)))))));


ALTER TABLE public.dwh_host_interface_configuration_history_view OWNER TO engineer;

--
-- Name: dwh_host_interface_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_host_interface_history_view AS
    SELECT vds_interface_statistics.id AS host_interface_id, (vds_interface_statistics.rx_rate)::smallint AS receive_rate_percent, (vds_interface_statistics.tx_rate)::smallint AS transmit_rate_percent FROM vds_interface_statistics;


ALTER TABLE public.dwh_host_interface_history_view OWNER TO engineer;

--
-- Name: dwh_remove_tags_relations_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_remove_tags_relations_history_view AS
    ((((SELECT tags.tag_id AS entity_id, tags.parent_id FROM tags UNION ALL SELECT tags_vds_map.vds_id AS entity_id, tags_vds_map.tag_id AS parent_id FROM tags_vds_map) UNION ALL SELECT tags_vm_pool_map.vm_pool_id AS entity_id, tags_vm_pool_map.tag_id AS parent_id FROM tags_vm_pool_map) UNION ALL SELECT tags_vm_map.vm_id AS entity_id, tags_vm_map.tag_id AS parent_id FROM tags_vm_map) UNION ALL SELECT tags_user_map.user_id AS entity_id, tags_user_map.tag_id AS parent_id FROM tags_user_map) UNION ALL SELECT tags_user_group_map.group_id AS entity_id, tags_user_group_map.tag_id AS parent_id FROM tags_user_group_map;


ALTER TABLE public.dwh_remove_tags_relations_history_view OWNER TO engineer;

--
-- Name: dwh_storage_domain_configuration_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_storage_domain_configuration_history_view AS
    SELECT storage_domain_static.id AS storage_domain_id, storage_domain_static.storage_name AS storage_domain_name, (storage_domain_static.storage_domain_type)::smallint AS storage_domain_type, (storage_domain_static.storage_type)::smallint AS storage_type, storage_domain_static._create_date AS create_date, storage_domain_static._update_date AS update_date FROM storage_domain_static WHERE ((storage_domain_static._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text))) OR (storage_domain_static._update_date > (SELECT history_timekeeping_1.var_datetime FROM dwh_history_timekeeping history_timekeeping_1 WHERE ((history_timekeeping_1.var_name)::text = 'lastSync'::text))));


ALTER TABLE public.dwh_storage_domain_configuration_history_view OWNER TO engineer;

--
-- Name: dwh_storage_domain_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_storage_domain_history_view AS
    SELECT storage_domain_dynamic.id AS storage_domain_id, fn_get_storage_domain_shared_status_by_domain_id(storage_domain_static.id, status_table.status, storage_domain_static.storage_domain_type) AS storage_domain_status, storage_domain_dynamic.available_disk_size AS available_disk_size_gb, storage_domain_dynamic.used_disk_size AS used_disk_size_gb FROM ((storage_domain_dynamic JOIN storage_domain_static ON ((storage_domain_dynamic.id = storage_domain_static.id))) LEFT JOIN (SELECT storage_pool_iso_map.storage_id, max(storage_pool_iso_map.status) AS status FROM storage_pool_iso_map GROUP BY storage_pool_iso_map.storage_id) status_table ON ((storage_domain_static.id = status_table.storage_id)));


ALTER TABLE public.dwh_storage_domain_history_view OWNER TO engineer;

--
-- Name: dwh_tags_details_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_tags_details_history_view AS
    SELECT tags.tag_id, tags.tag_name, tags.description AS tag_description, tags._create_date AS create_date, tags._update_date AS update_date FROM tags WHERE ((tags._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text))) OR (tags._update_date > (SELECT history_timekeeping_1.var_datetime FROM dwh_history_timekeeping history_timekeeping_1 WHERE ((history_timekeeping_1.var_name)::text = 'lastSync'::text))));


ALTER TABLE public.dwh_tags_details_history_view OWNER TO engineer;

--
-- Name: dwh_vm_configuration_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_vm_configuration_history_view AS
    SELECT a.vm_guid AS vm_id, a.vm_name, a.description AS vm_description, (a.vm_type)::smallint AS vm_type, a.vds_group_id AS cluster_id, a.vmt_guid AS template_id, b.vm_name AS template_name, (a.cpu_per_socket)::smallint AS cpu_per_socket, (a.num_of_sockets)::smallint AS number_of_sockets, a.mem_size_mb AS memory_size_mb, (a.os)::smallint AS operating_system, a.domain AS ad_domain, a.dedicated_vm_for_vds AS default_host, a.auto_startup AS high_availability, a.is_initialized AS initialized, a.is_stateless AS stateless, a.fail_back, a.is_auto_suspend AS auto_suspend, (a.usb_policy)::smallint AS usb_policy, a.time_zone, a._create_date AS create_date, a._update_date AS update_date FROM (vm_static a JOIN vm_static b ON ((a.vmt_guid = b.vm_guid))) WHERE ((((a.entity_type)::text = 'VM'::text) AND ((b.entity_type)::text = 'TEMPLATE'::text)) AND (((a._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text))) OR (a._update_date > (SELECT history_timekeeping_1.var_datetime FROM dwh_history_timekeeping history_timekeeping_1 WHERE ((history_timekeeping_1.var_name)::text = 'lastSync'::text)))) OR (b._update_date > (SELECT history_timekeeping_1.var_datetime FROM dwh_history_timekeeping history_timekeeping_1 WHERE ((history_timekeeping_1.var_name)::text = 'lastSync'::text)))));


ALTER TABLE public.dwh_vm_configuration_history_view OWNER TO engineer;

--
-- Name: dwh_vm_device_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_vm_device_history_view AS
    SELECT vm_device.device_id, vm_device.vm_id, vm_device.type, vm_device.address, vm_device.is_managed, vm_device.is_plugged, vm_device.is_readonly, vm_device._create_date AS create_date, vm_device._update_date AS update_date FROM vm_device WHERE (((((vm_device.type)::text = 'disk'::text) AND ((vm_device.device)::text = 'disk'::text)) OR ((vm_device.type)::text = 'interface'::text)) AND ((vm_device._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text))) OR (vm_device._update_date > (SELECT history_timekeeping_1.var_datetime FROM dwh_history_timekeeping history_timekeeping_1 WHERE ((history_timekeeping_1.var_name)::text = 'lastSync'::text)))));


ALTER TABLE public.dwh_vm_device_history_view OWNER TO engineer;

--
-- Name: dwh_vm_disk_configuration_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_vm_disk_configuration_history_view AS
    SELECT d.disk_id AS vm_disk_id, d.disk_alias AS vm_disk_name, d.disk_description AS vm_disk_description, i.image_guid AS image_id, image_storage_domain_map.storage_domain_id, ((i.size / 1048576))::integer AS vm_disk_size_mb, (i.volume_type)::smallint AS vm_disk_type, (i.volume_format)::smallint AS vm_disk_format, CASE WHEN ((d.disk_interface)::text = 'IDE'::text) THEN (0)::smallint WHEN ((d.disk_interface)::text = 'SCSI'::text) THEN (1)::smallint WHEN ((d.disk_interface)::text = 'VirtIO'::text) THEN (2)::smallint ELSE NULL::smallint END AS vm_disk_interface, d.shareable AS is_shared, i._create_date AS create_date, i._update_date AS update_date FROM ((((images i JOIN base_disks d ON ((i.image_group_id = d.disk_id))) JOIN image_storage_domain_map ON ((image_storage_domain_map.image_id = i.image_guid))) LEFT JOIN vm_device ON ((vm_device.device_id = i.image_group_id))) LEFT JOIN vm_static ON ((vm_static.vm_guid = vm_device.vm_id))) WHERE (((i.active = true) AND (((vm_static.entity_type)::text = 'VM'::text) OR (vm_static.entity_type IS NULL))) AND ((i._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text))) OR (i._update_date > (SELECT history_timekeeping_1.var_datetime FROM dwh_history_timekeeping history_timekeeping_1 WHERE ((history_timekeeping_1.var_name)::text = 'lastSync'::text)))));


ALTER TABLE public.dwh_vm_disk_configuration_history_view OWNER TO engineer;

--
-- Name: dwh_vm_disks_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_vm_disks_history_view AS
    SELECT d.disk_id AS vm_disk_id, images.image_guid AS image_id, (images.imagestatus)::smallint AS vm_disk_status, ((disk_image_dynamic.actual_size / 1048576))::integer AS vm_disk_actual_size_mb, disk_image_dynamic.read_rate AS read_rate_bytes_per_second, disk_image_dynamic.read_latency_seconds, disk_image_dynamic.write_rate AS write_rate_bytes_per_second, disk_image_dynamic.write_latency_seconds, disk_image_dynamic.flush_latency_seconds FROM ((((images JOIN disk_image_dynamic ON ((images.image_guid = disk_image_dynamic.image_id))) JOIN base_disks d ON ((images.image_group_id = d.disk_id))) LEFT JOIN vm_device ON ((vm_device.device_id = images.image_group_id))) LEFT JOIN vm_static ON ((vm_static.vm_guid = vm_device.vm_id))) WHERE ((images.active = true) AND (((vm_static.entity_type)::text = 'VM'::text) OR (vm_static.entity_type IS NULL)));


ALTER TABLE public.dwh_vm_disks_history_view OWNER TO engineer;

--
-- Name: dwh_vm_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_vm_history_view AS
    SELECT c.vm_guid AS vm_id, (b.status)::smallint AS vm_status, (c.usage_cpu_percent)::smallint AS cpu_usage_percent, (c.usage_mem_percent)::smallint AS memory_usage_percent, (c.cpu_sys)::smallint AS system_cpu_usage_percent, (c.cpu_user)::smallint AS user_cpu_usage_percent, c.disks_usage, b.vm_ip, b.console_cur_user_name AS current_user_name, b.run_on_vds AS currently_running_on_host FROM vm_dynamic b, vm_statistics c WHERE (c.vm_guid = b.vm_guid);


ALTER TABLE public.dwh_vm_history_view OWNER TO engineer;

--
-- Name: dwh_vm_interface_configuration_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_vm_interface_configuration_history_view AS
    SELECT vm_interface.id AS vm_interface_id, vm_interface.name AS vm_interface_name, vm_interface.vm_guid AS vm_id, (vm_interface.type)::smallint AS vm_interface_type, vm_interface.speed AS vm_interface_speed_bps, vm_interface.mac_addr AS mac_address, vm_interface.network_name, vm_interface._create_date AS create_date, vm_interface._update_date AS update_date FROM vm_interface WHERE ((vm_interface.vmt_guid IS NULL) AND ((vm_interface._create_date > (SELECT dwh_history_timekeeping.var_datetime FROM dwh_history_timekeeping WHERE ((dwh_history_timekeeping.var_name)::text = 'lastSync'::text))) OR (vm_interface._update_date > (SELECT history_timekeeping_1.var_datetime FROM dwh_history_timekeeping history_timekeeping_1 WHERE ((history_timekeeping_1.var_name)::text = 'lastSync'::text)))));


ALTER TABLE public.dwh_vm_interface_configuration_history_view OWNER TO engineer;

--
-- Name: dwh_vm_interface_history_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW dwh_vm_interface_history_view AS
    SELECT vm_interface_statistics.id AS vm_interface_id, (vm_interface_statistics.rx_rate)::smallint AS receive_rate_percent, (vm_interface_statistics.tx_rate)::smallint AS transmit_rate_percent FROM vm_interface_statistics;


ALTER TABLE public.dwh_vm_interface_history_view OWNER TO engineer;

--
-- Name: internal_permissions_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW internal_permissions_view AS
    SELECT permissions.id, permissions.role_id, permissions.ad_element_id, permissions.object_id, permissions.object_type_id, roles.name AS role_name, roles.role_type, roles.allows_viewing_children FROM (permissions JOIN roles ON ((permissions.role_id = roles.id)));


ALTER TABLE public.internal_permissions_view OWNER TO engineer;

SET default_with_oids = false;

--
-- Name: materialized_views; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE materialized_views (
    mv_name name NOT NULL,
    v_name name NOT NULL,
    refresh_rate_in_sec integer,
    last_refresh timestamp with time zone,
    avg_cost_ms integer DEFAULT 0 NOT NULL,
    min_refresh_rate_in_sec integer DEFAULT 0,
    custom boolean DEFAULT false,
    active boolean DEFAULT true
);


ALTER TABLE public.materialized_views OWNER TO engineer;

--
-- Name: network_cluster_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW network_cluster_view AS
    SELECT network_cluster.cluster_id, network_cluster.network_id, network.name AS network_name, network_cluster.status, network_cluster.required, network_cluster.is_display, vds_groups.name AS cluster_name FROM ((network_cluster JOIN network ON ((network_cluster.network_id = network.id))) JOIN vds_groups ON ((network_cluster.cluster_id = vds_groups.vds_group_id)));


ALTER TABLE public.network_cluster_view OWNER TO engineer;

--
-- Name: network_vds_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW network_vds_view AS
    SELECT network.id AS network_id, network.name AS network_name, vds_static.vds_name FROM (((vds_interface JOIN vds_static ON ((vds_interface.vds_id = vds_static.vds_id))) JOIN network ON (((vds_interface.network_name)::text = (network.name)::text))) JOIN network_cluster ON ((network_cluster.network_id = network.id))) WHERE (network_cluster.cluster_id = vds_static.vds_group_id);


ALTER TABLE public.network_vds_view OWNER TO engineer;

--
-- Name: network_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW network_view AS
    SELECT network.id, network.name, network.description, network.type, network.addr, network.subnet, network.gateway, network.vlan_id, network.stp, network.mtu, network.vm_network, network.storage_pool_id, storage_pool.name AS storage_pool_name, storage_pool.compatibility_version FROM (network JOIN storage_pool ON ((network.storage_pool_id = storage_pool.id)));


ALTER TABLE public.network_view OWNER TO engineer;

SET default_with_oids = true;

--
-- Name: object_column_white_list; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE object_column_white_list (
    object_name character varying(128) NOT NULL,
    column_name character varying(128) NOT NULL
);


ALTER TABLE public.object_column_white_list OWNER TO engineer;

--
-- Name: object_column_white_list_sql; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE object_column_white_list_sql (
    object_name character varying(128) NOT NULL,
    sql text NOT NULL
);


ALTER TABLE public.object_column_white_list_sql OWNER TO engineer;

--
-- Name: quota_limitations_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW quota_limitations_view AS
    SELECT q_limit.quota_id, q.storage_pool_id, storage_pool.name AS storage_pool_name, q.quota_name, q.description, q.threshold_vds_group_percentage, q.threshold_storage_percentage, q.grace_vds_group_percentage, q.grace_storage_percentage, q_limit.virtual_cpu, q_limit.mem_size_mb, q_limit.storage_size_gb, storage_pool.quota_enforcement_type, q_limit.vds_group_id, q_limit.storage_id, (COALESCE(q_limit.vds_group_id, q_limit.storage_id) IS NULL) AS is_global, (COALESCE((q_limit.virtual_cpu)::bigint, q_limit.mem_size_mb, q_limit.storage_size_gb) IS NULL) AS is_empty FROM ((quota q JOIN storage_pool ON ((storage_pool.id = q.storage_pool_id))) LEFT JOIN quota_limitation q_limit ON ((q_limit.quota_id = q.id)));


ALTER TABLE public.quota_limitations_view OWNER TO engineer;

--
-- Name: schema_version_seq; Type: SEQUENCE; Schema: public; Owner: engineer
--

CREATE SEQUENCE schema_version_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.schema_version_seq OWNER TO engineer;

--
-- Name: schema_version_seq; Type: SEQUENCE SET; Schema: public; Owner: engineer
--

SELECT pg_catalog.setval('schema_version_seq', 197, true);


SET default_with_oids = false;

--
-- Name: schema_version; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE schema_version (
    id integer DEFAULT nextval('schema_version_seq'::regclass) NOT NULL,
    version character varying(10) NOT NULL,
    script character varying(255) NOT NULL,
    checksum character varying(128),
    installed_by character varying(30) NOT NULL,
    started_at timestamp without time zone DEFAULT now(),
    ended_at timestamp without time zone,
    state character varying(15) NOT NULL,
    current boolean NOT NULL,
    comment text DEFAULT ''::text
);


ALTER TABLE public.schema_version OWNER TO engineer;

--
-- Name: server_vms; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW server_vms AS
    SELECT vms.vm_name, vms.vm_mem_size_mb, vms.nice_level, vms.vmt_guid, vms.vm_os, vms.vm_description, vms.vds_group_id, vms.vm_domain, vms.vm_creation_date, vms.auto_startup, vms.is_stateless, vms.is_smartcard_enabled, vms.is_delete_protected, vms.dedicated_vm_for_vds, vms.fail_back, vms.default_boot_sequence, vms.vm_type, vms.vds_group_name, vms.selection_algorithm, vms.transparent_hugepages, vms.storage_pool_id, vms.storage_pool_name, vms.vds_group_description, vms.vmt_name, vms.vmt_mem_size_mb, vms.vmt_os, vms.vmt_creation_date, vms.vmt_child_count, vms.vmt_num_of_sockets, vms.vmt_cpu_per_socket, vms.vmt_num_of_cpus, vms.vmt_description, vms.status, vms.vm_ip, vms.vm_host, vms.vm_pid, vms.last_start_time, vms.guest_cur_user_name, vms.console_cur_user_name, vms.guest_last_login_time, vms.guest_last_logout_time, vms.guest_os, vms.console_user_id, vms.guest_agent_nics_hash, vms.run_on_vds, vms.migrating_to_vds, vms.app_list, vms.display, vms.hibernation_vol_handle, vms.vm_pool_name, vms.vm_pool_id, vms.vm_guid, vms.num_of_monitors, vms.allow_console_reconnect, vms.is_initialized, vms.is_auto_suspend, vms.num_of_sockets, vms.cpu_per_socket, vms.usb_policy, vms.acpi_enable, vms.session, vms.num_of_cpus, vms.quota_id, vms.quota_name, vms.quota_enforcement_type, vms.display_ip, vms.display_type, vms.kvm_enable, vms.boot_sequence, vms.display_secure_port, vms.utc_diff, vms.last_vds_run_on, vms.client_ip, vms.guest_requested_memory, vms.time_zone, vms.cpu_user, vms.cpu_sys, vms.elapsed_time, vms.usage_network_percent, vms.usage_mem_percent, vms.usage_cpu_percent, vms.run_on_vds_name, vms.vds_group_cpu_name, vms.default_display_type, vms.priority, vms.iso_path, vms.origin, vms.vds_group_compatibility_version, vms.initrd_url, vms.kernel_url, vms.kernel_params, vms.pause_status, vms.exit_message, vms.exit_status, vms.migration_support, vms.predefined_properties, vms.userdefined_properties, vms.min_allocated_mem, vms.hash, vms.cpu_pinning, vms.db_generation, vms.host_cpu_flags FROM vms WHERE (vms.vm_type = 1);


ALTER TABLE public.server_vms OWNER TO engineer;

--
-- Name: storage_domains_for_search; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW storage_domains_for_search AS
    SELECT storage_domain_static.id, storage_domain_static.storage, storage_domain_static.storage_name, storage_domain_static.storage_type, storage_domain_static.storage_domain_type, storage_domain_static.storage_domain_format_type, storage_domain_static.last_time_used_as_master, CASE WHEN status_table.is_multi_domain THEN NULL::integer WHEN (status_table.status IS NULL) THEN 2 ELSE status_table.status END AS status, NULL::unknown AS owner, NULL::unknown AS storage_pool_id, NULL::unknown AS storage_pool_name, storage_domain_dynamic.available_disk_size, storage_domain_dynamic.used_disk_size, fn_get_disk_commited_value_by_storage(storage_domain_static.id) AS commited_disk_size, fn_get_storage_domain_shared_status_by_domain_id(storage_domain_static.id, status_table.status, storage_domain_static.storage_domain_type) AS storage_domain_shared_status, storage_domain_static.recoverable FROM ((storage_domain_static JOIN storage_domain_dynamic ON ((storage_domain_static.id = storage_domain_dynamic.id))) LEFT JOIN (SELECT storage_pool_iso_map.storage_id, (count(storage_pool_iso_map.storage_id) > 1) AS is_multi_domain, max(storage_pool_iso_map.status) AS status FROM storage_pool_iso_map GROUP BY storage_pool_iso_map.storage_id) status_table ON ((storage_domain_static.id = status_table.storage_id)));


ALTER TABLE public.storage_domains_for_search OWNER TO engineer;

--
-- Name: storage_domains_with_hosts_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW storage_domains_with_hosts_view AS
    SELECT storage_domain_static.id, storage_domain_static.storage, storage_domain_static.storage_name, storage_domain_dynamic.available_disk_size, storage_domain_dynamic.used_disk_size, fn_get_disk_commited_value_by_storage(storage_domain_static.id) AS commited_disk_size, storage_pool.name AS storage_pool_name, storage_domain_static.storage_type, storage_domain_static.storage_domain_type, storage_domain_static.storage_domain_format_type, storage_domain_static.last_time_used_as_master, fn_get_storage_domain_shared_status_by_domain_id(storage_domain_static.id, storage_pool_iso_map.status, storage_domain_static.storage_domain_type) AS storage_domain_shared_status, vds_groups.vds_group_id, vds_static.vds_id, storage_pool_iso_map.storage_pool_id, vds_static.recoverable FROM (((((storage_domain_static JOIN storage_domain_dynamic ON ((storage_domain_static.id = storage_domain_dynamic.id))) LEFT JOIN storage_pool_iso_map ON ((storage_domain_static.id = storage_pool_iso_map.storage_id))) LEFT JOIN storage_pool ON ((storage_pool_iso_map.storage_pool_id = storage_pool.id))) LEFT JOIN vds_groups ON ((storage_pool_iso_map.storage_pool_id = vds_groups.storage_pool_id))) LEFT JOIN vds_static ON ((vds_groups.vds_group_id = vds_static.vds_group_id)));


ALTER TABLE public.storage_domains_with_hosts_view OWNER TO engineer;

--
-- Name: storage_pool_with_storage_domain; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW storage_pool_with_storage_domain AS
    SELECT storage_pool.id, storage_pool.name, storage_pool.description, storage_pool.storage_pool_type, storage_pool.status, storage_pool.master_domain_version, storage_pool.spm_vds_id, storage_pool.compatibility_version, storage_pool._create_date, storage_pool._update_date, storage_pool_iso_map.storage_id, storage_pool_iso_map.storage_pool_id, storage_pool_iso_map.owner, storage_domain_static.storage_type, storage_domain_static.storage_domain_type, storage_domain_static.storage_domain_format_type, storage_domain_static.storage_name, storage_domain_static.storage, storage_domain_static.last_time_used_as_master FROM ((storage_pool LEFT JOIN storage_pool_iso_map ON ((storage_pool.id = storage_pool_iso_map.storage_pool_id))) LEFT JOIN storage_domain_static ON ((storage_pool_iso_map.storage_id = storage_domain_static.id)));


ALTER TABLE public.storage_pool_with_storage_domain OWNER TO engineer;

--
-- Name: user_flat_groups; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_flat_groups AS
    (SELECT users.user_id, fnsplitteruuid(users.group_ids) AS granted_id FROM users UNION ALL SELECT users.user_id, users.user_id AS granted_id FROM users) UNION ALL SELECT users.user_id, 'EEE00000-0000-0000-0000-123456789EEE' AS granted_id FROM users;


ALTER TABLE public.user_flat_groups OWNER TO engineer;

--
-- Name: user_vm_permissions_view_base; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_vm_permissions_view_base AS
    ((SELECT internal_permissions_view.object_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM internal_permissions_view WHERE ((internal_permissions_view.object_type_id = 2) AND (internal_permissions_view.role_type = 2)) UNION ALL SELECT vm_static.vm_guid AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (vm_static JOIN internal_permissions_view ON (((((internal_permissions_view.object_id = vm_static.vds_group_id) AND (internal_permissions_view.object_type_id = 9)) AND internal_permissions_view.allows_viewing_children) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT vm_static.vm_guid AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM ((vm_static JOIN vds_groups ON ((vds_groups.vds_group_id = vm_static.vds_group_id))) JOIN internal_permissions_view ON (((((internal_permissions_view.object_id = vds_groups.storage_pool_id) AND (internal_permissions_view.object_type_id = 14)) AND internal_permissions_view.allows_viewing_children) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT vm_static.vm_guid AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (internal_permissions_view CROSS JOIN vm_static) WHERE (((internal_permissions_view.object_type_id = 1) AND internal_permissions_view.allows_viewing_children) AND (internal_permissions_view.role_type = 2));


ALTER TABLE public.user_vm_permissions_view_base OWNER TO engineer;

--
-- Name: user_vm_permissions_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_vm_permissions_view AS
    SELECT DISTINCT user_vm_permissions_view_base.entity_id, user_flat_groups.user_id FROM (user_vm_permissions_view_base NATURAL JOIN user_flat_groups);


ALTER TABLE public.user_vm_permissions_view OWNER TO engineer;

--
-- Name: user_vm_template_permissions_view_base; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_vm_template_permissions_view_base AS
    ((SELECT internal_permissions_view.object_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM internal_permissions_view WHERE ((internal_permissions_view.object_type_id = 4) AND (internal_permissions_view.role_type = 2)) UNION ALL SELECT vm_static.vmt_guid AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (vm_static JOIN internal_permissions_view ON ((((internal_permissions_view.object_id = vm_static.vm_guid) AND (internal_permissions_view.object_type_id = 2)) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT vm_static.vm_guid AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM ((vm_static JOIN vds_groups ON ((vds_groups.vds_group_id = vm_static.vds_group_id))) JOIN internal_permissions_view ON ((((((internal_permissions_view.object_id = vds_groups.storage_pool_id) AND (internal_permissions_view.object_type_id = 14)) AND internal_permissions_view.allows_viewing_children) AND (internal_permissions_view.role_type = 2)) AND ((vm_static.entity_type)::text = 'TEMPLATE'::text))))) UNION ALL SELECT vm_static.vm_guid AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (internal_permissions_view CROSS JOIN vm_static) WHERE ((((internal_permissions_view.object_type_id = 1) AND internal_permissions_view.allows_viewing_children) AND (internal_permissions_view.role_type = 2)) AND ((vm_static.entity_type)::text = 'TEMPLATE'::text));


ALTER TABLE public.user_vm_template_permissions_view_base OWNER TO engineer;

--
-- Name: user_vm_template_permissions_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_vm_template_permissions_view AS
    SELECT DISTINCT user_vm_template_permissions_view_base.entity_id, user_flat_groups.user_id FROM (user_vm_template_permissions_view_base NATURAL JOIN user_flat_groups);


ALTER TABLE public.user_vm_template_permissions_view OWNER TO engineer;

--
-- Name: user_disk_permissions_view_base; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_disk_permissions_view_base AS
    ((((SELECT internal_permissions_view.object_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM internal_permissions_view WHERE ((internal_permissions_view.object_type_id = 19) AND (internal_permissions_view.role_type = 2)) UNION ALL SELECT vm_device.device_id AS entity_id, user_vm_permissions_view.user_id AS granted_id FROM (vm_device JOIN user_vm_permissions_view ON ((user_vm_permissions_view.entity_id = vm_device.vm_id))) WHERE (((vm_device.type)::text = 'disk'::text) AND ((vm_device.device)::text = 'disk'::text))) UNION ALL SELECT vm_device.device_id AS entity_id, user_vm_template_permissions_view.user_id AS granted_id FROM (vm_device JOIN user_vm_template_permissions_view ON ((user_vm_template_permissions_view.entity_id = vm_device.vm_id))) WHERE (((vm_device.type)::text = 'disk'::text) AND ((vm_device.device)::text = 'disk'::text))) UNION ALL SELECT images.image_group_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM ((image_storage_domain_map JOIN images ON ((images.image_guid = image_storage_domain_map.image_id))) JOIN internal_permissions_view ON (((((internal_permissions_view.object_id = image_storage_domain_map.storage_domain_id) AND (internal_permissions_view.object_type_id = 11)) AND internal_permissions_view.allows_viewing_children) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT images.image_group_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (((image_storage_domain_map JOIN storage_pool_iso_map ON ((image_storage_domain_map.storage_domain_id = storage_pool_iso_map.storage_id))) JOIN images ON ((images.image_guid = image_storage_domain_map.image_id))) JOIN internal_permissions_view ON (((((internal_permissions_view.object_id = storage_pool_iso_map.storage_pool_id) AND (internal_permissions_view.object_type_id = 14)) AND internal_permissions_view.allows_viewing_children) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT vm_device.device_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (internal_permissions_view CROSS JOIN vm_device) WHERE (((internal_permissions_view.object_type_id = 1) AND internal_permissions_view.allows_viewing_children) AND (internal_permissions_view.role_type = 2));


ALTER TABLE public.user_disk_permissions_view_base OWNER TO engineer;

--
-- Name: user_disk_permissions_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_disk_permissions_view AS
    SELECT DISTINCT user_disk_permissions_view_base.entity_id, user_flat_groups.user_id FROM (user_disk_permissions_view_base NATURAL JOIN user_flat_groups);


ALTER TABLE public.user_disk_permissions_view OWNER TO engineer;

--
-- Name: vm_interface_ext_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vm_interface_ext_view AS
    SELECT vm_interface_view.rx_rate, vm_interface_view.tx_rate, vm_interface_view.rx_drop, vm_interface_view.tx_drop, vm_interface_view.iface_status, vm_interface_view.type, vm_interface_view.speed, vm_interface_view.mac_addr, vm_interface_view.network_name, vm_interface_view.name, vm_interface_view.vm_guid, vm_interface_view.vmt_guid, vm_interface_view.vm_name, vm_interface_view.id, vm_interface_view.boot_protocol, vm_interface_view.is_vds, vm_interface_view.is_plugged, vm_interface_view.port_mirroring, vm_interface_view.linked, vm_interface_view.vds_group_id, vm_interface_view.vm_entity_type, network.id AS network_id, network_cluster.cluster_id, network.storage_pool_id AS data_center_id FROM ((vm_interface_view JOIN network_cluster ON ((network_cluster.cluster_id = vm_interface_view.vds_group_id))) JOIN network ON (((network.id = network_cluster.network_id) AND ((network.name)::text = (vm_interface_view.network_name)::text))));


ALTER TABLE public.vm_interface_ext_view OWNER TO engineer;

--
-- Name: user_network_permissions_view_base; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_network_permissions_view_base AS
    ((((SELECT internal_permissions_view.object_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM internal_permissions_view WHERE ((internal_permissions_view.object_type_id = 20) AND (internal_permissions_view.role_type = 2)) UNION ALL SELECT network.id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (network JOIN internal_permissions_view ON ((internal_permissions_view.object_id = network.storage_pool_id))) WHERE (((internal_permissions_view.object_type_id = 14) AND internal_permissions_view.allows_viewing_children) AND (internal_permissions_view.role_type = 2))) UNION ALL SELECT network_cluster.network_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (network_cluster JOIN internal_permissions_view ON ((internal_permissions_view.object_id = network_cluster.cluster_id))) WHERE (((internal_permissions_view.object_type_id = 9) AND internal_permissions_view.allows_viewing_children) AND (internal_permissions_view.role_type = 2))) UNION ALL SELECT vm_interface_ext_view.network_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (vm_interface_ext_view JOIN internal_permissions_view ON ((internal_permissions_view.object_id = vm_interface_ext_view.vm_guid))) WHERE ((internal_permissions_view.object_type_id = 2) AND (internal_permissions_view.role_type = 2))) UNION ALL SELECT vm_interface_ext_view.network_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (vm_interface_ext_view JOIN internal_permissions_view ON ((internal_permissions_view.object_id = vm_interface_ext_view.vmt_guid))) WHERE ((internal_permissions_view.object_type_id = 4) AND (internal_permissions_view.role_type = 2))) UNION ALL SELECT vm_interface_ext_view.network_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (internal_permissions_view CROSS JOIN vm_interface_ext_view) WHERE (((internal_permissions_view.object_type_id = 1) AND internal_permissions_view.allows_viewing_children) AND (internal_permissions_view.role_type = 2));


ALTER TABLE public.user_network_permissions_view_base OWNER TO engineer;

--
-- Name: user_network_permissions_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_network_permissions_view AS
    SELECT DISTINCT user_network_permissions_view_base.entity_id, user_flat_groups.user_id FROM (user_network_permissions_view_base NATURAL JOIN user_flat_groups);


ALTER TABLE public.user_network_permissions_view OWNER TO engineer;

--
-- Name: user_object_permissions_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_object_permissions_view AS
    SELECT DISTINCT permissions.object_id AS entity_id, user_flat_groups.user_id FROM ((permissions JOIN roles ON ((permissions.role_id = roles.id))) JOIN user_flat_groups ON ((user_flat_groups.granted_id = permissions.ad_element_id))) WHERE (permissions.ad_element_id <> getglobalids('everyone'::character varying));


ALTER TABLE public.user_object_permissions_view OWNER TO engineer;

--
-- Name: user_permissions_permissions_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_permissions_permissions_view AS
    SELECT DISTINCT internal_permissions_view.id AS entity_id, user_flat_groups.user_id FROM (internal_permissions_view JOIN user_flat_groups ON ((user_flat_groups.granted_id = internal_permissions_view.ad_element_id)));


ALTER TABLE public.user_permissions_permissions_view OWNER TO engineer;

--
-- Name: vm_templates_storage_domain; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vm_templates_storage_domain AS
    SELECT vm_templates.vm_guid AS vmt_guid, vm_templates.vm_name AS name, vm_templates.mem_size_mb, vm_templates.os, vm_templates.creation_date, vm_templates.child_count, vm_templates.num_of_sockets, vm_templates.cpu_per_socket, (vm_templates.num_of_sockets * vm_templates.cpu_per_socket) AS num_of_cpus, vm_templates.description, vm_templates.vds_group_id, vm_templates.domain, vm_templates.num_of_monitors, vm_templates.allow_console_reconnect, vm_templates.template_status AS status, vm_templates.usb_policy, vm_templates.time_zone, vm_templates.is_auto_suspend, vm_templates.fail_back, vds_groups.name AS vds_group_name, vm_templates.vm_type, vm_templates.nice_level, storage_pool.id AS storage_pool_id, storage_pool.name AS storage_pool_name, vm_templates.default_boot_sequence, vm_templates.default_display_type, vm_templates.priority, vm_templates.auto_startup, vm_templates.is_stateless, vm_templates.iso_path, vm_templates.origin, vm_templates.initrd_url, vm_templates.kernel_url, vm_templates.kernel_params, image_storage_domain_map.storage_domain_id AS storage_id, quota.quota_name, vm_templates.is_disabled, vm_templates.min_allocated_mem FROM ((((((vm_static vm_templates JOIN vds_groups ON ((vm_templates.vds_group_id = vds_groups.vds_group_id))) LEFT JOIN storage_pool ON ((storage_pool.id = vds_groups.storage_pool_id))) JOIN vm_device ON ((vm_device.vm_id = vm_templates.vm_guid))) LEFT JOIN images ON ((images.image_group_id = vm_device.device_id))) LEFT JOIN image_storage_domain_map ON ((image_storage_domain_map.image_id = images.image_guid))) LEFT JOIN quota quota ON ((quota.id = vm_templates.quota_id))) WHERE ((vm_templates.entity_type)::text = 'TEMPLATE'::text) UNION SELECT vm_templates_1.vm_guid AS vmt_guid, vm_templates_1.vm_name AS name, vm_templates_1.mem_size_mb, vm_templates_1.os, vm_templates_1.creation_date, vm_templates_1.child_count, vm_templates_1.num_of_sockets, vm_templates_1.cpu_per_socket, (vm_templates_1.num_of_sockets * vm_templates_1.cpu_per_socket) AS num_of_cpus, vm_templates_1.description, vm_templates_1.vds_group_id, vm_templates_1.domain, vm_templates_1.num_of_monitors, vm_templates_1.allow_console_reconnect, vm_templates_1.template_status AS status, vm_templates_1.usb_policy, vm_templates_1.time_zone, vm_templates_1.is_auto_suspend, vm_templates_1.fail_back, vds_groups_1.name AS vds_group_name, vm_templates_1.vm_type, vm_templates_1.nice_level, storage_pool_1.id AS storage_pool_id, storage_pool_1.name AS storage_pool_name, vm_templates_1.default_boot_sequence, vm_templates_1.default_display_type, vm_templates_1.priority, vm_templates_1.auto_startup, vm_templates_1.is_stateless, vm_templates_1.iso_path, vm_templates_1.origin, vm_templates_1.initrd_url, vm_templates_1.kernel_url, vm_templates_1.kernel_params, image_storage_domain_map.storage_domain_id AS storage_id, quota.quota_name, vm_templates_1.is_disabled, vm_templates_1.min_allocated_mem FROM ((((((vm_static vm_templates_1 JOIN vds_groups vds_groups_1 ON ((vm_templates_1.vds_group_id = vds_groups_1.vds_group_id))) LEFT JOIN storage_pool storage_pool_1 ON ((storage_pool_1.id = vds_groups_1.storage_pool_id))) JOIN vm_device vm_device_1 ON ((vm_device_1.vm_id = vm_templates_1.vm_guid))) JOIN images images_1 ON ((images_1.image_group_id = vm_device_1.device_id))) JOIN image_storage_domain_map ON ((image_storage_domain_map.image_id = images_1.image_guid))) LEFT JOIN quota quota ON ((quota.id = vm_templates_1.quota_id))) WHERE ((vm_templates_1.entity_type)::text = 'TEMPLATE'::text);


ALTER TABLE public.vm_templates_storage_domain OWNER TO engineer;

--
-- Name: user_storage_domain_permissions_view_base; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_storage_domain_permissions_view_base AS
    ((((SELECT internal_permissions_view.object_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM internal_permissions_view WHERE ((internal_permissions_view.object_type_id = 11) AND (internal_permissions_view.role_type = 2)) UNION ALL SELECT storage_domains.id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (((storage_domains JOIN vds_groups ON ((vds_groups.storage_pool_id = storage_domains.storage_pool_id))) JOIN vm_static ON ((vds_groups.vds_group_id = vm_static.vds_group_id))) JOIN internal_permissions_view ON ((((internal_permissions_view.object_id = vm_static.vm_guid) AND (internal_permissions_view.object_type_id = 2)) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT vm_templates_storage_domain.storage_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (vm_templates_storage_domain JOIN internal_permissions_view ON ((((vm_templates_storage_domain.vmt_guid = internal_permissions_view.object_id) AND (internal_permissions_view.object_type_id = 4)) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT vm_templates_storage_domain.storage_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM ((vm_static JOIN vm_templates_storage_domain ON ((vm_static.vmt_guid = vm_templates_storage_domain.vmt_guid))) JOIN internal_permissions_view ON ((((vm_static.vm_guid = internal_permissions_view.object_id) AND (internal_permissions_view.object_type_id = 2)) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT storage_domains.id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (storage_domains JOIN internal_permissions_view ON ((((internal_permissions_view.object_id = storage_domains.storage_pool_id) AND (internal_permissions_view.object_type_id = 14)) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT storage_domains.id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (internal_permissions_view CROSS JOIN storage_domains) WHERE ((internal_permissions_view.object_type_id = 1) AND (internal_permissions_view.role_type = 2));


ALTER TABLE public.user_storage_domain_permissions_view_base OWNER TO engineer;

--
-- Name: user_storage_domain_permissions_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_storage_domain_permissions_view AS
    SELECT DISTINCT user_storage_domain_permissions_view_base.entity_id, user_flat_groups.user_id FROM (user_storage_domain_permissions_view_base NATURAL JOIN user_flat_groups);


ALTER TABLE public.user_storage_domain_permissions_view OWNER TO engineer;

--
-- Name: user_storage_pool_permissions_view_base; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_storage_pool_permissions_view_base AS
    (((SELECT internal_permissions_view.object_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM internal_permissions_view WHERE ((internal_permissions_view.object_type_id = 14) AND (internal_permissions_view.role_type = 2)) UNION ALL SELECT vds_groups.storage_pool_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (vds_groups JOIN internal_permissions_view ON ((((internal_permissions_view.object_id = vds_groups.vds_group_id) AND (internal_permissions_view.object_type_id = 9)) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT vds_groups.storage_pool_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM ((vds_groups JOIN vm_pools ON ((vds_groups.vds_group_id = vm_pools.vds_group_id))) JOIN internal_permissions_view ON ((((internal_permissions_view.object_id = vm_pools.vm_pool_id) AND (internal_permissions_view.object_type_id = 5)) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT vds_groups.storage_pool_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM ((vm_static JOIN vds_groups ON ((vds_groups.vds_group_id = vm_static.vds_group_id))) JOIN internal_permissions_view ON ((((internal_permissions_view.object_id = vm_static.vm_guid) AND (internal_permissions_view.object_type_id = 2)) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT storage_pool.id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (internal_permissions_view CROSS JOIN storage_pool) WHERE ((internal_permissions_view.object_type_id = 1) AND (internal_permissions_view.role_type = 2));


ALTER TABLE public.user_storage_pool_permissions_view_base OWNER TO engineer;

--
-- Name: user_storage_pool_permissions_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_storage_pool_permissions_view AS
    SELECT DISTINCT user_storage_pool_permissions_view_base.entity_id, user_flat_groups.user_id FROM (user_storage_pool_permissions_view_base NATURAL JOIN user_flat_groups);


ALTER TABLE public.user_storage_pool_permissions_view OWNER TO engineer;

--
-- Name: user_vds_groups_permissions_view_base; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_vds_groups_permissions_view_base AS
    ((SELECT internal_permissions_view.object_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM internal_permissions_view WHERE ((internal_permissions_view.object_type_id = 9) AND (internal_permissions_view.role_type = 2)) UNION ALL SELECT vm_static.vds_group_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (vm_static JOIN internal_permissions_view ON ((((internal_permissions_view.object_id = vm_static.vm_guid) AND (internal_permissions_view.object_type_id = 2)) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT vds_groups.vds_group_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (vds_groups JOIN internal_permissions_view ON ((((internal_permissions_view.object_id = vds_groups.storage_pool_id) AND (internal_permissions_view.object_type_id = 14)) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT vds_groups.vds_group_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (internal_permissions_view CROSS JOIN vds_groups) WHERE ((internal_permissions_view.object_type_id = 1) AND (internal_permissions_view.role_type = 2));


ALTER TABLE public.user_vds_groups_permissions_view_base OWNER TO engineer;

--
-- Name: user_vds_groups_permissions_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_vds_groups_permissions_view AS
    SELECT DISTINCT user_vds_groups_permissions_view_base.entity_id, user_flat_groups.user_id FROM (user_vds_groups_permissions_view_base NATURAL JOIN user_flat_groups);


ALTER TABLE public.user_vds_groups_permissions_view OWNER TO engineer;

--
-- Name: user_vds_permissions_view_base; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_vds_permissions_view_base AS
    (SELECT internal_permissions_view.object_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM internal_permissions_view WHERE ((internal_permissions_view.object_type_id = 3) AND (internal_permissions_view.role_type = 2)) UNION ALL SELECT vds.vds_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (vds JOIN internal_permissions_view ON ((((internal_permissions_view.object_id = vds.vds_group_id) AND (internal_permissions_view.object_type_id = 9)) OR (((internal_permissions_view.object_id = vds.storage_pool_id) AND (internal_permissions_view.object_type_id = 14)) AND (internal_permissions_view.role_type = 2)))))) UNION ALL SELECT vds.vds_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (internal_permissions_view CROSS JOIN vds) WHERE ((internal_permissions_view.object_type_id = 1) AND (internal_permissions_view.role_type = 2));


ALTER TABLE public.user_vds_permissions_view_base OWNER TO engineer;

--
-- Name: user_vds_permissions_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_vds_permissions_view AS
    SELECT DISTINCT user_vds_permissions_view_base.entity_id, user_flat_groups.user_id FROM (user_vds_permissions_view_base NATURAL JOIN user_flat_groups);


ALTER TABLE public.user_vds_permissions_view OWNER TO engineer;

--
-- Name: user_vm_pool_permissions_view_base; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_vm_pool_permissions_view_base AS
    (((SELECT internal_permissions_view.object_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM internal_permissions_view WHERE ((internal_permissions_view.object_type_id = 5) AND (internal_permissions_view.role_type = 2)) UNION ALL SELECT vm_pool_map.vm_pool_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (vm_pool_map JOIN internal_permissions_view ON ((((internal_permissions_view.object_id = vm_pool_map.vm_guid) AND (internal_permissions_view.object_type_id = 2)) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT vm_pools.vm_pool_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (vm_pools JOIN internal_permissions_view ON (((((internal_permissions_view.object_id = vm_pools.vds_group_id) AND (internal_permissions_view.object_type_id = 9)) AND internal_permissions_view.allows_viewing_children) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT vm_pools.vm_pool_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM ((vm_pools JOIN vds_groups ON ((vm_pools.vds_group_id = vds_groups.vds_group_id))) JOIN internal_permissions_view ON (((((internal_permissions_view.object_id = vds_groups.storage_pool_id) AND (internal_permissions_view.object_type_id = 14)) AND internal_permissions_view.allows_viewing_children) AND (internal_permissions_view.role_type = 2))))) UNION ALL SELECT vm_pools.vm_pool_id AS entity_id, internal_permissions_view.ad_element_id AS granted_id FROM (internal_permissions_view CROSS JOIN vm_pools) WHERE (((internal_permissions_view.object_type_id = 1) AND internal_permissions_view.allows_viewing_children) AND (internal_permissions_view.role_type = 2));


ALTER TABLE public.user_vm_pool_permissions_view_base OWNER TO engineer;

--
-- Name: user_vm_pool_permissions_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW user_vm_pool_permissions_view AS
    SELECT DISTINCT user_vm_pool_permissions_view_base.entity_id, user_flat_groups.user_id FROM (user_vm_pool_permissions_view_base NATURAL JOIN user_flat_groups);


ALTER TABLE public.user_vm_pool_permissions_view OWNER TO engineer;

--
-- Name: users_and_groups_to_vm_pool_map_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW users_and_groups_to_vm_pool_map_view AS
    SELECT p.vm_pool_id, p.vm_pool_name, per.ad_element_id AS user_id FROM (vm_pools p JOIN permissions per ON ((per.object_id = p.vm_pool_id)));


ALTER TABLE public.users_and_groups_to_vm_pool_map_view OWNER TO engineer;

--
-- Name: uuid_sequence; Type: SEQUENCE; Schema: public; Owner: engineer
--

CREATE SEQUENCE uuid_sequence
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.uuid_sequence OWNER TO engineer;

--
-- Name: uuid_sequence; Type: SEQUENCE SET; Schema: public; Owner: engineer
--

SELECT pg_catalog.setval('uuid_sequence', 18, true);


--
-- Name: vdc_db_log_seq; Type: SEQUENCE; Schema: public; Owner: engineer
--

CREATE SEQUENCE vdc_db_log_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.vdc_db_log_seq OWNER TO engineer;

--
-- Name: vdc_db_log_seq; Type: SEQUENCE SET; Schema: public; Owner: engineer
--

SELECT pg_catalog.setval('vdc_db_log_seq', 1, false);


SET default_with_oids = true;

--
-- Name: vdc_db_log; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vdc_db_log (
    error_id bigint DEFAULT nextval('vdc_db_log_seq'::regclass) NOT NULL,
    occured_at timestamp with time zone DEFAULT ('now'::text)::timestamp without time zone NOT NULL,
    error_code character varying(16) NOT NULL,
    error_message character varying(2048),
    error_proc character varying(126),
    error_line integer
);


ALTER TABLE public.vdc_db_log OWNER TO engineer;

--
-- Name: vdc_users; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vdc_users AS
    SELECT 'user' AS user_group, users_1.name, users_1.user_id, users_1.surname, users_1.domain, users_1.username, users_1.groups, users_1.department, users_1.role, users_1.user_icon_path, users_1.desktop_device, users_1.email, users_1.note, users_1.status, 0 AS vm_admin, users_1.session_count, users_1.last_admin_check_status, users_1.group_ids FROM users users_1 UNION SELECT 'group' AS user_group, ad_groups.name, ad_groups.id AS user_id, '' AS surname, ad_groups.domain, '' AS username, '' AS groups, '' AS department, '' AS role, '' AS user_icon_path, '' AS desktop_device, '' AS email, '' AS note, ad_groups.status, 1 AS vm_admin, 0 AS session_count, NULL::unknown AS last_admin_check_status, '' AS group_ids FROM ad_groups;


ALTER TABLE public.vdc_users OWNER TO engineer;

--
-- Name: vdc_users_with_tags; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vdc_users_with_tags AS
    SELECT users_1.user_group, users_1.name, permissions.object_id AS vm_guid, users_1.user_id, users_1.surname, users_1.domain, users_1.username, users_1.groups, users_1.department, users_1.role, roles1.name AS mla_role, users_1.user_icon_path, users_1.desktop_device, users_1.email, users_1.note, users_1.status, users_1.vm_admin, tags_user_map_view_1.tag_name, tags_user_map_view_1.tag_id, users_1.session_count, users_1.last_admin_check_status, users_1.group_ids, pools.vm_pool_name FROM (((((vdc_users users_1 LEFT JOIN users_and_groups_to_vm_pool_map_view pools ON ((users_1.user_id = pools.user_id))) LEFT JOIN permissions ON ((users_1.user_id = permissions.ad_element_id))) LEFT JOIN tags ON ((tags.type = 1))) LEFT JOIN tags_user_map_view tags_user_map_view_1 ON ((users_1.user_id = tags_user_map_view_1.user_id))) LEFT JOIN roles roles1 ON ((roles1.id = permissions.role_id))) WHERE (users_1.user_group = 'user'::text) UNION SELECT users_2.user_group, users_2.name, permissions_1.object_id AS vm_guid, users_2.user_id, users_2.surname, users_2.domain, users_2.username, users_2.groups, users_2.department, users_2.role, roles2.name AS mla_role, users_2.user_icon_path, users_2.desktop_device, users_2.email, users_2.note, users_2.status, users_2.vm_admin, tags_user_group_map_view.tag_name, tags_user_group_map_view.tag_id, users_2.session_count, users_2.last_admin_check_status, users_2.group_ids, pools1.vm_pool_name FROM (((((vdc_users users_2 LEFT JOIN users_and_groups_to_vm_pool_map_view pools1 ON ((users_2.user_id = pools1.user_id))) LEFT JOIN permissions permissions_1 ON ((users_2.user_id = permissions_1.ad_element_id))) LEFT JOIN tags tags_1 ON ((tags_1.type = 1))) LEFT JOIN tags_user_group_map_view ON ((users_2.user_id = tags_user_group_map_view.group_id))) LEFT JOIN roles roles2 ON ((roles2.id = permissions_1.role_id))) WHERE (users_2.user_group = 'group'::text);


ALTER TABLE public.vdc_users_with_tags OWNER TO engineer;

--
-- Name: vds_groups_storage_domain; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vds_groups_storage_domain AS
    SELECT vds_groups.vds_group_id, vds_groups.name, vds_groups.description, vds_groups.cpu_name, vds_groups._create_date, vds_groups._update_date, vds_groups.selection_algorithm, vds_groups.high_utilization, vds_groups.low_utilization, vds_groups.cpu_over_commit_duration_minutes, vds_groups.storage_pool_id, vds_groups.max_vds_memory_over_commit, vds_groups.count_threads_as_cores, vds_groups.compatibility_version, vds_groups.transparent_hugepages, vds_groups.migrate_on_error, storage_pool_iso_map.storage_id, storage_pool.name AS storage_pool_name FROM ((vds_groups LEFT JOIN storage_pool_iso_map ON ((vds_groups.storage_pool_id = storage_pool_iso_map.storage_pool_id))) LEFT JOIN storage_pool ON ((vds_groups.storage_pool_id = storage_pool.id)));


ALTER TABLE public.vds_groups_storage_domain OWNER TO engineer;

--
-- Name: vds_with_tags; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vds_with_tags AS
    SELECT vds_groups.vds_group_id, vds_groups.name AS vds_group_name, vds_groups.description AS vds_group_description, vds_groups.selection_algorithm, vds_static.vds_id, vds_static.vds_name, vds_static.ip, vds_static.vds_unique_id, vds_static.host_name, vds_static.port, vds_static.vds_strength, vds_static.server_ssl_enabled, vds_static.vds_type, vds_static.pm_type, vds_static.pm_user, vds_static.pm_password, vds_static.pm_port, vds_dynamic.hw_product_name, vds_dynamic.hw_version, vds_dynamic.hw_serial_number, vds_dynamic.hw_uuid, vds_dynamic.hw_family, vds_static.pm_options, vds_static.pm_enabled, vds_static.pm_proxy_preferences, vds_static.pm_secondary_ip, vds_static.pm_secondary_options, vds_static.pm_secondary_port, vds_static.pm_secondary_password, vds_static.pm_secondary_user, vds_static.pm_secondary_type, vds_static.pm_secondary_concurrent, vds_dynamic.hooks, vds_dynamic.status, vds_dynamic.cpu_cores, vds_dynamic.cpu_threads, vds_dynamic.cpu_model, vds_dynamic.cpu_speed_mh, vds_dynamic.if_total_speed, vds_dynamic.kvm_enabled, vds_dynamic.physical_mem_mb, vds_dynamic.pending_vcpus_count, vds_dynamic.pending_vmem_size, vds_dynamic.mem_commited, vds_dynamic.vm_active, vds_dynamic.vm_count, vds_dynamic.vm_migrating, vds_dynamic.vms_cores_count, vds_dynamic.cpu_over_commit_time_stamp, vds_dynamic.net_config_dirty, vds_groups.high_utilization, vds_groups.low_utilization, vds_groups.max_vds_memory_over_commit, vds_groups.cpu_over_commit_duration_minutes, vds_groups.count_threads_as_cores, storage_pool.id AS storage_pool_id, storage_pool.name AS storage_pool_name, tags_vds_map_view.tag_name, tags_vds_map_view.tag_id, vds_dynamic.reserved_mem, vds_dynamic.guest_overhead, vds_dynamic.rpm_version, vds_dynamic.software_version, vds_dynamic.version_name, vds_dynamic.build_name, vds_dynamic.previous_status, vds_statistics.cpu_idle, vds_statistics.cpu_load, vds_statistics.cpu_sys, vds_statistics.cpu_user, vds_statistics.usage_mem_percent, vds_statistics.usage_cpu_percent, vds_statistics.usage_network_percent, vds_statistics.mem_available, vds_statistics.mem_shared, vds_statistics.swap_free, vds_statistics.swap_total, vds_statistics.ksm_cpu_percent, vds_statistics.ksm_pages, vds_statistics.ksm_state, vds_dynamic.cpu_flags, vds_groups.cpu_name AS vds_group_cpu_name, vds_dynamic.cpu_sockets, vds_spm_id_map.vds_spm_id, vds_static.otp_validity, vds_static.console_address, CASE WHEN (storage_pool.spm_vds_id = vds_static.vds_id) THEN CASE WHEN (storage_pool.status = 5) THEN 1 ELSE 2 END ELSE 0 END AS spm_status, vds_dynamic.supported_cluster_levels, vds_dynamic.supported_engines, vds_groups.compatibility_version AS vds_group_compatibility_version, vds_dynamic.host_os, vds_dynamic.kvm_version, vds_dynamic.libvirt_version, vds_dynamic.spice_version, vds_dynamic.kernel_version, vds_dynamic.iscsi_initiator_name, vds_dynamic.transparent_hugepages_state, vds_dynamic.anonymous_hugepages, vds_dynamic.non_operational_reason, storage_pool_iso_map.storage_id FROM (((((((vds_groups JOIN vds_static ON ((vds_groups.vds_group_id = vds_static.vds_group_id))) JOIN vds_dynamic ON ((vds_static.vds_id = vds_dynamic.vds_id))) JOIN vds_statistics ON ((vds_static.vds_id = vds_statistics.vds_id))) LEFT JOIN storage_pool ON ((vds_groups.storage_pool_id = storage_pool.id))) LEFT JOIN tags_vds_map_view ON ((vds_static.vds_id = tags_vds_map_view.vds_id))) LEFT JOIN vds_spm_id_map ON ((vds_static.vds_id = vds_spm_id_map.vds_id))) LEFT JOIN storage_pool_iso_map ON ((storage_pool_iso_map.storage_pool_id = storage_pool.id)));


ALTER TABLE public.vds_with_tags OWNER TO engineer;

--
-- Name: vm_images_storage_domains_view; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vm_images_storage_domains_view AS
    SELECT vm_images_view.storage_id, vm_images_view.storage_path, vm_images_view.storage_pool_id, vm_images_view.image_guid, vm_images_view.creation_date, vm_images_view.actual_size, vm_images_view.read_rate, vm_images_view.write_rate, vm_images_view.size, vm_images_view.it_guid, vm_images_view.description, vm_images_view.parentid, vm_images_view.imagestatus, vm_images_view.lastmodified, vm_images_view.app_list, vm_images_view.vm_snapshot_id, vm_images_view.volume_type, vm_images_view.image_group_id, vm_images_view.active, vm_images_view.volume_format, vm_images_view.disk_interface, vm_images_view.boot, vm_images_view.wipe_after_delete, vm_images_view.propagate_errors, vm_images_view.entity_type, vm_images_view.number_of_vms, vm_images_view.vm_names, vm_images_view.quota_id, vm_images_view.quota_name, vm_images_view.disk_alias, vm_images_view.disk_description, storage_domains_with_hosts_view.id, storage_domains_with_hosts_view.storage, storage_domains_with_hosts_view.storage_name, storage_domains_with_hosts_view.available_disk_size, storage_domains_with_hosts_view.used_disk_size, storage_domains_with_hosts_view.commited_disk_size, storage_domains_with_hosts_view.storage_type, storage_domains_with_hosts_view.storage_domain_type, storage_domains_with_hosts_view.storage_domain_format_type, storage_domains_with_hosts_view.storage_domain_shared_status, storage_domains_with_hosts_view.vds_group_id, storage_domains_with_hosts_view.vds_id, storage_domains_with_hosts_view.recoverable, storage_domains_with_hosts_view.storage_pool_name, storage_domains_with_hosts_view.storage_name AS name FROM ((vm_images_view JOIN images_storage_domain_view ON ((vm_images_view.image_guid = images_storage_domain_view.image_guid))) JOIN storage_domains_with_hosts_view ON ((storage_domains_with_hosts_view.id = images_storage_domain_view.storage_id)));


ALTER TABLE public.vm_images_storage_domains_view OWNER TO engineer;

SET default_with_oids = false;

--
-- Name: vm_ovf_generations; Type: TABLE; Schema: public; Owner: engineer; Tablespace: 
--

CREATE TABLE vm_ovf_generations (
    vm_guid uuid NOT NULL,
    storage_pool_id uuid,
    ovf_generation bigint DEFAULT 0
);


ALTER TABLE public.vm_ovf_generations OWNER TO engineer;

--
-- Name: vms_with_tags; Type: VIEW; Schema: public; Owner: engineer
--

CREATE VIEW vms_with_tags AS
    SELECT vms.vm_name, vms.vm_mem_size_mb, vms.nice_level, vms.vmt_guid, vms.vm_os, vms.vm_description, vms.vds_group_id, vms.vm_domain, vms.vm_creation_date, vms.auto_startup, vms.is_stateless, vms.is_smartcard_enabled, vms.is_delete_protected, vms.dedicated_vm_for_vds, vms.fail_back, vms.default_boot_sequence, vms.vm_type, vms.vds_group_name, vms.selection_algorithm, vms.storage_pool_id, vms.storage_pool_name, vms.vds_group_description, vms.vmt_name, vms.vmt_mem_size_mb, vms.vmt_os, vms.vmt_creation_date, vms.vmt_child_count, vms.vmt_num_of_sockets, vms.vmt_cpu_per_socket, vms.vmt_description, vms.status, vms.vm_ip, vms.vm_host, (vms.vmt_num_of_sockets * vms.vmt_cpu_per_socket) AS vmt_num_of_cpus, vms.vm_pid, vms.last_start_time, vms.guest_cur_user_name, vms.console_cur_user_name, vms.guest_last_login_time, vms.console_user_id, vms.guest_last_logout_time, vms.guest_os, vms.run_on_vds, vms.migrating_to_vds, vms.app_list, vms.display, vms.hibernation_vol_handle, vms.vm_pool_name, vms.vm_pool_id, vms.vm_guid, vms.num_of_monitors, vms.allow_console_reconnect, vms.is_initialized, vms.is_auto_suspend, vms.num_of_sockets, vms.cpu_per_socket, vms.usb_policy, vms.acpi_enable, vms.session, (vms.num_of_sockets * vms.cpu_per_socket) AS num_of_cpus, vms.display_ip, vms.display_type, vms.kvm_enable, vms.boot_sequence, vms.display_secure_port, vms.utc_diff, vms.last_vds_run_on, vms.client_ip, vms.guest_requested_memory, vms.time_zone, vms.cpu_user, vms.cpu_sys, vms.elapsed_time, vms.usage_network_percent, vms.usage_mem_percent, vms.usage_cpu_percent, vms.run_on_vds_name, vms.vds_group_cpu_name, tags_vm_map_view.tag_name, tags_vm_map_view.tag_id, vms.default_display_type, vms.priority, vms.vds_group_compatibility_version, vms.initrd_url, vms.kernel_url, vms.kernel_params, vms.pause_status, vms.exit_status, vms.exit_message, vms.min_allocated_mem, storage_domain_static.id AS storage_id, vms.quota_id, vms.quota_name FROM (((((vms LEFT JOIN tags_vm_map_view ON ((vms.vm_guid = tags_vm_map_view.vm_id))) LEFT JOIN vm_device ON ((vm_device.vm_id = vms.vm_guid))) LEFT JOIN images ON ((images.image_group_id = vm_device.device_id))) LEFT JOIN image_storage_domain_map ON ((image_storage_domain_map.image_id = images.image_guid))) LEFT JOIN storage_domain_static ON ((storage_domain_static.id = image_storage_domain_map.storage_domain_id))) WHERE ((images.active IS NULL) OR (images.active = true));


ALTER TABLE public.vms_with_tags OWNER TO engineer;

--
-- Data for Name: action_version_map; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY action_version_map (action_type, cluster_minimal_version, storage_pool_minimal_version) FROM stdin;
\.
copy action_version_map (action_type, cluster_minimal_version, storage_pool_minimal_version)  from '$$PATH$$/4109.dat' ;
--
-- Data for Name: ad_groups; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY ad_groups (id, name, status, domain, distinguishedname) FROM stdin;
\.
copy ad_groups (id, name, status, domain, distinguishedname)  from '$$PATH$$/4115.dat' ;
--
-- Data for Name: async_tasks; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY async_tasks (task_id, action_type, status, result, action_parameters, action_params_class, step_id, command_id, started_at, storage_pool_id, task_type, task_parameters, task_params_class) FROM stdin;
\.
copy async_tasks (task_id, action_type, status, result, action_parameters, action_params_class, step_id, command_id, started_at, storage_pool_id, task_type, task_parameters, task_params_class)  from '$$PATH$$/4126.dat' ;
--
-- Data for Name: async_tasks_entities; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY async_tasks_entities (async_task_id, entity_id, entity_type) FROM stdin;
\.
copy async_tasks_entities (async_task_id, entity_id, entity_type)  from '$$PATH$$/4167.dat' ;
--
-- Data for Name: audit_log; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY audit_log (audit_log_id, user_id, user_name, vm_id, vm_name, vm_template_id, vm_template_name, vds_id, vds_name, log_time, log_type_name, log_type, severity, message, processed, storage_pool_id, storage_pool_name, storage_domain_id, storage_domain_name, vds_group_id, vds_group_name, correlation_id, job_id, quota_id, quota_name, gluster_volume_id, gluster_volume_name, origin, custom_event_id, event_flood_in_sec, custom_data, deleted) FROM stdin;
\.
copy audit_log (audit_log_id, user_id, user_name, vm_id, vm_name, vm_template_id, vm_template_name, vds_id, vds_name, log_time, log_type_name, log_type, severity, message, processed, storage_pool_id, storage_pool_name, storage_domain_id, storage_domain_name, vds_group_id, vds_group_name, correlation_id, job_id, quota_id, quota_name, gluster_volume_id, gluster_volume_name, origin, custom_event_id, event_flood_in_sec, custom_data, deleted)  from '$$PATH$$/4127.dat' ;
--
-- Data for Name: base_disks; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY base_disks (disk_id, disk_interface, wipe_after_delete, propagate_errors, disk_alias, disk_description, shareable, boot) FROM stdin;
\.
copy base_disks (disk_id, disk_interface, wipe_after_delete, propagate_errors, disk_alias, disk_description, shareable, boot)  from '$$PATH$$/4116.dat' ;
--
-- Data for Name: bookmarks; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY bookmarks (bookmark_id, bookmark_name, bookmark_value) FROM stdin;
\.
copy bookmarks (bookmark_id, bookmark_name, bookmark_value)  from '$$PATH$$/4128.dat' ;
--
-- Data for Name: business_entity_snapshot; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY business_entity_snapshot (id, command_id, command_type, entity_id, entity_type, entity_snapshot, snapshot_class, snapshot_type, insertion_order, started_at) FROM stdin;
\.
copy business_entity_snapshot (id, command_id, command_type, entity_id, entity_type, entity_snapshot, snapshot_class, snapshot_type, insertion_order, started_at)  from '$$PATH$$/4106.dat' ;
--
-- Data for Name: custom_actions; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY custom_actions (action_id, action_name, path, tab, description) FROM stdin;
\.
copy custom_actions (action_id, action_name, path, tab, description)  from '$$PATH$$/4129.dat' ;
--
-- Data for Name: disk_image_dynamic; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY disk_image_dynamic (image_id, read_rate, write_rate, actual_size, read_latency_seconds, write_latency_seconds, flush_latency_seconds, _update_date) FROM stdin;
\.
copy disk_image_dynamic (image_id, read_rate, write_rate, actual_size, read_latency_seconds, write_latency_seconds, flush_latency_seconds, _update_date)  from '$$PATH$$/4117.dat' ;
--
-- Data for Name: disk_lun_map; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY disk_lun_map (disk_id, lun_id) FROM stdin;
\.
copy disk_lun_map (disk_id, lun_id)  from '$$PATH$$/4118.dat' ;
--
-- Data for Name: dwh_history_timekeeping; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY dwh_history_timekeeping (var_name, var_value, var_datetime) FROM stdin;
\.
copy dwh_history_timekeeping (var_name, var_value, var_datetime)  from '$$PATH$$/4168.dat' ;
--
-- Data for Name: event_map; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY event_map (event_up_name, event_down_name) FROM stdin;
\.
copy event_map (event_up_name, event_down_name)  from '$$PATH$$/4130.dat' ;
--
-- Data for Name: event_notification_hist; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY event_notification_hist (subscriber_id, event_name, audit_log_id, method_type, sent_at, status, reason) FROM stdin;
\.
copy event_notification_hist (subscriber_id, event_name, audit_log_id, method_type, sent_at, status, reason)  from '$$PATH$$/4132.dat' ;
--
-- Data for Name: event_notification_methods; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY event_notification_methods (method_id, method_type) FROM stdin;
\.
copy event_notification_methods (method_id, method_type)  from '$$PATH$$/4133.dat' ;
--
-- Data for Name: event_subscriber; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY event_subscriber (subscriber_id, event_up_name, method_id, method_address, tag_name) FROM stdin;
\.
copy event_subscriber (subscriber_id, event_up_name, method_id, method_address, tag_name)  from '$$PATH$$/4131.dat' ;
--
-- Data for Name: gluster_volume_access_protocols; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY gluster_volume_access_protocols (volume_id, access_protocol) FROM stdin;
\.
copy gluster_volume_access_protocols (volume_id, access_protocol)  from '$$PATH$$/4108.dat' ;
--
-- Data for Name: gluster_volume_bricks; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY gluster_volume_bricks (volume_id, server_id, brick_dir, status, _create_date, _update_date, id, brick_order) FROM stdin;
\.
copy gluster_volume_bricks (volume_id, server_id, brick_dir, status, _create_date, _update_date, id, brick_order)  from '$$PATH$$/4156.dat' ;
--
-- Data for Name: gluster_volume_options; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY gluster_volume_options (volume_id, option_key, option_val, id) FROM stdin;
\.
copy gluster_volume_options (volume_id, option_key, option_val, id)  from '$$PATH$$/4158.dat' ;
--
-- Data for Name: gluster_volume_transport_types; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY gluster_volume_transport_types (volume_id, transport_type) FROM stdin;
\.
copy gluster_volume_transport_types (volume_id, transport_type)  from '$$PATH$$/4165.dat' ;
--
-- Data for Name: gluster_volumes; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY gluster_volumes (id, cluster_id, vol_name, vol_type, status, replica_count, stripe_count, _create_date, _update_date) FROM stdin;
\.
copy gluster_volumes (id, cluster_id, vol_name, vol_type, status, replica_count, stripe_count, _create_date, _update_date)  from '$$PATH$$/4159.dat' ;
--
-- Data for Name: image_storage_domain_map; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY image_storage_domain_map (image_id, storage_domain_id) FROM stdin;
\.
copy image_storage_domain_map (image_id, storage_domain_id)  from '$$PATH$$/4119.dat' ;
--
-- Data for Name: images; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY images (image_guid, creation_date, size, it_guid, parentid, imagestatus, lastmodified, vm_snapshot_id, volume_type, volume_format, image_group_id, _create_date, _update_date, quota_id, active) FROM stdin;
\.
copy images (image_guid, creation_date, size, it_guid, parentid, imagestatus, lastmodified, vm_snapshot_id, volume_type, volume_format, image_group_id, _create_date, _update_date, quota_id, active)  from '$$PATH$$/4120.dat' ;
--
-- Data for Name: job; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY job (job_id, action_type, description, status, owner_id, visible, start_time, end_time, last_update_time, correlation_id) FROM stdin;
\.
copy job (job_id, action_type, description, status, owner_id, visible, start_time, end_time, last_update_time, correlation_id)  from '$$PATH$$/4154.dat' ;
--
-- Data for Name: job_subject_entity; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY job_subject_entity (job_id, entity_id, entity_type) FROM stdin;
\.
copy job_subject_entity (job_id, entity_id, entity_type)  from '$$PATH$$/4162.dat' ;
--
-- Data for Name: lun_storage_server_connection_map; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY lun_storage_server_connection_map (lun_id, storage_server_connection) FROM stdin;
\.
copy lun_storage_server_connection_map (lun_id, storage_server_connection)  from '$$PATH$$/4134.dat' ;
--
-- Data for Name: luns; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY luns (physical_volume_id, lun_id, volume_group_id, serial, lun_mapping, vendor_id, product_id, device_size) FROM stdin;
\.
copy luns (physical_volume_id, lun_id, volume_group_id, serial, lun_mapping, vendor_id, product_id, device_size)  from '$$PATH$$/4125.dat' ;
--
-- Data for Name: materialized_views; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY materialized_views (mv_name, v_name, refresh_rate_in_sec, last_refresh, avg_cost_ms, min_refresh_rate_in_sec, custom, active) FROM stdin;
\.
copy materialized_views (mv_name, v_name, refresh_rate_in_sec, last_refresh, avg_cost_ms, min_refresh_rate_in_sec, custom, active)  from '$$PATH$$/4173.dat' ;
--
-- Data for Name: network; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY network (id, name, description, type, addr, subnet, gateway, vlan_id, stp, storage_pool_id, mtu, vm_network) FROM stdin;
\.
copy network (id, name, description, type, addr, subnet, gateway, vlan_id, stp, storage_pool_id, mtu, vm_network)  from '$$PATH$$/4135.dat' ;
--
-- Data for Name: network_cluster; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY network_cluster (network_id, cluster_id, status, is_display, required) FROM stdin;
\.
copy network_cluster (network_id, cluster_id, status, is_display, required)  from '$$PATH$$/4136.dat' ;
--
-- Data for Name: object_column_white_list; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY object_column_white_list (object_name, column_name) FROM stdin;
\.
copy object_column_white_list (object_name, column_name)  from '$$PATH$$/4169.dat' ;
--
-- Data for Name: object_column_white_list_sql; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY object_column_white_list_sql (object_name, sql) FROM stdin;
\.
copy object_column_white_list_sql (object_name, sql)  from '$$PATH$$/4170.dat' ;
--
-- Data for Name: permissions; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY permissions (id, role_id, ad_element_id, object_id, object_type_id) FROM stdin;
\.
copy permissions (id, role_id, ad_element_id, object_id, object_type_id)  from '$$PATH$$/4157.dat' ;
--
-- Data for Name: quota; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY quota (id, storage_pool_id, quota_name, description, _create_date, _update_date, threshold_vds_group_percentage, threshold_storage_percentage, grace_vds_group_percentage, grace_storage_percentage) FROM stdin;
\.
copy quota (id, storage_pool_id, quota_name, description, _create_date, _update_date, threshold_vds_group_percentage, threshold_storage_percentage, grace_vds_group_percentage, grace_storage_percentage)  from '$$PATH$$/4103.dat' ;
--
-- Data for Name: quota_limitation; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY quota_limitation (id, quota_id, storage_id, vds_group_id, virtual_cpu, mem_size_mb, storage_size_gb) FROM stdin;
\.
copy quota_limitation (id, quota_id, storage_id, vds_group_id, virtual_cpu, mem_size_mb, storage_size_gb)  from '$$PATH$$/4163.dat' ;
--
-- Data for Name: repo_file_meta_data; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY repo_file_meta_data (repo_domain_id, repo_file_name, size, date_created, last_refreshed, file_type) FROM stdin;
\.
copy repo_file_meta_data (repo_domain_id, repo_file_name, size, date_created, last_refreshed, file_type)  from '$$PATH$$/4164.dat' ;
--
-- Data for Name: roles; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY roles (id, name, description, is_readonly, role_type, allows_viewing_children) FROM stdin;
\.
copy roles (id, name, description, is_readonly, role_type, allows_viewing_children)  from '$$PATH$$/4137.dat' ;
--
-- Data for Name: roles_groups; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY roles_groups (role_id, action_group_id) FROM stdin;
\.
copy roles_groups (role_id, action_group_id)  from '$$PATH$$/4107.dat' ;
--
-- Data for Name: roles_relations; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY roles_relations (role_id, role_container_id) FROM stdin;
\.
copy roles_relations (role_id, role_container_id)  from '$$PATH$$/4138.dat' ;
--
-- Data for Name: schema_version; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY schema_version (id, version, script, checksum, installed_by, started_at, ended_at, state, current, comment) FROM stdin;
\.
copy schema_version (id, version, script, checksum, installed_by, started_at, ended_at, state, current, comment)  from '$$PATH$$/4171.dat' ;
--
-- Data for Name: snapshots; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY snapshots (snapshot_id, vm_id, snapshot_type, status, description, creation_date, app_list, vm_configuration, _create_date, _update_date) FROM stdin;
\.
copy snapshots (snapshot_id, vm_id, snapshot_type, status, description, creation_date, app_list, vm_configuration, _create_date, _update_date)  from '$$PATH$$/4121.dat' ;
--
-- Data for Name: step; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY step (step_id, parent_step_id, job_id, step_type, description, step_number, status, start_time, end_time, correlation_id, external_id, external_system_type) FROM stdin;
\.
copy step (step_id, parent_step_id, job_id, step_type, description, step_number, status, start_time, end_time, correlation_id, external_id, external_system_type)  from '$$PATH$$/4155.dat' ;
--
-- Data for Name: storage_domain_dynamic; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY storage_domain_dynamic (id, available_disk_size, used_disk_size, _update_date) FROM stdin;
\.
copy storage_domain_dynamic (id, available_disk_size, used_disk_size, _update_date)  from '$$PATH$$/4139.dat' ;
--
-- Data for Name: storage_domain_static; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY storage_domain_static (id, storage, storage_name, storage_domain_type, storage_type, storage_domain_format_type, _create_date, _update_date, recoverable, last_time_used_as_master) FROM stdin;
\.
copy storage_domain_static (id, storage, storage_name, storage_domain_type, storage_type, storage_domain_format_type, _create_date, _update_date, recoverable, last_time_used_as_master)  from '$$PATH$$/4122.dat' ;
--
-- Data for Name: storage_pool; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY storage_pool (id, name, description, storage_pool_type, storage_pool_format_type, status, master_domain_version, spm_vds_id, compatibility_version, _create_date, _update_date, quota_enforcement_type) FROM stdin;
\.
copy storage_pool (id, name, description, storage_pool_type, storage_pool_format_type, status, master_domain_version, spm_vds_id, compatibility_version, _create_date, _update_date, quota_enforcement_type)  from '$$PATH$$/4102.dat' ;
--
-- Data for Name: storage_pool_iso_map; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY storage_pool_iso_map (storage_id, storage_pool_id, status, owner) FROM stdin;
\.
copy storage_pool_iso_map (storage_id, storage_pool_id, status, owner)  from '$$PATH$$/4123.dat' ;
--
-- Data for Name: storage_server_connections; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY storage_server_connections (id, connection, user_name, password, iqn, port, portal, storage_type, mount_options, vfs_type, nfs_version, nfs_timeo, nfs_retrans) FROM stdin;
\.
copy storage_server_connections (id, connection, user_name, password, iqn, port, portal, storage_type, mount_options, vfs_type, nfs_version, nfs_timeo, nfs_retrans)  from '$$PATH$$/4140.dat' ;
--
-- Data for Name: tags; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY tags (tag_id, tag_name, description, parent_id, readonly, type, _create_date, _update_date) FROM stdin;
\.
copy tags (tag_id, tag_name, description, parent_id, readonly, type, _create_date, _update_date)  from '$$PATH$$/4141.dat' ;
--
-- Data for Name: tags_user_group_map; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY tags_user_group_map (tag_id, group_id, _create_date) FROM stdin;
\.
copy tags_user_group_map (tag_id, group_id, _create_date)  from '$$PATH$$/4142.dat' ;
--
-- Data for Name: tags_user_map; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY tags_user_map (tag_id, user_id, _create_date) FROM stdin;
\.
copy tags_user_map (tag_id, user_id, _create_date)  from '$$PATH$$/4143.dat' ;
--
-- Data for Name: tags_vds_map; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY tags_vds_map (tag_id, vds_id, _create_date) FROM stdin;
\.
copy tags_vds_map (tag_id, vds_id, _create_date)  from '$$PATH$$/4144.dat' ;
--
-- Data for Name: tags_vm_map; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY tags_vm_map (tag_id, vm_id, _create_date, defaultdisplaytype) FROM stdin;
\.
copy tags_vm_map (tag_id, vm_id, _create_date, defaultdisplaytype)  from '$$PATH$$/4145.dat' ;
--
-- Data for Name: tags_vm_pool_map; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY tags_vm_pool_map (tag_id, vm_pool_id, _create_date) FROM stdin;
\.
copy tags_vm_pool_map (tag_id, vm_pool_id, _create_date)  from '$$PATH$$/4146.dat' ;
--
-- Data for Name: user_sessions; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY user_sessions (session_id, user_id, os, browser, client_type, login_time) FROM stdin;
\.
copy user_sessions (session_id, user_id, os, browser, client_type, login_time)  from '$$PATH$$/4147.dat' ;
--
-- Data for Name: users; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY users (user_id, name, surname, domain, username, groups, department, role, user_icon_path, desktop_device, email, note, status, session_count, last_admin_check_status, group_ids) FROM stdin;
\.
copy users (user_id, name, surname, domain, username, groups, department, role, user_icon_path, desktop_device, email, note, status, session_count, last_admin_check_status, group_ids)  from '$$PATH$$/4148.dat' ;
--
-- Data for Name: vdc_db_log; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vdc_db_log (error_id, occured_at, error_code, error_message, error_proc, error_line) FROM stdin;
\.
copy vdc_db_log (error_id, occured_at, error_code, error_message, error_proc, error_line)  from '$$PATH$$/4172.dat' ;
--
-- Data for Name: vdc_options; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vdc_options (option_id, option_name, option_value, version) FROM stdin;
\.
copy vdc_options (option_id, option_name, option_value, version)  from '$$PATH$$/4149.dat' ;
--
-- Data for Name: vds_dynamic; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vds_dynamic (vds_id, status, cpu_cores, cpu_model, cpu_speed_mh, if_total_speed, kvm_enabled, physical_mem_mb, mem_commited, vm_active, vm_count, vm_migrating, reserved_mem, guest_overhead, software_version, version_name, build_name, previous_status, cpu_flags, cpu_over_commit_time_stamp, vms_cores_count, pending_vcpus_count, cpu_sockets, net_config_dirty, supported_cluster_levels, host_os, kvm_version, spice_version, kernel_version, iscsi_initiator_name, transparent_hugepages_state, anonymous_hugepages, hooks, _update_date, non_operational_reason, pending_vmem_size, supported_engines, rpm_version, libvirt_version, cpu_threads, hw_manufacturer, hw_product_name, hw_version, hw_serial_number, hw_uuid, hw_family) FROM stdin;
\.
copy vds_dynamic (vds_id, status, cpu_cores, cpu_model, cpu_speed_mh, if_total_speed, kvm_enabled, physical_mem_mb, mem_commited, vm_active, vm_count, vm_migrating, reserved_mem, guest_overhead, software_version, version_name, build_name, previous_status, cpu_flags, cpu_over_commit_time_stamp, vms_cores_count, pending_vcpus_count, cpu_sockets, net_config_dirty, supported_cluster_levels, host_os, kvm_version, spice_version, kernel_version, iscsi_initiator_name, transparent_hugepages_state, anonymous_hugepages, hooks, _update_date, non_operational_reason, pending_vmem_size, supported_engines, rpm_version, libvirt_version, cpu_threads, hw_manufacturer, hw_product_name, hw_version, hw_serial_number, hw_uuid, hw_family)  from '$$PATH$$/4150.dat' ;
--
-- Data for Name: vds_groups; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vds_groups (vds_group_id, name, description, cpu_name, _create_date, _update_date, selection_algorithm, high_utilization, low_utilization, cpu_over_commit_duration_minutes, storage_pool_id, max_vds_memory_over_commit, compatibility_version, transparent_hugepages, migrate_on_error, virt_service, gluster_service, count_threads_as_cores) FROM stdin;
\.
copy vds_groups (vds_group_id, name, description, cpu_name, _create_date, _update_date, selection_algorithm, high_utilization, low_utilization, cpu_over_commit_duration_minutes, storage_pool_id, max_vds_memory_over_commit, compatibility_version, transparent_hugepages, migrate_on_error, virt_service, gluster_service, count_threads_as_cores)  from '$$PATH$$/4104.dat' ;
--
-- Data for Name: vds_interface; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vds_interface (id, name, network_name, vds_id, mac_addr, is_bond, bond_name, bond_type, bond_opts, vlan_id, speed, addr, subnet, gateway, boot_protocol, type, _create_date, _update_date, mtu, bridged) FROM stdin;
\.
copy vds_interface (id, name, network_name, vds_id, mac_addr, is_bond, bond_name, bond_type, bond_opts, vlan_id, speed, addr, subnet, gateway, boot_protocol, type, _create_date, _update_date, mtu, bridged)  from '$$PATH$$/4160.dat' ;
--
-- Data for Name: vds_interface_statistics; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vds_interface_statistics (id, vds_id, rx_rate, tx_rate, rx_drop, tx_drop, iface_status, _update_date) FROM stdin;
\.
copy vds_interface_statistics (id, vds_id, rx_rate, tx_rate, rx_drop, tx_drop, iface_status, _update_date)  from '$$PATH$$/4161.dat' ;
--
-- Data for Name: vds_spm_id_map; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vds_spm_id_map (storage_pool_id, vds_spm_id, vds_id) FROM stdin;
\.
copy vds_spm_id_map (storage_pool_id, vds_spm_id, vds_id)  from '$$PATH$$/4151.dat' ;
--
-- Data for Name: vds_static; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vds_static (vds_id, vds_name, ip, vds_unique_id, host_name, port, vds_group_id, server_ssl_enabled, vds_type, vds_strength, pm_type, pm_user, pm_password, pm_port, pm_options, pm_enabled, _create_date, _update_date, otp_validity, vds_spm_priority, recoverable, sshkeyfingerprint, pm_proxy_preferences, pm_secondary_ip, pm_secondary_type, pm_secondary_user, pm_secondary_password, pm_secondary_port, pm_secondary_options, pm_secondary_concurrent, console_address) FROM stdin;
\.
copy vds_static (vds_id, vds_name, ip, vds_unique_id, host_name, port, vds_group_id, server_ssl_enabled, vds_type, vds_strength, pm_type, pm_user, pm_password, pm_port, pm_options, pm_enabled, _create_date, _update_date, otp_validity, vds_spm_priority, recoverable, sshkeyfingerprint, pm_proxy_preferences, pm_secondary_ip, pm_secondary_type, pm_secondary_user, pm_secondary_password, pm_secondary_port, pm_secondary_options, pm_secondary_concurrent, console_address)  from '$$PATH$$/4110.dat' ;
--
-- Data for Name: vds_statistics; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vds_statistics (vds_id, cpu_idle, cpu_load, cpu_sys, cpu_user, usage_mem_percent, usage_cpu_percent, usage_network_percent, mem_available, mem_shared, swap_free, swap_total, ksm_cpu_percent, ksm_pages, ksm_state, _update_date) FROM stdin;
\.
copy vds_statistics (vds_id, cpu_idle, cpu_load, cpu_sys, cpu_user, usage_mem_percent, usage_cpu_percent, usage_network_percent, mem_available, mem_shared, swap_free, swap_total, ksm_cpu_percent, ksm_pages, ksm_state, _update_date)  from '$$PATH$$/4152.dat' ;
--
-- Data for Name: vm_device; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vm_device (device_id, vm_id, type, device, address, boot_order, spec_params, is_managed, is_plugged, is_readonly, _create_date, _update_date, alias) FROM stdin;
\.
copy vm_device (device_id, vm_id, type, device, address, boot_order, spec_params, is_managed, is_plugged, is_readonly, _create_date, _update_date, alias)  from '$$PATH$$/4124.dat' ;
--
-- Data for Name: vm_dynamic; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vm_dynamic (vm_guid, status, vm_ip, vm_host, vm_pid, last_start_time, guest_cur_user_name, guest_last_login_time, guest_last_logout_time, guest_os, run_on_vds, migrating_to_vds, app_list, display, acpi_enable, session, display_ip, display_type, kvm_enable, display_secure_port, utc_diff, last_vds_run_on, client_ip, guest_requested_memory, hibernation_vol_handle, boot_sequence, exit_status, pause_status, exit_message, hash, console_user_id, guest_agent_nics_hash, console_cur_user_name) FROM stdin;
\.
copy vm_dynamic (vm_guid, status, vm_ip, vm_host, vm_pid, last_start_time, guest_cur_user_name, guest_last_login_time, guest_last_logout_time, guest_os, run_on_vds, migrating_to_vds, app_list, display, acpi_enable, session, display_ip, display_type, kvm_enable, display_secure_port, utc_diff, last_vds_run_on, client_ip, guest_requested_memory, hibernation_vol_handle, boot_sequence, exit_status, pause_status, exit_message, hash, console_user_id, guest_agent_nics_hash, console_cur_user_name)  from '$$PATH$$/4111.dat' ;
--
-- Data for Name: vm_guest_agent_interfaces; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vm_guest_agent_interfaces (vm_id, interface_name, mac_address, ipv4_addresses, ipv6_addresses) FROM stdin;
\.
copy vm_guest_agent_interfaces (vm_id, interface_name, mac_address, ipv4_addresses, ipv6_addresses)  from '$$PATH$$/4174.dat' ;
--
-- Data for Name: vm_interface; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vm_interface (id, network_name, vm_guid, vmt_guid, mac_addr, name, speed, type, _create_date, _update_date, port_mirroring, linked) FROM stdin;
\.
copy vm_interface (id, network_name, vm_guid, vmt_guid, mac_addr, name, speed, type, _create_date, _update_date, port_mirroring, linked)  from '$$PATH$$/4153.dat' ;
--
-- Data for Name: vm_interface_statistics; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vm_interface_statistics (id, vm_id, rx_rate, tx_rate, rx_drop, tx_drop, iface_status, _update_date) FROM stdin;
\.
copy vm_interface_statistics (id, vm_id, rx_rate, tx_rate, rx_drop, tx_drop, iface_status, _update_date)  from '$$PATH$$/4166.dat' ;
--
-- Data for Name: vm_ovf_generations; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vm_ovf_generations (vm_guid, storage_pool_id, ovf_generation) FROM stdin;
\.
copy vm_ovf_generations (vm_guid, storage_pool_id, ovf_generation)  from '$$PATH$$/4175.dat' ;
--
-- Data for Name: vm_pool_map; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vm_pool_map (vm_pool_id, vm_guid) FROM stdin;
\.
copy vm_pool_map (vm_pool_id, vm_guid)  from '$$PATH$$/4112.dat' ;
--
-- Data for Name: vm_pools; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vm_pools (vm_pool_id, vm_pool_name, vm_pool_description, vm_pool_type, parameters, vds_group_id, prestarted_vms) FROM stdin;
\.
copy vm_pools (vm_pool_id, vm_pool_name, vm_pool_description, vm_pool_type, parameters, vds_group_id, prestarted_vms)  from '$$PATH$$/4113.dat' ;
--
-- Data for Name: vm_static; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vm_static (vm_guid, vm_name, mem_size_mb, vmt_guid, os, description, vds_group_id, domain, creation_date, num_of_monitors, is_initialized, is_auto_suspend, num_of_sockets, cpu_per_socket, usb_policy, time_zone, is_stateless, fail_back, _create_date, _update_date, dedicated_vm_for_vds, auto_startup, vm_type, nice_level, default_boot_sequence, default_display_type, priority, iso_path, origin, initrd_url, kernel_url, kernel_params, migration_support, userdefined_properties, predefined_properties, min_allocated_mem, entity_type, child_count, template_status, quota_id, allow_console_reconnect, cpu_pinning, is_smartcard_enabled, host_cpu_flags, db_generation, is_delete_protected, is_disabled) FROM stdin;
\.
copy vm_static (vm_guid, vm_name, mem_size_mb, vmt_guid, os, description, vds_group_id, domain, creation_date, num_of_monitors, is_initialized, is_auto_suspend, num_of_sockets, cpu_per_socket, usb_policy, time_zone, is_stateless, fail_back, _create_date, _update_date, dedicated_vm_for_vds, auto_startup, vm_type, nice_level, default_boot_sequence, default_display_type, priority, iso_path, origin, initrd_url, kernel_url, kernel_params, migration_support, userdefined_properties, predefined_properties, min_allocated_mem, entity_type, child_count, template_status, quota_id, allow_console_reconnect, cpu_pinning, is_smartcard_enabled, host_cpu_flags, db_generation, is_delete_protected, is_disabled)  from '$$PATH$$/4105.dat' ;
--
-- Data for Name: vm_statistics; Type: TABLE DATA; Schema: public; Owner: engineer
--

COPY vm_statistics (vm_guid, cpu_user, cpu_sys, elapsed_time, usage_network_percent, usage_mem_percent, usage_cpu_percent, disks_usage, _update_date) FROM stdin;
\.
copy vm_statistics (vm_guid, cpu_user, cpu_sys, elapsed_time, usage_network_percent, usage_mem_percent, usage_cpu_percent, disks_usage, _update_date)  from '$$PATH$$/4114.dat' ;
--
-- Name: disk_lun_map_pk; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY disk_lun_map
    ADD CONSTRAINT disk_lun_map_pk PRIMARY KEY (disk_id, lun_id);


--
-- Name: gluster_volumes_name_unique; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY gluster_volumes
    ADD CONSTRAINT gluster_volumes_name_unique UNIQUE (cluster_id, vol_name);


--
-- Name: idx_gluster_volume_bricks_volume_server_brickdir; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY gluster_volume_bricks
    ADD CONSTRAINT idx_gluster_volume_bricks_volume_server_brickdir UNIQUE (volume_id, server_id, brick_dir);


--
-- Name: idx_gluster_volume_options_volume_id_option_key; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY gluster_volume_options
    ADD CONSTRAINT idx_gluster_volume_options_volume_id_option_key UNIQUE (volume_id, option_key);


--
-- Name: materialized_views_pkey; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY materialized_views
    ADD CONSTRAINT materialized_views_pkey PRIMARY KEY (mv_name);


--
-- Name: pk_action_version_map; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY action_version_map
    ADD CONSTRAINT pk_action_version_map PRIMARY KEY (action_type);


--
-- Name: pk_ad_group_id; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY ad_groups
    ADD CONSTRAINT pk_ad_group_id PRIMARY KEY (id);


--
-- Name: pk_async_tasks; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY async_tasks
    ADD CONSTRAINT pk_async_tasks PRIMARY KEY (task_id);


--
-- Name: pk_audit_log; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY audit_log
    ADD CONSTRAINT pk_audit_log PRIMARY KEY (audit_log_id);


--
-- Name: pk_bookmarks; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY bookmarks
    ADD CONSTRAINT pk_bookmarks PRIMARY KEY (bookmark_id);


--
-- Name: pk_custom_actions; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY custom_actions
    ADD CONSTRAINT pk_custom_actions PRIMARY KEY (action_name, tab);


--
-- Name: pk_disk_image_dynamic; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY disk_image_dynamic
    ADD CONSTRAINT pk_disk_image_dynamic PRIMARY KEY (image_id);


--
-- Name: pk_disks; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY base_disks
    ADD CONSTRAINT pk_disks PRIMARY KEY (disk_id);


--
-- Name: pk_event_map; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY event_map
    ADD CONSTRAINT pk_event_map PRIMARY KEY (event_up_name);


--
-- Name: pk_event_notification_methods; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY event_notification_methods
    ADD CONSTRAINT pk_event_notification_methods PRIMARY KEY (method_id);


--
-- Name: pk_event_subscriber; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY event_subscriber
    ADD CONSTRAINT pk_event_subscriber PRIMARY KEY (subscriber_id, event_up_name, method_id, tag_name);


--
-- Name: pk_gluster_volume_access_protocols; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY gluster_volume_access_protocols
    ADD CONSTRAINT pk_gluster_volume_access_protocols PRIMARY KEY (volume_id, access_protocol);


--
-- Name: pk_gluster_volume_bricks; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY gluster_volume_bricks
    ADD CONSTRAINT pk_gluster_volume_bricks PRIMARY KEY (id);


--
-- Name: pk_gluster_volume_options; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY gluster_volume_options
    ADD CONSTRAINT pk_gluster_volume_options PRIMARY KEY (id);


--
-- Name: pk_gluster_volume_transport_types; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY gluster_volume_transport_types
    ADD CONSTRAINT pk_gluster_volume_transport_types PRIMARY KEY (volume_id, transport_type);


--
-- Name: pk_gluster_volumes; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY gluster_volumes
    ADD CONSTRAINT pk_gluster_volumes PRIMARY KEY (id);


--
-- Name: pk_id; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY business_entity_snapshot
    ADD CONSTRAINT pk_id PRIMARY KEY (id);


--
-- Name: pk_image_storage_domain_map; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY image_storage_domain_map
    ADD CONSTRAINT pk_image_storage_domain_map PRIMARY KEY (image_id, storage_domain_id);


--
-- Name: pk_images; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY images
    ADD CONSTRAINT pk_images PRIMARY KEY (image_guid);


--
-- Name: pk_jobs; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY job
    ADD CONSTRAINT pk_jobs PRIMARY KEY (job_id);


--
-- Name: pk_jobs_subject_entity; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY job_subject_entity
    ADD CONSTRAINT pk_jobs_subject_entity PRIMARY KEY (job_id, entity_id);


--
-- Name: pk_lun_storage_server_connection_map; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY lun_storage_server_connection_map
    ADD CONSTRAINT pk_lun_storage_server_connection_map PRIMARY KEY (lun_id, storage_server_connection);


--
-- Name: pk_luns; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY luns
    ADD CONSTRAINT pk_luns PRIMARY KEY (lun_id);


--
-- Name: pk_network; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY network
    ADD CONSTRAINT pk_network PRIMARY KEY (id);


--
-- Name: pk_network_cluster; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY network_cluster
    ADD CONSTRAINT pk_network_cluster PRIMARY KEY (network_id, cluster_id);


--
-- Name: pk_object_column_white_list; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY object_column_white_list
    ADD CONSTRAINT pk_object_column_white_list PRIMARY KEY (object_name, column_name);


--
-- Name: pk_object_column_white_list_sql; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY object_column_white_list_sql
    ADD CONSTRAINT pk_object_column_white_list_sql PRIMARY KEY (object_name);


--
-- Name: pk_permissions_id; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY permissions
    ADD CONSTRAINT pk_permissions_id PRIMARY KEY (id);


--
-- Name: pk_quota; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY quota
    ADD CONSTRAINT pk_quota PRIMARY KEY (id);


--
-- Name: pk_quota_limitation; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY quota_limitation
    ADD CONSTRAINT pk_quota_limitation PRIMARY KEY (id);


--
-- Name: pk_repo_file_meta_data; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY repo_file_meta_data
    ADD CONSTRAINT pk_repo_file_meta_data PRIMARY KEY (repo_domain_id, repo_file_name);


--
-- Name: pk_roles_groups; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY roles_groups
    ADD CONSTRAINT pk_roles_groups PRIMARY KEY (role_id, action_group_id);


--
-- Name: pk_roles_id; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY roles
    ADD CONSTRAINT pk_roles_id PRIMARY KEY (id);


--
-- Name: pk_roles_relations; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY roles_relations
    ADD CONSTRAINT pk_roles_relations PRIMARY KEY (role_id, role_container_id);


--
-- Name: pk_snapshots; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY snapshots
    ADD CONSTRAINT pk_snapshots PRIMARY KEY (snapshot_id);


--
-- Name: pk_steps; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY step
    ADD CONSTRAINT pk_steps PRIMARY KEY (step_id);


--
-- Name: pk_storage; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY storage_domain_static
    ADD CONSTRAINT pk_storage PRIMARY KEY (id);


--
-- Name: pk_storage_domain_dynamic; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY storage_domain_dynamic
    ADD CONSTRAINT pk_storage_domain_dynamic PRIMARY KEY (id);


--
-- Name: pk_storage_domain_pool_map; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY storage_pool_iso_map
    ADD CONSTRAINT pk_storage_domain_pool_map PRIMARY KEY (storage_id, storage_pool_id);


--
-- Name: pk_storage_pool; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY storage_pool
    ADD CONSTRAINT pk_storage_pool PRIMARY KEY (id);


--
-- Name: pk_storage_server; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY storage_server_connections
    ADD CONSTRAINT pk_storage_server PRIMARY KEY (id);


--
-- Name: pk_tags_id; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY tags
    ADD CONSTRAINT pk_tags_id PRIMARY KEY (tag_id);


--
-- Name: pk_tags_user_group_map; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY tags_user_group_map
    ADD CONSTRAINT pk_tags_user_group_map PRIMARY KEY (tag_id, group_id);


--
-- Name: pk_tags_user_map; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY tags_user_map
    ADD CONSTRAINT pk_tags_user_map PRIMARY KEY (tag_id, user_id);


--
-- Name: pk_tags_vds_map; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY tags_vds_map
    ADD CONSTRAINT pk_tags_vds_map PRIMARY KEY (tag_id, vds_id);


--
-- Name: pk_tags_vm_map; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY tags_vm_map
    ADD CONSTRAINT pk_tags_vm_map PRIMARY KEY (tag_id, vm_id);


--
-- Name: pk_tags_vm_pool_map; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY tags_vm_pool_map
    ADD CONSTRAINT pk_tags_vm_pool_map PRIMARY KEY (tag_id, vm_pool_id);


--
-- Name: pk_user_sessions; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY user_sessions
    ADD CONSTRAINT pk_user_sessions PRIMARY KEY (user_id, session_id);


--
-- Name: pk_users; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY users
    ADD CONSTRAINT pk_users PRIMARY KEY (user_id);


--
-- Name: pk_vdc_db_log; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vdc_db_log
    ADD CONSTRAINT pk_vdc_db_log PRIMARY KEY (error_id);


--
-- Name: pk_vdc_options; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vdc_options
    ADD CONSTRAINT pk_vdc_options PRIMARY KEY (option_id);


--
-- Name: pk_vds_dynamic; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vds_dynamic
    ADD CONSTRAINT pk_vds_dynamic PRIMARY KEY (vds_id);


--
-- Name: pk_vds_groups; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vds_groups
    ADD CONSTRAINT pk_vds_groups PRIMARY KEY (vds_group_id);


--
-- Name: pk_vds_interface; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vds_interface
    ADD CONSTRAINT pk_vds_interface PRIMARY KEY (id);


--
-- Name: pk_vds_interface_statistics; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vds_interface_statistics
    ADD CONSTRAINT pk_vds_interface_statistics PRIMARY KEY (id);


--
-- Name: pk_vds_spm_id_map; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vds_spm_id_map
    ADD CONSTRAINT pk_vds_spm_id_map PRIMARY KEY (storage_pool_id, vds_spm_id);


--
-- Name: pk_vds_static; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vds_static
    ADD CONSTRAINT pk_vds_static PRIMARY KEY (vds_id);


--
-- Name: pk_vds_statistics; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vds_statistics
    ADD CONSTRAINT pk_vds_statistics PRIMARY KEY (vds_id);


--
-- Name: pk_vm_device; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vm_device
    ADD CONSTRAINT pk_vm_device PRIMARY KEY (device_id, vm_id);


--
-- Name: pk_vm_dynamic; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vm_dynamic
    ADD CONSTRAINT pk_vm_dynamic PRIMARY KEY (vm_guid);


--
-- Name: pk_vm_interface; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vm_interface
    ADD CONSTRAINT pk_vm_interface PRIMARY KEY (id);


--
-- Name: pk_vm_interface_statistics; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vm_interface_statistics
    ADD CONSTRAINT pk_vm_interface_statistics PRIMARY KEY (id);


--
-- Name: pk_vm_pool_map; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vm_pool_map
    ADD CONSTRAINT pk_vm_pool_map PRIMARY KEY (vm_guid);


--
-- Name: pk_vm_pools; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vm_pools
    ADD CONSTRAINT pk_vm_pools PRIMARY KEY (vm_pool_id);


--
-- Name: pk_vm_static; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vm_static
    ADD CONSTRAINT pk_vm_static PRIMARY KEY (vm_guid);


--
-- Name: pk_vm_statistics; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vm_statistics
    ADD CONSTRAINT pk_vm_statistics PRIMARY KEY (vm_guid);


--
-- Name: quota_quota_name_unique; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY quota
    ADD CONSTRAINT quota_quota_name_unique UNIQUE (quota_name);


--
-- Name: schema_version_primary_key; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY schema_version
    ADD CONSTRAINT schema_version_primary_key PRIMARY KEY (id);


--
-- Name: uq_command_id_entity_id; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY business_entity_snapshot
    ADD CONSTRAINT uq_command_id_entity_id UNIQUE (command_id, entity_id, entity_type, snapshot_type);


--
-- Name: vds_static_host_name_unique; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vds_static
    ADD CONSTRAINT vds_static_host_name_unique UNIQUE (host_name);


--
-- Name: vds_static_vds_name_unique; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vds_static
    ADD CONSTRAINT vds_static_vds_name_unique UNIQUE (vds_name);


--
-- Name: vm_ovf_generations_pkey; Type: CONSTRAINT; Schema: public; Owner: engineer; Tablespace: 
--

ALTER TABLE ONLY vm_ovf_generations
    ADD CONSTRAINT vm_ovf_generations_pkey PRIMARY KEY (vm_guid);


--
-- Name: audit_log_origin_custom_event_id_idx; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE UNIQUE INDEX audit_log_origin_custom_event_id_idx ON audit_log USING btree (origin, custom_event_id) WHERE ((origin)::text !~~* 'ovirt'::text);


--
-- Name: idx_audit_correlation_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_audit_correlation_id ON audit_log USING btree (correlation_id);


--
-- Name: idx_audit_log_job_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_audit_log_job_id ON audit_log USING btree (job_id);


--
-- Name: idx_audit_log_log_time; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_audit_log_log_time ON audit_log USING btree (log_time);


--
-- Name: idx_audit_log_storage_domain_name; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_audit_log_storage_domain_name ON audit_log USING btree (storage_domain_name);


--
-- Name: idx_audit_log_storage_pool_name; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_audit_log_storage_pool_name ON audit_log USING btree (storage_pool_name);


--
-- Name: idx_audit_log_user_name; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_audit_log_user_name ON audit_log USING btree (user_name);


--
-- Name: idx_audit_log_vds_name; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_audit_log_vds_name ON audit_log USING btree (vds_name);


--
-- Name: idx_audit_log_vm_name; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_audit_log_vm_name ON audit_log USING btree (vm_name);


--
-- Name: idx_audit_log_vm_template_name; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_audit_log_vm_template_name ON audit_log USING btree (vm_template_name);


--
-- Name: idx_business_entity_snapshot_command_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_business_entity_snapshot_command_id ON business_entity_snapshot USING btree (command_id);


--
-- Name: idx_combined_ad_role_object; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE UNIQUE INDEX idx_combined_ad_role_object ON permissions USING btree (ad_element_id, role_id, object_id);


--
-- Name: idx_gluster_volume_access_protocols_volume_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_gluster_volume_access_protocols_volume_id ON gluster_volume_access_protocols USING btree (volume_id);


--
-- Name: idx_gluster_volume_bricks_volume_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_gluster_volume_bricks_volume_id ON gluster_volume_bricks USING btree (volume_id);


--
-- Name: idx_gluster_volume_options_volume_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_gluster_volume_options_volume_id ON gluster_volume_options USING btree (volume_id);


--
-- Name: idx_gluster_volume_transport_types_volume_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_gluster_volume_transport_types_volume_id ON gluster_volume_transport_types USING btree (volume_id);


--
-- Name: idx_gluster_volumes_cluster_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_gluster_volumes_cluster_id ON gluster_volumes USING btree (cluster_id);


--
-- Name: idx_job_subject_entity_entity_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_job_subject_entity_entity_id ON job_subject_entity USING btree (entity_id);


--
-- Name: idx_permissions_ad_element_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_permissions_ad_element_id ON permissions USING btree (ad_element_id);


--
-- Name: idx_permissions_object_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_permissions_object_id ON permissions USING btree (object_id);


--
-- Name: idx_permissions_role_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_permissions_role_id ON permissions USING btree (role_id);


--
-- Name: idx_quota_limitation_quota_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_quota_limitation_quota_id ON quota_limitation USING btree (quota_id);


--
-- Name: idx_quota_limitation_storage_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_quota_limitation_storage_id ON quota_limitation USING btree (storage_id) WHERE (storage_id IS NOT NULL);


--
-- Name: idx_quota_limitation_vds_group_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_quota_limitation_vds_group_id ON quota_limitation USING btree (vds_group_id) WHERE (vds_group_id IS NOT NULL);


--
-- Name: idx_repo_file_file_type; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_repo_file_file_type ON repo_file_meta_data USING btree (file_type);


--
-- Name: idx_roles_groups_action_group_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_roles_groups_action_group_id ON roles_groups USING btree (action_group_id);


--
-- Name: idx_step_job_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_step_job_id ON step USING btree (job_id);


--
-- Name: idx_step_parent_step_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_step_parent_step_id ON step USING btree (parent_step_id);


--
-- Name: idx_storage_pool_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_storage_pool_id ON quota USING btree (storage_pool_id) WHERE (storage_pool_id IS NOT NULL);


--
-- Name: idx_vds_interface_vds_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_vds_interface_vds_id ON vds_interface USING btree (vds_id);


--
-- Name: idx_vm_dynamic_run_on_vds; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_vm_dynamic_run_on_vds ON vm_dynamic USING btree (run_on_vds);


--
-- Name: idx_vm_guest_agent_interfaces_vm_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_vm_guest_agent_interfaces_vm_id ON vm_guest_agent_interfaces USING btree (vm_id);


--
-- Name: idx_vm_interface_vm_vmt_guid; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_vm_interface_vm_vmt_guid ON vm_interface USING btree (vm_guid, vmt_guid);


--
-- Name: idx_vm_ovf_generations_storage_pool_id; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_vm_ovf_generations_storage_pool_id ON vm_ovf_generations USING btree (storage_pool_id);


--
-- Name: idx_vm_ovf_generations_vm_guid; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_vm_ovf_generations_vm_guid ON vm_ovf_generations USING btree (vm_guid);


--
-- Name: idx_vm_static_vm_name; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX idx_vm_static_vm_name ON vm_static USING btree (vm_name);


--
-- Name: ix_vdc_options; Type: INDEX; Schema: public; Owner: engineer; Tablespace: 
--

CREATE INDEX ix_vdc_options ON vdc_options USING btree (option_name);


--
-- Name: disk_lun_to_disk_fk; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY disk_lun_map
    ADD CONSTRAINT disk_lun_to_disk_fk FOREIGN KEY (disk_id) REFERENCES base_disks(disk_id);


--
-- Name: disk_lun_to_lun_fk; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY disk_lun_map
    ADD CONSTRAINT disk_lun_to_lun_fk FOREIGN KEY (lun_id) REFERENCES luns(lun_id);


--
-- Name: fk_async_task_entity; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY async_tasks_entities
    ADD CONSTRAINT fk_async_task_entity FOREIGN KEY (async_task_id) REFERENCES async_tasks(task_id) ON DELETE CASCADE;


--
-- Name: fk_disk_image_dynamic_images; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY disk_image_dynamic
    ADD CONSTRAINT fk_disk_image_dynamic_images FOREIGN KEY (image_id) REFERENCES images(image_guid) ON DELETE CASCADE;


--
-- Name: fk_event_notification_hist_audit_log; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY event_notification_hist
    ADD CONSTRAINT fk_event_notification_hist_audit_log FOREIGN KEY (audit_log_id) REFERENCES audit_log(audit_log_id) ON DELETE CASCADE;


--
-- Name: fk_event_notification_users; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY event_notification_hist
    ADD CONSTRAINT fk_event_notification_users FOREIGN KEY (subscriber_id) REFERENCES users(user_id) ON DELETE CASCADE;


--
-- Name: fk_event_subscriber_event_map; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY event_subscriber
    ADD CONSTRAINT fk_event_subscriber_event_map FOREIGN KEY (event_up_name) REFERENCES event_map(event_up_name) ON DELETE CASCADE;


--
-- Name: fk_event_subscriber_event_notification_methods; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY event_subscriber
    ADD CONSTRAINT fk_event_subscriber_event_notification_methods FOREIGN KEY (method_id) REFERENCES event_notification_methods(method_id) ON DELETE CASCADE;


--
-- Name: fk_event_subscriber_users; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY event_subscriber
    ADD CONSTRAINT fk_event_subscriber_users FOREIGN KEY (subscriber_id) REFERENCES users(user_id) ON DELETE CASCADE;


--
-- Name: fk_image_storage_domain_map_images; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY image_storage_domain_map
    ADD CONSTRAINT fk_image_storage_domain_map_images FOREIGN KEY (image_id) REFERENCES images(image_guid) ON DELETE CASCADE;


--
-- Name: fk_image_storage_domain_map_storage_domain_static; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY image_storage_domain_map
    ADD CONSTRAINT fk_image_storage_domain_map_storage_domain_static FOREIGN KEY (storage_domain_id) REFERENCES storage_domain_static(id) ON DELETE CASCADE;


--
-- Name: fk_job_subject_entity_job; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY job_subject_entity
    ADD CONSTRAINT fk_job_subject_entity_job FOREIGN KEY (job_id) REFERENCES job(job_id) ON DELETE CASCADE;


--
-- Name: fk_lun_storage_server_connection_map_luns; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY lun_storage_server_connection_map
    ADD CONSTRAINT fk_lun_storage_server_connection_map_luns FOREIGN KEY (lun_id) REFERENCES luns(lun_id) ON DELETE CASCADE;


--
-- Name: fk_lun_storage_server_connection_map_storage_server_connections; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY lun_storage_server_connection_map
    ADD CONSTRAINT fk_lun_storage_server_connection_map_storage_server_connections FOREIGN KEY (storage_server_connection) REFERENCES storage_server_connections(id) ON DELETE CASCADE;


--
-- Name: fk_network_cluster_network; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY network_cluster
    ADD CONSTRAINT fk_network_cluster_network FOREIGN KEY (network_id) REFERENCES network(id) ON DELETE CASCADE;


--
-- Name: fk_network_cluster_vds_groups; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY network_cluster
    ADD CONSTRAINT fk_network_cluster_vds_groups FOREIGN KEY (cluster_id) REFERENCES vds_groups(vds_group_id) ON DELETE CASCADE;


--
-- Name: fk_network_storage_pool; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY network
    ADD CONSTRAINT fk_network_storage_pool FOREIGN KEY (storage_pool_id) REFERENCES storage_pool(id) ON DELETE SET NULL;


--
-- Name: fk_permissions_roles; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY permissions
    ADD CONSTRAINT fk_permissions_roles FOREIGN KEY (role_id) REFERENCES roles(id) ON DELETE CASCADE;


--
-- Name: fk_repo_file_meta_data_storage_domain_static; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY repo_file_meta_data
    ADD CONSTRAINT fk_repo_file_meta_data_storage_domain_static FOREIGN KEY (repo_domain_id) REFERENCES storage_domain_static(id) ON DELETE CASCADE;


--
-- Name: fk_roles_groups_action_id; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY roles_groups
    ADD CONSTRAINT fk_roles_groups_action_id FOREIGN KEY (role_id) REFERENCES roles(id) ON DELETE CASCADE;


--
-- Name: fk_roles_relations_container_id; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY roles_relations
    ADD CONSTRAINT fk_roles_relations_container_id FOREIGN KEY (role_container_id) REFERENCES roles(id);


--
-- Name: fk_roles_relations_role_id; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY roles_relations
    ADD CONSTRAINT fk_roles_relations_role_id FOREIGN KEY (role_id) REFERENCES roles(id);


--
-- Name: fk_snapshot_vm; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY snapshots
    ADD CONSTRAINT fk_snapshot_vm FOREIGN KEY (vm_id) REFERENCES vm_static(vm_guid);


--
-- Name: fk_step_job; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY step
    ADD CONSTRAINT fk_step_job FOREIGN KEY (job_id) REFERENCES job(job_id) ON DELETE CASCADE;


--
-- Name: fk_storage_domain_dynamic_storage_domain_static; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY storage_domain_dynamic
    ADD CONSTRAINT fk_storage_domain_dynamic_storage_domain_static FOREIGN KEY (id) REFERENCES storage_domain_static(id);


--
-- Name: fk_storage_domain_pool_map_storage_domain_static; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY storage_pool_iso_map
    ADD CONSTRAINT fk_storage_domain_pool_map_storage_domain_static FOREIGN KEY (storage_id) REFERENCES storage_domain_static(id) ON DELETE CASCADE;


--
-- Name: fk_storage_domain_pool_map_storage_pool; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY storage_pool_iso_map
    ADD CONSTRAINT fk_storage_domain_pool_map_storage_pool FOREIGN KEY (storage_pool_id) REFERENCES storage_pool(id) ON DELETE CASCADE;


--
-- Name: fk_tags_vm_pool_map_tag; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY tags_vm_pool_map
    ADD CONSTRAINT fk_tags_vm_pool_map_tag FOREIGN KEY (tag_id) REFERENCES tags(tag_id) ON DELETE CASCADE;


--
-- Name: fk_tags_vm_pool_map_vm_pool; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY tags_vm_pool_map
    ADD CONSTRAINT fk_tags_vm_pool_map_vm_pool FOREIGN KEY (vm_pool_id) REFERENCES vm_pools(vm_pool_id) ON DELETE CASCADE;


--
-- Name: fk_users; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY user_sessions
    ADD CONSTRAINT fk_users FOREIGN KEY (user_id) REFERENCES users(user_id) ON DELETE CASCADE;


--
-- Name: fk_vds_groups_storage_pool_id; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vds_groups
    ADD CONSTRAINT fk_vds_groups_storage_pool_id FOREIGN KEY (storage_pool_id) REFERENCES storage_pool(id) ON DELETE SET NULL;


--
-- Name: fk_vds_groups_vm_pools; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_pools
    ADD CONSTRAINT fk_vds_groups_vm_pools FOREIGN KEY (vds_group_id) REFERENCES vds_groups(vds_group_id);


--
-- Name: fk_vds_interface_statistics_vds_static; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vds_interface_statistics
    ADD CONSTRAINT fk_vds_interface_statistics_vds_static FOREIGN KEY (vds_id) REFERENCES vds_static(vds_id) ON DELETE CASCADE;


--
-- Name: fk_vds_interface_vds_interface; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vds_interface
    ADD CONSTRAINT fk_vds_interface_vds_interface FOREIGN KEY (vds_id) REFERENCES vds_static(vds_id) ON DELETE CASCADE;


--
-- Name: fk_vds_spm_id_map_storage_pool; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vds_spm_id_map
    ADD CONSTRAINT fk_vds_spm_id_map_storage_pool FOREIGN KEY (storage_pool_id) REFERENCES storage_pool(id) ON DELETE CASCADE;


--
-- Name: fk_vds_spm_id_map_vds_id; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vds_spm_id_map
    ADD CONSTRAINT fk_vds_spm_id_map_vds_id FOREIGN KEY (vds_id) REFERENCES vds_static(vds_id) ON DELETE CASCADE;


--
-- Name: fk_vds_static_vm_static; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_static
    ADD CONSTRAINT fk_vds_static_vm_static FOREIGN KEY (dedicated_vm_for_vds) REFERENCES vds_static(vds_id);


--
-- Name: fk_vm_device_vm_static; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_device
    ADD CONSTRAINT fk_vm_device_vm_static FOREIGN KEY (vm_id) REFERENCES vm_static(vm_guid) ON DELETE CASCADE;


--
-- Name: fk_vm_guest_agent_interfaces; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_guest_agent_interfaces
    ADD CONSTRAINT fk_vm_guest_agent_interfaces FOREIGN KEY (vm_id) REFERENCES vm_static(vm_guid) ON DELETE CASCADE;


--
-- Name: fk_vm_interface_statistics_vm_static; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_interface_statistics
    ADD CONSTRAINT fk_vm_interface_statistics_vm_static FOREIGN KEY (vm_id) REFERENCES vm_static(vm_guid) ON DELETE CASCADE;


--
-- Name: fk_vm_interface_vm_static; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_interface
    ADD CONSTRAINT fk_vm_interface_vm_static FOREIGN KEY (vm_guid) REFERENCES vm_static(vm_guid) ON DELETE CASCADE;


--
-- Name: fk_vm_interface_vm_static_template; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_interface
    ADD CONSTRAINT fk_vm_interface_vm_static_template FOREIGN KEY (vmt_guid) REFERENCES vm_static(vm_guid) ON DELETE CASCADE;


--
-- Name: gluster_volume_access_protocols_volume_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY gluster_volume_access_protocols
    ADD CONSTRAINT gluster_volume_access_protocols_volume_id_fkey FOREIGN KEY (volume_id) REFERENCES gluster_volumes(id) ON DELETE CASCADE;


--
-- Name: gluster_volume_bricks_server_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY gluster_volume_bricks
    ADD CONSTRAINT gluster_volume_bricks_server_id_fkey FOREIGN KEY (server_id) REFERENCES vds_static(vds_id) ON DELETE CASCADE;


--
-- Name: gluster_volume_bricks_volume_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY gluster_volume_bricks
    ADD CONSTRAINT gluster_volume_bricks_volume_id_fkey FOREIGN KEY (volume_id) REFERENCES gluster_volumes(id) ON DELETE CASCADE;


--
-- Name: gluster_volume_options_volume_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY gluster_volume_options
    ADD CONSTRAINT gluster_volume_options_volume_id_fkey FOREIGN KEY (volume_id) REFERENCES gluster_volumes(id) ON DELETE CASCADE;


--
-- Name: gluster_volume_transport_types_volume_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY gluster_volume_transport_types
    ADD CONSTRAINT gluster_volume_transport_types_volume_id_fkey FOREIGN KEY (volume_id) REFERENCES gluster_volumes(id) ON DELETE CASCADE;


--
-- Name: gluster_volumes_cluster_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY gluster_volumes
    ADD CONSTRAINT gluster_volumes_cluster_id_fkey FOREIGN KEY (cluster_id) REFERENCES vds_groups(vds_group_id) ON DELETE CASCADE;


--
-- Name: image_templates_images; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY images
    ADD CONSTRAINT image_templates_images FOREIGN KEY (it_guid) REFERENCES images(image_guid);


--
-- Name: quota_limitation_quota_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY quota_limitation
    ADD CONSTRAINT quota_limitation_quota_id_fkey FOREIGN KEY (quota_id) REFERENCES quota(id) ON DELETE CASCADE;


--
-- Name: quota_limitation_storage_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY quota_limitation
    ADD CONSTRAINT quota_limitation_storage_id_fkey FOREIGN KEY (storage_id) REFERENCES storage_domain_static(id) ON DELETE CASCADE;


--
-- Name: quota_limitation_vds_group_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY quota_limitation
    ADD CONSTRAINT quota_limitation_vds_group_id_fkey FOREIGN KEY (vds_group_id) REFERENCES vds_groups(vds_group_id) ON DELETE CASCADE;


--
-- Name: quota_storage_pool_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY quota
    ADD CONSTRAINT quota_storage_pool_id_fkey FOREIGN KEY (storage_pool_id) REFERENCES storage_pool(id) ON DELETE CASCADE;


--
-- Name: tags_user_group_map_tag; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY tags_user_group_map
    ADD CONSTRAINT tags_user_group_map_tag FOREIGN KEY (tag_id) REFERENCES tags(tag_id);


--
-- Name: tags_user_map_tag; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY tags_user_map
    ADD CONSTRAINT tags_user_map_tag FOREIGN KEY (tag_id) REFERENCES tags(tag_id);


--
-- Name: tags_user_map_user; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY tags_user_map
    ADD CONSTRAINT tags_user_map_user FOREIGN KEY (user_id) REFERENCES users(user_id);


--
-- Name: tags_user_map_user_group; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY tags_user_group_map
    ADD CONSTRAINT tags_user_map_user_group FOREIGN KEY (group_id) REFERENCES ad_groups(id);


--
-- Name: tags_vds_map_tag; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY tags_vds_map
    ADD CONSTRAINT tags_vds_map_tag FOREIGN KEY (tag_id) REFERENCES tags(tag_id);


--
-- Name: tags_vds_map_vds; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY tags_vds_map
    ADD CONSTRAINT tags_vds_map_vds FOREIGN KEY (vds_id) REFERENCES vds_static(vds_id);


--
-- Name: tags_vm_map_tag; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY tags_vm_map
    ADD CONSTRAINT tags_vm_map_tag FOREIGN KEY (tag_id) REFERENCES tags(tag_id);


--
-- Name: tags_vm_map_vm; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY tags_vm_map
    ADD CONSTRAINT tags_vm_map_vm FOREIGN KEY (vm_id) REFERENCES vm_static(vm_guid) ON DELETE CASCADE;


--
-- Name: vds_groups_vds_static; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vds_static
    ADD CONSTRAINT vds_groups_vds_static FOREIGN KEY (vds_group_id) REFERENCES vds_groups(vds_group_id);


--
-- Name: vds_groups_vm_static; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_static
    ADD CONSTRAINT vds_groups_vm_static FOREIGN KEY (vds_group_id) REFERENCES vds_groups(vds_group_id);


--
-- Name: vds_static_vds_dynamic; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vds_dynamic
    ADD CONSTRAINT vds_static_vds_dynamic FOREIGN KEY (vds_id) REFERENCES vds_static(vds_id);


--
-- Name: vds_static_vds_statistics; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vds_statistics
    ADD CONSTRAINT vds_static_vds_statistics FOREIGN KEY (vds_id) REFERENCES vds_static(vds_id);


--
-- Name: vds_static_vm_dynamic_m; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_dynamic
    ADD CONSTRAINT vds_static_vm_dynamic_m FOREIGN KEY (migrating_to_vds) REFERENCES vds_static(vds_id);


--
-- Name: vds_static_vm_dynamic_r; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_dynamic
    ADD CONSTRAINT vds_static_vm_dynamic_r FOREIGN KEY (run_on_vds) REFERENCES vds_static(vds_id);


--
-- Name: vm_guid_pools; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_pool_map
    ADD CONSTRAINT vm_guid_pools FOREIGN KEY (vm_guid) REFERENCES vm_static(vm_guid) ON DELETE CASCADE;


--
-- Name: vm_ovf_generations_storage_pool_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_ovf_generations
    ADD CONSTRAINT vm_ovf_generations_storage_pool_id_fkey FOREIGN KEY (storage_pool_id) REFERENCES storage_pool(id) ON DELETE CASCADE;


--
-- Name: vm_pools_vm; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_pool_map
    ADD CONSTRAINT vm_pools_vm FOREIGN KEY (vm_pool_id) REFERENCES vm_pools(vm_pool_id);


--
-- Name: vm_static_vm_dynamic; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_dynamic
    ADD CONSTRAINT vm_static_vm_dynamic FOREIGN KEY (vm_guid) REFERENCES vm_static(vm_guid) ON DELETE CASCADE;


--
-- Name: vm_static_vm_statistics; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_statistics
    ADD CONSTRAINT vm_static_vm_statistics FOREIGN KEY (vm_guid) REFERENCES vm_static(vm_guid) ON DELETE CASCADE;


--
-- Name: vm_templates_vm_static; Type: FK CONSTRAINT; Schema: public; Owner: engineer
--

ALTER TABLE ONLY vm_static
    ADD CONSTRAINT vm_templates_vm_static FOREIGN KEY (vmt_guid) REFERENCES vm_static(vm_guid);


--
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- PostgreSQL database dump complete
--

